/*
 *      Web server handler routines for ACL stuffs
 *
 */



/*-- System inlcude files --*/
#include <net/if.h>
#include <sys/ioctl.h>
#include <sys/time.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/socket.h>
#include <net/route.h>

/*-- Local inlcude files --*/
#include "../webs.h"
#include "webform.h"
#include "mib.h"
#include "utility.h"

#if 0
#ifdef CONFIG_USER_DDNS
///////////////////////////////////////////////////////////////////
void formDDNS(webs_t wp, char_t *path, char_t *query)
{
	char_t	*str, *submitUrl;
	char tmpBuf[100], ifname[6];
	unsigned char ddns_if, if_num;	
#ifndef NO_ACTION
	int pid;
#endif	
	
	// Remove
	str = websGetVar(wp, T("delacc"), T(""));
	if (str[0]) {
		unsigned int i;
		unsigned int idx;
		unsigned int totalEntry = mib_chain_total(MIB_DDNS_TBL); /* get chain record size */		
		
		str = websGetVar(wp, T("select"), T(""));		
		if (str[0]) {
			for (i=0; i<totalEntry; i++) {
				idx = totalEntry-i-1;			
				snprintf(tmpBuf, 4, "s%d", idx);
				//printf("tmpBuf(select) = %s idx=%d\n", tmpBuf, idx);
				
				if ( !gstrcmp(str, T(tmpBuf)) ) {					
					// delete from chain record
					if(mib_chain_delete(MIB_DDNS_TBL, idx) != 1) {
						strcpy(tmpBuf, T("Delete chain record error!"));
						goto setErr_route;
					}

					
				}
			} // end of for
		}		
		goto setOk_route;
	}
	
	// Add
	str = websGetVar(wp, T("addacc"), T(""));		
	if (str[0]) {
		MIB_CE_DDNS_T entry;				
		
		// Added by Mason Yu
		memset(&entry, '\0', sizeof(MIB_CE_DDNS_T));	
		
		str = websGetVar(wp, T("ddnsProv"), T(""));			
		if ( str[0]=='0' ) {	
			strcpy(entry.provider, "dyndns");
		} else if ( str[0]=='1') {
			strcpy(entry.provider, "tzo");
		} else
			printf("Updatedd not support this provider!!\n");
		//printf("entry.provider = %s\n",entry.provider);
		
		str = websGetVar(wp, T("hostname"), T(""));
		if (str[0]) {							
			strcpy(entry.hostname, str);		
		}
		//printf("entry.hostname = %s\n", entry.hostname);
		
		str = websGetVar(wp, T("interface"), T(""));
		if (str[0]) {			
			ddns_if = (unsigned char)atoi(str);			
			
			if ( ddns_if == 100 ) {
				strcpy(entry.interface, "br0");
			} else {
				if_num = PPP_INDEX(ddns_if);
				if (if_num != 0x0f) {
					snprintf(ifname, 6, "ppp%u", if_num);					
				}else {
					snprintf(ifname, 5, "vc%u", VC_INDEX(ddns_if));					
				}
				strcpy(entry.interface, ifname);
			}		
			//printf("entry.interface= %s\n", entry.interface);	
		}			
		
		if ( strcmp(entry.provider, "dyndns") == 0 ) {
			str = websGetVar(wp, T("username"), T(""));
			if (str[0]) {							
				strcpy(entry.username, str);		
			}
			//printf("entry.username = %s\n", entry.username);
		
			str = websGetVar(wp, T("password"), T(""));
			if (str[0]) {							
				strcpy(entry.password, str);		
			}
			//printf("entry.password = %s\n", entry.password);			
			
		} else if ( strcmp(entry.provider, "tzo") == 0 ) {
			str = websGetVar(wp, T("email"), T(""));
			if (str[0]) {							
				//strcpy(entry.email, str);
				strcpy(entry.username, str);		
			}
			printf("email = %s\n", entry.username);
		
			str = websGetVar(wp, T("key"), T(""));
			if (str[0]) {							
				//strcpy(entry.key, str);	
				strcpy(entry.password, str);	
			}
			printf("key = %s\n", entry.password);			
			
		} else
			printf("Please choice the correct provider!!!\n");
		
		str = websGetVar(wp, T("enable"), T(""));
		if ( str && str[0] ) {
			entry.Enabled = 1;
		}
	
		if(mib_chain_add(MIB_DDNS_TBL, (unsigned char*)&entry) != 1){
			websWrite(wp, T("%s"), "Error: Add chain(MIB_DDNS_TBL) record.");
			return;
		}

	}


setOk_route:
	/* upgdate to flash */
//	mib_update(CURRENT_SETTING);

#ifndef NO_ACTION
	pid = fork();
        if (pid)
                waitpid(pid, NULL, 0);
        else if (pid == 0) {
		snprintf(tmpBuf, 100, "%s/%s", _CONFIG_SCRIPT_PATH, _CONFIG_SCRIPT_PROG);
#ifdef HOME_GATEWAY
		execl( tmpBuf, _CONFIG_SCRIPT_PROG, "gw", "bridge", NULL);
#else
		execl( tmpBuf, _CONFIG_SCRIPT_PROG, "ap", "bridge", NULL);
#endif
                exit(1);
        }
#endif

	submitUrl = websGetVar(wp, T("submit-url"), T(""));
	if (submitUrl[0])
		websRedirect(wp, submitUrl);
	else
		websDone(wp, 200);
  	return;

setErr_route:
	ERR_MSG(tmpBuf);	
}

int showDNSTable(int eid, webs_t wp, int argc, char_t **argv)
{
	int nBytesSent=0;	
	unsigned int entryNum, i;
	MIB_CE_DDNS_T Entry;
	unsigned long int d,g,m;
	struct in_addr dest;
	struct in_addr gw;
	struct in_addr mask;
	char sdest[16], sgw[16];
	
	entryNum = mib_chain_total(MIB_DDNS_TBL);
	
	nBytesSent += websWrite(wp, T("<tr><font size=1>"
	"<td align=center width=\"5%%\" bgcolor=\"#808080\">Select</td>\n"
	"<td align=center width=\"20%%\" bgcolor=\"#808080\">state</td>"
	"<td align=center width=\"20%%\" bgcolor=\"#808080\">Hostname</td>"
	"<td align=center width=\"20%%\" bgcolor=\"#808080\">Username</td>"
	"<td align=center width=\"20%%\" bgcolor=\"#808080\">Service</td>"
	"<td align=center width=\"20%%\" bgcolor=\"#808080\">Interface</td>"
	"</font></tr>\n"));

	for (i=0; i<entryNum; i++) {

		if (!mib_chain_get(MIB_DDNS_TBL, i, (void *)&Entry))
		{
  			websError(wp, 400, T("Get chain record error!\n"));
			return;
		}		
	
		nBytesSent += websWrite(wp, T("<tr>"
		"<td align=center width=\"5%%\" bgcolor=\"#C0C0C0\"><input type=\"radio\" name=\"select\""
		" value=\"s%d\"></td>\n"
		"<td align=center width=\"20%%\" bgcolor=\"#C0C0C0\"><font size=\"2\"><b>%s</b></font></td>"
		"<td align=center width=\"20%%\" bgcolor=\"#C0C0C0\"><font size=\"2\"><b>%s</b></font></td>"
		"<td align=center width=\"20%%\" bgcolor=\"#C0C0C0\"><font size=\"2\"><b>%s</b></font></td>"
		"<td align=center width=\"20%%\" bgcolor=\"#C0C0C0\"><font size=\"2\"><b>%s</b></font></td>"
		"<td align=center width=\"20%%\" bgcolor=\"#C0C0C0\"><font size=\"2\"><b>%s</b></font></td>"
		"</tr>\n"),
		//i, Entry.hostname, strcmp(Entry.username, "")==0?Entry.email:Entry.username, Entry.provider, Entry.interface);
		i, Entry.Enabled ? "Enable" : "Disable", Entry.hostname, Entry.username, Entry.provider, Entry.interface);
		
	}	
	return 0;
}
#endif
#endif
