/*
 *      Web server handler routines for SEC
 *      Authors: 
 *
 */

/*-- System inlcude files --*/
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <ctype.h>
#include <sys/wait.h>
#include <semaphore.h>
#ifdef EMBED
#include <linux/config.h>
#else
#include "../../../uClibc/include/linux/autoconf.h"
#endif

/* for ioctl */
#include <sys/ioctl.h>
#include <net/if.h>

#include "../webs.h"
#include "fmdefs.h"
#include "mib.h"
#include "utility.h"
#include "debug.h"
#include "../defs.h"


/*****************************
** 
*/
int initPageURL(int eid, webs_t wp, int argc, char_t ** argv)
{
	unsigned char 	urlfilterEnble = 1;	//1- ;  0- 
	unsigned char 	urlFilterMode = 0;	//1- ;  0- 
	struct url_entryx	entry;
	int				total = 0;
	int				index = 0;
	int				lineno = __LINE__;

	_TRACE_CALL;

	if (!mib_get(MIB_URL_FILTER_ENABLED, (void *)&urlfilterEnble))
		return -1;
	if (!mib_get(MIB_URL_FILTER_MODE, (void *)&urlFilterMode))
		return -1;

	_PUT_BOOL(urlfilterEnble);
	_PUT_BOOL(urlFilterMode);
	
	total = mib_chain_total(MIB_URL_TBL);
	for(index = 0; index < total; index++)
	{
		if (!mib_chain_get(MIB_URL_TBL, index, (void *)&entry)) {
			printf("get URL chain error!\n");
			goto check_err;
		}
		
		websWrite (wp, T ("push(new it_nr(\"%d\""_PTS _PTI "));\n"), index, _PME(url), _PME(port));
	}

check_err:
	_TRACE_LEAVEL;
	return 0;
}

void formURL(webs_t wp, char_t *path, char_t *query)
{
	unsigned char 	urlfilterEnble = 0;	// 1- ;  0- 
	unsigned char 	urlFilterMode = 0;	// 0- ;  1- 
	struct url_entryx	entry;
	char*			stemp = "";
	int				lineno = __LINE__;
	_BC_USE;
	int idx;
	int total;

	_TRACE_CALL;

	FETCH_INVALID_OPT(stemp, "action", _NEED);
	
	if(strcmp(stemp, "sw") == 0)	// switch
	{
		_GET_BOOL(urlfilterEnble, _NEED);

		if ( !mib_set(MIB_URL_FILTER_ENABLED, (void *)&urlfilterEnble)) {
			printf("Set URL Enable error!");
			goto check_err;
		}
	}
	else if(strcmp(stemp, "md") == 0)	//mode
	{
		_GET_BOOL(urlFilterMode, _NEED);

		if ( !mib_set(MIB_URL_FILTER_MODE, (void *)&urlFilterMode)) {
			printf("Set URL Mode error!");
			goto check_err;
		}
	}
	else if(strcmp(stemp, "rm") == 0)	//remove
	{
		struct url_entryx	Entry;
		
		_BC_INIT("bcdata");
		while(_BC_NEXT())
		{
			_BC_ENTRY_STR(url, _NEED);
			_BC_ENTRY_INT(port, _OPT);
			/************Place your code here, do what you want to do! ************/
			total = mib_chain_total(MIB_URL_TBL);
			for(idx = 0; idx < total; idx++)
			{
				if (!mib_chain_get(MIB_URL_TBL, idx, (void *)&Entry)) {
					printf("get URL chain error!\n");
					goto check_err;
				}
				
				if (!gstrcmp(entry.url, Entry.url))
				{
					//delete from chain record
					if (mib_chain_delete(MIB_URL_TBL, idx) != 1)
					{
						printf("Delete URL chain record error!");
						goto check_err;
					}
					printf("delete %s\n", entry.url);
					break;
				}
			}
		}
	}
	else if(strcmp(stemp, "ad") == 0)	//add
	{
		struct url_entryx	Entry;
		
		_ENTRY_STR(url, _NEED);
		_ENTRY_INT(port, _NEED);
		if(entry.port <= 0 || entry.port > 65535){lineno = __LINE__; goto check_err;}
		total = mib_chain_total(MIB_URL_TBL);
		for (idx=0; idx<total; idx++)
		{
			if (!mib_chain_get(MIB_URL_TBL, idx, (void *)&Entry)) {
				printf("get URL chain error!\n");
				goto check_err;
			}
			if (!gstrcmp(Entry.url, entry.url))
			{
				printf("URL has been existed!");
				goto check_ok;
			}
		}
		if (!mib_chain_add(MIB_URL_TBL, (void *)&entry)) {
			printf("add URL chain error!\n");
			goto check_err;
		}
	}
	else {lineno = __LINE__; goto check_err;}

	//write to flash
	mib_update(CURRENT_SETTING, CONFIG_MIB_ALL);
	
	//take effect
	if ( !mib_get(MIB_URL_FILTER_ENABLED, (void *)&urlfilterEnble))
		goto check_err;
	if ( !mib_get(MIB_URL_FILTER_MODE, (void *)&urlFilterMode))
		goto check_err;
	
	if (!urlfilterEnble)
		filter_set_url(0);
	else {
		if (urlFilterMode) //whitelist
			filter_set_url(2);
		else
			filter_set_url(1);
	}

check_ok:
	_COND_REDIRECT;

	return;
	
check_err:
	_BC_FREE();	
	_TRACE_LEAVEL;
	return;
}


/*****************************
** ȫ
*/
int initPageFirewall(int eid, webs_t wp, int argc, char_t ** argv)
{
	//ǽȼ:	
	unsigned char 	filterLevel=1;	// 1- ;  2- ;  3- 
	int				lineno = __LINE__;

	_TRACE_CALL;

	if (!mib_get(MIB_FW_GRADE, (void *)&filterLevel)) {
		printf("get fw grade fail\n");
	}

	_PUT_INT(filterLevel);

check_err:
	_TRACE_LEAVEL;
	return 0;
}

void formFirewall(webs_t wp, char_t *path, char_t *query)
{
	//ǽȼ:	
	unsigned char 	filterLevel;	//1- ;  2- ;  3- 
	char*			stemp = "";
	int				lineno = __LINE__;

	_TRACE_CALL;

	_GET_INT(filterLevel, _NEED);
	if(filterLevel > 3)	// out of range
	{
		lineno = __LINE__; goto check_err;
	}

	if (!mib_set(MIB_FW_GRADE, (void *)&filterLevel)) {
		printf("set firewall grade fail\n");
		goto check_err;
	}

	//write to flash
	mib_update(CURRENT_SETTING, CONFIG_MIB_ALL);

	//take effect
	changeFwGrade(filterLevel);
	
	_COND_REDIRECT;
check_err:
	_TRACE_LEAVEL;
	return;
}


/*****************************
** 
*/
int initPageDos(int eid, webs_t wp, int argc, char_t ** argv)
{
	//ʹ:			
	unsigned int		dosEnble;	// 1- ʹ;  0- 
	int				lineno = __LINE__;

	_TRACE_CALL;

	if (!mib_get(MIB_DOS_ENABLED, (void *)&dosEnble)) {
		printf("get DOS fail\n");
	}

	_PUT_BOOL(dosEnble);

check_err:
	_TRACE_LEAVEL;
	return 0;
}

void formDos(webs_t wp, char_t *path, char_t *query)
{
	//ʹ:			
	unsigned int		dosEnble;	//1- ʹ;  0- 	
	char*			stemp = "";
	int				lineno = __LINE__;
	unsigned int lastStatus;

	_TRACE_CALL;

	_GET_BOOL(dosEnble, _NEED);

	if (!mib_get(MIB_DOS_ENABLED, (void *)&lastStatus))
		printf("get DOS failed!\n");
	
	if (!mib_set(MIB_DOS_ENABLED, (void *)&dosEnble)) {
		printf("set DOS failed!\n");
		goto check_err;
	}

	//write to flash
	mib_update(CURRENT_SETTING, CONFIG_MIB_ALL);

	//take effect
	if (lastStatus != dosEnble)
		setupDos();
	
	_COND_REDIRECT;
check_err:
	_TRACE_LEAVEL;
	return;
}
#ifdef MAC_FILTER_EBTABLES_SUPPORT
void changeMacFormat(char* str,char s,char d)
{
    int i=0;
    int length=strlen(str);
    for (i=0;i<length;i++)
    {
        if (str[i]==s) str[i]=d;
    }
}
/*****************************
** ŽMAC
*/
int brgMacFilterList(int eid, webs_t wp, int argc, char_t ** argv)
{
	//MACַʹ:		
	unsigned char 		macFilterEnble = 1;	//1- ʹ;  0- 
	//ģʽ:				
	unsigned char 		macFilterMode = 0;	//0- ;  1- 
	//struct brgmac_entry	entry = {1, 0, 0, 1, 0,"00-11-22-33-44-55", "11-11-22-33-44-55" };
	char				ifname[1024] = "INTERNET_R_0_0_32";
	int					cnt = 2;
	int					index = 0;
	int					lineno = __LINE__;

	_TRACE_CALL;

	/************Place your code here, do what you want to do! ************/
	cnt=mib_chain_total(MIB_MAC_FILTER_EBTABLES_TBL);
	mib_get(MIB_MAC_FILTER_EBTABLES_ENABLE,&macFilterEnble);
	mib_get(MIB_MAC_FILTER_EBTABLES_MODE,&macFilterMode);
	/************Place your code here, do what you want to do! ************/

	_PUT_BOOL(macFilterEnble);
	_PUT_BOOL(macFilterMode);
	
	for(index = 0; index < cnt; index++)
	{
		memset(ifname, 0, sizeof(ifname));

		/************Place your code here, do what you want to do! ************/
		struct brgmac_entry entry;
		mib_chain_get(MIB_MAC_FILTER_EBTABLES_TBL,index,&entry);	
		int i=0;
		for(i=0;i<entry.portNum;i++)
		{
			char name[256]={0};	
			MIB_CE_ATM_VC_T pvc_entry;
			{
				getWanEntrybyindex(&pvc_entry, entry.ifIndex[i]);
				getWanName(&pvc_entry, name);
				strcat(ifname,name);
				if(i!=entry.portNum-1)
					strcat(ifname,"/");
			}
		}	
		changeMacFormat(entry.dmac,':','-');
		changeMacFormat(entry.smac,':','-');
		/************Place your code here, do what you want to do! ************/
		
		websWrite(wp, T("push(new it_nr(\"%d\"" _PTS _PTS _PTI _PTI _PTI _PTI _PTS "));\n"), 
			index, _PME(dmac), _PME(smac), _PME(protoType), _PME(direction), 
			_PME(allPort), _PME(portNum), "ifname",ifname);
		
	}
		
check_err:
	_TRACE_LEAVEL;
	return 0;
}

void formBrgMacFilter(webs_t wp, char_t *path, char_t *query)
{
	//MACַʹ:		
	unsigned char 		macFilterEnble = 0;	//1- ʹ;  0- 
	//ģʽ:				
	unsigned char 		macFilterMode = 0;	//0- ;  1- 
	struct brgmac_entry	entry;
	char				ifname[1024];
	char*				stemp = "";
	char*				send = NULL;
	char*				stoken = NULL;
	char**				ppifs = NULL;
	int					index = 0;
	int					lineno = __LINE__;
	_BC_USE;
	memset(&entry,0,sizeof(struct brgmac_entry));
	FETCH_INVALID_OPT(stemp, "action", _NEED); 	
	if(strcmp(stemp, "sw") == 0)	//switch
	{
		_GET_BOOL(macFilterEnble, _NEED);		
		/************Place your code here, do what you want to do! ************/
		printf("macFilterEnble=%d\n",macFilterEnble);
		mib_set(MIB_MAC_FILTER_EBTABLES_ENABLE,&macFilterEnble);
		//macFilterMode=0;//default is black list
		//mib_set(MIB_MAC_FILTER_EBTABLES_MODE,&macFilterMode);
		/************Place your code here, do what you want to do! ************/
	}else if(strcmp(stemp,"modesw")==0){
		_GET_BOOL(macFilterMode, _NEED);
		mib_chain_clear(MIB_MAC_FILTER_EBTABLES_TBL);	
		mib_set(MIB_MAC_FILTER_EBTABLES_MODE,&macFilterMode);	
	}
	else if(strcmp(stemp, "rm") == 0)	//remove
	{
		_BC_INIT("bcdata");
		while(_BC_NEXT())
		{
			memset(ifname, 0, sizeof(ifname));
			
			_BC_ENTRY_STR(dmac, _OPT);
			_BC_ENTRY_STR(smac, _OPT);
			_BC_ENTRY_INT(protoType, _OPT);
			_BC_ENTRY_INT(direction, _OPT);
			_BC_ENTRY_INT(allPort, _OPT);
			_BC_ENTRY_INT(portNum,OPT);
			
			/************Place your code here, do what you want to do! ************/
			/*remove*/
			char *itf;
			itf=bc_gets(bc,"ifname");
			strncpy(ifname, itf, sizeof(ifname));
			stoken = &ifname[0];
			send = strchr(stoken, '/');
			index = 0;
			while(stoken && index < entry.portNum)
			{
				if(send)*send = '\0';
				
				//ppifs[index] = stoken;				
				entry.ifIndex[index]=getifIndexByWanName(stoken);		
				printf("entry[%d]=%d\n",index,entry.ifIndex[index]);
				if(send == NULL)break;
				stoken = send + 1;
				send = strchr(stoken, '/');
				index++;
			}		
			/************Place your code here, do what you want to do! ************/
			int t=0;
			char *bugentry=(char*)&entry;			
			changeMacFormat(entry.smac,'-',':');
			changeMacFormat(entry.dmac,'-',':');
			MIB_CHAIN_DELETE(MIB_MAC_FILTER_EBTABLES_TBL, struct brgmac_entry, entry)
		}
	}
	else if(strcmp(stemp, "ad") == 0)	//add
	{
		memset(ifname, 0, sizeof(ifname));
		if(mib_chain_total(MIB_MAC_FILTER_EBTABLES_TBL)>=MAC_FILTER_BRIDGE_RULES)
			{
			ERR_MSG("Բ,Ѵ!");
			goto check_err;
			}
		_ENTRY_STR(dmac, _OPT);
		_ENTRY_STR(smac, _OPT);
		_ENTRY_INT(protoType, _OPT);
		if(entry.protoType < 0 || entry.protoType > 7){lineno = __LINE__; goto check_err;}
		_ENTRY_INT(direction, _OPT);
		if(entry.direction < 0 || entry.direction > 2){lineno = __LINE__; goto check_err;}
		_ENTRY_INT(allPort, _OPT);
		if(entry.allPort < 0 || entry.allPort > 1){lineno = __LINE__; goto check_err;}
		if(!entry.allPort)
		{
			_ENTRY_INT(portNum, _NEED);
			if(entry.portNum < 0 || entry.portNum > 256){lineno = __LINE__; goto check_err;}
			FETCH_INVALID_OPT(stemp, "ifname", _OPT);
			strncpy(ifname, stemp, sizeof(ifname));
			//if(ppifs) {free(ppifs); ppifs = NULL;}
			//ppifs = (char**)malloc((entry.portNum + 1) * sizeof(char*));
			stoken = &ifname[0];
			send = strchr(stoken, ';');
			index = 0;
			while(stoken && index < entry.portNum)
			{
				if(send)*send = '\0';
				
				//ppifs[index] = stoken;
				entry.ifIndex[index]=atoi(stoken);
				printf("ifIndex=%d\n",entry.ifIndex[index]);
				if(send == NULL)break;
				stoken = send + 1;
				send = strchr(stoken, ';');
				index++;
			}
		}
		
		/************Place your code here, do what you want to do! ************/
		//fix the mac format form xx-xx-xx-xx-xx-xx to xx:xx:xx:xx:xx
		changeMacFormat(entry.smac,'-',':');
		changeMacFormat(entry.dmac,'-',':');		
		mib_chain_add(MIB_MAC_FILTER_EBTABLES_TBL,&entry);
		/************Place your code here, do what you want to do! ************/
	}
	else {lineno = __LINE__; goto check_err;}

	if (!mib_get(MIB_MAC_FILTER_EBTABLES_ENABLE, &macFilterEnble))
		macFilterEnble = 0;
	if (macFilterEnble)
		setupEbtables(EBTABLES_ENABLED);
	else
		setupEbtables(EBTABLES_DISABLED);
	
	mib_update(CURRENT_SETTING, CONFIG_MIB_ALL);
	_COND_REDIRECT;
check_err:
	_BC_FREE();
	if(ppifs) {free(ppifs); ppifs = NULL;}
	_TRACE_LEAVEL;
	return;
}


/*****************************
** ·MAC
*/
int rteMacFilterList(int eid, webs_t wp, int argc, char_t ** argv)
{
	struct routemac_entry	entry = {"00-11-22-33-44-55", "INTERNET_R_0_0_32"};
	int					cnt = 2;
	int					index = 0;
	int					lineno = __LINE__;

	_TRACE_CALL;

	/************Place your code here, do what you want to do! ************/
	cnt=mib_chain_total(MIB_MAC_FILTER_ROUTER_TBL);
	/************Place your code here, do what you want to do! ************/

	for(index = 0; index < cnt; index++)
	{
		/************Place your code here, do what you want to do! ************/
		memset(&entry,0,sizeof(struct routemac_entry));
		mib_chain_get(MIB_MAC_FILTER_ROUTER_TBL,index,&entry);
		/************Place your code here, do what you want to do! ************/
		changeMacFormat(entry.mac,':','-');
		websWrite(wp, T("push(new it_nr(\"%d\"" _PTS _PTS "));\n"), 
			index, _PME(devname), _PME(mac));
	}
	_TRACE_LEAVEL;
	return 0;
}

void formRteMacFilter(webs_t wp, char_t *path, char_t *query)
{
	struct routemac_entry	entry;
	char*				stemp = "";
	int					index = 0;
	int					lineno = __LINE__;
	unsigned char 		macFilterEnble = 0;
	_BC_USE;

	_TRACE_CALL;	
	FETCH_INVALID_OPT(stemp, "action", _NEED);
	
	if(strcmp(stemp, "rm") == 0)	//remove
	{
		_BC_INIT("bcdata");
		while(_BC_NEXT())
		{
			_BC_ENTRY_STR(devname, _OPT);
			_BC_ENTRY_STR(mac, _OPT);
			changeMacFormat(entry.mac,'-',':');
			/************Place your code here, do what you want to do! ************/
			/*remove*/
			MIB_CHAIN_DELETE(MIB_MAC_FILTER_ROUTER_TBL,struct routemac_entry,entry);
			/************Place your code here, do what you want to do! ************/
		}
	}
	else if(strcmp(stemp, "ad") == 0)	//add
	{
		if(mib_chain_total(MIB_MAC_FILTER_ROUTER_TBL)>=MAC_FILTER_ROUTER_RULES)
			{
			ERR_MSG("Բ,Ѵ!");
			goto check_err;
			}
		_ENTRY_STR(devname, _NEED);
		_ENTRY_STR(mac, _NEED);
		
		/************Place your code here, do what you want to do! ************/
		changeMacFormat(entry.mac,'-',':');
	   	mib_chain_add(MIB_MAC_FILTER_ROUTER_TBL,&entry);
		/************Place your code here, do what you want to do! ************/
	}
	else {lineno = __LINE__; goto check_err;}

	if (!mib_get(MIB_MAC_FILTER_EBTABLES_ENABLE, &macFilterEnble))
		macFilterEnble = 0;
	if (macFilterEnble)
		setupEbtables(EBTABLES_ENABLED);
	else
		setupEbtables(EBTABLES_DISABLED);
	
	mib_update(CURRENT_SETTING, CONFIG_MIB_ALL);
	_COND_REDIRECT;
check_err:
	_BC_FREE();
	_TRACE_LEAVEL;
	return;
}
#endif
/*****************************
** ˿ڹ
*/
int ipPortFilterConfig(int eid, webs_t wp, int argc, char_t ** argv)
{
	//IPַ:	
	unsigned char 				ipfilterEnable = 0;	//1- ;  0- 
	int							lineno = __LINE__;

	_TRACE_CALL;

	/************Place your code here, do what you want to do! ************/
	mib_get(MIB_IPFILTER_ON_OFF, (void*)&ipfilterEnable);
	/************Place your code here, do what you want to do! ************/

	_PUT_BOOL(ipfilterEnable);

check_err:
	_TRACE_LEAVEL;
	return 0;
}

void formPortFilter(webs_t wp, char_t *path, char_t *query)
{
	//IPַ:	
	unsigned char 		ipfilterEnable = 0;		//1- ;  0- 
	char*				stemp = "";
	int					lineno = __LINE__;
       unsigned char 		original_state=0;
	_TRACE_CALL;

	_GET_BOOL(ipfilterEnable, _NEED);

	/************Place your code here, do what you want to do! ************/
#ifdef IP_FILTER_ONOFF_SUPPORT
	mib_get(MIB_IPFILTER_ON_OFF, (void*)&original_state); 
	if(ipfilterEnable)
		ipfilterEnable=1;
	//printf("new=%d, old=%d, new^old=%d\n",ipfilterEnable, original_state, (ipfilterEnable^original_state));
	if(ipfilterEnable^original_state)
	{//mib set only if ipfitler switch changed...
		//printf("###%d###\n", ipfilterEnable);
		mib_set(MIB_IPFILTER_ON_OFF, (void*)&ipfilterEnable);
		//take effect immediate...
		setupFirewall();
		//Write to flash, take effect forever
		mib_update(CURRENT_SETTING, CONFIG_MIB_ALL);
	}
#endif	
	/************Place your code here, do what you want to do! ************/

	_COND_REDIRECT;
check_err:
	_TRACE_LEAVEL;
	return;
}

//DIR_OUT 0
//DIR_IN    1
int parseIpFilterInfo2Entry(struct ipfilter_blacklist_entry *entry, MIB_CE_IP_PORT_FILTER_T *filterEntry, int direction)
{
	unsigned long mask, mbit;		
	memset(filterEntry, 0x00, sizeof(MIB_CE_IP_PORT_FILTER_T));
	strncpy(filterEntry->name, entry->filterName, 32);
	switch(entry->protoType)
	{
		case 0:
			filterEntry->protoType=PROTO_NONE;
			break;
		case 1:
			filterEntry->protoType=PROTO_UDPTCP;
			break;
		case 2:
			filterEntry->protoType=PROTO_TCP;
			break;
		case 3:
			filterEntry->protoType=PROTO_UDP;
			break;
		case 4:
			filterEntry->protoType=PROTO_ICMP;
			break;
	}
	memcpy(filterEntry->srcIp, &entry->sipStart, 4);
	memcpy(filterEntry->srcIp2, &entry->sipEnd, 4);		
	memcpy(filterEntry->dstIp, &entry->dipStart, 4);
	memcpy(filterEntry->dstIp2, &entry->dipEnd, 4);
	filterEntry->srcPortFrom=entry->sportStart;
	filterEntry->srcPortTo=entry->sportEnd;		
	filterEntry->dstPortFrom=entry->dportStart;
	filterEntry->dstPortTo=entry->dportEnd;		
	filterEntry->dir=direction;
	mask=entry->smask;
	mbit=0;				
	while (1) {
		if (mask&0x80000000) {
			mbit++;
			mask <<= 1;
		}
		else
			break;
	}				
	filterEntry->smaskbit = mbit;
	mask=entry->dmask;
	mbit=0;				
	while (1) {
		if (mask&0x80000000) {
			mbit++;
			mask <<= 1;
		}
		else
			break;
	}				
	filterEntry->dmaskbit = mbit;
	if(direction == DIR_OUT)
		filterEntry->action=0; //deny
	else
		filterEntry->action=1; //allow
	return 0;
}

// caculate the total entry numbers at one direction (incoming or outgoing)
int getTotalIPFilterNumOneDirection(int dir)
{
	int entrynum=0;
	int totalentrynum=0;
	int index;
	MIB_CE_IP_PORT_FILTER_T Entry;
	totalentrynum = mib_chain_total(MIB_IP_PORT_FILTER_TBL);
	for(index = 0; index < totalentrynum; index++)
	{
		if (!mib_chain_get(MIB_IP_PORT_FILTER_TBL, index, (void *)&Entry))
		{
  			return 0;
		}
		if (Entry.dir == dir) 
		{
			entrynum++;
		}
	}
	return entrynum;
}
//dir DIR_IN    1
//     DIR_OUT 0
// pIndex tell caller the found entry's index in table, if can.
// ret   1: the entry found , otherwise not found...
int findIPFilterEntrybyNameDirection(char *name, int dir, MIB_CE_IP_PORT_FILTER_T *pEntry, int *pIndex)
{
	int entrynum=0;
	int index;
	MIB_CE_IP_PORT_FILTER_T Entry;
	entrynum = mib_chain_total(MIB_IP_PORT_FILTER_TBL);
	for(index = 0; index < entrynum; index++)
	{
		if (!mib_chain_get(MIB_IP_PORT_FILTER_TBL, index, (void *)&Entry))
		{
  			return 0;
		}
		if (Entry.dir != dir) //bypass the reversed direction rules...
			continue;
		if(!strncmp(Entry.name, name , sizeof(Entry.name)))
		{
			if(pEntry)
				memcpy(pEntry, &Entry, sizeof(MIB_CE_IP_PORT_FILTER_T));
			if(pIndex)
				*pIndex=index;
			//found the entry by name and direction
			return 1;
		}
	}
	//not found the wanted entry....
	return 0;
}
int ipPortFilterBlacklist (int eid, webs_t wp, int argc, char_t ** argv)
{
	//IPַ:	
	struct ipfilter_blacklist_entry	entry = {"test", 1, 0x10101010, 0x11101010, 0x00FFFFFF, 80, 81, 0x10101010, 0x11101010, 0x00FFFFFF, 80, 81};
	char						sipStart[16];
	char						sipEnd[16];
	char						smask[16];
	char						dipStart[16];
	char						dipEnd[16];
	char						dmask[16];
	int							cnt = 2;
	int							index = 0;
	int							lineno = __LINE__;

	_TRACE_CALL;

	/************Place your code here, do what you want to do! ************/
	MIB_CE_IP_PORT_FILTER_T Mib_Entry;
	cnt = mib_chain_total(MIB_IP_PORT_FILTER_TBL);
	/************Place your code here, do what you want to do! ************/

	for(index = 0; index < cnt; index++)
	{
		/************Place your code here, do what you want to do! ************/
		memset(&entry, 0, sizeof(entry));
		if (!mib_chain_get(MIB_IP_PORT_FILTER_TBL, index, (void *)&Mib_Entry))
		{
  			websError(wp, 400, T("Get chain record error!\n"));
			return -1;
		}
		if (Mib_Entry.dir == DIR_IN) //incoming rules, which belong to white list...
		{
			continue;
		}
		memcpy(entry.filterName, Mib_Entry.name, sizeof(entry.filterName));
		switch(Mib_Entry.protoType)
		{
			case PROTO_NONE:
				entry.protoType=0;
				break;
			case PROTO_UDPTCP:
				entry.protoType=1;
				break;
			case PROTO_TCP:
				entry.protoType=2;
				break;
			case PROTO_UDP:
				entry.protoType=3;
				break;
			case PROTO_ICMP:
				entry.protoType=4;
				break;
		}
		memcpy(&entry.sipStart, Mib_Entry.srcIp, 4);
		memcpy(&entry.sipEnd, Mib_Entry.srcIp2, 4);
		entry.smask=0xFFFFFFFF;
		if(Mib_Entry.smaskbit !=0)
			entry.smask =entry.smask<<(32-Mib_Entry.smaskbit);
		else
			entry.smask=0;
		memcpy(&entry.dipStart, Mib_Entry.dstIp, 4);
		memcpy(&entry.dipEnd, Mib_Entry.dstIp2, 4);
		entry.dmask=0xFFFFFFFF;
		if(Mib_Entry.dmaskbit !=0)
			entry.dmask =(entry.dmask<<(32-Mib_Entry.dmaskbit));
		else
			entry.dmask=0;
		entry.sportStart=Mib_Entry.srcPortFrom;
		entry.sportEnd=Mib_Entry.srcPortTo;
		entry.dportStart=Mib_Entry.dstPortFrom;
		entry.dportEnd=Mib_Entry.dstPortTo;
		/************Place your code here, do what you want to do! ************/

		websWrite (wp, T ("push(new it_nr(\"%d\"" _PTS _PTI _PTS _PTS _PTS _PTS _PTS _PTS _PTI _PTI _PTI _PTI "));\n"), 
		index, _PME(filterName), _PME(protoType), 
		_PMEIP(sipStart), _PMEIP(sipEnd), _PMEIP(smask), _PMEIP(dipStart), _PMEIP(dipEnd), _PMEIP(dmask),
		_PME(sportStart), _PME(sportEnd), _PME(dportStart), _PME(dportEnd));
	}

check_err:
	_TRACE_LEAVEL;
	return 0;
}

int ipPortFilterWhitelist (int eid, webs_t wp, int argc, char_t ** argv)
{
	//IPַ:	
	struct ipfilter_whitelist_entry	entry = {"test", 1, 0x10101010, 0x11101010, 0x00FFFFFF, 80, 81, 0x10101010, 0x11101010, 0x00FFFFFF, 80, 81, 0, 2, NULL};
	char						sipStart[16];
	char						sipEnd[16];
	char						smask[16];
	char						dipStart[16];
	char						dipEnd[16];
	char						dmask[16];
	char						ifname[1024] = "INTERNET_R_0_0_32;INTERNET_R_0_8_35";
	int							cnt = 2;
	int							index = 0;
	int							lineno = __LINE__;

	_TRACE_CALL;

	/************Place your code here, do what you want to do! ************/
	MIB_CE_IP_PORT_FILTER_T Mib_Entry;
	cnt = mib_chain_total(MIB_IP_PORT_FILTER_TBL);
	/************Place your code here, do what you want to do! ************/

	for(index = 0; index < cnt; index++)
	{
		/************Place your code here, do what you want to do! ************/
		memset(&entry, 0, sizeof(entry));
		if (!mib_chain_get(MIB_IP_PORT_FILTER_TBL, index, (void *)&Mib_Entry))
		{
  			websError(wp, 400, T("Get chain record error!\n"));
			return -1;
		}
		if (Mib_Entry.dir == DIR_OUT) //outgoing rules, which belong to black list...
		{
			continue;
		}
		memcpy(entry.filterName, Mib_Entry.name, sizeof(entry.filterName));
		switch(Mib_Entry.protoType)
		{
			case PROTO_NONE:
				entry.protoType=0;
				break;
			case PROTO_UDPTCP:
				entry.protoType=1;
				break;
			case PROTO_TCP:
				entry.protoType=2;
				break;
			case PROTO_UDP:
				entry.protoType=3;
				break;
			case PROTO_ICMP:
				entry.protoType=4;
				break;
		}
		memcpy(&entry.sipStart, Mib_Entry.srcIp, 4);
		memcpy(&entry.sipEnd, Mib_Entry.srcIp2, 4);
		entry.smask=0xFFFFFFFF;
		if(Mib_Entry.smaskbit !=0)
			entry.smask =entry.smask<<(32-Mib_Entry.smaskbit);
		else
			entry.smask=0;
		memcpy(&entry.dipStart, Mib_Entry.dstIp, 4);
		memcpy(&entry.dipEnd, Mib_Entry.dstIp2, 4);
		entry.dmask=0xFFFFFFFF;
		if(Mib_Entry.dmaskbit !=0)
			entry.dmask =(entry.dmask<<(32-Mib_Entry.dmaskbit));
		else
			entry.dmask=0;
		entry.sportStart=Mib_Entry.srcPortFrom;
		entry.sportEnd=Mib_Entry.srcPortTo;
		entry.dportStart=Mib_Entry.dstPortFrom;
		entry.dportEnd=Mib_Entry.dstPortTo;
		/************Place your code here, do what you want to do! ************/

		websWrite (wp, T ("push(new it_nr(\"%d\"" _PTS _PTI _PTS _PTS _PTS _PTS _PTS _PTS _PTI _PTI _PTI _PTI _PTI _PTI _PTS "));\n"), 
		index, _PME(filterName), _PME(protoType), 
		_PMEIP(sipStart), _PMEIP(sipEnd), _PMEIP(smask), _PMEIP(dipStart), _PMEIP(dipEnd), _PMEIP(dmask),
		_PME(sportStart), _PME(sportEnd), _PME(dportStart), _PME(dportEnd), _PME(allport), _PME(portnum), _PMEX(ifname));
	}
	_TRACE_LEAVEL;
	return 0;
}

void formPortFilterBlack(webs_t wp, char_t *path, char_t *query)
{
	struct ipfilter_blacklist_entry	entry;
	char*				stemp = "";
	int					lineno = __LINE__;
	int					index = 0;
	_BC_USE;

	_TRACE_CALL;

	FETCH_INVALID_OPT(stemp, "action", _NEED);
	
	if(strcmp(stemp, "rm") == 0)	//remove
	{
		_BC_INIT("bcdata");
		while(_BC_NEXT())
		{
			memset(&entry, 0, sizeof(entry));
			_BC_ENTRY_STR(filterName, _OPT);
			_BC_ENTRY_INT(protoType, _OPT);
			_BC_ENTRY_IP(sipStart, _OPT);
			_BC_ENTRY_IP(sipEnd, _OPT);
			_BC_ENTRY_IP(smask, _OPT);
			_BC_ENTRY_INT(sportStart, _OPT);
			_BC_ENTRY_INT(sportEnd, _OPT);
			_BC_ENTRY_IP(dipStart, _OPT);
			_BC_ENTRY_IP(dipEnd, _OPT);
			_BC_ENTRY_IP(dmask, _OPT);
			_BC_ENTRY_INT(dportStart, _OPT);
			_BC_ENTRY_INT(dportEnd, _OPT);
			/************Place your code here, do what you want to do! ************/
			/*remove*/
			if(findIPFilterEntrybyNameDirection(entry.filterName, DIR_OUT, NULL, &index))
				mib_chain_delete(MIB_IP_PORT_FILTER_TBL, index);			
			/************Place your code here, do what you want to do! ************/
		}
		//take effect immediately...
		setupFirewall();
	}
	else if(strcmp(stemp, "ad") == 0)	//add
	{
		memset(&entry, 0, sizeof(entry));

		_ENTRY_STR(filterName, _NEED);
		_ENTRY_INT(protoType, _NEED);
		if(entry.protoType < 0 || entry.protoType > 4){lineno = __LINE__; goto check_err;}
		_ENTRY_IP(sipStart, _OPT);
		_ENTRY_IP(sipEnd, _OPT);
		_ENTRY_IP(smask, _OPT);
		_ENTRY_IP(dipStart, _OPT);
		_ENTRY_IP(dipEnd, _OPT); 
		_ENTRY_IP(dmask, _OPT); 
		_ENTRY_INT(sportStart, _OPT);
		if(entry.sportStart < 0 || entry.sportStart > 65535){lineno = __LINE__; goto check_err;}
		_ENTRY_INT(sportEnd, _OPT);
		if(stemp && *stemp != 0)
		{
			if(entry.sportEnd < entry.sportStart || entry.sportEnd > 65535){lineno = __LINE__; goto check_err;}
		}

		_ENTRY_INT(dportStart, _OPT);
		if(entry.dportStart < 0 || entry.dportStart > 65535){lineno = __LINE__; goto check_err;}
		_ENTRY_INT(dportEnd, _OPT);
		if(stemp && *stemp != 0)
		{
			if(entry.dportEnd < entry.dportStart || entry.dportEnd > 65535){lineno = __LINE__; goto check_err;}
		}

		/************Place your code here, do what you want to do! ************/
		/*add new*/
		//jim double check the parameters validity.
		if(!entry.sipStart)
		{
			entry.smask=0;
			entry.sipEnd=0;
		}
		if(!entry.dipStart)
		{
			entry.dmask=0;
			entry.dipEnd=0;
		}
		if(entry.protoType == 0) //None proto... don't care ,, all.
		{    //mask off port info...
			entry.sportStart=0;
			entry.sportEnd=0;
			entry.dportStart=0;
			entry.dportEnd=0;
		}
		{		// IP/Port FILTER
			MIB_CE_IP_PORT_FILTER_T filterEntry;
			// if the exist entry with the same name, abandon the add action...
			if(findIPFilterEntrybyNameDirection(entry.filterName, DIR_OUT, NULL, NULL) \
				|| getTotalIPFilterNumOneDirection(DIR_OUT) > MAX_OUTGOING_IPFILTER_RULE_NUM)
				goto check_err;
			parseIpFilterInfo2Entry(&entry, &filterEntry, DIR_OUT);
			if(mib_chain_add(MIB_IP_PORT_FILTER_TBL, (unsigned char*)&filterEntry) != 1)
				goto check_err;
			//take effect immediate
			setupFirewall();
		}
		/************Place your code here, do what you want to do! ************/
	}
	else {lineno = __LINE__; goto check_err;}
	//Write to flash, take effect forever
	mib_update(CURRENT_SETTING, CONFIG_MIB_ALL);
	_COND_REDIRECT;
check_err:
	_BC_FREE();
	_TRACE_LEAVEL;
	ERR_MSG("趨!");
	return;
}

void formPortFilterWhite(webs_t wp, char_t *path, char_t *query)
{
	struct ipfilter_whitelist_entry	entry;
	char				isblack = 0;
	char*				slist = NULL;
	char*				stemp = "";
	char*				send = NULL;
	char*				stoken = NULL;
	int					lineno = __LINE__;
	int					index = 0;
	char				iffs[20][20];	//ӿб
	_BC_USE;

	_TRACE_CALL;

	FETCH_INVALID_OPT(stemp, "action", _NEED);
	
	if(strcmp(stemp, "rm") == 0)	//remove
	{
		_BC_INIT("bcdata");
		while(_BC_NEXT())
		{
			memset(&entry, 0, sizeof(entry));
			_BC_ENTRY_STR(filterName, _OPT);
			_BC_ENTRY_INT(protoType, _OPT);
			_BC_ENTRY_IP(sipStart, _OPT);
			_BC_ENTRY_IP(sipEnd, _OPT);
			_BC_ENTRY_IP(smask, _OPT);
			_BC_ENTRY_INT(sportStart, _OPT);
			_BC_ENTRY_INT(sportEnd, _OPT);
			_BC_ENTRY_IP(dipStart, _OPT);
			_BC_ENTRY_IP(dipEnd, _OPT);
			_BC_ENTRY_IP(dmask, _OPT);
			_BC_ENTRY_INT(dportStart, _OPT);
			_BC_ENTRY_INT(dportEnd, _OPT);
			/************Place your code here, do what you want to do! ************/
			/*remove*/
			if(findIPFilterEntrybyNameDirection(entry.filterName, DIR_IN, NULL, &index))
				mib_chain_delete(MIB_IP_PORT_FILTER_TBL, index);		
			/************Place your code here, do what you want to do! ************/
		}
		//take effect immediately
		setupFirewall();
	}
	else if(strcmp(stemp, "ad") == 0)	//add
	{
		memset(&entry, 0, sizeof(entry));

		_ENTRY_STR(filterName, _NEED);
		_ENTRY_INT(protoType, _NEED);
		if(entry.protoType < 0 || entry.protoType > 4){lineno = __LINE__; goto check_err;}
		_ENTRY_IP(sipStart, _OPT);
		_ENTRY_IP(sipEnd, _OPT);
		_ENTRY_IP(smask, _OPT);
		_ENTRY_IP(dipStart, _OPT);
		_ENTRY_IP(dipEnd, _OPT);
		_ENTRY_IP(dmask, _OPT);
		_ENTRY_INT(sportStart, _OPT);
		if(entry.sportStart < 0 || entry.sportStart > 65535){lineno = __LINE__; goto check_err;}
		_ENTRY_INT(sportEnd, _OPT);
		if(stemp && *stemp != 0)
		{
			if(entry.sportEnd < entry.sportStart || entry.sportEnd > 65535){lineno = __LINE__; goto check_err;}
		}

		_ENTRY_INT(dportStart, _OPT);
		if(entry.dportStart < 0 || entry.dportStart > 65535){lineno = __LINE__; goto check_err;}
		_ENTRY_INT(dportEnd, _OPT);
		if(stemp && *stemp != 0)
		{
			if(entry.dportEnd < entry.dportStart || entry.dportEnd > 65535){lineno = __LINE__; goto check_err;}
		}

/*
	//closed by jim ,we current do not support ip filter bound with interface...
		_ENTRY_BOOL(allport, _NEED);
		if(entry.allport < 0 || entry.allport > 1){lineno = __LINE__; goto check_err;}
		if(entry.allport == 0)
		{
			_ENTRY_INT(portnum, _NEED);
			if(entry.portnum < 0 || entry.portnum >= 20){lineno = __LINE__; goto check_err;}
			if(entry.portnum){FETCH_INVALID_OPT(stemp, "ifname", _NEED); stoken = stemp;}
			for(index = 0; stemp && index < entry.portnum; index++)
			{
				stemp = strchr(stoken, ';');
				if(stemp)*stemp = 0;
				strncpy(iffs[index], stoken, 20);
				stoken = stemp ? stemp + 1: NULL;
			}
		}
*/	
		//jim double check the parameters validity.
		if(!entry.sipStart)
		{
			entry.smask=0;
			entry.sipEnd=0;
		}
		if(!entry.dipStart)
		{
			entry.dmask=0;
			entry.dipEnd=0;
		}
		if(entry.protoType == 0) //None proto... don't care ,, all.
		{    //mask off port info...
			entry.sportStart=0;
			entry.sportEnd=0;
			entry.dportStart=0;
			entry.dportEnd=0; 
		}
		/************Place your code here, do what you want to do! ************/
		{		// IP/Port FILTER
			MIB_CE_IP_PORT_FILTER_T filterEntry;
			// if the exist entry with the same name, abandon the add action...
			if(findIPFilterEntrybyNameDirection(entry.filterName, DIR_IN, NULL, NULL) \
				|| getTotalIPFilterNumOneDirection(DIR_IN) > MAX_INCOMING_IPFILTER_RULE_NUM)
				goto check_err;
			parseIpFilterInfo2Entry(&entry, &filterEntry, DIR_IN);
			if(mib_chain_add(MIB_IP_PORT_FILTER_TBL, (unsigned char*)&filterEntry) != 1)
				goto check_err;
			//take effect immediate
			setupFirewall();
			
		}
		/************Place your code here, do what you want to do! ************/
	}
	else {lineno = __LINE__; goto check_err;}
		//Write to flash, take effect forever
	mib_update(CURRENT_SETTING, CONFIG_MIB_ALL);
	_COND_REDIRECT;
check_err:
	_BC_FREE();
	_TRACE_LEAVEL;
	ERR_MSG("趨!");
	return;
}

