/*
 *      Web server handler routines for TCP/IP stuffs
 *      Authors: David Hsu	<davidhsu@realtek.com.tw>
 *      Authors: Dick Tam	<dicktam@realtek.com.tw>
 *
 */


/*-- System inlcude files --*/
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <dirent.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <signal.h>
#include <netinet/in.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <sys/wait.h>
#include <time.h>
#include <net/route.h>
#include <sys/ioctl.h>
#include <signal.h>
#include <sys/ioctl.h>
#include <net/if.h>

/*-- Local inlcude files --*/
#include "../webs.h"
#include "webform.h"
#include "mib.h"
#include "../defs.h"
#include <config/autoconf.h>

#define	CONFIG_DIR	"/var/config"
#define CA_FNAME	CONFIG_DIR"/cacert.pem"
#define CERT_FNAME	CONFIG_DIR"/client.pem"

#ifdef CONFIG_BOA_WEB_E8B_CH
#define RECONNECT_MSG(url) { \
	websHeader(wp); \
	websWrite(wp, T("<body><blockquote><h4>%s" \
                "<form><input type=button value=\"%s\" OnClick=window.location.replace(\"%s\")></form></blockquote></body>"),\
                TAdmin_tr069_change, TAdmin_tr069_ok,url);\
	websFooter(wp); \
	websDone(wp, 200); \
}


#define UPLOAD_MSG(url) { \
	websHeader(wp); \
	websWrite(wp, T("<body><blockquote><h4>%s" \
                "<form><input type=button value=\"%s\" OnClick=window.location.replace(\"%s\")></form></blockquote></body>"), \
                TAdmin_tr069_uploadf,TAdmin_tr069_ok,url);\
	websFooter(wp); \
	websDone(wp, 200); \
}
#else
#define RECONNECT_MSG(url) { \
	websHeader(wp); \
	websWrite(wp, T("<body><blockquote><h4>%s" \
                "<form><input type=button value=\"%s\" OnClick=window.location.replace(\"%s\")></form></blockquote></body>"),\
                TAdmin_tr069_change, TAdmin_tr069_ok, url);\
	websFooter(wp); \
	websDone(wp, 200); \
}


#define UPLOAD_MSG(url) { \
	websHeader(wp); \
	websWrite(wp, T("<body><blockquote><h4>%s" \
                "<form><input type=button value=\"%s\" OnClick=window.location.replace(\"%s\")></form></blockquote></body>"), \
                TAdmin_tr069_uploadf,TAdmin_tr069_ok,url);\
	websFooter(wp); \
	websDone(wp, 200); \
}
#endif

//copy from fmmgmt.c
//find the start and end of the upload file.
FILE * uploadGetCert(request *wp, unsigned int *startPos, unsigned *endPos)
{
	FILE *fp=NULL;	
	struct stat statbuf;	
	unsigned char c, *buf; 
	char boundary[80];

	
	if (wp->method == M_POST)
	{
		int i;
		
	        fstat(wp->post_data_fd, &statbuf);
		lseek(wp->post_data_fd, SEEK_SET, 0);
      
		printf("file size=%d\n",statbuf.st_size);
		fp=fopen(wp->post_file_name,"rb");
		if(fp==NULL) goto error;
		
		memset( boundary, 0, sizeof( boundary ) );
		if( fgets( boundary,80,fp )==NULL ) goto error;
		if( boundary[0]!='-' || boundary[1]!='-') goto error;
		
		i= strlen( boundary ) - 1;
		while( boundary[i]=='\r' || boundary[i]=='\n' )
		{
			boundary[i]='\0';
			i--;
		}		
		printf( "boundary=%s\n", boundary );
	}
	else goto error;

   
   	//printf("_uploadGet\n");
   	do
   	{
		if(feof(fp))
		{
			printf("Cannot find start of file\n");
			goto error;
		}
		c= fgetc(fp);
		if (c!=0xd)
			continue;
		c= fgetc(fp);
		if (c!=0xa)
			continue;
		c= fgetc(fp);
		if (c!=0xd)
			continue;
		c= fgetc(fp);
		if (c!=0xa)
			continue;
		break;
	}while(1);
	(*startPos)=ftell(fp);

   	if(fseek(fp,statbuf.st_size-0x200,SEEK_SET)<0) 
      		goto error;
    	
	do
	{
		if(feof(fp))
		{
			printf("Cannot find end of file\n");
			goto error;
		}
		c= fgetc(fp);
		if (c!=0xd)
			continue;
		c= fgetc(fp);
		if (c!=0xa)
			continue;

		{
			int i, blen;
			
			blen= strlen( boundary );
			for( i=0; i<blen; i++)
			{
				c= fgetc(fp);
				//printf("%c(%u)", c, c);
				if (c!=boundary[i])
				{
					ungetc( c, fp );
					break;
				}
			}
			//printf("\r\n");
			if( i!=blen ) continue;
		}

		break;
	}while(1);
	(*endPos)=ftell(fp)-strlen(boundary)-2;

   	return fp;
error:
   	return NULL;
}
///////////////////////////////////////////////////////////////////
//add by chenzhuoxin
void formTR069Config(webs_t wp, char_t *path, char_t *query)
{
       char_t *strVal = NULL;
       unsigned char informEnble;	   //0- ֹ;  1- 
       unsigned int informInterv;	         //λ: 
       char *pAcsUrl;
	char *pAcsUser;
	char *pAcsPass;
	unsigned char linkPermit;	        //1- û; 0- ֹ
	char * pConnReqName=0;
	char * pConnReqPasw=0;
#ifdef CONFIG_MIDDLEWARE
	unsigned char midwareEnable;
	unsigned char tr069Enable;
	char *midwareAddr;
	unsigned int midwarePort;
#endif
	char tmpBuf[100];
	char tmpStr[256+1];
	unsigned char vChar;
	unsigned int vInt;
	char changeflag=0;
	  
	printf("enter formTR069Config\n");
	//get informEnble
	strVal = websGetVar(wp, T("inform"), T(""));
	if(0 == strcmp(strVal,"on"))
		informEnble = 1;
	else
		informEnble = 0;
	printf("informEnble=%d\n",informEnble);

	//get informInterv
	strVal = websGetVar(wp, T("informInterval"), T(""));
      informInterv = atoi(strVal);
	printf("informInterv=%d\n",informInterv);

      //get pAcsUrl
	strVal = websGetVar(wp, T("acsURL"), T(""));
      pAcsUrl = strVal;
	printf("pAcsUrl=%s\n",pAcsUrl);

	//get pAcsUser
	strVal = websGetVar(wp, T("acsUser"), T(""));
      pAcsUser = strVal;
	printf("pAcsUser=%s\n",pAcsUser);

	//get pAcsPass
	strVal = websGetVar(wp, T("acsPwd"), T(""));
      pAcsPass = strVal;
	printf("pAcsPass=%s\n",pAcsPass);

	//get linkPermit
	strVal = websGetVar(wp, T("connReqAuth"), T(""));
	if(0 == strcmp(strVal,"on"))
		linkPermit = 1;
	else
		linkPermit = 0;
	printf("linkPermit=%d\n",linkPermit);

	if(linkPermit == 1){
		//get pConnReqName
		strVal = websGetVar(wp, T("connReqUser"), T(""));
	      pConnReqName = strVal;
		printf("pConnReqName=%s\n",pConnReqName);

		//get pConnReqPasw
		strVal = websGetVar(wp, T("connReqPwd"), T(""));
	      pConnReqPasw = strVal;
		printf("pConnReqPasw=%s\n",pConnReqPasw);
	}

#ifdef CONFIG_MIDDLEWARE
      //get midwareEnable
	strVal = websGetVar(wp, T("ctMDW"), T(""));{
		printf("%s\n",strVal);
	}
	if(0 == strcmp(strVal,"on"))
		midwareEnable = 1;
	else
		midwareEnable = 0;
	printf("midwareEnable=%d\n",midwareEnable);

	//get midwareAddr
	strVal = websGetVar(wp, T("mwsURLIP"), T(""));
	midwareAddr = strVal;
	printf("midwareAddr = %s\n",midwareAddr);
//	if(strVal)
//		if(0 != inet_aton(strVal,(struct in_addr *)&midwareAddr))
//			printf("midwareAddr = %s\n",midwareAddr);
//		else
//			midwareAddr = 0;

	//get midwarePort
	strVal = websGetVar(wp, T("mwsURLPort"), T(""));
      midwarePort = atoi(strVal);
	printf("midwarePort=%d\n",midwarePort);
#endif

//add by star
	mib_get( CWMP_INFORM_ENABLE, (void*)&vChar);
	if(vChar != informEnble){
		changeflag = 1;
		if ( !mib_set( CWMP_INFORM_ENABLE, (void *)&informEnble)) {
			strcpy(tmpBuf, T(strSetInformEnableerror));
			goto setErr_tr069;
		}
	}

	if(informEnble == 1){
		mib_get( CWMP_INFORM_INTERVAL, (void*)&vInt);
		if(vInt != informInterv){
			changeflag = 1;
			if ( !mib_set( CWMP_INFORM_INTERVAL, (void *)&informInterv)) {
				strcpy(tmpBuf, T(strSetInformIntererror));
				goto setErr_tr069;
			}
		}
	}

	{
#ifndef _CWMP_WITH_SSL_
		if ( strstr(pAcsUrl, "https://") )
		{
			strcpy(tmpBuf, T(strSSLWrong));
			goto setErr_tr069;
		}
#endif	
		mib_get( CWMP_ACS_URL, (void *)tmpStr);
		if(strcmp(tmpStr,pAcsUrl)!=0){
			changeflag = 1;
#if defined(CTC_WAN_NAME)&&defined(_CWMP_MIB_)
			if ( !mib_set( CWMP_ACS_URL_OLD, (void *)tmpStr)) 
			{
				strcpy(tmpBuf, T(strSetACSURLerror));
				goto setErr_tr069;
			}
#endif
			if ( !mib_set( CWMP_ACS_URL, (void *)pAcsUrl)) 
			{
				strcpy(tmpBuf, T(strSetACSURLerror));
				goto setErr_tr069;
			}
		}
	}
	mib_get( CWMP_ACS_USERNAME, (void *)tmpStr);
	if(strcmp(tmpStr,pAcsUser)!=0){
		changeflag = 1;
		if ( !mib_set( CWMP_ACS_USERNAME, (void *)pAcsUser)) {
			strcpy(tmpBuf, T(strSetUserNameerror));
			goto setErr_tr069;
		}
	}
	mib_get( CWMP_ACS_PASSWORD, (void *)tmpStr);
	if(strcmp(tmpStr,pAcsPass)!=0){
		changeflag = 1;
		if ( !mib_set( CWMP_ACS_PASSWORD, (void *)pAcsPass)) {
			strcpy(tmpBuf, T(strSetPasserror));
			goto setErr_tr069;
		}
	}

	mib_get( CWMP_CONREQ_ENABLE, (void*)&vChar);
	if(vChar != linkPermit){
		changeflag = 1;
		if ( !mib_set( CWMP_CONREQ_ENABLE, (void *)&linkPermit)) {
			strcpy(tmpBuf, T(strSetConReqEnableerror));
			goto setErr_tr069;
		}
	}

	if(linkPermit == 1){
		mib_get( CWMP_CONREQ_USERNAME, (void *)tmpStr);
		if(strcmp(tmpStr,pConnReqName)!=0){
			changeflag = 1;
			if ( !mib_set( CWMP_CONREQ_USERNAME, (void *)pConnReqName)) {
				strcpy(tmpBuf, T(strSetConReqUsererror));
				goto setErr_tr069;
			}
		}
		mib_get( CWMP_CONREQ_PASSWORD, (void *)tmpStr);
		if(strcmp(tmpStr,pConnReqPasw)!=0){
			changeflag = 1;
			if ( !mib_set( CWMP_CONREQ_PASSWORD, (void *)pConnReqPasw)) {
				strcpy(tmpBuf, T(strSetConReqPasserror));
				goto setErr_tr069;
			}
		}
	}

#ifdef CONFIG_MIDDLEWARE
	tr069Enable = (midwareEnable == 0 ? 1 : 0);
	mib_get( CWMP_TR069_ENABLE, (void*)&vChar);
	if(vChar != tr069Enable){
		changeflag = 1;
		if ( !mib_set( CWMP_TR069_ENABLE, (void *)&tr069Enable)) {
			strcpy(tmpBuf, T(strSetTR069EnableError));
			goto setErr_tr069;
		}
	}
	
	mib_get( CWMP_MIDWARE_SERVER_ADDR, (void *)tmpStr);
	if(strcmp(tmpStr,midwareAddr)!=0){
		changeflag = 1;
		if ( !mib_set( CWMP_MIDWARE_SERVER_ADDR, (void *)midwareAddr)) 
		{
			strcpy(tmpBuf, T(strSetMidwareAddrError));
			goto setErr_tr069;
		}
	}

	mib_get( CWMP_MIDWARE_SERVER_PORT, (void*)&vInt);
	if(vInt != midwarePort){
		changeflag = 1;
		if ( !mib_set( CWMP_MIDWARE_SERVER_PORT, (void *)&midwarePort)) {
			strcpy(tmpBuf, T(strSetMidwarePortError));
			goto setErr_tr069;
		}
	}

#endif

	printf("\nchangeflag=%d\n",changeflag);
end_tr069:	
	if(changeflag == 1){
#ifdef WRITE_TO_FLASH
		mib_update(CURRENT_SETTING, CONFIG_MIB_ALL);
#endif
		off_tr069();
		if (-1==startCWMP()){
			strcpy(tmpBuf, T("tr069ͻ˳ʧ!"));
			goto setErr_tr069;
		}
	}
	REDIRECTSUBMITURL;
	return ;
	
setErr_tr069:
	ERR_MSG(tmpBuf);
}
//tr069֤鵼
extern void formCertcaInsert(webs_t wp, char_t *path, char_t *query)
{
       char_t *strVal = NULL;
 
       char certType[8];
       char certContent[2048];

	  
	printf("enter formCertcaInsert\n");
	//get certType
	strVal = websGetVar(wp, T("certName"), T(""));
      strcpy(certType,strVal);
	printf("certType=%s\n",certType);

	//get certContent
	strVal = websGetVar(wp, T("certPublic"), T(""));
      strcpy(certContent,strVal);
	printf("certContent=%s\n",certContent);
	REDIRECTSUBMITURL;
	return ;
}
int showCert(int eid, webs_t wp, int argc, char_t **argv)
{
       char_t *strVal = NULL;
 
       char certType[8] = "ac";
	 char certName[64] = "acscert";
	 char certSubject[128] = "C/CN/ST=nanjing/O=127.24.22.1/OU=172.24.22.1";
       char certContent[2048] =  "MIICVTCCAb4CAQAwDQYJKoZIhvcNAQEEBQAwczELMAkGA1UEBhMCQ04xEDAOBgNV";

      /*
	 *Add code by Realtek
	 */

	//Debug
	printf("enter showCert\n");
	
       //return certName
      websWrite(wp, "certname = \"%s\";\n", certName);

      //return certType
      websWrite(wp, "certtype = \"%s\";\n", certType);

      //return certSubject
      websWrite(wp, "certsubject = \"%s\";\n", certSubject);

	//return certContent
      websWrite(wp, "certContent = \"%s\";\n", certContent);

	return 0;
}
//tr069֤鵼
void formTR069CertDel(webs_t wp, char_t *path, char_t *query)
{
       char_t *strVal = NULL;
 
        char certType[8];
	 char certName[64];
	 char certSubject[128];
	 char *ptemp = NULL;
	  
	printf("enter formTR069CertDel\n");
	
	//get lst
	strVal = websGetVar(wp, T("lst"), T(""));
	printf("lst=%s\n",strVal);

	//get certContent
      if(' ' != strVal)
      	{
      	       //get certname
      	       ptemp = certName;
      	       while('|' != *strVal)
			 *ptemp++ = *strVal++;
		*ptemp = '\0';
		 strVal++;
		 printf("certName = %s\n",certName);

		  //get certsubject
      	       ptemp = certSubject;
      	       while('|' != *strVal)
			 *ptemp++ = *strVal++;
		*ptemp = '\0';
		 strVal++;
		 printf("certSubject = %s\n",certSubject);

		   //get certtype
      	       ptemp = certType;
      	       while('|' != *strVal && '\0' != *strVal)
			 *ptemp++ = *strVal++;
		*ptemp = '\0';
		 strVal++;
		printf("certType = %s\n",certType);				  
      	}
	REDIRECTSUBMITURL;
	return ;
}
//////////////////////////////////////////////////////////////////
#if 0
void formTR069Config(webs_t wp, char_t *path, char_t *query)
{
	char_t	*strData;
	char tmpBuf[100];
	unsigned char vChar;
	unsigned char cwmp_flag;
	int vInt;

#ifdef _CWMP_WITH_SSL_
	//CPE Certificat Password
	strData = websGetVar(wp, T("CPE_Cert"), T(""));
	if( strData[0] )
	{	
		strData = websGetVar(wp, T("certpw"), T(""));
		if ( !mib_set( CWMP_CERT_PASSWORD, (void *)strData)) 
		{
			strcpy(tmpBuf, T(strSetCerPasserror));
			goto setErr_tr069;
		}
		goto end_tr069;
	}
#endif
	
	strData = websGetVar(wp, T("url"), T(""));
	//if ( strData[0] ) 
	{
		if ( strlen(strData)==0 )
		{
			strcpy(tmpBuf, T(strACSURLWrong));
			goto setErr_tr069;
		}
#ifndef _CWMP_WITH_SSL_
		if ( strstr(strData, "https://") )
		{
			strcpy(tmpBuf, T(strSSLWrong));
			goto setErr_tr069;
		}
#endif		
		if ( !mib_set( CWMP_ACS_URL, (void *)strData)) 
		{
			strcpy(tmpBuf, T(strSetACSURLerror));
			goto setErr_tr069;
		}
	}

	strData = websGetVar(wp, T("username"), T(""));
	//if ( strData[0] ) 
	{
		if ( !mib_set( CWMP_ACS_USERNAME, (void *)strData)) {
			strcpy(tmpBuf, T(strSetUserNameerror));
			goto setErr_tr069;
		}
	}

	strData = websGetVar(wp, T("password"), T(""));
	//if ( strData[0] ) 
	{
		if ( !mib_set( CWMP_ACS_PASSWORD, (void *)strData)) {
			strcpy(tmpBuf, T(strSetPasserror));
			goto setErr_tr069;
		}
	}

	strData = websGetVar(wp, T("enable"), T(""));
	if ( strData[0] ) {
		vChar = (strData[0]=='0')? 0:1;
		if ( !mib_set( CWMP_INFORM_ENABLE, (void *)&vChar)) {
			strcpy(tmpBuf, T(strSetInformEnableerror));
			goto setErr_tr069;
		}
	}

	strData = websGetVar(wp, T("interval"), T(""));
	if ( strData[0] ) {
		vInt = atoi(strData);
		if ( !mib_set( CWMP_INFORM_INTERVAL, (void *)&vInt)) {
			strcpy(tmpBuf, T(strSetInformIntererror));
			goto setErr_tr069;
		}
	}

	strData = websGetVar(wp, T("conreqname"), T(""));
	//if ( strData[0] ) 
	{
		if ( !mib_set( CWMP_CONREQ_USERNAME, (void *)strData)) {
			strcpy(tmpBuf, T(strSetConReqUsererror));
			goto setErr_tr069;
		}
	}

	strData = websGetVar(wp, T("conreqpw"), T(""));
	//if ( strData[0] ) 
	{
		if ( !mib_set( CWMP_CONREQ_PASSWORD, (void *)strData)) {
			strcpy(tmpBuf, T(strSetConReqPasserror));
			goto setErr_tr069;
		}
	}
/*for debug*/
	strData = websGetVar(wp, T("dbgmsg"), T(""));
	if ( strData[0] ) {
		cwmp_flag=0;
		vChar=0;

		if( mib_get( CWMP_FLAG, (void *)&cwmp_flag ) )
		{
			if(strData[0]=='0')
				cwmp_flag = cwmp_flag & (~CWMP_FLAG_DEBUG_MSG);
			else
				cwmp_flag = cwmp_flag | CWMP_FLAG_DEBUG_MSG;
				
			if ( !mib_set( CWMP_FLAG, (void *)&cwmp_flag)) {
				strcpy(tmpBuf, T(strSetCWMPFlagerror));
				goto setErr_tr069;
			}
		}else{
			strcpy(tmpBuf, T(strGetCWMPFlagerror));
			goto setErr_tr069;
		}
	}

#ifdef _CWMP_WITH_SSL_
	strData = websGetVar(wp, T("certauth"), T(""));
	if ( strData[0] ) {
		cwmp_flag=0;
		vChar=0;

		if( mib_get( CWMP_FLAG, (void *)&cwmp_flag ) )
		{
			if(strData[0]=='0')
				cwmp_flag = cwmp_flag & (~CWMP_FLAG_CERT_AUTH);
			else
				cwmp_flag = cwmp_flag | CWMP_FLAG_CERT_AUTH;
				
			if ( !mib_set( CWMP_FLAG, (void *)&cwmp_flag)) {
				strcpy(tmpBuf, T(strSetCWMPFlagerror));
				goto setErr_tr069;
			}
		}else{
			strcpy(tmpBuf, T(strGetCWMPFlagerror));
			goto setErr_tr069;
		}
	}
#endif

#ifdef _INFORM_EXT_FOR_X_CT_
	strData = websGetVar(wp, T("ctinformext"), T(""));
	if ( strData[0] ) {
		cwmp_flag=0;
		vChar=0;

		if( mib_get( CWMP_FLAG, (void *)&cwmp_flag ) )
		{
			if(strData[0]=='0')
				cwmp_flag = cwmp_flag & (~CWMP_FLAG_CTINFORMEXT);
			else
				cwmp_flag = cwmp_flag | CWMP_FLAG_CTINFORMEXT;
				
			if ( !mib_set( CWMP_FLAG, (void *)&cwmp_flag)) {
				strcpy(tmpBuf, T(strSetCWMPFlagerror));
				goto setErr_tr069;
			}
		}else{
			strcpy(tmpBuf, T(strGetCWMPFlagerror));
			goto setErr_tr069;
		}
	}
#endif

	strData = websGetVar(wp, T("sendgetrpc"), T(""));
	if ( strData[0] ) {
		cwmp_flag=0;
		vChar=0;

		if( mib_get( CWMP_FLAG, (void *)&cwmp_flag ) )
		{
			if(strData[0]=='0')
				cwmp_flag = cwmp_flag & (~CWMP_FLAG_SENDGETRPC);
			else
				cwmp_flag = cwmp_flag | CWMP_FLAG_SENDGETRPC;
				
			if ( !mib_set( CWMP_FLAG, (void *)&cwmp_flag)) {
				strcpy(tmpBuf, T(strSetCWMPFlagerror));
				goto setErr_tr069;
			}
		}else{
			strcpy(tmpBuf, T(strGetCWMPFlagerror));
			goto setErr_tr069;
		}
	}

	strData = websGetVar(wp, T("skipmreboot"), T(""));
	if ( strData[0] ) {
		cwmp_flag=0;
		vChar=0;

		if( mib_get( CWMP_FLAG, (void *)&cwmp_flag ) )
		{
			if(strData[0]=='0')
				cwmp_flag = cwmp_flag & (~CWMP_FLAG_SKIPMREBOOT);
			else
				cwmp_flag = cwmp_flag | CWMP_FLAG_SKIPMREBOOT;
				
			if ( !mib_set( CWMP_FLAG, (void *)&cwmp_flag)) {
				strcpy(tmpBuf, T(strSetCWMPFlagerror));
				goto setErr_tr069;
			}
		}else{
			strcpy(tmpBuf, T(strGetCWMPFlagerror));
			goto setErr_tr069;
		}
	}

	strData = websGetVar(wp, T("delay"), T(""));
	if ( strData[0] ) {
		cwmp_flag=0;
		vChar=0;

		if( mib_get( CWMP_FLAG, (void *)&cwmp_flag ) )
		{
			if(strData[0]=='0')
				cwmp_flag = cwmp_flag & (~CWMP_FLAG_DELAY);
			else
				cwmp_flag = cwmp_flag | CWMP_FLAG_DELAY;
				
			if ( !mib_set( CWMP_FLAG, (void *)&cwmp_flag)) {
				strcpy(tmpBuf, T(strSetCWMPFlagerror));
				goto setErr_tr069;
			}
		}else{
			strcpy(tmpBuf, T(strGetCWMPFlagerror));
			goto setErr_tr069;
		}
	}
	strData = websGetVar(wp, T("autoexec"), T(""));
	if ( strData[0] ) {
		cwmp_flag=0;
		vChar=0;

		if( mib_get( CWMP_FLAG, (void *)&cwmp_flag ) )
		{
			if(strData[0]=='0')
				cwmp_flag = cwmp_flag & (~CWMP_FLAG_AUTORUN);
			else
				cwmp_flag = cwmp_flag | CWMP_FLAG_AUTORUN;
				
			if ( !mib_set( CWMP_FLAG, (void *)&cwmp_flag)) {
				strcpy(tmpBuf, T(strSetCWMPFlagerror));
				goto setErr_tr069;
			}
		}else{
			strcpy(tmpBuf, T(strGetCWMPFlagerror));
			goto setErr_tr069;
		}
	}
/*end for debug*/

end_tr069:
	strData = websGetVar(wp, T("submit-url"), T(""));
	RECONNECT_MSG(strData);// display reconnect msg to remote
	return;

setErr_tr069:
	ERR_MSG(tmpBuf);
}
#endif


void formTR069CPECert(webs_t wp, char_t *path, char_t *query)
{
	char_t	*strData;
	char tmpBuf[100];
	FILE	*fp=NULL,*fp_input;
	unsigned char *buf;
	unsigned int startPos,endPos,nLen,nRead;
	if ((fp = uploadGetCert(wp, &startPos, &endPos)) == NULL)
	{
		strcpy(tmpBuf, T(strUploaderror));
 		goto setErr_tr069cpe;
 	}

	nLen = endPos - startPos;
	//printf("filesize is %d\n", nLen);
	buf = malloc(nLen+1);
	if (!buf)
	{
		strcpy(tmpBuf, T(strMallocFail));
 		goto setErr_tr069cpe;
 	}

	fseek(fp, startPos, SEEK_SET);
	nRead = fread((void *)buf, 1, nLen, fp);
	buf[nRead]=0;
	if (nRead != nLen)
 		printf("Read %d bytes, expect %d bytes\n", nRead, nLen);

	//printf("write to %d bytes from %08x\n", nLen, buf);
	
	fp_input=fopen(CERT_FNAME,"w");
	if (!fp_input)
		printf("create %s file fail!\n", CERT_FNAME);
	fprintf(fp_input,buf);
	printf("create file %s\n", CERT_FNAME);
	free(buf);
	fclose(fp_input);

	if( va_cmd( "/bin/flatfsd",1,1,"-s" ) )
		printf( "[%d]:exec 'flatfsd -s' error!",__FILE__ );

#ifdef ZTE_GENERAL_ROUTER_SC
	strData = websGetVar(wp, T("submit-url"), T("/tr069config_sc.asp"));
#else
	strData = websGetVar(wp, T("submit-url"), T("/tr069config.asp"));
#endif
	UPLOAD_MSG(strData);// display reconnect msg to remote
	return;

setErr_tr069cpe:
	ERR_MSG(tmpBuf);
}


void formTR069CACert(webs_t wp, char_t *path, char_t *query)
{
	char_t	*strData;
	char tmpBuf[100];
	FILE	*fp=NULL,*fp_input;
	unsigned char *buf;
	unsigned int startPos,endPos,nLen,nRead;
	if ((fp = uploadGetCert(wp, &startPos, &endPos)) == NULL)
	{
		strcpy(tmpBuf, T(strUploaderror));
 		goto setErr_tr069ca;
 	}
printf("\nenter formca!\n");
	nLen = endPos - startPos;
	//printf("filesize is %d\n", nLen);
	buf = malloc(nLen+1);
	if (!buf)
	{
		strcpy(tmpBuf, T(strMallocFail));
 		goto setErr_tr069ca;
 	}

	fseek(fp, startPos, SEEK_SET);
	nRead = fread((void *)buf, 1, nLen, fp);
	buf[nRead]=0;
	if (nRead != nLen)
 		printf("Read %d bytes, expect %d bytes\n", nRead, nLen);

	//printf("write to %d bytes from %08x\n", nLen, buf);
	
	fp_input=fopen(CA_FNAME,"w");
	if (!fp_input)
		printf("create %s file fail!\n", CA_FNAME );
	fprintf(fp_input,buf);
	printf("create file %s\n",CA_FNAME);
	free(buf);
	fclose(fp_input);
	
	if( va_cmd( "/bin/flatfsd",1,1,"-s" ) )
		printf( "[%d]:exec 'flatfsd -s' error!",__FILE__ );


#ifdef ZTE_GENERAL_ROUTER_SC
	strData = websGetVar(wp, T("submit-url"), T("/tr069config_sc.asp"));
#else
	strData = websGetVar(wp, T("submit-url"), T("/net_tr069.asp"));
#endif
	UPLOAD_MSG(strData);// display reconnect msg to remote
	return;

setErr_tr069ca:
	ERR_MSG(tmpBuf);
}

/*******************************************************/
/*show extra fileds at tr069config.asp*/
/*******************************************************/
#ifdef _CWMP_WITH_SSL_
#ifdef ZTE_GENERAL_ROUTER_SC
int ShowACSCertCPE(webs_t wp)
{
	int nBytesSent=0;
	unsigned char vChar=0;
	int isEnable=0;  

	if ( mib_get( CWMP_FLAG, (void *)&vChar) )
		if ( (vChar & CWMP_FLAG_CERT_AUTH)!=0 )
			isEnable=1;

	nBytesSent += websWrite(wp, T("  <tr>\n"));
	nBytesSent += websWrite(wp, T("      <td width=\"30%%\"><font size=2><b>%s</b></td>\n"),TAdmin_tr069_CPE);
	nBytesSent += websWrite(wp, T("      <td width=\"70%%\"><font size=2>\n"));
	nBytesSent += websWrite(wp, T("      <input type=\"radio\" name=certauth value=0 %s >%s&nbsp;&nbsp;\n"), isEnable==0?"checked":"" ,TAdmin_tr069_no);
	nBytesSent += websWrite(wp, T("      <input type=\"radio\" name=certauth value=1 %s >%s\n"), isEnable==1?"checked":"" ,TAdmin_tr069_yes);
	nBytesSent += websWrite(wp, T("      </td>\n"));
	nBytesSent += websWrite(wp, T("  </tr>\n"));

//		"\n"), isEnable==0?"checked":"", isEnable==1?"checked":"" );
	
	return nBytesSent;
}

int ShowMNGCertTable(webs_t wp)
{
	int nBytesSent=0;
	char buffer[256]="";
	
	getMIB2Str(CWMP_CERT_PASSWORD,buffer);

	nBytesSent += websWrite(wp, T("\n"
		"<table border=0 width=\"600\" cellspacing=4 cellpadding=0>\n"
		"  <tr><hr size=1 noshade align=top></tr>\n"
		"  <tr>\n"
		"      <td width=\"30%%\"><font size=3><b>%s</b></td>\n"
		"      <td width=\"70%%\"><b></b></td>\n"
		"  </tr>\n"
		"\n"),TAdmin_tr069_manag);


	nBytesSent += websWrite(wp, T("\n"
		"  <tr>\n"
		"      <td width=\"30%%\"><font size=2><b>%s</b></td>\n"
		"      <td width=\"70%%\">\n"
		"		<form action=/goform/formTR069Config method=POST name=\"cpe_passwd\">\n"
		"		<input type=\"text\" name=\"certpw\" size=\"24\" maxlength=\"64\" value=\"%s\">\n"
		"		<input type=\"submit\" value=\"%s\" name=\"CPE_Cert\">\n"
		"		<input type=\"hidden\" value=\"/tr069config_sc.asp\" name=\"submit-url\">\n"
		"		</form>\n"
		"      </td>\n"
		"  </tr>\n"
		"\n"),TAdmin_tr069_pass, buffer,TAdmin_tr069_App);

	nBytesSent += websWrite(wp, T("\n"
		"  <tr>\n"
		"      <td width=\"30%%\"><font size=2><b>CPE%s:</b></td>\n"
		"      <td width=\"70%%\"><font size=2>\n"
		"           <form action=/goform/formTR069CPECert method=POST enctype=\"multipart/form-data\" name=\"cpe_cert\">\n"
		"           <input type=\"file\" name=\"binary\" size=24>&nbsp;&nbsp;\n"
		"           <input type=\"submit\" value=\"%s\" name=\"load\">\n"
		"           </form>\n"
		"      </td>\n"
		"  </tr>\n"
		"\n"),TAdmin_tr069_certificat,TAdmin_tr069_Upload);

	nBytesSent += websWrite(wp, T("\n"
		"  <tr>\n"
		"      <td width=\"30%%\"><font size=2><b>CA%s:</b></td>\n"
		"      <td width=\"70%%\"><font size=2>\n"
		"           <form action=/goform/formTR069CACert method=POST enctype=\"multipart/form-data\" name=\"ca_cert\">\n"
		"           <input type=\"file\" name=\"binary\" size=24>&nbsp;&nbsp;\n"
		"           <input type=\"submit\" value=\"%s\" name=\"load\">\n"
		"           </form>\n"
		"      </td>\n"
		"  </tr>\n"
		"\n"),TAdmin_tr069_certificat,TAdmin_tr069_Upload);

	nBytesSent += websWrite(wp, T("\n"
		"</table>\n"
		"\n"));

	
	return nBytesSent;
}

#else
int ShowACSCertCPE(webs_t wp)
{
	int nBytesSent=0;
	unsigned char vChar=0;
	int isEnable=0;  

	if ( mib_get( CWMP_FLAG, (void *)&vChar) )
		if ( (vChar & CWMP_FLAG_CERT_AUTH)!=0 )
			isEnable=1;

	nBytesSent += websWrite(wp, T("  <tr>\n"));
	nBytesSent += websWrite(wp, T("      <td width=\"30%%\"><font size=2><b>%s</b></td>\n"),TAdmin_tr069_CPE);
	nBytesSent += websWrite(wp, T("      <td width=\"70%%\"><font size=2>\n"));
	nBytesSent += websWrite(wp, T("      <input type=\"radio\" name=certauth value=0 %s >%s&nbsp;&nbsp;\n"), isEnable==0?"checked":"" ,TAdmin_tr069_no);
	nBytesSent += websWrite(wp, T("      <input type=\"radio\" name=certauth value=1 %s >%s\n"), isEnable==1?"checked":"" ,TAdmin_tr069_yes);
	nBytesSent += websWrite(wp, T("      </td>\n"));
	nBytesSent += websWrite(wp, T("  </tr>\n"));

//		"\n"), isEnable==0?"checked":"", isEnable==1?"checked":"" );
	
	return nBytesSent;
}

int ShowMNGCertTable(webs_t wp)
{
	int nBytesSent=0;
	char buffer[256]="";
	
	getMIB2Str(CWMP_CERT_PASSWORD,buffer);

	nBytesSent += websWrite(wp, T("\n"
		"<table border=0 width=\"500\" cellspacing=4 cellpadding=0>\n"
		"  <tr><hr size=1 noshade align=top></tr>\n"
		"  <tr>\n"
		"      <td width=\"30%%\"><font size=2><b>%s</b></td>\n"
		"      <td width=\"70%%\"><b></b></td>\n"
		"  </tr>\n"
		"\n"),TAdmin_tr069_manag);


	nBytesSent += websWrite(wp, T("\n"
		"  <tr>\n"
		"      <td width=\"30%%\"><font size=2><b>%s</b></td>\n"
		"      <td width=\"70%%\">\n"
		"		<form action=/goform/formTR069Config method=POST name=\"cpe_passwd\">\n"
		"		<input type=\"text\" name=\"certpw\" size=\"24\" maxlength=\"64\" value=\"%s\">\n"
		"		<input type=\"submit\" value=\" %s \" name=\"CPE_Cert\">\n"
		"		<input type=\"hidden\" value=\"/tr069config.asp\" name=\"submit-url\">\n"
		"		</form>\n"
		"      </td>\n"
		"  </tr>\n"
		"\n"),TAdmin_tr069_pass, buffer,TAdmin_tr069_App);

	nBytesSent += websWrite(wp, T("\n"
		"  <tr>\n"
		"      <td width=\"30%%\"><font size=2><b>CPE %s:</b></td>\n"
		"      <td width=\"70%%\"><font size=2>\n"
		"           <form action=/goform/formTR069CPECert method=POST enctype=\"multipart/form-data\" name=\"cpe_cert\">\n"
		"           <input type=\"file\" name=\"binary\" size=24>&nbsp;&nbsp;\n"
		"           <input type=\"submit\" value=\" %s \" name=\"load\">\n"
		"           </form>\n"
		"      </td>\n"
		"  </tr>\n"
		"\n"),TAdmin_tr069_certificat,TAdmin_tr069_Upload);

	nBytesSent += websWrite(wp, T("\n"
		"  <tr>\n"
		"      <td width=\"30%%\"><font size=2><b>CA %s:</b></td>\n"
		"      <td width=\"70%%\"><font size=2>\n"
		"           <form action=/goform/formTR069CACert method=POST enctype=\"multipart/form-data\" name=\"ca_cert\">\n"
		"           <input type=\"file\" name=\"binary\" size=24>&nbsp;&nbsp;\n"
		"           <input type=\"submit\" value=\" %s \" name=\"load\">\n"
		"           </form>\n"
		"      </td>\n"
		"  </tr>\n"
		"\n"),TAdmin_tr069_certificat,TAdmin_tr069_Upload);

	nBytesSent += websWrite(wp, T("\n"
		"</table>\n"
		"\n"));

	
	return nBytesSent;
}
#endif
#endif

#ifdef _INFORM_EXT_FOR_X_CT_
#ifdef ZTE_GENERAL_ROUTER_SC
int ShowCTInformExt(webs_t wp)
{
	int nBytesSent=0;
	unsigned char vChar=0;
	int isEnable=0;  

	if ( mib_get( CWMP_FLAG, (void *)&vChar) )
		if ( (vChar & CWMP_FLAG_CTINFORMEXT)!=0 )
			isEnable=1;

	nBytesSent += websWrite(wp, T("  <tr>\n"));
	nBytesSent += websWrite(wp, T("      <td width=\"30%%\"><font size=2><b>%s</b></td>\n"),TAdmin_tr069_ct);
	nBytesSent += websWrite(wp, T("      <td width=\"70%%\"><font size=2>\n"));
	nBytesSent += websWrite(wp, T("      <input type=\"radio\" name=ctinformext value=0 %s >%s&nbsp;&nbsp;\n"), isEnable==0?"checked":"" ,TAdmin_tr069_disable);
	nBytesSent += websWrite(wp, T("      <input type=\"radio\" name=ctinformext value=1 %s >%s\n"), isEnable==1?"checked":"" ,TAdmin_tr069_enable);
	nBytesSent += websWrite(wp, T("      </td>\n"));
	nBytesSent += websWrite(wp, T("  </tr>\n"));
	
	return nBytesSent;
}
#else
int ShowCTInformExt(webs_t wp)
{
	int nBytesSent=0;
	unsigned char vChar=0;
	int isEnable=0;  

	if ( mib_get( CWMP_FLAG, (void *)&vChar) )
		if ( (vChar & CWMP_FLAG_CTINFORMEXT)!=0 )
			isEnable=1;

	nBytesSent += websWrite(wp, T("  <tr>\n"));
	nBytesSent += websWrite(wp, T("      <td width=\"30%%\"><font size=2><b>%s</b></td>\n"),TAdmin_tr069_ct);
	nBytesSent += websWrite(wp, T("      <td width=\"70%%\"><font size=2>\n"));
	nBytesSent += websWrite(wp, T("      <input type=\"radio\" name=ctinformext value=0 %s >%s&nbsp;&nbsp;\n"), isEnable==0?"checked":"" ,TAdmin_tr069_disable);
	nBytesSent += websWrite(wp, T("      <input type=\"radio\" name=ctinformext value=1 %s >%s\n"), isEnable==1?"checked":"" ,TAdmin_tr069_enable);
	nBytesSent += websWrite(wp, T("      </td>\n"));
	nBytesSent += websWrite(wp, T("  </tr>\n"));
	
	return nBytesSent;
}
#endif
#endif

int TR069ConPageShow(int eid, webs_t wp, int argc, char_t **argv)
{
	int nBytesSent=0;
	char_t *name;
	
	if (ejArgs(argc, argv, T("%s"), &name) < 1) {
		websError(wp, 400, T(strArgerror));
		return -1;
	}

#ifdef _CWMP_WITH_SSL_	
	if ( !strcmp(name, T("ShowACSCertCPE")) )
		return ShowACSCertCPE( wp );
	else if ( !strcmp(name, T("ShowMNGCertTable")) )
		return ShowMNGCertTable( wp );
#endif
#ifdef _INFORM_EXT_FOR_X_CT_
	if ( !strcmp(name, T("ShowCTInformExt")) )
		return ShowCTInformExt( wp );
#endif	
	return nBytesSent;
}

