/*
 *      MIB table declaration
 *      Authors: David Hsu	<davidhsu@realtek.com.tw>
 *      Authors: Dick Tam	<dicktam@realtek.com.tw>
 *
 */

/* Include files */
#include "mibtbl.h"
#ifdef EMBED
#include <linux/config.h>
#else
#include "../../../uClibc/include/linux/autoconf.h"
#endif
#include <config/autoconf.h>
#include "options.h"
#include "fmdefs.h"

/* Global variable definitions */
mib_table_entry_T mib_table[]={

MIB_TBL_ENTRY(MIB_ADSL_LAN_IP,			CURRENT_SETTING,	"LAN_IP_ADDR", 		IA_T,		_OFFSET(ipAddr), 		_SIZE(ipAddr),			"192.168.1.1"),
MIB_TBL_ENTRY(MIB_ADSL_LAN_SUBNET,		CURRENT_SETTING,	"LAN_SUBNET", 		IA_T,		_OFFSET(subnetMask), 		_SIZE(subnetMask),		"255.255.255.0"),
MIB_TBL_ENTRY(MIB_ADSL_LAN_ENABLE_IP2,		CURRENT_SETTING,	"LAN_ENABLE_IP2",	BYTE_T,		_OFFSET(enable_ip2), 		_SIZE(enable_ip2),		"0"),
MIB_TBL_ENTRY(MIB_ADSL_LAN_IP2,			CURRENT_SETTING,	"LAN_IP_ADDR2", 	IA_T,		_OFFSET(ipAddr2), 		_SIZE(ipAddr2),			"192.168.100.1"),
MIB_TBL_ENTRY(MIB_ADSL_LAN_SUBNET2,		CURRENT_SETTING,	"LAN_SUBNET2", 		IA_T,		_OFFSET(subnetMask2), 		_SIZE(subnetMask2),		"255.255.255.0"),
MIB_TBL_ENTRY(MIB_ADSL_LAN_DHCP,		CURRENT_SETTING,	"LAN_DHCP",		BYTE_T,		_OFFSET(dhcp), 			_SIZE(dhcp),			"0"),
MIB_TBL_ENTRY(MIB_ADSL_LAN_CLIENT_START,	CURRENT_SETTING,	"LAN_DHCP_START", 	BYTE_T, 	_OFFSET(dhcpClientStart), 	_SIZE(dhcpClientStart),		"2"),
MIB_TBL_ENTRY(MIB_ADSL_LAN_CLIENT_END,		CURRENT_SETTING,	"LAN_DHCP_END", 	BYTE_T,		_OFFSET(dhcpClientEnd), 	_SIZE(dhcpClientEnd),		"254"),
MIB_TBL_ENTRY(MIB_ADSL_LAN_DHCP_LEASE,		CURRENT_SETTING,	"LAN_DHCP_LEASE",	INTEGER_T,	_OFFSET(dhcpLTime), 		_SIZE(dhcpLTime),		"86400"),
MIB_TBL_ENTRY(MIB_ADSL_LAN_DHCP_DOMAIN,		CURRENT_SETTING,	"LAN_DHCP_DOMAIN",	STRING_T,	_OFFSET(dhcpDomain), 		_SIZE(dhcpDomain),		"domain.name"),
MIB_TBL_ENTRY(MIB_ADSL_LAN_RIP,			CURRENT_SETTING,	"LAN_RIP",		BYTE_T,		_OFFSET(rip), 			_SIZE(rip),			"0"),
MIB_TBL_ENTRY(MIB_ADSL_LAN_AUTOSEARCH,		CURRENT_SETTING,	"LAN_AUTOSEARCH",	BYTE_T,		_OFFSET(lanAutoSearch), 	_SIZE(lanAutoSearch),		"0"),
MIB_TBL_ENTRY(MIB_DHCP_POOL_START,		CURRENT_SETTING,	"LAN_DHCP_POOL_START", 	IA_T,		_OFFSET(ipDhcpStart), 		_SIZE(ipDhcpStart),			"192.168.1.2"),
MIB_TBL_ENTRY(MIB_DHCP_POOL_END,		CURRENT_SETTING,	"LAN_DHCP_POOL_END", 	IA_T,		_OFFSET(ipDhcpEnd), 		_SIZE(ipDhcpEnd),			"192.168.1.254"),

//add by liuxiao 2008-01-15
//MIB_TBL_ENTRY(MIB_SOFTWARE_VERSION,		CURRENT_SETTING,	"SOFTWARE_VERSION",	STRING_T,		_OFFSET(softwareVersion), 	_SIZE(softwareVersion),		"1.3.9"),
//add end by liuxiao 2008-01-15

#ifdef DEFAULT_GATEWAY_V2
#ifdef AUTO_PPPOE_ROUTE
MIB_TBL_ENTRY(MIB_ADSL_WAN_DGW_ITF,			CURRENT_SETTING,	"DGW_ITF",		BYTE_T,		_OFFSET(dgwItf), 		_SIZE(dgwItf),			"239"),
#else
MIB_TBL_ENTRY(MIB_ADSL_WAN_DGW_ITF,			CURRENT_SETTING,	"DGW_ITF",		BYTE_T,		_OFFSET(dgwItf), 		_SIZE(dgwItf),			"255"),
#endif
#endif
MIB_TBL_ENTRY(MIB_ADSL_WAN_DNS_MODE,		CURRENT_SETTING,	"DNS_MODE",		BYTE_T,		_OFFSET(dnsMode), 		_SIZE(dnsMode),			"0"),
MIB_TBL_ENTRY(MIB_ADSL_WAN_DNS1,		CURRENT_SETTING,	"DNS1",			IA_T,		_OFFSET(dns1), 			_SIZE(dns1),			"0"),
MIB_TBL_ENTRY(MIB_ADSL_WAN_DNS2,		CURRENT_SETTING,	"DNS2", 		IA_T, 		_OFFSET(dns2), 			_SIZE(dns2),			"0"),
MIB_TBL_ENTRY(MIB_ADSL_WAN_DNS3,		CURRENT_SETTING,	"DNS3", 		IA_T,		_OFFSET(dns3), 			_SIZE(dns3),			"0"),

MIB_TBL_ENTRY(MIB_ADSL_WAN_DHCPS,		CURRENT_SETTING,	"DHCPS",		IA_T,		_OFFSET(dhcps), 		_SIZE(dhcps),			"172.19.31.4"),
#if defined(ZTE_531B_BRIDGE_SC)||defined(ZTE_GENERAL_ROUTER_SC)
MIB_TBL_ENTRY(MIB_DHCP_MODE,			CURRENT_SETTING,	"DHCP_MODE",		BYTE_T,		_OFFSET(dhcpMode),		_SIZE(dhcpMode),		"0"),
#else
MIB_TBL_ENTRY(MIB_DHCP_MODE,			CURRENT_SETTING,	"DHCP_MODE",		BYTE_T,		_OFFSET(dhcpMode),		_SIZE(dhcpMode),		"2"),
#endif
#if defined(ZTE_531B_BRIDGE_SC)||defined(ZTE_GENERAL_ROUTER_SC)
MIB_TBL_ENTRY(MIB_ADSL_MODE,			CURRENT_SETTING,	"ADSL_MODE",		WORD_T,		_OFFSET(adslMode), 		_SIZE(adslMode),		"115"),
#else
MIB_TBL_ENTRY(MIB_ADSL_MODE,			CURRENT_SETTING,	"ADSL_MODE",		WORD_T,		_OFFSET(adslMode), 		_SIZE(adslMode),		"83"),
#endif
MIB_TBL_ENTRY(MIB_ADSL_OLR,			CURRENT_SETTING,	"ADSL_OLR",		BYTE_T,		_OFFSET(adslOlr), 		_SIZE(adslOlr),			"3"),
#ifdef CONFIG_USER_ROUTED_ROUTED
MIB_TBL_ENTRY(MIB_RIP_ENABLE,			CURRENT_SETTING,	"RIP_ENABLE",		BYTE_T,		_OFFSET(ripEnabled), 		_SIZE(ripEnabled),		"0"),
MIB_TBL_ENTRY(MIB_RIP_VERSION,			CURRENT_SETTING,	"RIP_VERSION",		BYTE_T,		_OFFSET(ripVer), 		_SIZE(ripVer),			"1"),
#endif

MIB_TBL_ENTRY(MIB_IPF_OUT_ACTION,		CURRENT_SETTING,	"IPF_OUT_ACTION",	BYTE_T,		_OFFSET(ipfOutAction),	 	_SIZE(ipfOutAction),		"1"),
MIB_TBL_ENTRY(MIB_IPF_IN_ACTION,		CURRENT_SETTING,	"IPF_IN_ACTION",	BYTE_T,		_OFFSET(ipfInAction),	 	_SIZE(ipfInAction),		"0"),
MIB_TBL_ENTRY(MIB_MACF_OUT_ACTION,		CURRENT_SETTING,	"MACF_OUT_ACTION",	BYTE_T,		_OFFSET(macfOutAction),	 	_SIZE(macfOutAction),		"1"),
MIB_TBL_ENTRY(MIB_MACF_IN_ACTION,		CURRENT_SETTING,	"MACF_IN_ACTION",	BYTE_T,		_OFFSET(macfInAction),	 	_SIZE(macfInAction),		"1"),
MIB_TBL_ENTRY(MIB_PORT_FW_ENABLE,		CURRENT_SETTING,	"PORT_FW_ENABLE",	BYTE_T,		_OFFSET(portFwEnabled), 	_SIZE(portFwEnabled),		"0"),
#ifdef NATIP_FORWARDING
MIB_TBL_ENTRY(MIB_IP_FW_ENABLE,			CURRENT_SETTING,	"IP_FW_ENABLE",		BYTE_T,		_OFFSET(ipFwEnabled), 		_SIZE(ipFwEnabled),		"0"),
#endif
#ifdef DMZ_SUPPORT
MIB_TBL_ENTRY(MIB_DMZ_ENABLE,			CURRENT_SETTING,	"DMZ_ENABLE",		BYTE_T,		_OFFSET(dmzEnabled), 		_SIZE(dmzEnabled),		"0"),
//MIB_TBL_ENTRY(MIB_DMZ_IP,			CURRENT_SETTING,	"DMZ_IP",		IA_T,		_OFFSET(dmzHost), 		_SIZE(dmzHost),			"0"),
MIB_TBL_ENTRY(MIB_DMZ_IP,			CURRENT_SETTING,	"DMZ_IP",		INTEGER_T,		_OFFSET(dmzHost), 		_SIZE(dmzHost),			"0"),
#endif
#if defined(E8B_DEFAULT_ACCOUNT)
 MIB_TBL_ENTRY(MIB_USER_NAME,			CURRENT_SETTING,	"USER_NAME",		STRING_T,	_OFFSET(userName), 		_SIZE(userName),		"useradmin"),
 	#if	defined(RANDOM_DEFAULT_PASSWORD_SUPPORT)
MIB_TBL_ENTRY(MIB_USER_PASSWORD,		CURRENT_SETTING,	"USER_PASSWORD",	STRING_T,	_OFFSET(userPassword), 		_SIZE(userPassword),		""),
 	#else
MIB_TBL_ENTRY(MIB_USER_PASSWORD,		CURRENT_SETTING,	"USER_PASSWORD",	STRING_T,	_OFFSET(userPassword), 		_SIZE(userPassword),		"useradmin"),
	#endif
#else
MIB_TBL_ENTRY(MIB_USER_NAME,			CURRENT_SETTING,	"USER_NAME",		STRING_T,	_OFFSET(userName), 		_SIZE(userName),		"user"),
MIB_TBL_ENTRY(MIB_USER_PASSWORD,		CURRENT_SETTING,	"USER_PASSWORD",	STRING_T,	_OFFSET(userPassword), 		_SIZE(userPassword),		"user"),
#endif
#ifdef BRIDGE_ONLY	// DEVICE_TYPE: 0
MIB_TBL_ENTRY(MIB_DEVICE_TYPE,			CURRENT_SETTING,	"DEVICE_TYPE",		BYTE_T,		_OFFSET(deviceType), 		_SIZE(deviceType),		"0"),
#else	// DEVICE_TYPE: 1
MIB_TBL_ENTRY(MIB_DEVICE_TYPE,			CURRENT_SETTING,	"DEVICE_TYPE",		BYTE_T,		_OFFSET(deviceType), 		_SIZE(deviceType),		"5"),
#endif
MIB_TBL_ENTRY(MIB_INIT_LINE,			CURRENT_SETTING,	"INIT_LINE",		BYTE_T,		_OFFSET(initLine), 		_SIZE(initLine),		"1"),
MIB_TBL_ENTRY(MIB_INIT_SCRIPT,			CURRENT_SETTING,	"INIT_SCRIPT",		BYTE_T,		_OFFSET(initScript), 		_SIZE(initScript),		"1"),



MIB_TBL_ENTRY(MIB_SUPER_NAME,			HW_SETTING,		"SUPER_NAME", 		STRING_T,	_OFFSET_HW(superName),		_SIZE_HW(superName),		"adsl"),
MIB_TBL_ENTRY(MIB_SUPER_PASSWORD,		HW_SETTING,		"SUPER_PASSWORD",	STRING_T,	_OFFSET_HW(superPassword), 	_SIZE_HW(superPassword),	"realtek"),
MIB_TBL_ENTRY(MIB_BOOT_MODE,			HW_SETTING,		"BOOT_MODE",		BYTE_T,		_OFFSET_HW(bootMode),		_SIZE_HW(bootMode),		"0"),
MIB_TBL_ENTRY(MIB_ELAN_MAC_ADDR, 		HW_SETTING,		"ELAN_MAC_ADDR",	BYTE6_T, 	_OFFSET_HW(elanMacAddr),	_SIZE_HW(elanMacAddr),		"00E04C867001"),
MIB_TBL_ENTRY(MIB_WLAN_MAC_ADDR, 		HW_SETTING,		"WLAN_MAC_ADDR",	BYTE6_T, 	_OFFSET_HW(wlanMacAddr),	_SIZE_HW(wlanMacAddr),		"00E04C076802"),
#if WLAN_SUPPORT
#ifdef CONFIG_BOA_WEB_E8B_CH
MIB_TBL_ENTRY(MIB_HW_REG_DOMAIN, 		HW_SETTING,		"HW_REG_DOMAIN",	BYTE_T, 	_OFFSET_HW(regDomain),		_SIZE_HW(regDomain),		"3"),
#else
MIB_TBL_ENTRY(MIB_HW_REG_DOMAIN, 		HW_SETTING,		"HW_REG_DOMAIN",	BYTE_T, 	_OFFSET_HW(regDomain),		_SIZE_HW(regDomain),		"1"),
#endif
MIB_TBL_ENTRY(MIB_HW_RF_TYPE, 			HW_SETTING,		"HW_RF_TYPE",		BYTE_T, 	_OFFSET_HW(rfType),		_SIZE_HW(rfType),		"7"),
#ifdef WLAN_8185AG
MIB_TBL_ENTRY(MIB_HW_TX_POWER_CCK, 		HW_SETTING,		"HW_TX_POWER_CCK",	BYTE_ARRAY_T, 	_OFFSET_HW(txPowerCCK),		_SIZE_HW(txPowerCCK),		"12 12 12 12 12 12 12 12 12 12 12 12 12 12"),
#ifdef CONFIG_BOA_WEB_E8B_CH
MIB_TBL_ENTRY(MIB_HW_TX_POWER_OFDM, 		HW_SETTING,		"HW_TX_POWER_OFDM",	BYTE_ARRAY_T, 	_OFFSET_HW(txPowerOFDM),	_SIZE_HW(txPowerOFDM),		"09 09 09 09 09 09 09 09 09 09 09 09 09 09"),
#else
MIB_TBL_ENTRY(MIB_HW_TX_POWER_OFDM, 		HW_SETTING,		"HW_TX_POWER_OFDM",	BYTE_ARRAY_T, 	_OFFSET_HW(txPowerOFDM),	_SIZE_HW(txPowerOFDM),		"22 22 22 22 22 22 22 22 22 22 22 22 22 22"),
#endif
#else
MIB_TBL_ENTRY(MIB_HW_TX_POWER, 			HW_SETTING,		"HW_TX_POWER",		BYTE_ARRAY_T, 	_OFFSET_HW(txPower),		_SIZE_HW(txPower),		"6 6 6 6 6 6 6 6 6 6 6 6 6 6"),
#endif
MIB_TBL_ENTRY(MIB_HW_ANT_DIVERSITY, 		HW_SETTING,		"HW_ANT_DIVERSITY",	BYTE_T, 	_OFFSET_HW(antDiversity),	_SIZE_HW(antDiversity),		"0"),
MIB_TBL_ENTRY(MIB_HW_TX_ANT, 			HW_SETTING,		"HW_TX_ANT",		BYTE_T, 	_OFFSET_HW(txAnt),		_SIZE_HW(txAnt),		"0"),
MIB_TBL_ENTRY(MIB_HW_CS_THRESHOLD, 		HW_SETTING,		"HW_CS_THRESHOLD",	BYTE_T, 	_OFFSET_HW(csThreshold),	_SIZE_HW(csThreshold),		"11"),
MIB_TBL_ENTRY(MIB_HW_CCA_MODE, 			HW_SETTING,		"HW_CCA_MODE",		BYTE_T, 	_OFFSET_HW(ccaMode),		_SIZE_HW(ccaMode),		"1"),
MIB_TBL_ENTRY(MIB_HW_PHY_TYPE, 			HW_SETTING,		"HW_PHY_TYPE",		BYTE_T, 	_OFFSET_HW(phyType),		_SIZE_HW(phyType),		"0"),
MIB_TBL_ENTRY(MIB_HW_LED_TYPE, 			HW_SETTING,		"HW_WLAN_LED_TYPE",	BYTE_T, 	_OFFSET_HW(ledType),		_SIZE_HW(ledType),		"7"),
#endif // of WLAN_SUPPORT
MIB_TBL_ENTRY(MIB_BYTE_TEST,			HW_SETTING,		"BYTE",			BYTE_T,		_OFFSET_HW(byte_test), 		_SIZE_HW(byte_test),		"255"),
MIB_TBL_ENTRY(MIB_WORD_TEST,			HW_SETTING,		"WORD",			WORD_T,		_OFFSET_HW(word_test), 		_SIZE_HW(word_test),		"65535"),
MIB_TBL_ENTRY(MIB_DWORD_TEST,			HW_SETTING,		"DWORD",		DWORD_T,	_OFFSET_HW(dword_test), 	_SIZE_HW(dword_test),		"4294967295"),
MIB_TBL_ENTRY(MIB_INTERGER_TEST1,		HW_SETTING,		"INT1",			INTEGER_T,	_OFFSET_HW(int_test1), 		_SIZE_HW(int_test1),		"2147483647"),
MIB_TBL_ENTRY(MIB_INTERGER_TEST2,		HW_SETTING,		"INT2",			INTEGER_T,	_OFFSET_HW(int_test2), 		_SIZE_HW(int_test2),		"-2147483648"),
//star zhang to support WIFI logo test Mode...
#ifdef WLAN_SUPPORT
MIB_TBL_ENTRY(MIB_WIFI_SUPPORT,		HW_SETTING,		"WIFI_SUPPORT",			BYTE_T,	_OFFSET_HW(wifi_support), 		_SIZE_HW(wifi_support),		"0"),
#endif
  
#if defined(ZTE_531B_BRIDGE_SC) || defined(ZTE_GENERAL_ROUTER_SC)
MIB_TBL_ENTRY(MIB_SNMP_SYS_DESCR,		CURRENT_SETTING,	"SNMP_SYS_DESCR",	STRING_T,	_OFFSET(snmpSysDescr), 		_SIZE(snmpSysDescr),		"System Description"),
#else
MIB_TBL_ENTRY(MIB_SNMP_SYS_DESCR,		CURRENT_SETTING,	"SNMP_SYS_DESCR",	STRING_T,	_OFFSET(snmpSysDescr), 		_SIZE(snmpSysDescr),		"System Description"),
#endif
MIB_TBL_ENTRY(MIB_SNMP_SYS_OID,			CURRENT_SETTING,	"SNMP_SYS_OID",		STRING_T,	_OFFSET(snmpSysObjectID), 	_SIZE(snmpSysObjectID),		"1.3.6.1.4.1.16972"),
#if defined(ZTE_531B_BRIDGE_SC) || defined(ZTE_GENERAL_ROUTER_SC)
MIB_TBL_ENTRY(MIB_SNMP_SYS_CONTACT,		CURRENT_SETTING,	"SNMP_SYS_CONTACT",	STRING_T,	_OFFSET(snmpSysContact), 	_SIZE(snmpSysContact),		"WWW.REALTEK.COM"),
#else
MIB_TBL_ENTRY(MIB_SNMP_SYS_CONTACT,		CURRENT_SETTING,	"SNMP_SYS_CONTACT",	STRING_T,	_OFFSET(snmpSysContact), 	_SIZE(snmpSysContact),		"System Contact"),
#endif
#if defined(ZTE_531B_BRIDGE_SC) || defined(ZTE_GENERAL_ROUTER_SC)
MIB_TBL_ENTRY(MIB_SNMP_SYS_NAME,		CURRENT_SETTING,	"SNMP_SYS_NAME",	STRING_T,	_OFFSET(snmpSysName), 		_SIZE(snmpSysName),		"ADSL Modem/Router"),
#else
MIB_TBL_ENTRY(MIB_SNMP_SYS_NAME,		CURRENT_SETTING,	"SNMP_SYS_NAME",	STRING_T,	_OFFSET(snmpSysName), 		_SIZE(snmpSysName),		"ADSL Modem/Router"),
#endif
#if defined(ZTE_531B_BRIDGE_SC) || defined(ZTE_GENERAL_ROUTER_SC)
MIB_TBL_ENTRY(MIB_SNMP_SYS_LOCATION,		CURRENT_SETTING,	"SNMP_SYS_LOCATION",	STRING_T,	_OFFSET(snmpSysLocation), 	_SIZE(snmpSysLocation),		"WWW.REALTEK.COM"),
#else
MIB_TBL_ENTRY(MIB_SNMP_SYS_LOCATION,		CURRENT_SETTING,	"SNMP_SYS_LOCATION",	STRING_T,	_OFFSET(snmpSysLocation), 	_SIZE(snmpSysLocation),		"System Location"),
#endif
MIB_TBL_ENTRY(MIB_SNMP_TRAP_IP,			CURRENT_SETTING,	"SNMP_TRAP_IP",		IA_T,		_OFFSET(snmpTrapIpAddr), 	_SIZE(snmpTrapIpAddr),		"192.168.1.254"),
MIB_TBL_ENTRY(MIB_SNMP_COMM_RO,			CURRENT_SETTING,	"SNMP_COMM_RO",		STRING_T,	_OFFSET(snmpCommunityRO),	_SIZE(snmpCommunityRO),		"public"),
MIB_TBL_ENTRY(MIB_SNMP_COMM_RW,			CURRENT_SETTING,	"SNMP_COMM_RW",		STRING_T,	_OFFSET(snmpCommunityRW),	_SIZE(snmpCommunityRW),		"public"),

// Kao
MIB_TBL_ENTRY(MIB_ATM_VC_AUTOSEARCH,		CURRENT_SETTING,	"VC_AUTOSEARCH",	BYTE_T,		_OFFSET(atmVcAutoSearch), 	_SIZE(atmVcAutoSearch),		"0"),

MIB_TBL_ENTRY(MIB_BRCTL_AGEINGTIME,		CURRENT_SETTING,	"BR_AGEING_TIME",	WORD_T,		_OFFSET(brctlAgeingTime), 	_SIZE(brctlAgeingTime),		"300"),
MIB_TBL_ENTRY(MIB_BRCTL_STP,			CURRENT_SETTING,	"BR_STP_ENABLED",	BYTE_T,		_OFFSET(brctlStp), 		_SIZE(brctlStp),		"0"),
MIB_TBL_ENTRY(MIB_MPMODE,			CURRENT_SETTING,	"MP_MODE",		BYTE_T,		_OFFSET(mpMode), 		_SIZE(mpMode),			"0"),
MIB_TBL_ENTRY(MIB_QOS_DOMAIN,			CURRENT_SETTING,	"QOS_DOMAIN",		BYTE_T,		_OFFSET(qosDomain), 		_SIZE(qosDomain),		"0"),
#ifdef FIREWALL_GRADE
MIB_TBL_ENTRY(MIB_FW_GRADE,				CURRENT_SETTING,	"FW_GRADE",			BYTE_T,		_OFFSET(fwGrade),			_SIZE(fwGrade),			"1"),
#endif
#ifdef CONFIG_USER_IGMPPROXY
MIB_TBL_ENTRY(MIB_IGMP_PROXY,			CURRENT_SETTING,	"IGMP_PROXY",		BYTE_T,		_OFFSET(igmpProxy), 		_SIZE(igmpProxy),		"0"),
MIB_TBL_ENTRY(MIB_IGMP_PROXY_ITF,		CURRENT_SETTING,	"IGMP_PROXY_ITF",	BYTE_T,		_OFFSET(igmpProxyItf), 		_SIZE(igmpProxyItf),		"255"),
#endif
#ifdef IP_PASSTHROUGH
MIB_TBL_ENTRY(MIB_IPPT_ITF,			CURRENT_SETTING,	"IPPT_ITF",		BYTE_T,		_OFFSET(ipptItf), 		_SIZE(ipptItf),			"255"),
MIB_TBL_ENTRY(MIB_IPPT_LEASE,			CURRENT_SETTING,	"IPPT_LEASE",		INTEGER_T,	_OFFSET(ipptLTime), 		_SIZE(ipptLTime),		"600"),
MIB_TBL_ENTRY(MIB_IPPT_LANACC,			CURRENT_SETTING,	"IPPT_LANACC",		BYTE_T,		_OFFSET(ipptLanacc), 		_SIZE(ipptLanacc),		"0"),
#endif
MIB_TBL_ENTRY(MIB_SPC_ENABLE,			CURRENT_SETTING,	"SPC_ENABLED",		BYTE_T,		_OFFSET(spcEnable), 		_SIZE(spcEnable),		"0"),
MIB_TBL_ENTRY(MIB_SPC_IPTYPE,			CURRENT_SETTING,	"SPC_IPTYPE",		BYTE_T,		_OFFSET(spcIPType), 		_SIZE(spcIPType),		"0"),
MIB_TBL_ENTRY(MIB_ACL_CAPABILITY,		CURRENT_SETTING,	"ACL_CAPABILITY",	BYTE_T,		_OFFSET(aclcapability),		_SIZE(aclcapability),		"0"),
#ifdef URL_BLOCKING_SUPPORT
MIB_TBL_ENTRY(MIB_URL_FILTER_ENABLED,	CURRENT_SETTING,	"URL_ENABLED",	BYTE_T,		_OFFSET(urlEnabled),		_SIZE(urlEnabled),		"0"),  // Mason Yu for URL Blocking
MIB_TBL_ENTRY(MIB_URL_FILTER_MODE,		CURRENT_SETTING,	"URL_MODE",		BYTE_T, 	_OFFSET(urlMode), 	_SIZE(urlMode),		"0"),  // Mason Yu for URL Blocking
#endif
#if defined(ZTE_GENERAL_ROUTER_SC) || defined(TIME_ZONE)
MIB_TBL_ENTRY(MIB_NTP_ENABLED, 			CURRENT_SETTING,	"NTP_ENABLED",		BYTE_T, 	_OFFSET(ntpEnabled),		_SIZE(ntpEnabled),		"0"),
MIB_TBL_ENTRY(MIB_NTP_SERVER_ID, 		CURRENT_SETTING,	"NTP_SERVER_ID",	BYTE_T, 	_OFFSET(ntpServerId),		_SIZE(ntpServerId),		"0"),
MIB_TBL_ENTRY(MIB_NTP_TIMEZONE, 		CURRENT_SETTING,	"NTP_TIMEZONE",		STRING_T, 	_OFFSET(ntpTimeZone),		_SIZE(ntpTimeZone),		"-8 1"),
MIB_TBL_ENTRY(MIB_NTP_SERVER_IP1, 		CURRENT_SETTING,	"NTP_SERVER_IP1",	IA_T, 		_OFFSET(ntpServerIp1),		_SIZE(ntpServerIp1),		"203.117.180.36"),
MIB_TBL_ENTRY(MIB_NTP_SERVER_IP2, 		CURRENT_SETTING,	"NTP_SERVER_IP2",	IA_T, 		_OFFSET(ntpServerIp2),		_SIZE(ntpServerIp2),		""),
MIB_TBL_ENTRY(MIB_NTP_SERVER_HOST1, 		CURRENT_SETTING,	"MIB_NTP_SERVER_HOST1",	STRING_T, 		_OFFSET(ntpServerHost1),		_SIZE(ntpServerHost1),		""),
MIB_TBL_ENTRY(MIB_NTP_SERVER_HOST2, 		CURRENT_SETTING,	"MIB_NTP_SERVER_HOST2",	STRING_T, 		_OFFSET(ntpServerHost2),		_SIZE(ntpServerHost2),		""),
#endif
MIB_TBL_ENTRY(MIB_UPNP_DAEMON,			CURRENT_SETTING,	"UPNP",			BYTE_T,		_OFFSET(upnp), 			_SIZE(upnp),			"0"),
MIB_TBL_ENTRY(MIB_UPNP_EXT_ITF,			CURRENT_SETTING,	"UPNP_EXT_ITF",		BYTE_T,		_OFFSET(upnpExtItf), 		_SIZE(upnpExtItf),		"255"),
#ifdef DOMAIN_BLOCKING_SUPPORT
MIB_TBL_ENTRY(MIB_DOMAINBLK_CAPABILITY,		CURRENT_SETTING,	"DOMAINBLK_CAPABILITY",	BYTE_T,		_OFFSET(domainblkcap),		_SIZE(domainblkcap),		"0"),  // Mason Yu for Domain Blocking
#endif


#ifdef WLAN_SUPPORT
#if defined(ZTE_531B_BRIDGE_SC) || defined(ZTE_GENERAL_ROUTER_SC)
MIB_TBL_ENTRY(MIB_WLAN_SSID,			CURRENT_SETTING,	"SSID", 		STRING_T,	_OFFSET(ssid),			_SIZE(ssid),			""),
#else
#ifdef CONFIG_BOA_WEB_E8B_CH
//MIB_TBL_ENTRY(MIB_WLAN_SSID,			CURRENT_SETTING,	"SSID", 		STRING_T,	_OFFSET(ssid),			_SIZE(ssid),			"ChinaNet-two"),  //cathy
MIB_TBL_ENTRY(MIB_WLAN_SSID,			CURRENT_SETTING,	"SSID", 		STRING_T,	_OFFSET(ssid),			_SIZE(ssid),			""),  //xl_yue:will be initiated in setupWlan()
#else
MIB_TBL_ENTRY(MIB_WLAN_SSID,			CURRENT_SETTING,	"SSID", 		STRING_T,	_OFFSET(ssid),			_SIZE(ssid),			"ADSL Modem"),
#endif
#endif
MIB_TBL_ENTRY(MIB_WLAN_CHAN_NUM,		CURRENT_SETTING,	"CHANNEL", 		BYTE_T, 	_OFFSET(channel),		_SIZE(channel),			"0"),	//cathy, should be 0
MIB_TBL_ENTRY(MIB_WLAN_WEP,			CURRENT_SETTING,	"WEP", 			BYTE_T,		_OFFSET(wep),			_SIZE(wep),			"0"),
MIB_TBL_ENTRY(MIB_WLAN_WEP64_KEY1,		CURRENT_SETTING,	"WEP64_KEY1", 		BYTE5_T,	_OFFSET(wep64Key1),		_SIZE(wep64Key1),		"0000000000"),
MIB_TBL_ENTRY(MIB_WLAN_WEP64_KEY2,		CURRENT_SETTING,	"WEP64_KEY2", 		BYTE5_T,	_OFFSET(wep64Key2),		_SIZE(wep64Key2),		"0000000000"),
MIB_TBL_ENTRY(MIB_WLAN_WEP64_KEY3,		CURRENT_SETTING,	"WEP64_KEY3", 		BYTE5_T,	_OFFSET(wep64Key3),		_SIZE(wep64Key3),		"0000000000"),
MIB_TBL_ENTRY(MIB_WLAN_WEP64_KEY4,		CURRENT_SETTING,	"WEP64_KEY4", 		BYTE5_T,	_OFFSET(wep64Key4),		_SIZE(wep64Key4),		"0000000000"),
MIB_TBL_ENTRY(MIB_WLAN_WEP128_KEY1,		CURRENT_SETTING,	"WEP128_KEY1", 		BYTE13_T,	_OFFSET(wep128Key1),		_SIZE(wep128Key1),		"00000000000000000000000000"),
MIB_TBL_ENTRY(MIB_WLAN_WEP128_KEY2,		CURRENT_SETTING,	"WEP128_KEY2", 		BYTE13_T,	_OFFSET(wep128Key2),		_SIZE(wep128Key2),		"00000000000000000000000000"),
MIB_TBL_ENTRY(MIB_WLAN_WEP128_KEY3,		CURRENT_SETTING,	"WEP128_KEY3", 		BYTE13_T,	_OFFSET(wep128Key3),		_SIZE(wep128Key3),		"00000000000000000000000000"),
MIB_TBL_ENTRY(MIB_WLAN_WEP128_KEY4,		CURRENT_SETTING,	"WEP128_KEY4", 		BYTE13_T,	_OFFSET(wep128Key4),		_SIZE(wep128Key4),		"00000000000000000000000000"),
MIB_TBL_ENTRY(MIB_WLAN_WEP_DEFAULT_KEY,		CURRENT_SETTING,	"WEP_DEFAULT_KEY", 	BYTE_T,		_OFFSET(wepDefaultKey),		_SIZE(wepDefaultKey),		"0"),
MIB_TBL_ENTRY(MIB_WLAN_WEP_KEY_TYPE,		CURRENT_SETTING,	"WEP_KEY_TYPE", 	BYTE_T,		_OFFSET(wepKeyType),		_SIZE(wepKeyType),		"0"),
MIB_TBL_ENTRY(MIB_WLAN_FRAG_THRESHOLD,		CURRENT_SETTING,	"FRAG_THRESHOLD", 	WORD_T,		_OFFSET(fragThreshold),		_SIZE(fragThreshold),		"2346"),
MIB_TBL_ENTRY(MIB_WLAN_SUPPORTED_RATE,		CURRENT_SETTING,	"SUPPORTED_RATES", 	WORD_T,		_OFFSET(supportedRates),	_SIZE(supportedRates),		"4095"),
MIB_TBL_ENTRY(MIB_WLAN_BEACON_INTERVAL,		CURRENT_SETTING,	"BEACON_INTERVAL", 	WORD_T,		_OFFSET(beaconInterval),	_SIZE(beaconInterval),		"100"),
#if defined(ZTE_531B_BRIDGE_SC) || defined(ZTE_GENERAL_ROUTER_SC)
MIB_TBL_ENTRY(MIB_WLAN_PREAMBLE_TYPE,		CURRENT_SETTING,	"PREAMBLE_TYPE", 	BYTE_T,		_OFFSET(preambleType),		_SIZE(preambleType),		"2"),
#else
MIB_TBL_ENTRY(MIB_WLAN_PREAMBLE_TYPE,		CURRENT_SETTING,	"PREAMBLE_TYPE", 	BYTE_T,		_OFFSET(preambleType),		_SIZE(preambleType),		"0"),
#endif
MIB_TBL_ENTRY(MIB_WLAN_BASIC_RATE,		CURRENT_SETTING,	"BASIC_RATES", 		WORD_T, 	_OFFSET(basicRates),		_SIZE(basicRates),		"15"),
MIB_TBL_ENTRY(MIB_WLAN_RTS_THRESHOLD,		CURRENT_SETTING,	"RTS_THRESHOLD", 	WORD_T, 	_OFFSET(rtsThreshold),		_SIZE(rtsThreshold),		"2347"),
MIB_TBL_ENTRY(MIB_WLAN_AUTH_TYPE,		CURRENT_SETTING,	"AUTH_TYPE", 		BYTE_T,		_OFFSET(authType),		_SIZE(authType),		"0"),
MIB_TBL_ENTRY(MIB_WLAN_HIDDEN_SSID,		CURRENT_SETTING,	"HIDDEN_SSID", 		BYTE_T,		_OFFSET(hiddenSSID),		_SIZE(hiddenSSID),		"0"),
MIB_TBL_ENTRY(MIB_WLAN_DISABLED,		CURRENT_SETTING,	"WLAN_DISABLED", 	BYTE_T,		_OFFSET(wlanDisabled),		_SIZE(wlanDisabled),		"0"),
// Added by Mason Yu for TxPower
//modified by xl_yue
#if defined(ZTE_531B_BRIDGE_SC) || defined(ZTE_GENERAL_ROUTER_SC)
MIB_TBL_ENTRY(MIB_TX_POWER,			CURRENT_SETTING,	"TX_POWER", 		BYTE_T,		_OFFSET(txPower),		_SIZE(txPower),			"0"),	//default 100%
#else
MIB_TBL_ENTRY(MIB_TX_POWER,			CURRENT_SETTING,	"TX_POWER", 		BYTE_T,		_OFFSET(txPower),		_SIZE(txPower),			"2"),	//default 60mW
#endif
MIB_TBL_ENTRY(MIB_WLAN_INACTIVITY_TIME,		CURRENT_SETTING,	"INACTIVITY_TIME",	DWORD_T,	_OFFSET(inactivityTime),	_SIZE(inactivityTime),		"30000"),
MIB_TBL_ENTRY(MIB_WLAN_RATE_ADAPTIVE_ENABLED,	CURRENT_SETTING,	"RATE_ADAPTIVE_ENABLED",BYTE_T,		_OFFSET(rateAdaptiveEnabled),	_SIZE(rateAdaptiveEnabled),	"1"),
MIB_TBL_ENTRY(MIB_WLAN_DTIM_PERIOD,		CURRENT_SETTING,	"DTIM_PERIOD", 		BYTE_T,		_OFFSET(dtimPeriod),		_SIZE(dtimPeriod),		"1"),
MIB_TBL_ENTRY(MIB_WLAN_MODE,			CURRENT_SETTING,	"WLAN_MODE", 		BYTE_T,		_OFFSET(wlanMode),		_SIZE(wlanMode),		"0"),
MIB_TBL_ENTRY(MIB_WLAN_NETWORK_TYPE,		CURRENT_SETTING,	"NETWORK_TYPE",		BYTE_T,		_OFFSET(networkType),		_SIZE(networkType),		"0"),
#ifdef WLAN_IAPP
MIB_TBL_ENTRY(MIB_WLAN_IAPP_DISABLED,		CURRENT_SETTING,	"IAPP_DISABLED",	BYTE_T,		_OFFSET(iappDisabled),		_SIZE(iappDisabled),		"0"),
#endif

#ifdef WLAN_WDS
MIB_TBL_ENTRY(MIB_WLAN_WDS_ENABLED,		CURRENT_SETTING,	"WLAN_WDS_ENABLED",	BYTE_T,		_OFFSET(wdsEnabled),		_SIZE(wdsEnabled),		"0"),
MIB_TBL_ENTRY(MIB_WLAN_WDS_NUM,			CURRENT_SETTING,	"WLAN_WDS_NUM",		BYTE_T,		_OFFSET(wdsNum),		_SIZE(wdsNum),			"0"),
MIB_TBL_ENTRY(MIB_WLAN_WDS,			CURRENT_SETTING,	"WLAN_WDS",		WDS_ARRAY_T,	_OFFSET(wdsArray),		_SIZE(wdsArray),		""),
MIB_TBL_ENTRY(MIB_WLAN_WDS_WEP,			CURRENT_SETTING,	"WDS_WEP", 		BYTE_T,		_OFFSET(wdsWep),		_SIZE(wdsWep),			"0"),
MIB_TBL_ENTRY(MIB_WLAN_WDS_WEP64_KEY1,		CURRENT_SETTING,	"WDS_WEP64_KEY1", 	BYTE5_T,	_OFFSET(wdsWep64Key1),		_SIZE(wdsWep64Key1),		"0000000000"),
MIB_TBL_ENTRY(MIB_WLAN_WDS_WEP64_KEY2,		CURRENT_SETTING,	"WDS_WEP64_KEY2", 	BYTE5_T,	_OFFSET(wdsWep64Key2),		_SIZE(wdsWep64Key2),		"0000000000"),
MIB_TBL_ENTRY(MIB_WLAN_WDS_WEP64_KEY3,		CURRENT_SETTING,	"WDS_WEP64_KEY3", 	BYTE5_T,	_OFFSET(wdsWep64Key3),		_SIZE(wdsWep64Key3),		"0000000000"),
MIB_TBL_ENTRY(MIB_WLAN_WDS_WEP64_KEY4,		CURRENT_SETTING,	"WDS_WEP64_KEY4", 	BYTE5_T,	_OFFSET(wdsWep64Key4),		_SIZE(wdsWep64Key4),		"0000000000"),
MIB_TBL_ENTRY(MIB_WLAN_WDS_WEP128_KEY1,		CURRENT_SETTING,	"WDS_WEP128_KEY1",	BYTE13_T,	_OFFSET(wdsWep128Key1),		_SIZE(wdsWep128Key1),		"00000000000000000000000000"),
MIB_TBL_ENTRY(MIB_WLAN_WDS_WEP128_KEY2,		CURRENT_SETTING,	"WDS_WEP128_KEY2", 	BYTE13_T,	_OFFSET(wdsWep128Key2),		_SIZE(wdsWep128Key2),		"00000000000000000000000000"),
MIB_TBL_ENTRY(MIB_WLAN_WDS_WEP128_KEY3,		CURRENT_SETTING,	"WDS_WEP128_KEY3", 	BYTE13_T,	_OFFSET(wdsWep128Key3),		_SIZE(wdsWep128Key3),		"00000000000000000000000000"),
MIB_TBL_ENTRY(MIB_WLAN_WDS_WEP128_KEY4,		CURRENT_SETTING,	"WDS_WEP128_KEY4", 	BYTE13_T,	_OFFSET(wdsWep128Key4),		_SIZE(wdsWep128Key4),		"00000000000000000000000000"),
MIB_TBL_ENTRY(MIB_WLAN_WDS_WEP_DEFAULT_KEY,	CURRENT_SETTING,	"WDS_WEP_DEFAULT_KEY", 	BYTE_T,		_OFFSET(wdsWepDefaultKey),	_SIZE(wdsWepDefaultKey),	"0"),
MIB_TBL_ENTRY(MIB_WLAN_WDS_WEP_KEY_TYPE,	CURRENT_SETTING,	"WDS_WEP_KEY_TYPE", 	BYTE_T,		_OFFSET(wdsWepKeyType),		_SIZE(wdsWepKeyType),		"1"),
#endif

#ifdef WLAN_WPA
#ifdef CONFIG_BOA_WEB_E8B_CH	//cathy, default wpa-psk-tkip
MIB_TBL_ENTRY(MIB_WLAN_ENCRYPT,			CURRENT_SETTING,	"WLAN_ENCRYPT",		BYTE_T,		_OFFSET(encrypt),		_SIZE(encrypt),			"2"),	//wpa-psk is enabled defaultly
#else
MIB_TBL_ENTRY(MIB_WLAN_ENCRYPT,			CURRENT_SETTING,	"WLAN_ENCRYPT",		BYTE_T,		_OFFSET(encrypt),		_SIZE(encrypt),			"0"),
#endif
MIB_TBL_ENTRY(MIB_WLAN_ENABLE_SUPP_NONWPA,	CURRENT_SETTING,	"WLAN_ENABLE_SUPP_NONWPA", BYTE_T,	_OFFSET(enableSuppNonWpa),	_SIZE(enableSuppNonWpa),	"0"),
MIB_TBL_ENTRY(MIB_WLAN_SUPP_NONWPA,		CURRENT_SETTING,	"WLAN_SUPP_NONWPA", 	BYTE_T,		_OFFSET(suppNonWpa),		_SIZE(suppNonWpa),		"0"),
MIB_TBL_ENTRY(MIB_WLAN_WPA_AUTH,		CURRENT_SETTING,	"WLAN_WPA_AUTH", 	BYTE_T,		_OFFSET(wpaAuth),		_SIZE(wpaAuth),			"2"),	//psk
MIB_TBL_ENTRY(MIB_WLAN_WPA_CIPHER_SUITE,	CURRENT_SETTING,	"WLAN_WPA_CIPHER_SUITE",BYTE_T,		_OFFSET(wpaCipher),		_SIZE(wpaCipher),		"1"),		//tkip
#ifdef CONFIG_BOA_WEB_E8B_CH
//MIB_TBL_ENTRY(MIB_WLAN_WPA_PSK,			CURRENT_SETTING,	"WLAN_WPA_PSK",		STRING_T,	_OFFSET(wpaPSK),		_SIZE(wpaPSK),			"12345678"),
MIB_TBL_ENTRY(MIB_WLAN_WPA_PSK,			CURRENT_SETTING,	"WLAN_WPA_PSK",		STRING_T,	_OFFSET(wpaPSK),		_SIZE(wpaPSK),			"0"),	//xl_yue:will create in generateWpaConf()
#else
MIB_TBL_ENTRY(MIB_WLAN_WPA_PSK,			CURRENT_SETTING,	"WLAN_WPA_PSK",		STRING_T,	_OFFSET(wpaPSK),		_SIZE(wpaPSK),			"0"),
#endif
MIB_TBL_ENTRY(MIB_WLAN_WPA_GROUP_REKEY_TIME,	CURRENT_SETTING,	"WLAN_WPA_GROUP_REKEY_TIME",DWORD_T,	_OFFSET(wpaGroupRekeyTime),	_SIZE(wpaGroupRekeyTime),	"86400"),
MIB_TBL_ENTRY(MIB_WLAN_ENABLE_MAC_AUTH,		CURRENT_SETTING,	"MAC_AUTH_ENABLED",     BYTE_T,         _OFFSET(macAuthEnabled),	_SIZE(macAuthEnabled),		"0"),
#ifdef WLAN_1x
MIB_TBL_ENTRY(MIB_WLAN_RS_IP,			CURRENT_SETTING,	"RS_IP",		IA_T,		_OFFSET(rsIpAddr),		_SIZE(rsIpAddr),		"0.0.0.0"),
MIB_TBL_ENTRY(MIB_WLAN_RS_PORT,			CURRENT_SETTING,	"RS_PORT",		WORD_T,		_OFFSET(rsPort),		_SIZE(rsPort),			"1812"),
MIB_TBL_ENTRY(MIB_WLAN_RS_PASSWORD,		CURRENT_SETTING,	"RS_PASSWORD",		STRING_T,	_OFFSET(rsPassword),		_SIZE(rsPassword),		0),
MIB_TBL_ENTRY(MIB_WLAN_RS_RETRY,		CURRENT_SETTING,	"RS_MAXRETRY",		BYTE_T,		_OFFSET(rsMaxRetry),		_SIZE(rsMaxRetry),		"3"),
MIB_TBL_ENTRY(MIB_WLAN_RS_INTERVAL_TIME,	CURRENT_SETTING,	"RS_INTERVAL_TIME",	WORD_T,		_OFFSET(rsIntervalTime),	_SIZE(rsIntervalTime),		"5"),
MIB_TBL_ENTRY(MIB_WLAN_ACCOUNT_RS_ENABLED,	CURRENT_SETTING,	"ACCOUNT_RS_ENABLED", 	BYTE_T,		_OFFSET(accountRsEnabled),	_SIZE(accountRsEnabled),	"0"),
MIB_TBL_ENTRY(MIB_WLAN_ACCOUNT_RS_IP,		CURRENT_SETTING,	"ACCOUNT_RS_IP",	IA_T,		_OFFSET(accountRsIpAddr),	_SIZE(accountRsIpAddr),		0),
MIB_TBL_ENTRY(MIB_WLAN_ACCOUNT_RS_PORT,		CURRENT_SETTING,	"ACCOUNT_RS_PORT",	WORD_T,		_OFFSET(accountRsPort),		_SIZE(accountRsPort),		"0"),
MIB_TBL_ENTRY(MIB_WLAN_ACCOUNT_RS_PASSWORD,	CURRENT_SETTING,	"ACCOUNT_RS_PASSWORD",	STRING_T,	_OFFSET(accountRsPassword),	_SIZE(accountRsPassword),	0),
MIB_TBL_ENTRY(MIB_WLAN_ACCOUNT_UPDATE_ENABLED,	CURRENT_SETTING,	"ACCOUNT_RS_UPDATE_ENABLED",BYTE_T,	_OFFSET(accountRsUpdateEnabled),_SIZE(accountRsUpdateEnabled),	"0"),
MIB_TBL_ENTRY(MIB_WLAN_ACCOUNT_UPDATE_DELAY,	CURRENT_SETTING,	"ACCOUNT_RS_UPDATE_DELAY",WORD_T,	_OFFSET(accountRsUpdateDelay),	_SIZE(accountRsUpdateDelay),	"0"),
MIB_TBL_ENTRY(MIB_WLAN_ACCOUNT_RS_RETRY,	CURRENT_SETTING,	"ACCOUNT_RS_MAXRETRY",	BYTE_T,		_OFFSET(accountRsMaxRetry),	_SIZE(accountRsMaxRetry),	"0"),
MIB_TBL_ENTRY(MIB_WLAN_ACCOUNT_RS_INTERVAL_TIME,CURRENT_SETTING,	"ACCOUNT_RS_INTERVAL_TIME",	WORD_T,	_OFFSET(accountRsIntervalTime),	_SIZE(accountRsIntervalTime),	"0"),
MIB_TBL_ENTRY(MIB_WLAN_ENABLE_1X,		CURRENT_SETTING,	"WLAN_ENABLE_1X", 	BYTE_T,		_OFFSET(enable1X),		_SIZE(enable1X),		"0"),
#endif
MIB_TBL_ENTRY(MIB_WLAN_WPA_PSK_FORMAT,		CURRENT_SETTING,	"WLAN_PSK_FORMAT", 	BYTE_T,		_OFFSET(wpaPSKFormat),		_SIZE(wpaPSKFormat),		"0"),
MIB_TBL_ENTRY(MIB_WLAN_WPA2_CIPHER_SUITE,	CURRENT_SETTING,	"WPA2_CIPHER_SUITE",	BYTE_T,		_OFFSET(wpa2Cipher),		_SIZE(wpa2Cipher),		"2"),
#endif                                          

#ifdef WLAN_ACL
MIB_TBL_ENTRY(MIB_WLAN_AC_ENABLED,		CURRENT_SETTING,	"WLAN_MACAC_ENABLED",	BYTE_T,		_OFFSET(acEnabled),		_SIZE(acEnabled),		"0"),
#endif
                                                
MIB_TBL_ENTRY(MIB_WLAN_BLOCK_RELAY,		CURRENT_SETTING,	"WLAN_BLOCK_RELAY",	BYTE_T,		_OFFSET(blockRelay),		_SIZE(blockRelay),		"0"),
MIB_TBL_ENTRY(MIB_WLAN_BLOCK_ETH2WIR,		CURRENT_SETTING,	"WLAN_BLOCK_ETH2WIR",	BYTE_T,		_OFFSET(BlockEth2Wir),		_SIZE(BlockEth2Wir),		"0"),
MIB_TBL_ENTRY(MIB_WLAN_ITF_GROUP,		CURRENT_SETTING,	"WLAN_ITF_GROUP",	BYTE_T,		_OFFSET(itfGroup),		_SIZE(itfGroup),		"0"),
#ifdef WLAN_8185AG
MIB_TBL_ENTRY(MIB_WLAN_BAND,			CURRENT_SETTING,	"WLAN_BAND",		BYTE_T,		_OFFSET(wlanBand),		_SIZE(wlanBand),		"3"),
MIB_TBL_ENTRY(MIB_WLAN_FIX_RATE,		CURRENT_SETTING,	"WLAN_FIX_RATE",	WORD_T,		_OFFSET(fixedTxRate),		_SIZE(fixedTxRate),		"1"),
#ifdef CONFIG_BOA_WEB_E8B_CH
MIB_TBL_ENTRY(MIB_WLAN_MLCSTRATE,		CURRENT_SETTING,	"WLAN_MLCSTRATE",	WORD_T,		_OFFSET(mlcstRate),		_SIZE(mlcstRate),		"0"),	//cathy
#endif
#endif
#ifdef WLAN_WEB_REDIRECT  //jiunming,web_redirect
MIB_TBL_ENTRY(MIB_WLAN_WEB_REDIR_URL,		CURRENT_SETTING,	"WLAN_WEB_REDIR_URL",	STRING_T,	_OFFSET(WlanWebRedirURL),	_SIZE(WlanWebRedirURL),		"http://192.168.1.1/"),
#endif
#ifdef WLAN_QoS
#ifdef CONFIG_BOA_WEB_E8B_CH
MIB_TBL_ENTRY(MIB_WLAN_QoS, 			CURRENT_SETTING, 	"WLAN_QoS", BYTE_T,	_OFFSET(wlanqos), 	_SIZE(wlanqos), 	"0"),		//cathy, should be 1
#else
MIB_TBL_ENTRY(MIB_WLAN_QoS, 			CURRENT_SETTING, 	"WLAN_QoS", BYTE_T,	_OFFSET(wlanqos), 	_SIZE(wlanqos), 	"0"),
#endif
#endif
#endif // of WLAN_SUPPORT

// Added by Mason Yu for write superUser into Current Setting
#if defined(E8B_DEFAULT_ACCOUNT)
MIB_TBL_ENTRY(MIB_SUSER_NAME,			CURRENT_SETTING,	"SUSER_NAME",		STRING_T,	_OFFSET(suserName), 		_SIZE(suserName),		"telecomadmin"),
#else
MIB_TBL_ENTRY(MIB_SUSER_NAME,			CURRENT_SETTING,	"SUSER_NAME",		STRING_T,	_OFFSET(suserName), 		_SIZE(suserName),		"admin"),
#endif
#if defined(ZTE_531B_BRIDGE_SC)||defined(ZTE_GENERAL_ROUTER_SC)
MIB_TBL_ENTRY(MIB_SUSER_PASSWORD,		CURRENT_SETTING,	"SUSER_PASSWORD",	STRING_T,	_OFFSET(suserPassword), 	_SIZE(suserPassword),		"admin"),
#elif defined(E8B_DEFAULT_ACCOUNT)
MIB_TBL_ENTRY(MIB_SUSER_PASSWORD,		CURRENT_SETTING,	"SUSER_PASSWORD",	STRING_T,	_OFFSET(suserPassword), 	_SIZE(suserPassword),		"nE7jA%5m"),
#else
MIB_TBL_ENTRY(MIB_SUSER_PASSWORD,		CURRENT_SETTING,	"SUSER_PASSWORD",	STRING_T,	_OFFSET(suserPassword), 	_SIZE(suserPassword),		"system"),
#endif
MIB_TBL_ENTRY(MIB_ADSL_TONE,	 	 	CURRENT_SETTING,	"ADSL_TONE",		BYTE_ARRAY_T,	_OFFSET(adslTone), 		_SIZE(adslTone),		"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00"),    // Added by Mason Yu for correct Tone Mib Type
// ioctl for direct bridge mode, jiunming
MIB_TBL_ENTRY(MIB_DIRECT_BRIDGE_MODE,		CURRENT_SETTING,	"DIRECT_BRIDGE_MODE",	BYTE_T,		_OFFSET(DirectBridgeMode), 	_SIZE(DirectBridgeMode),	"1"),
MIB_TBL_ENTRY(MIB_ADSL_HIGH_INP,		CURRENT_SETTING,	"ADSL_HIGH_INP",	BYTE_T,		_OFFSET(adslHighInp), 		_SIZE(adslHighInp),		"0"),
#ifdef AUTO_PROVISIONING
// Jenny, configuration file version
MIB_TBL_ENTRY(MIB_CONFIG_VERSION,		CURRENT_SETTING,	"CONFIG_VERSION",	STRING_T,		_OFFSET(configFileVersion), 		_SIZE(configFileVersion),		"0.0.0"),
// Jenny, http server IP for auto-provisioning
MIB_TBL_ENTRY(MIB_HTTP_SERVER_IP,		CURRENT_SETTING,	"HTTP_SERVER_IP",	IA_T,		_OFFSET(httpServerIpAddr), 		_SIZE(httpServerIpAddr),		"192.168.1.6"),
#endif
#if 0
// Jenny, PPPoE AC MAC address
MIB_TBL_ENTRY(MIB_PPPOE_AC_MAC_ADDR,	CURRENT_SETTING,	"PPPOE_AC_MAC_ADDR",	BYTE6_T, 	_OFFSET(pppoeACMacAddr),	_SIZE(pppoeACMacAddr),		"000000000000"),
// Jenny,identifier for PPPoE session
MIB_TBL_ENTRY(MIB_PPPOE_SESSION,		CURRENT_SETTING,	"PPPOE_SESSION", 		WORD_T, 	_OFFSET(pppoeSession),		_SIZE(pppoeSession),		"0"),
#endif

#ifdef _CWMP_MIB_ /*jiunming, mib for cwmp-tr069*/
MIB_TBL_ENTRY(CWMP_PROVISIONINGCODE,		CURRENT_SETTING,	"CWMP_PROVISIONINGCODE",	STRING_T,		_OFFSET(cwmp_ProvisioningCode), 	_SIZE(cwmp_ProvisioningCode),	""),
MIB_TBL_ENTRY(CWMP_ACS_URL,			CURRENT_SETTING,	"CWMP_ACS_URL",			STRING_T,		_OFFSET(cwmp_ACSURL), 			_SIZE(cwmp_ACSURL),		"http://202.102.15.115/ACS/"),
//MIB_TBL_ENTRY(CWMP_ACS_URL,			CURRENT_SETTING,	"CWMP_ACS_URL",			STRING_T,		_OFFSET(cwmp_ACSURL), 			_SIZE(cwmp_ACSURL),		"http://218.80.221.105:9090/ACS-server/ACS"),
#ifdef CTC_WAN_NAME
MIB_TBL_ENTRY(CWMP_ACS_URL_OLD,			CURRENT_SETTING,	"CWMP_ACS_URL_OLD",			STRING_T,		_OFFSET(cwmp_ACSURL_OLD), 			_SIZE(cwmp_ACSURL),		""),
#endif
MIB_TBL_ENTRY(CWMP_ACS_USERNAME,		CURRENT_SETTING,	"CWMP_ACS_USERNAME",		STRING_T,		_OFFSET(cwmp_ACSUserName), 		_SIZE(cwmp_ACSUserName),	"hgw"),
MIB_TBL_ENTRY(CWMP_ACS_PASSWORD,		CURRENT_SETTING,	"CWMP_ACS_PASSWORD",		STRING_T,		_OFFSET(cwmp_ACSPassword), 		_SIZE(cwmp_ACSPassword),	"hgw"),
MIB_TBL_ENTRY(CWMP_INFORM_ENABLE,		CURRENT_SETTING,	"CWMP_INFORM_ENABLE",		BYTE_T,			_OFFSET(cwmp_InformEnable), 		_SIZE(cwmp_InformEnable),	"1"),
MIB_TBL_ENTRY(CWMP_INFORM_INTERVAL,		CURRENT_SETTING,	"CWMP_INFORM_INTERVAL",		INTEGER_T,		_OFFSET(cwmp_InformInterval), 		_SIZE(cwmp_InformInterval),	"43200"),
MIB_TBL_ENTRY(CWMP_INFORM_TIME,			CURRENT_SETTING,	"CWMP_INFORM_TIME",		INTEGER_T,		_OFFSET(cwmp_InformTime), 		_SIZE(cwmp_InformTime),		"0"),
MIB_TBL_ENTRY(CWMP_CONREQ_ENABLE,		CURRENT_SETTING,	"CWMP_CONREQ_ENABLE",		BYTE_T,		_OFFSET(cwmp_ConnReqEnable), 		_SIZE(cwmp_ConnReqEnable),	"1"),
MIB_TBL_ENTRY(CWMP_CONREQ_USERNAME,		CURRENT_SETTING,	"CWMP_CONREQ_USERNAME",		STRING_T,		_OFFSET(cwmp_ConnReqUserName), 		_SIZE(cwmp_ConnReqUserName),	"itms"),
MIB_TBL_ENTRY(CWMP_CONREQ_PASSWORD,		CURRENT_SETTING,	"CWMP_CONREQ_PASSWORD",		STRING_T,		_OFFSET(cwmp_ConnReqPassword), 		_SIZE(cwmp_ConnReqPassword),	"itms"),
MIB_TBL_ENTRY(CWMP_ACS_UPGRADESMANAGED,		CURRENT_SETTING,	"CWMP_ACS_UPGRADESMANAGED",	BYTE_T,			_OFFSET(cwmp_UpgradesManaged), 		_SIZE(cwmp_UpgradesManaged),	"1"),
MIB_TBL_ENTRY(CWMP_LAN_CONFIGPASSWD,		CURRENT_SETTING,	"CWMP_LAN_CONFIGPASSWD",	STRING_T,		_OFFSET(cwmp_LANConfPassword), 		_SIZE(cwmp_LANConfPassword),	""),
MIB_TBL_ENTRY(CWMP_SERIALNUMBER,		CURRENT_SETTING,	"CWMP_SERIALNUMBER",		STRING_T,		_OFFSET(cwmp_SerialNumber), 		_SIZE(cwmp_SerialNumber),	"00000001"),
MIB_TBL_ENTRY(CWMP_DHCP_SERVERCONF,		CURRENT_SETTING,	"CWMP_DHCP_SERVERCONF",		BYTE_T,			_OFFSET(cwmp_DHCP_ServerConf), 		_SIZE(cwmp_DHCP_ServerConf),	"1"),
MIB_TBL_ENTRY(CWMP_LAN_IPIFENABLE,		CURRENT_SETTING,	"CWMP_LAN_IPIFENABLE",		BYTE_T,			_OFFSET(cwmp_LAN_IPIFEnable), 		_SIZE(cwmp_LAN_IPIFEnable),	"1"),
MIB_TBL_ENTRY(CWMP_LAN_ETHIFENABLE,		CURRENT_SETTING,	"CWMP_LAN_ETHIFENABLE",		BYTE_T,			_OFFSET(cwmp_LAN_EthIFEnable), 		_SIZE(cwmp_LAN_EthIFEnable),	"1"),
MIB_TBL_ENTRY(CWMP_WLAN_BASICENCRY,		CURRENT_SETTING,	"CWMP_WLAN_BASICENCRY",		BYTE_T,			_OFFSET(cwmp_WLAN_BasicEncry), 		_SIZE(cwmp_WLAN_BasicEncry),	"0"),
MIB_TBL_ENTRY(CWMP_WLAN_WPAENCRY,		CURRENT_SETTING,	"CWMP_WLAN_WPAENCRY",		BYTE_T,			_OFFSET(cwmp_WLAN_WPAEncry), 		_SIZE(cwmp_WLAN_WPAEncry),	"0"),

MIB_TBL_ENTRY(CWMP_DL_COMMANDKEY,		CURRENT_SETTING,	"CWMP_DL_COMMANDKEY",		STRING_T,		_OFFSET(cwmp_DL_CommandKey), 		_SIZE(cwmp_DL_CommandKey),	""),
MIB_TBL_ENTRY(CWMP_DL_STARTTIME,		CURRENT_SETTING,	"CWMP_DL_STARTTIME",		INTEGER_T,		_OFFSET(cwmp_DL_StartTime), 		_SIZE(cwmp_DL_StartTime),	"0"),
MIB_TBL_ENTRY(CWMP_DL_COMPLETETIME,		CURRENT_SETTING,	"CWMP_DL_COMPLETETIME",		INTEGER_T,		_OFFSET(cwmp_DL_CompleteTime), 		_SIZE(cwmp_DL_CompleteTime),	"0"),
MIB_TBL_ENTRY(CWMP_DL_FAULTCODE,		CURRENT_SETTING,	"CWMP_DL_FAULTCODE",		INTEGER_T,		_OFFSET(cwmp_DL_FaultCode), 		_SIZE(cwmp_DL_FaultCode),	"0"),
MIB_TBL_ENTRY(CWMP_INFORM_EVENTCODE,		CURRENT_SETTING,	"CWMP_INFORM_EVENTCODE",	INTEGER_T,		_OFFSET(cwmp_Inform_EventCode), 	_SIZE(cwmp_Inform_EventCode),	"1"),
MIB_TBL_ENTRY(CWMP_RB_COMMANDKEY,		CURRENT_SETTING,	"CWMP_RB_COMMANDKEY",		STRING_T,		_OFFSET(cwmp_RB_CommandKey), 		_SIZE(cwmp_RB_CommandKey),	""),
MIB_TBL_ENTRY(CWMP_ACS_PARAMETERKEY,		CURRENT_SETTING,	"CWMP_ACS_PARAMETERKEY",	STRING_T,		_OFFSET(cwmp_ACS_ParameterKey), 	_SIZE(cwmp_ACS_ParameterKey),	""),
MIB_TBL_ENTRY(CWMP_CERT_PASSWORD,		CURRENT_SETTING,	"CWMP_CERT_PASSWORD",		STRING_T,		_OFFSET(cwmp_CERT_Password), 		_SIZE(cwmp_CERT_Password),	"client"),
MIB_TBL_ENTRY(CWMP_FLAG,			CURRENT_SETTING,	"CWMP_FLAG",			BYTE_T,			_OFFSET(cwmp_Flag), 			_SIZE(cwmp_Flag),		"112"),


MIB_TBL_ENTRY(CWMP_SI_COMMANDKEY,		CURRENT_SETTING,	"CWMP_SI_COMMANDKEY",		STRING_T,		_OFFSET(cwmp_SI_CommandKey), 		_SIZE(cwmp_SI_CommandKey),	""),
#ifdef _PRMT_USERINTERFACE_
MIB_TBL_ENTRY(UIF_PW_REQUIRED,			CURRENT_SETTING,	"UIF_PW_REQUIRED",		BYTE_T,			_OFFSET(UIF_PW_Required), 		_SIZE(UIF_PW_Required),		"1"),
MIB_TBL_ENTRY(UIF_PW_USER_SEL,			CURRENT_SETTING,	"UIF_PW_USER_SEL",		BYTE_T,			_OFFSET(UIF_PW_User_Sel), 		_SIZE(UIF_PW_User_Sel),		"0"),
MIB_TBL_ENTRY(UIF_UPGRADE,			CURRENT_SETTING,	"UIF_UPGRADE",			BYTE_T,			_OFFSET(UIF_Upgrade), 			_SIZE(UIF_Upgrade),		"0"),
MIB_TBL_ENTRY(UIF_WARRANTYDATE,			CURRENT_SETTING,	"UIF_WARRANTYDATE",		INTEGER_T,		_OFFSET(UIF_WarrantyDate), 		_SIZE(UIF_WarrantyDate),	"0"),
MIB_TBL_ENTRY(UIF_AUTOUPDATESERVER,		CURRENT_SETTING,	"UIF_AUTOUPDATESERVER",		STRING_T,		_OFFSET(UIF_AutoUpdateServer), 		_SIZE(UIF_AutoUpdateServer),	""),
MIB_TBL_ENTRY(UIF_USERUPDATESERVER,		CURRENT_SETTING,	"UIF_USERUPDATESERVER",		STRING_T,		_OFFSET(UIF_UserUpdateServer), 		_SIZE(UIF_UserUpdateServer),	""),
#endif //#ifdef _PRMT_USERINTERFACE_
#ifdef  _PRMT_X_CT_COM_IPTV_
//MIB_TBL_ENTRY(CWMP_CT_IPTV_ENABLE,		CURRENT_SETTING,	"CWMP_CT_IPTV_ENABLE",		BYTE_T,			_OFFSET(cwmp_CT_IPTV_Enable), 		_SIZE(cwmp_CT_IPTV_Enable),	"0"),
MIB_TBL_ENTRY(CWMP_CT_IPTV_IGMPENABLE,		CURRENT_SETTING,	"CWMP_CT_IPTV_IGMPENABLE",	BYTE_T,			_OFFSET(cwmp_CT_IPTV_IGMPEnable), 	_SIZE(cwmp_CT_IPTV_IGMPEnable),	"0"),
MIB_TBL_ENTRY(CWMP_CT_IPTV_STBNUMBER,		CURRENT_SETTING,	"CWMP_CT_IPTV_STBNUMBER",	INTEGER_T,		_OFFSET(cwmp_CT_IPTV_STBNumber), 	_SIZE(cwmp_CT_IPTV_STBNumber),	"0"),
#endif //#ifdef  _PRMT_X_CT_COM_IPTV_
//#ifdef _PRMT_X_CT_COM_ACCOUNT_
//MIB_TBL_ENTRY(CWMP_CT_ACC_ENABLE,		CURRENT_SETTING,	"CWMP_CT_ACC_ENABLE",		BYTE_T,			_OFFSET(cwmp_CT_Acc_Enable), 		_SIZE(cwmp_CT_Acc_Enable),	"1"),
//MIB_TBL_ENTRY(CWMP_CT_ACC_USERNAME,		CURRENT_SETTING,	"CWMP_CT_ACC_USERNAME",		STRING_T,		_OFFSET(cwmp_CT_Acc_Username), 		_SIZE(cwmp_CT_Acc_Username),	"telecomadmin"),
//MIB_TBL_ENTRY(CWMP_CT_ACC_PASSWORD,		CURRENT_SETTING,	"CWMP_CT_ACC_PASSWORD",		STRING_T,		_OFFSET(cwmp_CT_Acc_Password), 		_SIZE(cwmp_CT_Acc_Password),	"telecomadmin"),
//#endif //_PRMT_X_CT_COM_ACCOUNT_
#ifdef  _PRMT_X_CT_COM_RECON_
MIB_TBL_ENTRY(CWMP_CT_RECON_ENABLE,		CURRENT_SETTING,	"CWMP_CT_RECON_ENABLE",		BYTE_T,			_OFFSET(cwmp_CT_ReCon_Enable), 		_SIZE(cwmp_CT_ReCon_Enable),	"1"),
#endif //#ifdef  _PRMT_X_CT_COM_VPDN_
#ifdef  _PRMT_X_CT_COM_MWBAND_
MIB_TBL_ENTRY(CWMP_CT_MWBAND_MODE,		CURRENT_SETTING,	"CWMP_CT_MWBAND_MODE",		INTEGER_T,		_OFFSET(cwmp_CT_MWBAND_Mode), 		_SIZE(cwmp_CT_MWBAND_Mode),	"1"),
MIB_TBL_ENTRY(CWMP_CT_MWBAND_STB_ENABLE,	CURRENT_SETTING,	"CWMP_CT_MWBAND_STB_ENABLE",	BYTE_T,			_OFFSET(cwmp_CT_MWBAND_STB_Enable), 	_SIZE(cwmp_CT_MWBAND_STB_Enable),"0"),
MIB_TBL_ENTRY(CWMP_CT_MWBAND_CMR_ENABLE,	CURRENT_SETTING,	"CWMP_CT_MWBAND_CMR_ENABLE",	BYTE_T,			_OFFSET(cwmp_CT_MWBAND_CMR_Enable), 	_SIZE(cwmp_CT_MWBAND_CMR_Enable),"0"),
MIB_TBL_ENTRY(CWMP_CT_MWBAND_PC_ENABLE,		CURRENT_SETTING,	"CWMP_CT_MWBAND_PC_ENABLE",	BYTE_T,			_OFFSET(cwmp_CT_MWBAND_PC_Enable), 	_SIZE(cwmp_CT_MWBAND_PC_Enable),"0"),
MIB_TBL_ENTRY(CWMP_CT_MWBAND_PHN_ENABLE,	CURRENT_SETTING,	"CWMP_CT_MWBAND_PHN_ENABLE",	BYTE_T,			_OFFSET(cwmp_CT_MWBAND_PHN_Enable), 	_SIZE(cwmp_CT_MWBAND_PHN_Enable),"0"),
MIB_TBL_ENTRY(CWMP_CT_MWBAND_NUMBER,		CURRENT_SETTING,	"CWMP_CT_MWBAND_NUMBER",	INTEGER_T,		_OFFSET(cwmp_CT_MWBAND_Number),		_SIZE(cwmp_CT_MWBAND_Number),	"4"),
MIB_TBL_ENTRY(CWMP_CT_MWBAND_STB_NUM,		CURRENT_SETTING,	"CWMP_CT_MWBAND_STB_NUM",	INTEGER_T,		_OFFSET(cwmp_CT_MWBAND_STB_Num),	_SIZE(cwmp_CT_MWBAND_STB_Num),	"0"),
MIB_TBL_ENTRY(CWMP_CT_MWBAND_CMR_NUM,		CURRENT_SETTING,	"CWMP_CT_MWBAND_CMR_NUM",	INTEGER_T,		_OFFSET(cwmp_CT_MWBAND_CMR_Num),	_SIZE(cwmp_CT_MWBAND_CMR_Num),	"0"),
MIB_TBL_ENTRY(CWMP_CT_MWBAND_PC_NUM,		CURRENT_SETTING,	"CWMP_CT_MWBAND_PC_NUM",	INTEGER_T,		_OFFSET(cwmp_CT_MWBAND_PC_Num),		_SIZE(cwmp_CT_MWBAND_PC_Num),	"0"),
MIB_TBL_ENTRY(CWMP_CT_MWBAND_PHN_NUM,		CURRENT_SETTING,	"CWMP_CT_MWBAND_PHN_NUM",	INTEGER_T,		_OFFSET(cwmp_CT_MWBAND_PHN_Num),	_SIZE(cwmp_CT_MWBAND_PHN_Num),	"0"),
#endif //#ifdef  _PRMT_X_CT_COM_MWBAND_
#ifdef _PRMT_X_CT_COM_PORTALMNT_
MIB_TBL_ENTRY(MIB_FP_ENABLE  ,		CURRENT_SETTING,	"MIB_FP_ENABLE",		BYTE_T,			_OFFSET(cwmp_CT_PM_Enable), 		_SIZE(cwmp_CT_PM_Enable),	"0"),
MIB_TBL_ENTRY(MIB_FP_PC_ADDR,		CURRENT_SETTING,	"MIB_FP_PC_ADDR",		STRING_T,		_OFFSET(cwmp_CT_PM_URL4PC), 		_SIZE(cwmp_CT_PM_URL4PC),	""),
MIB_TBL_ENTRY(MIB_FP_STB_ADDR,		CURRENT_SETTING,	"MIB_FP_STB_ADDR",		STRING_T,		_OFFSET(cwmp_CT_PM_URL4STB), 		_SIZE(cwmp_CT_PM_URL4STB),	""),
MIB_TBL_ENTRY(MIB_FP_MOB_ADDR,		CURRENT_SETTING,	"MIB_FP_MOB_ADDR",	STRING_T,		_OFFSET(cwmp_CT_PM_URL4MOBILE), 	_SIZE(cwmp_CT_PM_URL4MOBILE),	""),
#endif //_PRMT_X_CT_COM_PORTALMNT_

#if defined( _PRMT_X_CT_COM_DHCP_)||defined(IP_BASED_CLIENT_TYPE)
//MIB_TBL_ENTRY(CWMP_CT_STB_DHCPRELAY,		CURRENT_SETTING,	"CWMP_CT_STB_DHCPRELAY",	BYTE_T,			_OFFSET(cwmp_CT_STB_DHCPRelay), 	_SIZE(cwmp_CT_STB_DHCPRelay),	"0"),
//MIB_TBL_ENTRY(CWMP_CT_PHN_DHCPRELAY,		CURRENT_SETTING,	"CWMP_CT_PHN_DHCPRELAY",	BYTE_T,			_OFFSET(cwmp_CT_PHN_DHCPRelay), 	_SIZE(cwmp_CT_PHN_DHCPRelay),	"0"),
//MIB_TBL_ENTRY(CWMP_CT_CMR_DHCPRELAY,		CURRENT_SETTING,	"CWMP_CT_CMR_DHCPRELAY",	BYTE_T,			_OFFSET(cwmp_CT_CMR_DHCPRelay), 	_SIZE(cwmp_CT_CMR_DHCPRelay),	"0"),
//MIB_TBL_ENTRY(CWMP_CT_PC_DHCPRELAY,		CURRENT_SETTING,	"CWMP_CT_PC_DHCPRELAY",		BYTE_T,			_OFFSET(cwmp_CT_PC_DHCPRelay), 		_SIZE(cwmp_CT_PHN_DHCPRelay),	"0"),
#if 1
MIB_TBL_ENTRY(CWMP_CT_PC_MINADDR,		CURRENT_SETTING,	"CWMP_CT_PC_MINADDR", 		IA_T,			_OFFSET(cwmp_CT_PC_MinAddr), 		_SIZE(cwmp_CT_PC_MinAddr),	"192.168.1.20"),
MIB_TBL_ENTRY(CWMP_CT_PC_MAXADDR,		CURRENT_SETTING,	"CWMP_CT_PC_MAXADDR", 		IA_T,			_OFFSET(cwmp_CT_PC_MaxAddr), 		_SIZE(cwmp_CT_PC_MaxAddr),	"192.168.1.29"),
MIB_TBL_ENTRY(CWMP_CT_CMR_MINADDR,		CURRENT_SETTING,	"CWMP_CT_CMR_MINADDR", 		IA_T,			_OFFSET(cwmp_CT_CMR_MinAddr), 		_SIZE(cwmp_CT_CMR_MinAddr),	"192.168.1.30"),
MIB_TBL_ENTRY(CWMP_CT_CMR_MAXADDR,		CURRENT_SETTING,	"CWMP_CT_CMR_MAXADDR", 		IA_T,			_OFFSET(cwmp_CT_CMR_MaxAddr), 		_SIZE(cwmp_CT_CMR_MaxAddr),	"192.168.1.39"),
MIB_TBL_ENTRY(CWMP_CT_STB_MINADDR,		CURRENT_SETTING,	"CWMP_CT_STB_MINADDR", 		IA_T,			_OFFSET(cwmp_CT_STB_MinAddr), 		_SIZE(cwmp_CT_STB_MinAddr),	"192.168.1.40"),
MIB_TBL_ENTRY(CWMP_CT_STB_MAXADDR,		CURRENT_SETTING,	"CWMP_CT_STB_MAXADDR", 		IA_T,			_OFFSET(cwmp_CT_STB_MaxAddr), 		_SIZE(cwmp_CT_STB_MaxAddr),	"192.168.1.49"),
MIB_TBL_ENTRY(CWMP_CT_PHN_MINADDR,		CURRENT_SETTING,	"CWMP_CT_PHN_MINADDR", 		IA_T,			_OFFSET(cwmp_CT_PHN_MinAddr), 		_SIZE(cwmp_CT_PHN_MinAddr),	"192.168.1.50"),
MIB_TBL_ENTRY(CWMP_CT_PHN_MAXADDR,		CURRENT_SETTING,	"CWMP_CT_PHN_MAXADDR", 		IA_T,			_OFFSET(cwmp_CT_PHN_MaxAddr), 		_SIZE(cwmp_CT_PHN_MaxAddr),	"192.168.1.59"),
MIB_TBL_ENTRY(CWMP_CT_HGW_MINADDR,	    CURRENT_SETTING,	"CWMP_CT_HGW_MINADDR", 	    IA_T, 	        _OFFSET(cwmp_CT_HGW_MinAddr), 	    _SIZE(cwmp_CT_HGW_MinAddr),	"192.168.1.60"),
MIB_TBL_ENTRY(CWMP_CT_HGW_MAXADDR,	    CURRENT_SETTING,	"CWMP_CT_HGW_MAXADDR", 	    IA_T, 	        _OFFSET(cwmp_CT_HGW_MaxAddr), 	    _SIZE(cwmp_CT_HGW_MaxAddr),	"192.168.1.69"),
#else
MIB_TBL_ENTRY(CWMP_CT_PC_MINADDR,	CURRENT_SETTING,	"CWMP_CT_PC_MINADDR", 	BYTE_T, 	_OFFSET(cwmp_CT_PC_MinAddr), 	_SIZE(cwmp_CT_PC_MinAddr),		"20"),
MIB_TBL_ENTRY(CWMP_CT_PC_MAXADDR,	CURRENT_SETTING,	"CWMP_CT_PC_MAXADDR", 	BYTE_T, 	_OFFSET(cwmp_CT_PC_MaxAddr), 	_SIZE(cwmp_CT_PC_MaxAddr),		"29"),
MIB_TBL_ENTRY(CWMP_CT_CMR_MINADDR,	CURRENT_SETTING,	"CWMP_CT_CMR_MINADDR", 	BYTE_T, 	_OFFSET(cwmp_CT_CMR_MinAddr), 	_SIZE(cwmp_CT_CMR_MinAddr),		"30"),
MIB_TBL_ENTRY(CWMP_CT_CMR_MAXADDR,	CURRENT_SETTING,	"CWMP_CT_CMR_MAXADDR", 	BYTE_T, 	_OFFSET(cwmp_CT_CMR_MaxAddr), 	_SIZE(cwmp_CT_CMR_MaxAddr),		"39"),
MIB_TBL_ENTRY(CWMP_CT_STB_MINADDR,	CURRENT_SETTING,	"CWMP_CT_STB_MINADDR", 	BYTE_T, 	_OFFSET(cwmp_CT_STB_MinAddr), 	_SIZE(cwmp_CT_STB_MinAddr),		"40"),
MIB_TBL_ENTRY(CWMP_CT_STB_MAXADDR,	CURRENT_SETTING,	"CWMP_CT_STB_MAXADDR", 	BYTE_T, 	_OFFSET(cwmp_CT_STB_MaxAddr), 	_SIZE(cwmp_CT_STB_MaxAddr),		"49"),
MIB_TBL_ENTRY(CWMP_CT_PHN_MINADDR,	CURRENT_SETTING,	"CWMP_CT_PHN_MINADDR", 	BYTE_T, 	_OFFSET(cwmp_CT_PHN_MinAddr), 	_SIZE(cwmp_CT_PHN_MinAddr),		"50"),
MIB_TBL_ENTRY(CWMP_CT_PHN_MAXADDR,	CURRENT_SETTING,	"CWMP_CT_PHN_MAXADDR", 	BYTE_T, 	_OFFSET(cwmp_CT_PHN_MaxAddr), 	_SIZE(cwmp_CT_PHN_MaxAddr),		"59"),
MIB_TBL_ENTRY(CWMP_CT_HGW_MINADDR,	CURRENT_SETTING,	"CWMP_CT_HGW_MINADDR", 	BYTE_T, 	_OFFSET(cwmp_CT_HGW_MinAddr), 	_SIZE(cwmp_CT_HGW_MinAddr),		"60"),
MIB_TBL_ENTRY(CWMP_CT_HGW_MAXADDR,	CURRENT_SETTING,	"CWMP_CT_HGW_MAXADDR", 	BYTE_T, 	_OFFSET(cwmp_CT_HGW_MaxAddr), 	_SIZE(cwmp_CT_HGW_MaxAddr),		"69"),
#endif
#endif //_PRMT_X_CT_COM_DHCP_
#ifdef  _PRMT_X_CT_COM_MONITOR_
MIB_TBL_ENTRY(CWMP_CT_MNT_ENABLE,		CURRENT_SETTING,	"CWMP_CT_MNT_ENABLE",		BYTE_T,			_OFFSET(cwmp_CT_MNT_Enable), 		_SIZE(cwmp_CT_MNT_Enable),	"0"),
MIB_TBL_ENTRY(CWMP_CT_MNT_NUMBER,		CURRENT_SETTING,	"CWMP_CT_MNT_NUMBER",		INTEGER_T,		_OFFSET(cwmp_CT_MNT_Number), 		_SIZE(cwmp_CT_MNT_Number),	"1"),
#endif //#ifdef  _PRMT_X_CT_COM_MONITOR_
#ifdef  _PRMT_X_CT_COM_VPDN_
MIB_TBL_ENTRY(CWMP_CT_VPDN_ENABLE,		CURRENT_SETTING,	"CWMP_CT_VPDN_ENABLE",		BYTE_T,			_OFFSET(cwmp_CT_VPDN_Enable), 		_SIZE(cwmp_CT_VPDN_Enable),	"0"),
#endif //#ifdef  _PRMT_X_CT_COM_VPDN_
//#ifdef _PRMT_X_CT_COM_WLAN_
//MIB_TBL_ENTRY(CWMP_CT_WLAN_POWERLEVEL,		CURRENT_SETTING,	"CWMP_CT_WLAN_POWERLEVEL",	INTEGER_T,		_OFFSET(cwmp_CT_WLAN_Powerlevel), 	_SIZE(cwmp_CT_WLAN_Powerlevel),	"0"),
//MIB_TBL_ENTRY(CWMP_CT_WLAN_POWERVALUE,		CURRENT_SETTING,	"CWMP_CT_WLAN_POWERVALUE",	INTEGER_T,		_OFFSET(cwmp_CT_WLAN_PowerValue),	_SIZE(cwmp_CT_WLAN_PowerValue),	"0"),
//MIB_TBL_ENTRY(CWMP_CT_WLAN_SSIDHIDE,		CURRENT_SETTING,	"CWMP_CT_WLAN_SSIDHIDE",	BYTE_T,			_OFFSET(cwmp_CT_WLAN_SSIDHide),		_SIZE(cwmp_CT_WLAN_SSIDHide),	"0"),
//MIB_TBL_ENTRY(CWMP_CT_WLAN_INTERFACE,		CURRENT_SETTING,	"CWMP_CT_WLAN_INTERFACE",	STRING_T,		_OFFSET(cwmp_CT_WLAN_Interface), 	_SIZE(cwmp_CT_WLAN_Interface),	""),
//#endif //_PRMT_X_CT_COM_WLAN_
MIB_TBL_ENTRY(CWMP_ACS_KICKURL,			CURRENT_SETTING,	"CWMP_ACS_KICKURL",		STRING_T,		_OFFSET(cwmp_ACS_KickURL), 		_SIZE(cwmp_ACS_KickURL),	""),
MIB_TBL_ENTRY(CWMP_ACS_DOWNLOADURL,		CURRENT_SETTING,	"CWMP_ACS_DOWNLOADURL",		STRING_T,		_OFFSET(cwmp_ACS_DownloadURL), 		_SIZE(cwmp_ACS_DownloadURL),	""),
MIB_TBL_ENTRY(CWMP_CONREQ_PORT,			CURRENT_SETTING,	"CWMP_CONREQ_PORT",		INTEGER_T,		_OFFSET(cwmp_ConnReqPort), 		_SIZE(cwmp_ConnReqPort),	"7547"),
MIB_TBL_ENTRY(CWMP_CONREQ_PATH,			CURRENT_SETTING,	"CWMP_CONREQ_PATH",		STRING_T,		_OFFSET(cwmp_ConnReqPath), 		_SIZE(cwmp_ConnReqPath),	"/tr069"),
#else/*_CWMP_MIB_*/
#if defined( _PRMT_X_CT_COM_DHCP_)||defined(IP_BASED_CLIENT_TYPE)
#if 1
MIB_TBL_ENTRY(CWMP_CT_PC_MINADDR,		CURRENT_SETTING,	"CWMP_CT_PC_MINADDR", 		IA_T,			_OFFSET(cwmp_CT_PC_MinAddr), 		_SIZE(cwmp_CT_PC_MinAddr),	"192.168.1.20"),
MIB_TBL_ENTRY(CWMP_CT_PC_MAXADDR,		CURRENT_SETTING,	"CWMP_CT_PC_MAXADDR", 		IA_T,			_OFFSET(cwmp_CT_PC_MaxAddr), 		_SIZE(cwmp_CT_PC_MaxAddr),	"192.168.1.29"),
MIB_TBL_ENTRY(CWMP_CT_CMR_MINADDR,		CURRENT_SETTING,	"CWMP_CT_CMR_MINADDR", 		IA_T,			_OFFSET(cwmp_CT_CMR_MinAddr), 		_SIZE(cwmp_CT_CMR_MinAddr),	"192.168.1.30"),
MIB_TBL_ENTRY(CWMP_CT_CMR_MAXADDR,		CURRENT_SETTING,	"CWMP_CT_CMR_MAXADDR", 		IA_T,			_OFFSET(cwmp_CT_CMR_MaxAddr), 		_SIZE(cwmp_CT_CMR_MaxAddr),	"192.168.1.39"),
MIB_TBL_ENTRY(CWMP_CT_STB_MINADDR,		CURRENT_SETTING,	"CWMP_CT_STB_MINADDR", 		IA_T,			_OFFSET(cwmp_CT_STB_MinAddr), 		_SIZE(cwmp_CT_STB_MinAddr),	"192.168.1.40"),
MIB_TBL_ENTRY(CWMP_CT_STB_MAXADDR,		CURRENT_SETTING,	"CWMP_CT_STB_MAXADDR", 		IA_T,			_OFFSET(cwmp_CT_STB_MaxAddr), 		_SIZE(cwmp_CT_STB_MaxAddr),	"192.168.1.49"),
MIB_TBL_ENTRY(CWMP_CT_PHN_MINADDR,		CURRENT_SETTING,	"CWMP_CT_PHN_MINADDR", 		IA_T,			_OFFSET(cwmp_CT_PHN_MinAddr), 		_SIZE(cwmp_CT_PHN_MinAddr),	"192.168.1.50"),
MIB_TBL_ENTRY(CWMP_CT_PHN_MAXADDR,		CURRENT_SETTING,	"CWMP_CT_PHN_MAXADDR", 		IA_T,			_OFFSET(cwmp_CT_PHN_MaxAddr), 		_SIZE(cwmp_CT_PHN_MaxAddr),	"192.168.1.59"),
MIB_TBL_ENTRY(CWMP_CT_HGW_MINADDR,	    CURRENT_SETTING,	"CWMP_CT_HGW_MINADDR", 	    IA_T, 	        _OFFSET(cwmp_CT_HGW_MinAddr), 	    _SIZE(cwmp_CT_HGW_MinAddr),	"192.168.1.60"),
MIB_TBL_ENTRY(CWMP_CT_HGW_MAXADDR,	    CURRENT_SETTING,	"CWMP_CT_HGW_MAXADDR", 	    IA_T, 	        _OFFSET(cwmp_CT_HGW_MaxAddr), 	    _SIZE(cwmp_CT_HGW_MaxAddr),	"192.168.1.69"),
#else
MIB_TBL_ENTRY(CWMP_CT_PC_MINADDR,	CURRENT_SETTING,	"CWMP_CT_PC_MINADDR", 	BYTE_T, 	_OFFSET(cwmp_CT_PC_MinAddr), 	_SIZE(cwmp_CT_PC_MinAddr),		"20"),
MIB_TBL_ENTRY(CWMP_CT_PC_MAXADDR,	CURRENT_SETTING,	"CWMP_CT_PC_MAXADDR", 	BYTE_T, 	_OFFSET(cwmp_CT_PC_MaxAddr), 	_SIZE(cwmp_CT_PC_MaxAddr),		"29"),
MIB_TBL_ENTRY(CWMP_CT_CMR_MINADDR,	CURRENT_SETTING,	"CWMP_CT_CMR_MINADDR", 	BYTE_T, 	_OFFSET(cwmp_CT_CMR_MinAddr), 	_SIZE(cwmp_CT_CMR_MinAddr),		"30"),
MIB_TBL_ENTRY(CWMP_CT_CMR_MAXADDR,	CURRENT_SETTING,	"CWMP_CT_CMR_MAXADDR", 	BYTE_T, 	_OFFSET(cwmp_CT_CMR_MaxAddr), 	_SIZE(cwmp_CT_CMR_MaxAddr),		"39"),
MIB_TBL_ENTRY(CWMP_CT_STB_MINADDR,	CURRENT_SETTING,	"CWMP_CT_STB_MINADDR", 	BYTE_T, 	_OFFSET(cwmp_CT_STB_MinAddr), 	_SIZE(cwmp_CT_STB_MinAddr),		"40"),
MIB_TBL_ENTRY(CWMP_CT_STB_MAXADDR,	CURRENT_SETTING,	"CWMP_CT_STB_MAXADDR", 	BYTE_T, 	_OFFSET(cwmp_CT_STB_MaxAddr), 	_SIZE(cwmp_CT_STB_MaxAddr),		"49"),
MIB_TBL_ENTRY(CWMP_CT_PHN_MINADDR,	CURRENT_SETTING,	"CWMP_CT_PHN_MINADDR", 	BYTE_T, 	_OFFSET(cwmp_CT_PHN_MinAddr), 	_SIZE(cwmp_CT_PHN_MinAddr),		"50"),
MIB_TBL_ENTRY(CWMP_CT_PHN_MAXADDR,	CURRENT_SETTING,	"CWMP_CT_PHN_MAXADDR", 	BYTE_T, 	_OFFSET(cwmp_CT_PHN_MaxAddr), 	_SIZE(cwmp_CT_PHN_MaxAddr),		"59"),
MIB_TBL_ENTRY(CWMP_CT_HGW_MINADDR,	CURRENT_SETTING,	"CWMP_CT_HGW_MINADDR", 	BYTE_T, 	_OFFSET(cwmp_CT_HGW_MinAddr), 	_SIZE(cwmp_CT_HGW_MinAddr),		"60"),
MIB_TBL_ENTRY(CWMP_CT_HGW_MAXADDR,	CURRENT_SETTING,	"CWMP_CT_HGW_MAXADDR", 	BYTE_T, 	_OFFSET(cwmp_CT_HGW_MaxAddr), 	_SIZE(cwmp_CT_HGW_MaxAddr),		"69"),
#endif
#endif //_PRMT_X_CT_COM_DHCP_
#endif
#ifdef CONFIG_MIDDLEWARE
MIB_TBL_ENTRY(CWMP_TR069_ENABLE,		CURRENT_SETTING,	"CWMP_TR069_ENABLE",		BYTE_T,			_OFFSET(cwmp_TR069_Enable), 		_SIZE(cwmp_TR069_Enable),	"1"),
MIB_TBL_ENTRY(CWMP_MIDWARE_SERVER_ADDR,	CURRENT_SETTING,	"CWMP_MIDWARE_SERVER_ADDR",	STRING_T,		_OFFSET(cwmp_Midware_Server_Addr), 		_SIZE(cwmp_Midware_Server_Addr),		"0.0.0.0"),
MIB_TBL_ENTRY(CWMP_MIDWARE_SERVER_PORT,CURRENT_SETTING,	"CWMP_MIDWARE_SERVER_PORT",	INTEGER_T,		_OFFSET(cwmp_Midware_Server_Port),		_SIZE(cwmp_Midware_Server_Port),		"80"),
#endif

//for log
MIB_TBL_ENTRY(MIB_SYSLOG,			CURRENT_SETTING,	"SYSLOG",			BYTE_T,			_OFFSET(syslog), 			_SIZE(syslog),			"0"),
MIB_TBL_ENTRY(MIB_MAXLOGLEN,			CURRENT_SETTING,	"MAXLOGLEN",			INTEGER_T,		_OFFSET(maxmsglen), 			_SIZE(maxmsglen),		"16384"),
MIB_TBL_ENTRY(MIB_ADSL_DEBUG,			CURRENT_SETTING,	"ADSLDBG",			BYTE_T,			_OFFSET(adsldbg), 			_SIZE(adsldbg),			"0"),
MIB_TBL_ENTRY(MIB_ETH_MAC_CTRL,			CURRENT_SETTING,	"MIB_ETH_MAC_CTRL",		BYTE_T,			_OFFSET(eth_mac_ctrl), 			_SIZE(eth_mac_ctrl),		"0"),
MIB_TBL_ENTRY(MIB_WLAN_MAC_CTRL,		CURRENT_SETTING,	"MIB_WLAN_MAC_CTRL",		BYTE_T,			_OFFSET(wlan_mac_ctrl), 		_SIZE(wlan_mac_ctrl),		"0"),

#ifdef DOS_SUPPORT
MIB_TBL_ENTRY(MIB_DOS_ENABLED,		CURRENT_SETTING,	"DOS_ENABLED",		INTEGER_T,	_OFFSET(dos_enable),		_SIZE(dos_enable),		"0"),
MIB_TBL_ENTRY(MIB_DOS_SYSSYN_FLOOD,	CURRENT_SETTING,	"DOS_SYSSYN_FLOOD",	INTEGER_T,	_OFFSET(dos_syssyn_flood), 	_SIZE(dos_syssyn_flood),		"100"),
MIB_TBL_ENTRY(MIB_DOS_SYSFIN_FLOOD,	CURRENT_SETTING,	"DOS_SYSFIN_FLOOD",	INTEGER_T,	_OFFSET(dos_sysfin_flood), 	_SIZE(dos_sysfin_flood),		"100"),
MIB_TBL_ENTRY(MIB_DOS_SYSUDP_FLOOD,	CURRENT_SETTING,	"DOS_SYSUDP_FLOOD",	INTEGER_T,	_OFFSET(dos_sysudp_flood), 	_SIZE(dos_sysfin_flood),		"100"),
MIB_TBL_ENTRY(MIB_DOS_SYSICMP_FLOOD,	CURRENT_SETTING,	"DOS_SYSICMP_FLOOD",	INTEGER_T,	_OFFSET(dos_sysicmp_flood), 	_SIZE(dos_sysfin_flood),		"100"),
MIB_TBL_ENTRY(MIB_DOS_PIPSYN_FLOOD,	CURRENT_SETTING,	"DOS_PIPSYN_FLOOD",	INTEGER_T,	_OFFSET(dos_pipsyn_flood), 	_SIZE(dos_sysfin_flood),		"100"),
MIB_TBL_ENTRY(MIB_DOS_PIPFIN_FLOOD,	CURRENT_SETTING,	"DOS_PIPFIN_FLOOD",	INTEGER_T,	_OFFSET(dos_pipfin_flood), 	_SIZE(dos_sysfin_flood),		"100"),
MIB_TBL_ENTRY(MIB_DOS_PIPUDP_FLOOD,	CURRENT_SETTING,	"DOS_PIPUDP_FLOOD",	INTEGER_T,	_OFFSET(dos_pipudp_flood), 	_SIZE(dos_sysfin_flood),		"100"),
MIB_TBL_ENTRY(MIB_DOS_PIPICMP_FLOOD,	CURRENT_SETTING,	"DOS_PIPICMP_FLOOD",	INTEGER_T,	_OFFSET(dos_pipicmp_flood), 	_SIZE(dos_sysfin_flood),		"100"),
MIB_TBL_ENTRY(MIB_DOS_BLOCK_TIME,	CURRENT_SETTING,	"DOS_BLOCK_TIME",	INTEGER_T,	_OFFSET(dos_block_time), 	_SIZE(dos_sysfin_flood),		"300"),
#endif
#ifdef CONFIG_BOA_WEB_E8B_CH
MIB_TBL_ENTRY(MIB_DOS_ENABLED,		CURRENT_SETTING,	"DOS_ENABLED",		INTEGER_T,	_OFFSET(dos_enable),		_SIZE(dos_enable),		"0"),
#endif

#ifdef CONFIG_WIFI_SIMPLE_CONFIG //WPS
MIB_TBL_ENTRY(MIB_WSC_DISABLE,		CURRENT_SETTING,"WSC_DISABLE",		BYTE_T,		_OFFSET(wscDisable), _SIZE(wscDisable), "0"),
MIB_TBL_ENTRY(MIB_WSC_METHOD,		CURRENT_SETTING,"WSC_METHOD",		BYTE_T,		_OFFSET(wscMethod), _SIZE(wscMethod), "3"),
MIB_TBL_ENTRY(MIB_WSC_CONFIGURED,	CURRENT_SETTING,"WSC_CONFIGURED",	BYTE_T,		_OFFSET(wscConfigured), _SIZE(wscConfigured), "0"),
MIB_TBL_ENTRY(MIB_WSC_PIN,			CURRENT_SETTING,"WSC_PIN",			STRING_T,	_OFFSET(wscPin), _SIZE(wscPin), "12345670"),
MIB_TBL_ENTRY(MIB_WSC_AUTH,			CURRENT_SETTING,"WSC_AUTH",			BYTE_T,		_OFFSET(wscAuth), _SIZE(wscAuth), "1"),
MIB_TBL_ENTRY(MIB_WSC_ENC,			CURRENT_SETTING,"WSC_ENC",			BYTE_T,		_OFFSET(wscEnc), _SIZE(wscEnc), "1"),
MIB_TBL_ENTRY(MIB_WSC_MANUAL_ENABLED, CURRENT_SETTING,"WSC_MANUAL_ENABLED",	BYTE_T,	_OFFSET(wscManualEnabled), _SIZE(wscManualEnabled), "0"),
MIB_TBL_ENTRY(MIB_WSC_UPNP_ENABLED,CURRENT_SETTING, "WSC_UPNP_ENABLED",	BYTE_T,	_OFFSET(wscUpnpEnabled), _SIZE(wscUpnpEnabled), "1"),
MIB_TBL_ENTRY(MIB_WSC_REGISTRAR_ENABLED, CURRENT_SETTING,"WSC_REGISTRAR_ENABLED",	BYTE_T,	_OFFSET(wscRegistrarEnabled), _SIZE(wscRegistrarEnabled), "0"),
MIB_TBL_ENTRY(MIB_WSC_PSK,			CURRENT_SETTING,"WSC_PSK",			STRING_T,		_OFFSET(wscPsk), _SIZE(wscPsk), "0"),
MIB_TBL_ENTRY(MIB_WSC_SSID,			CURRENT_SETTING,"WSC_SSID",			STRING_T,		_OFFSET(wscSsid), _SIZE(wscSsid), "0"),
MIB_TBL_ENTRY(MIB_WSC_CONFIG_BY_EXT_REG,		CURRENT_SETTING,"WSC_CONFIGBYEXTREG",	BYTE_T,		_OFFSET(wscConfigByExtReg), _SIZE(wscConfigByExtReg), "0"),
#endif

MIB_TBL_ENTRY(MIB_ADSL_LAN_DHCP_GATEWAY,	CURRENT_SETTING,	"LAN_DHCP_GATEWAY", 		IA_T,			_OFFSET(dhcp_GatewayAddr), 		_SIZE(dhcp_GatewayAddr),	"192.168.1.1"),
#ifdef WLAN_MBSSID
MIB_TBL_ENTRY(MIB_WLAN_VAP0_ITF_GROUP,		CURRENT_SETTING,	"WLAN_VAP0_ITF_GROUP",		BYTE_T,			_OFFSET(itfGroupVap0),			_SIZE(itfGroupVap0),		"0"),
MIB_TBL_ENTRY(MIB_WLAN_VAP1_ITF_GROUP,		CURRENT_SETTING,	"WLAN_VAP1_ITF_GROUP",		BYTE_T,			_OFFSET(itfGroupVap1),			_SIZE(itfGroupVap1),		"0"),
MIB_TBL_ENTRY(MIB_WLAN_VAP2_ITF_GROUP,		CURRENT_SETTING,	"WLAN_VAP2_ITF_GROUP",		BYTE_T,			_OFFSET(itfGroupVap2),			_SIZE(itfGroupVap2),		"0"),
MIB_TBL_ENTRY(MIB_WLAN_VAP3_ITF_GROUP,		CURRENT_SETTING,	"WLAN_VAP3_ITF_GROUP",		BYTE_T,			_OFFSET(itfGroupVap3),			_SIZE(itfGroupVap3),		"0"),
#endif
#ifdef CTC_TELECOM_ACCOUNT
MIB_TBL_ENTRY(MIB_CTC_ACCOUNT_ENABLE,		CURRENT_SETTING,	"MIB_CTC_ACCOUNT_ENABLE",	BYTE_T,			_OFFSET(CTCAccountEnable),		_SIZE(CTCAccountEnable),	"1"),
#endif //CTC_TELECOM_ACCOUNT
//added by xl_yue
#if defined(ZTE_531B_BRIDGE_SC) || defined(ZTE_GENERAL_ROUTER_SC)
MIB_TBL_ENTRY(MIB_WLAN_COUNTRY_AREA,		CURRENT_SETTING,	"MIB_WLAN_COUNTRY_AREA",	BYTE_T,			_OFFSET(WlanCountryOrArea),	_SIZE(WlanCountryOrArea),	"0"),
MIB_TBL_ENTRY(MIB_WLAN_REG_DOMAIN, 			CURRENT_SETTING,	"WLAN_REG_DOMAIN",		BYTE_T, 			_OFFSET(WlanRegDomain),		_SIZE(WlanRegDomain),		"1"),
#endif


//add by ramen for DNS bind pvc
#ifdef DNS_BIND_PVC_SUPPORT
MIB_TBL_ENTRY(MIB_DNS_BIND_PVC_ENABLE,		CURRENT_SETTING,	"MIB_DNS_BIND_ENABLE",	BYTE_T,	_OFFSET(dns1PvcEnable),	_SIZE(dns1PvcEnable),	"0"),
MIB_TBL_ENTRY(MIB_DNS_BIND_PVC1,		CURRENT_SETTING,	"MIB_DNS_BIND_PVC1",	BYTE_T,	_OFFSET(dns1PvcIfIndex),	_SIZE(dns1PvcIfIndex),	"255"),
MIB_TBL_ENTRY(MIB_DNS_BIND_PVC2,		CURRENT_SETTING,	"MIB_DNS_BIND_PVC2",	BYTE_T,	_OFFSET(dns2PvcIfIndex),	_SIZE(dns2PvcIfIndex),	"255"),
MIB_TBL_ENTRY(MIB_DNS_BIND_PVC3,		CURRENT_SETTING,	"MIB_DNS_BIND_PVC3",	BYTE_T,	_OFFSET(dns3PvcIfIndex),	_SIZE(dns3PvcIfIndex),	"255"),
#endif

#ifdef CONFIG_IP_NF_ALG_ONOFF
#ifdef CONFIG_IP_NF_FTP
MIB_TBL_ENTRY(MIB_IP_ALG_FTP,		CURRENT_SETTING,	"MIB_IP_ALG_FTP",	BYTE_T,			_OFFSET(ipAlgFTP),	_SIZE(ipAlgFTP),	"0"),
#endif
#ifdef CONFIG_IP_NF_H323
MIB_TBL_ENTRY(MIB_IP_ALG_H323, 			CURRENT_SETTING,	"MIB_IP_ALG_H323",		BYTE_T, 			_OFFSET(ipAlgH323),		_SIZE(ipAlgH323),		"1"),
#endif
#ifdef CONFIG_IP_NF_IRC
MIB_TBL_ENTRY(MIB_IP_ALG_IRC,		CURRENT_SETTING,	"MIB_IP_ALG_IRC",	BYTE_T,			_OFFSET(ipAlgIRC),	_SIZE(ipAlgIRC),	"0"),
#endif
#ifdef CONFIG_IP_NF_RTSP
MIB_TBL_ENTRY(MIB_IP_ALG_RTSP, 			CURRENT_SETTING,	"MIB_IP_ALG_RTSP",		BYTE_T, 			_OFFSET(ipAlgRTSP),		_SIZE(ipAlgRTSP),		"1"),
#endif
#ifdef CONFIG_IP_NF_QUAKE3
MIB_TBL_ENTRY(MIB_IP_ALG_QUAKE3, 			CURRENT_SETTING,	"MIB_IP_ALG_QUAKE3",		BYTE_T, 			_OFFSET(ipAlgQUAKE3),		_SIZE(ipAlgQUAKE3),		"1"),
#endif
#ifdef CONFIG_IP_NF_L2TP
MIB_TBL_ENTRY(MIB_IP_ALG_L2TP, 			CURRENT_SETTING,	"MIB_IP_ALG_L2TP",		BYTE_T, 			_OFFSET(ipAlgL2TP),		_SIZE(ipAlgL2TP),		"1"),
#endif
#ifdef CONFIG_IP_NF_IPSEC
MIB_TBL_ENTRY(MIB_IP_ALG_IPSEC, 			CURRENT_SETTING,	"MIB_IP_ALG_IPSEC",		BYTE_T, 			_OFFSET(ipAlgIPSEC),		_SIZE(ipAlgIPSEC),		"1"),
#endif
#ifdef CONFIG_IP_NF_SIP
MIB_TBL_ENTRY(MIB_IP_ALG_SIP, 			CURRENT_SETTING,	"MIB_IP_ALG_SIP",		BYTE_T, 			_OFFSET(ipAlgSIP),		_SIZE(ipAlgSIP),		"0"),
#endif
#ifdef CONFIG_IP_NF_PPTP
MIB_TBL_ENTRY(MIB_IP_ALG_PPTP, 			CURRENT_SETTING,	"MIB_IP_ALG_PPTP",		BYTE_T, 			_OFFSET(ipAlgPPTP),		_SIZE(ipAlgPPTP),		"1"),
#endif
#endif

#ifdef CONFIG_BOA_WEB_E8B_CH
MIB_TBL_ENTRY(MIB_DDNS_ENABLE, 			CURRENT_SETTING,	"MIB_DDNS_ENABLE",		BYTE_T, 			_OFFSET(ddnsenable),		_SIZE(ddnsenable),		"1"),
#endif
#ifdef SYSLOG_SUPPORT_ENABLE
MIB_TBL_ENTRY(MIB_SYSLOG_ENABLE,CURRENT_SETTING,"MIB_SYSLOG_ENABLE",BYTE_T,_OFFSET(syslog_enable),_SIZE(syslog_enable),"0"),
MIB_TBL_ENTRY(MIB_SYSLOG_RECORDE_GRADE,CURRENT_SETTING,"MIB_SYSLOG_RECORD_GRADE",BYTE_T,_OFFSET(syslog_record_grade),_SIZE(syslog_record_grade),"7"),
MIB_TBL_ENTRY(MIB_SYSLOG_SHOW_GRADE,CURRENT_SETTING,"MIB_SYSLOG_SHOW_GRADE",BYTE_T,_OFFSET(syslog_show_grade),_SIZE(syslog_show_grade),"7"),
MIB_TBL_ENTRY(MIB_SYSLOG_MODE,CURRENT_SETTING,"MIB_SYSLOG_MODE",BYTE_T,_OFFSET(syslog_mode),_SIZE(syslog_mode),"0"),
MIB_TBL_ENTRY(MIB_SYSLOG_REMOTE_IP,CURRENT_SETTING,"MIB_SYSLOG_REMOTE_IP",INTEGER_T,_OFFSET(syslog_remote_ip),_SIZE(syslog_remote_ip),"0"),
MIB_TBL_ENTRY(MIB_SYSLOG_REMOTE_PORT,CURRENT_SETTING,"MIB_SYSLOG_REMOTE_PORT",WORD_T,_OFFSET(syslog_remote_port),_SIZE(syslog_remote_port),"0"),
#endif

#ifdef FTP_ACCOUNT_INDEPENDENT
//Jim
MIB_TBL_ENTRY(MIB_FTP_USER,		CURRENT_SETTING,		"MIB_FTP_USERNAME",	STRING_T,_OFFSET(ftp_server_username),_SIZE(ftp_server_username),"ftp"),
MIB_TBL_ENTRY(MIB_FTP_PASSWD,		CURRENT_SETTING,		"MIB_FTP_PASSWD",		STRING_T,_OFFSET(ftp_server_password),_SIZE(ftp_server_username),"ftp123"),
MIB_TBL_ENTRY(MIB_FTP_PORT, CURRENT_SETTING, "MIB_FTP_PORT", WORD_T, _OFFSET(ftp_server_port), _SIZE(ftp_server_port), "21"),
#endif

#ifdef TELNET_ACCOUNT_INDEPENDENT
//Jim
MIB_TBL_ENTRY(MIB_TELNET_USER,		CURRENT_SETTING,		"MIB_TELNENT_USERNAME",	STRING_T,_OFFSET(telnet_server_username),_SIZE(telnet_server_username),"telnet"),
MIB_TBL_ENTRY(MIB_TELNET_PASSWD,		CURRENT_SETTING,		"MIB_TELNET_PASSWD",		STRING_T,_OFFSET(telnet_server_password),_SIZE(telnet_server_username),"telnet123"),
#endif
#ifdef MAC_FILTER_EBTABLES_SUPPORT
MIB_TBL_ENTRY(MIB_MAC_FILTER_EBTABLES_ENABLE,		CURRENT_SETTING,		"MIB_MAC_FILTER_EBTABLES_ENABLE",	BYTE_T,_OFFSET(macfilter_ebtables_enable),_SIZE(macfilter_ebtables_enable),"0"),
MIB_TBL_ENTRY(MIB_MAC_FILTER_EBTABLES_MODE,		CURRENT_SETTING,		"MIB_MAC_FILTER_EBTABLES_MODE",	BYTE_T,_OFFSET(macfilter_ebtables_mode),_SIZE(macfilter_ebtables_mode),"0"),
#endif
#ifdef IP_FILTER_ONOFF_SUPPORT
MIB_TBL_ENTRY(MIB_IPFILTER_ON_OFF,		CURRENT_SETTING,		"MIB_IP_FILTER_ONOFF",		BYTE_T,_OFFSET(ip_filter_enable),_SIZE(ip_filter_enable),"0"),
#endif
MIB_TBL_ENTRY(MIB_FTP_ROOT_PATH, CURRENT_SETTING,	"FTP_ROOT_PATH", BYTE_T, _OFFSET(ftp_root_path),	_SIZE(ftp_root_path), "1"),
MIB_TBL_ENTRY(MIB_WGET_ROOT_PATH, CURRENT_SETTING,	"WGET_ROOT_PATH", BYTE_T, _OFFSET(wget_root_path),	_SIZE(wget_root_path), "1"),
MIB_TBL_ENTRY(MIB_BFTPD_ENABLE, CURRENT_SETTING,"BFTPD_ENABLE", BYTE_T, _OFFSET(ftp_ftpd_enable),	_SIZE(ftp_ftpd_enable), "1"),

//penggenyao, total bandwidth, default 1024Kbit/s
MIB_TBL_ENTRY(MIB_TOTAL_BANDWIDTH, CURRENT_SETTING, "TOTAL_BANDWIDTH", WORD_T, _OFFSET(TotalBandWidth), _SIZE(TotalBandWidth), "1024"),
MIB_TBL_ENTRY(MIB_TOTAL_BANDWIDTH_LIMIT_EN, CURRENT_SETTING, "TOTAL_BANDWIDTH_RESTRICT", BYTE_T, _OFFSET(TotalBandWidthEn), _SIZE(TotalBandWidthEn), "0"),
MIB_TBL_ENTRY(MIB_QOS_QUEUE_POLICY, CURRENT_SETTING, "QOS_QUEUE_POLICY",BYTE_T, _OFFSET(QosQueuePolicy), _SIZE(QosQueuePolicy), "0"),
//forceportal
MIB_TBL_ENTRY(MIB_FP_ENABLE,                    CURRENT_SETTING,        "fp_enable",            BYTE_T,
   _OFFSET(fpEnable),              _SIZE(fpEnable),                "0"),
MIB_TBL_ENTRY(MIB_FP_PC_ADDR,                   CURRENT_SETTING,        "fp_pc_addr",           STRING_T,
   _OFFSET(fpPCAddr),              _SIZE(fpPCAddr),                ""),
MIB_TBL_ENTRY(MIB_FP_STB_ADDR,                  CURRENT_SETTING,        "fp_stb_addr",          STRING_T,
   _OFFSET(fpSTBAddr),             _SIZE(fpSTBAddr),               ""),
MIB_TBL_ENTRY(MIB_FP_MOB_ADDR,                  CURRENT_SETTING,        "fp_mob_addr",          STRING_T,
   _OFFSET(fpMOBAddr),             _SIZE(fpMOBAddr),               ""),
#if defined(BACKDOOR_ACCOUNT_SUPPORT)
MIB_TBL_ENTRY(MIB_BACKDOOR_NAME,		CURRENT_SETTING,	"BACKDOOR_NAME",	STRING_T,	_OFFSET(backdoorName), 	_SIZE(backdoorName),		"RTKDSL"),
MIB_TBL_ENTRY(MIB_BACKDOOR_PASSWORD,		CURRENT_SETTING,	"BACKDOOR_PASSWORD",	STRING_T,	_OFFSET(backdoorPassword), 	_SIZE(backdoorPassword),		"real____tek"),
#endif
   

{0}	

};

#ifdef INCLUDE_DEFAULT_VALUE
#if defined(ZTE_531B_BRIDGE_SC)||defined(ZTE_GENERAL_ROUTER_SC)
MIB_CE_ATM_VC_T mib_atm_vc_default_table[] = {
	// 1. 8/81
	{0xf0, 8 , 0, 81, ATM_MAX_US_PCR, 0, 0, 0 , 1, 1, 0, 0, "\0", "\0", 0, "\0",
	 0, 0, 0, 0, "\0", "\0", 0, 1500, 1, "\0", 0
#ifdef CONFIG_EXT_SWITCH
	 , 0, 0, 0, 0, 0
#endif
	, 0, 0
#ifdef _CWMP_MIB_ /*jiunming, for cwmp-tr069*/
	, 0, 1, 1, 0, 0, 0, "\0", "\0"  /*connDisable, ConDevInstNum, ConIPInstNum, ConPPPInstNum, autoDisTime, warnDisDelay, pppServiceName, WanName*/
#ifdef _PRMT_X_CT_COM_PPPOEv2_
	, 0, 0 /*PPPoEProxyEnable, PPPoEProxyMaxUser*/ 
#endif //_PRMT_X_CT_COM_PPPOEv2_
#ifdef _PRMT_X_CT_COM_WANEXT_
	, 0 /*ServiceList*/
#endif //_PRMT_X_CT_COM_WANEXT_
#ifdef _PRMT_X_CT_COM_ETHLINK_
	//, 0
#endif //801.1p mark
#endif //_CWMP_MIB_
#ifdef CONFIG_SPPPD_STATICIP
	, 0 /*Static PPPoE*/
#endif //CONFIG_SPPPD_STATICIP
	},
	// 1. 0/35
	{0xf1, 0 , 0, 35, ATM_MAX_US_PCR, 0, 0, 0 , 1, 1, 0, 0, "\0", "\0", 0, "\0",
	 0, 0, 0, 0, "\0", "\0", 0, 1500, 1, "\0", 0
#ifdef CONFIG_EXT_SWITCH
	 , 0, 0, 0, 0, 0
#endif
	, 0, 0
#ifdef _CWMP_MIB_ /*jiunming, for cwmp-tr069*/
	, 0, 2, 1, 0, 0, 0, "\0", "\0"  /*connDisable, ConDevInstNum, ConIPInstNum, ConPPPInstNum, autoDisTime, warnDisDelay, pppServiceName, WanName*/
#ifdef _PRMT_X_CT_COM_PPPOEv2_
	, 0, 0 /*PPPoEProxyEnable, PPPoEProxyMaxUser*/ 
#endif //_PRMT_X_CT_COM_PPPOEv2_
#ifdef _PRMT_X_CT_COM_WANEXT_
	, 0 /*ServiceList*/
#endif //_PRMT_X_CT_COM_WANEXT_
#ifdef _PRMT_X_CT_COM_ETHLINK_
	//, 0
#endif //801.1p mark
#endif //_CWMP_MIB_
#ifdef CONFIG_SPPPD_STATICIP
	, 0 /*Static PPPoE*/
#endif //CONFIG_SPPPD_STATICIP
	},
	// 1. 8/35
	{0xf2, 8 , 0, 35, ATM_MAX_US_PCR, 0, 0, 0 , 1, 1, 0, 0, "\0", "\0", 0, "\0",
	 0, 0, 0, 0, "\0", "\0", 0, 1500, 1, "\0", 0
#ifdef CONFIG_EXT_SWITCH
	 , 0, 0, 0, 0, 0
#endif
	, 0, 0
#ifdef _CWMP_MIB_ /*jiunming, for cwmp-tr069*/
	, 0, 3, 1, 0, 0, 0, "\0", "\0"  /*connDisable, ConDevInstNum, ConIPInstNum, ConPPPInstNum, autoDisTime, warnDisDelay, pppServiceName, WanName*/
#ifdef _PRMT_X_CT_COM_PPPOEv2_
	, 0, 0 /*PPPoEProxyEnable, PPPoEProxyMaxUser*/ 
#endif //_PRMT_X_CT_COM_PPPOEv2_
#ifdef _PRMT_X_CT_COM_WANEXT_
	, 0 /*ServiceList*/
#endif //_PRMT_X_CT_COM_WANEXT_
#ifdef _PRMT_X_CT_COM_ETHLINK_
	//, 0
#endif //801.1p mark
#endif //_CWMP_MIB_
#ifdef CONFIG_SPPPD_STATICIP
	, 0 /*Static PPPoE*/
#endif //CONFIG_SPPPD_STATICIP
	},
	// 1. 0/32
	{0xf3, 0 , 0, 32, ATM_MAX_US_PCR, 0, 0, 0 , 1, 1, 0, 0, "\0", "\0", 0, "\0",
	 0, 0, 0, 0, "\0", "\0", 0, 1500, 1, "\0", 0
#ifdef CONFIG_EXT_SWITCH
	 , 0, 0, 0, 0, 0
#endif
	, 0, 0
#ifdef _CWMP_MIB_ /*jiunming, for cwmp-tr069*/
	, 0, 4, 1, 0, 0, 0, "\0", "\0"  /*connDisable, ConDevInstNum, ConIPInstNum, ConPPPInstNum, autoDisTime, warnDisDelay, pppServiceName, WanName*/
#ifdef _PRMT_X_CT_COM_PPPOEv2_
	, 0, 0 /*PPPoEProxyEnable, PPPoEProxyMaxUser*/ 
#endif //_PRMT_X_CT_COM_PPPOEv2_
#ifdef _PRMT_X_CT_COM_WANEXT_
	, 0 /*ServiceList*/
#endif //_PRMT_X_CT_COM_WANEXT_
#ifdef _PRMT_X_CT_COM_ETHLINK_
	//, 0
#endif //801.1p mark
#endif //_CWMP_MIB_
#ifdef CONFIG_SPPPD_STATICIP
	, 0 /*Static PPPoE*/
#endif //CONFIG_SPPPD_STATICIP
	},
	// 1. 0/100
	{0xf4, 0 , 0, 100, ATM_MAX_US_PCR, 0, 0, 0 , 1, 1, 0, 0, "\0", "\0", 0, "\0",
	 0, 0, 0, 0, "\0", "\0", 0, 1500, 1, "\0", 0
#ifdef CONFIG_EXT_SWITCH
	 , 0, 0, 0, 0, 0
#endif
	, 0, 0
#ifdef _CWMP_MIB_ /*jiunming, for cwmp-tr069*/
	, 0, 5, 1, 0, 0, 0, "\0", "\0"  /*connDisable, ConDevInstNum, ConIPInstNum, ConPPPInstNum, autoDisTime, warnDisDelay, pppServiceName, WanName*/
#ifdef _PRMT_X_CT_COM_PPPOEv2_
	, 0, 0 /*PPPoEProxyEnable, PPPoEProxyMaxUser*/ 
#endif //_PRMT_X_CT_COM_PPPOEv2_
#ifdef _PRMT_X_CT_COM_WANEXT_
	, 0 /*ServiceList*/
#endif //_PRMT_X_CT_COM_WANEXT_
#ifdef _PRMT_X_CT_COM_ETHLINK_
	//, 0
#endif //801.1p mark
#endif //_CWMP_MIB_
#ifdef CONFIG_SPPPD_STATICIP
	, 0 /*Static PPPoE*/
#endif //CONFIG_SPPPD_STATICIP
	},
	// 1. 8/36
	{0xf5, 8 , 0, 36, ATM_MAX_US_PCR, 0, 0, 0 , 1, 1, 0, 0, "\0", "\0", 0, "\0",
	 0, 0, 0, 0, "\0", "\0", 0, 1500, 1, "\0", 0
#ifdef CONFIG_EXT_SWITCH
	 , 0, 0, 0, 0, 0
#endif
	, 0, 0
#ifdef _CWMP_MIB_ /*jiunming, for cwmp-tr069*/
	, 0, 6, 1, 0, 0, 0, "\0", "\0"  /*connDisable, ConDevInstNum, ConIPInstNum, ConPPPInstNum, autoDisTime, warnDisDelay, pppServiceName, WanName*/
#ifdef _PRMT_X_CT_COM_PPPOEv2_
	, 0, 0 /*PPPoEProxyEnable, PPPoEProxyMaxUser*/ 
#endif //_PRMT_X_CT_COM_PPPOEv2_
#ifdef _PRMT_X_CT_COM_WANEXT_
	, 0 /*ServiceList*/
#endif //_PRMT_X_CT_COM_WANEXT_
#ifdef _PRMT_X_CT_COM_ETHLINK_
	//, 0
#endif //801.1p mark
#endif //_CWMP_MIB_
#ifdef CONFIG_SPPPD_STATICIP
	, 0 /*Static PPPoE*/
#endif //CONFIG_SPPPD_STATICIP
	},
	// 1. 0/33
	{0xf6, 0 , 0, 33, ATM_MAX_US_PCR, 0, 0, 0 , 1, 1, 0, 0, "\0", "\0", 0, "\0",
	 0, 0, 0, 0, "\0", "\0", 0, 1500, 1, "\0", 0
#ifdef CONFIG_EXT_SWITCH
	 , 0, 0, 0, 0, 0
#endif
	, 0, 0
#ifdef _CWMP_MIB_ /*jiunming, for cwmp-tr069*/
	, 0, 7, 1, 0, 0, 0, "\0", "\0"  /*connDisable, ConDevInstNum, ConIPInstNum, ConPPPInstNum, autoDisTime, warnDisDelay, pppServiceName, WanName*/
#ifdef _PRMT_X_CT_COM_PPPOEv2_
	, 0, 0 /*PPPoEProxyEnable, PPPoEProxyMaxUser*/ 
#endif //_PRMT_X_CT_COM_PPPOEv2_
#ifdef _PRMT_X_CT_COM_WANEXT_
	, 0 /*ServiceList*/
#endif //_PRMT_X_CT_COM_WANEXT_
#ifdef _PRMT_X_CT_COM_ETHLINK_
	//, 0
#endif //801.1p mark
#endif //_CWMP_MIB_
#ifdef CONFIG_SPPPD_STATICIP
	, 0 /*Static PPPoE*/
#endif //CONFIG_SPPPD_STATICIP
	},
	
};
#else    //ZTE_531B_BRIDGE_SC
MIB_CE_ATM_VC_T mib_atm_vc_default_table[] = {
	// 1. 5/35
	{0xf0, 5 , 0, 35, ATM_MAX_US_PCR, 0, 0, 0 , 1, 1, 0, 0, "\0", "\0", 0, "\0",
	 0, 0, 0, 0, "\0", "\0", 0, 1500, 1, "\0", 0
#ifdef CONFIG_EXT_SWITCH
	 , 0, 0, 0, 0, 0
#endif
#ifdef  CONFIG_IGMPPROXY_MULTIWAN
	, 0
#endif
	, 0, 0
#ifdef _CWMP_MIB_ /*jiunming, for cwmp-tr069*/
	, 0, 1, 1, 0, 0, 0, "\0", "\0"  /*connDisable, ConDevInstNum, ConIPInstNum, ConPPPInstNum, autoDisTime, warnDisDelay, pppServiceName, WanName*/
#ifdef _PRMT_X_CT_COM_PPPOEv2_
	, 0, 0 /*PPPoEProxyEnable, PPPoEProxyMaxUser*/ 
#endif //_PRMT_X_CT_COM_PPPOEv2_
#ifdef _PRMT_X_CT_COM_WANEXT_
	, 0 /*ServiceList*/
#endif //_PRMT_X_CT_COM_WANEXT_
#endif //_CWMP_MIB_
#ifdef _PRMT_X_CT_COM_ETHLINK_
	//, 0
#endif
#ifdef CTC_WAN_NAME
	, 1
#endif
#ifdef CONFIG_SPPPD_STATICIP
	, 0 /*Static PPPoE*/
#endif //CONFIG_SPPPD_STATICIP
	},
	
};
#endif

#ifdef CONFIG_EXT_SWITCH
MIB_CE_SW_PORT_T mib_sw_port_default_table[SW_PORT_NUM] = {
	{0xff, 0, 0, 1, 4}, {0xff, 0, 1, 1, 4}, {0xff, 0, 2, 1, 4}, {0xff, 0, 3, 1, 4}
};
MIB_CE_VLAN_T mib_vlan_default_table[VLAN_NUM] = {
	{0, 0}, {0, 0}, {0, 0}, {0, 0}
};
#endif

#ifdef ZTE_GENERAL_ROUTER_SC
MIB_CE_ACC_T mib_acc_default_table[] = {
	{0, 0, 0, 0x02, 0x03, 0, 0x02, 0, 23, 80, 21,0xf0,8,81,0},
	{0, 0, 0, 0x02, 0x03, 0, 0x02, 0, 23, 80, 21,0xf1,0,35,0},
	{0, 0, 0, 0x02, 0x03, 0, 0x02, 0, 23, 80, 21,0xf2,8,35,0},
	{0, 0, 0, 0x02, 0x03, 0, 0x02, 0, 23, 80, 21,0xf3,0,32,0},
	{0, 0, 0, 0x02, 0x03, 0, 0x02, 0, 23, 80, 21,0xf4,0,100,0},
	{0, 0, 0, 0x02, 0x03, 0, 0x02, 0, 23, 80, 21,0xf5,8,36,0},
	{0, 0, 0, 0x02, 0x03, 0, 0x02, 0, 23, 80, 21,0xf6,0,33,0}
};
#else
#ifdef ZTE_531B_BRIDGE_SC
MIB_CE_ACC_T mib_acc_default_table[1] = {
	{0, 0, 0, 0x02, 0x03, 0, 0x02, 0, 23, 80, 21}
};
#else
#ifdef CONFIG_BOA_WEB_E8B_CH
MIB_CE_ACC_T mib_acc_default_table[1] = {
	{0, 0, 0, 0x02, 0, 0, 0x03, 0, 23, 80, 21, 0, 443}
};
#else
MIB_CE_ACC_T mib_acc_default_table[1] = {
	{0x02, 0, 0, 0x02, 0x03, 0, 0x02, 0, 23, 80, 21}
};
#endif
#endif
#endif

#ifdef _CWMP_MIB_ /*jiunming, mib for cwmp-tr069*/
#ifdef WLAN_SUPPORT
CWMP_PSK_T mib_cwmp_psk_default_table[1]={
	{ 1, "0000000000000000000000000000000000000000000000000000000000000000", "000000000000000000000000000000000000000000000000000000000000000"}
};
#endif
#endif /*_CWMP_MIB_*/

// add for auto-pvc-search  TR068 defined
MIB_AUTO_PVC_SEARCH_T mib_auto_pvc_search_default_table[8] = {
    {0, 35}, {8, 35}, {0, 43}, {0, 51}, {0, 59},	{8, 43}, {8, 51}, {8, 59} 
};

// Added by mason Yu
#ifdef WLAN_MBSSID
MIB_CE_MBSSIB_T mib_mbssid_default_table[] = {
#if !(defined(ZTE_531B_BRIDGE_SC) || defined(ZTE_GENERAL_ROUTER_SC))

#ifdef E8A_CHINA
	{0, 1, 0, 0, 1, 0, "\0", 1812, "\0", "\0", 1, "CTC-0000", 2
#else
	{0, 0, 0, 0, 1, 0, "\0", 1812, "\0", "\0", 1, "CTC-0000", 2
#endif
#ifdef _CWMP_MIB_
	,0
#endif
#ifdef ENABLE_WPAAES_WPA2TKIP
	,1,2
#endif
	},
	{1, 0, 0, 0, 1, 0, "\0", 1812, "\0", "\0", 1, "CTC-1111", 2
#ifdef _CWMP_MIB_
	,0
#endif
#ifdef ENABLE_WPAAES_WPA2TKIP
	,1,2
#endif
	},
	{2, 0, 0, 0, 1, 0, "\0", 1812, "\0", "\0", 1, "CTC-2222", 2
#ifdef _CWMP_MIB_
	,0
#endif
#ifdef ENABLE_WPAAES_WPA2TKIP
	,1,2
#endif
	},
	{3, 0, 0, 0, 1, 0, "\0", 1812, "\0", "\0", 1, "CTC-3333", 2
#ifdef _CWMP_MIB_
	,0
#endif
#ifdef ENABLE_WPAAES_WPA2TKIP
	,1,2
#endif
	},
	{4, 0, 0, 0, 1, 0, "\0", 1812, "\0", "\0", 1, "CTC-4444", 2
#ifdef _CWMP_MIB_
	,0
#endif
#ifdef ENABLE_WPAAES_WPA2TKIP
	,1,2
#endif
	},

#else

#ifdef E8A_CHINA
	{0, 1, 0, 0, 1, 0, "\0", 1812, "\0", "\0", 1, "", 2
#else
	{0, 0, 0, 0, 1, 0, "\0", 1812, "\0", "\0", 1, "", 2
#endif
#ifdef _CWMP_MIB_
	,0
#endif
	},
	{1, 0, 0, 0, 1, 0, "\0", 1812, "\0", "\0", 1, "", 2
#ifdef _CWMP_MIB_
	,0
#endif
	},
	{2, 0, 0, 0, 1, 0, "\0", 1812, "\0", "\0", 1, "", 2
#ifdef _CWMP_MIB_
	,0
#endif
	},
	{3, 0, 0, 0, 1, 0, "\0", 1812, "\0", "\0", 1, "", 2
#ifdef _CWMP_MIB_
	,0
#endif
	},
	{4, 0, 0, 0, 1, 0, "\0", 1812, "\0", "\0", 1, "", 2
#ifdef _CWMP_MIB_
	,0
#endif
	},
#endif
};

MIB_CE_MBSSIB_WEP_T mib_mbssid_wep_default_table[] = {
#if defined(ZTE_531B_BRIDGE_SC) || defined(ZTE_GENERAL_ROUTER_SC)
  {"\0", "\0", "\0", "\0", "\0", "\0", "\0", "\0", 0, 0},
  {"\0", "\0", "\0", "\0", "\0", "\0", "\0", "\0", 0, 0},
  {"\0", "\0", "\0", "\0", "\0", "\0", "\0", "\0", 0, 0},
  {"\0", "\0", "\0", "\0", "\0", "\0", "\0", "\0", 0, 0},
  {"\0", "\0", "\0", "\0", "\0", "\0", "\0", "\0", 0, 0},
#else
#ifdef E8A_CHINA
	{"3131313131", "3232323232", "3333333333", "3434343434", "\0", "\0", "\0", "\0", 0, 0},
	// 3131313131: key is 11111
	// 3232323232: key is 22222
	// 3333333333: key is 33333
	// 3232323232: key is 22222
	// 3434343434: key is 44444
#else
	{"\0", "\0", "\0", "\0", "\0", "\0", "\0", "\0", 0, 0},
#endif
	{"\0", "\0", "\0", "\0", "\0", "\0", "\0", "\0", 0, 0},
	{"\0", "\0", "\0", "\0", "\0", "\0", "\0", "\0", 0, 0},
	{"\0", "\0", "\0", "\0", "\0", "\0", "\0", "\0", 0, 0},
	{"\0", "\0", "\0", "\0", "\0", "\0", "\0", "\0", 0, 0},
#endif
};
#endif

#else
MIB_CE_ATM_VC_Tp mib_atm_vc_default_table = (MIB_CE_ATM_VC_Tp)0;
#ifdef CONFIG_EXT_SWITCH
MIB_CE_SW_PORT_Tp mib_sw_port_default_table = (MIB_CE_SW_PORT_Tp)0;
#endif
#ifdef _CWMP_MIB_ /*jiunming, mib for cwmp-tr069*/
#ifdef WLAN_SUPPORT
CWMP_PSK_T mib_cwmp_psk_default_table = (CWMP_PSK_Tp)0;
#endif
#endif /*_CWMP_MIB_*/

#ifdef WLAN_MBSSID
MIB_CE_MBSSIB_Tp mib_mbssid_default_table = (MIB_CE_MBSSIB_Tp)0;
MIB_CE_MBSSIB_WEP_Tp mib_mbssid_wep_default_table = (MIB_CE_MBSSIB_WEP_Tp)0;
#endif

#endif

mib_chain_record_table_entry_T mib_chain_record_table[]={

#ifdef CONFIG_BOA_WEB_E8B_CH
MIB_CHAIN_TBL_ENTRY(MIB_ATM_VC_TBL,		CURRENT_SETTING,	"ATM_VC_TBL",			sizeof(MIB_CE_ATM_VC_T),		0,		0,		0),
#else
MIB_CHAIN_TBL_ENTRY(MIB_ATM_VC_TBL,		CURRENT_SETTING,	"ATM_VC_TBL",			sizeof(MIB_CE_ATM_VC_T),		0, mib_atm_vc_default_table, sizeof(mib_atm_vc_default_table)),
#endif
MIB_CHAIN_TBL_ENTRY(MIB_IP_PORT_FILTER_TBL,	CURRENT_SETTING,	"IP_PORT_FILTER_TBL",		sizeof(MIB_CE_IP_PORT_FILTER_T),	0,		0,		0),
#ifdef MAC_FILTER
MIB_CHAIN_TBL_ENTRY(MIB_MAC_FILTER_TBL,		CURRENT_SETTING,	"MAC_FILTER_TBL",		sizeof(MIB_CE_MAC_FILTER_T),		0,		0,		0),
#endif
MIB_CHAIN_TBL_ENTRY(MIB_PORT_FW_TBL,		CURRENT_SETTING,	"PORT_FW_TBL",			sizeof(MIB_CE_PORT_FW_T),		0,		0,		0),
#ifdef ZTE_GENERAL_ROUTER_SC
MIB_CHAIN_TBL_ENTRY(MIB_VIRTUAL_SVR_TBL,	CURRENT_SETTING,	"VIRTUAL_SVR_TBL",		sizeof(MIB_CE_VTL_SVR_T),		0,		0,		0),
#endif
#ifdef VIRTUAL_SERVER_SUPPORT
MIB_CHAIN_TBL_ENTRY(MIB_VIRTUAL_SVR_TBL,	CURRENT_SETTING,	"VIRTUAL_SVR_TBL",		sizeof(vtlsvr_entryx),		0,		0,		0),
#endif
MIB_CHAIN_TBL_ENTRY(MIB_IP_ROUTE_TBL,		CURRENT_SETTING,	"IP_ROUTE_TBL",			sizeof(MIB_CE_IP_ROUTE_T),		0,		0,		0),
MIB_CHAIN_TBL_ENTRY(MIB_ACL_IP_TBL,		CURRENT_SETTING,	"ACL_IP_TBL",			sizeof(MIB_CE_ACL_IP_T),		0,		0,		0),
//ql_xu add:
#ifdef MAC_ACL
MIB_CHAIN_TBL_ENTRY(MIB_ACL_MAC_TBL,		CURRENT_SETTING,	"ACL_MAC_TBL",			sizeof(MIB_CE_ACL_MAC_T),		0,		0,		0),
#endif
#ifdef WLAN_SUPPORT
#ifdef WLAN_ACL
MIB_CHAIN_TBL_ENTRY(MIB_WLAN_AC_TBL,		CURRENT_SETTING,	"WLAN_AC_TBL",			sizeof(MIB_CE_WLAN_AC_T),		0,		0,		0),
#endif
#endif
#ifdef CONFIG_EXT_SWITCH
MIB_CHAIN_TBL_ENTRY(MIB_SW_PORT_TBL,		CURRENT_SETTING,	"SW_PORT_TBL",			sizeof(MIB_CE_SW_PORT_T),		0, mib_sw_port_default_table, sizeof(mib_sw_port_default_table)),
MIB_CHAIN_TBL_ENTRY(MIB_VLAN_TBL,		CURRENT_SETTING,	"VLAN_TBL",			sizeof(MIB_CE_VLAN_T),			0, mib_vlan_default_table, sizeof(mib_vlan_default_table)),
#endif
MIB_CHAIN_TBL_ENTRY(MIB_IP_QOS_TBL,		CURRENT_SETTING,	"IP_QOS_TBL",			sizeof(MIB_CE_IP_QOS_T),		0,		0,		0),
MIB_CHAIN_TBL_ENTRY(MIB_ACC_TBL,		CURRENT_SETTING,	"ACC_TBL",			sizeof(MIB_CE_ACC_T),			0, mib_acc_default_table, sizeof(mib_acc_default_table)),
#ifdef WLAN_WDS
MIB_CHAIN_TBL_ENTRY(MIB_WDS_TBL,		CURRENT_SETTING,	"WLAN_WDS_TBL",			sizeof(WDS_T),				0,		0,		0),
#endif
#ifdef PORT_TRIGGERING
MIB_CHAIN_TBL_ENTRY(MIB_PORT_TRG_TBL,		CURRENT_SETTING,	"PORT_TRG_TBL",			sizeof(MIB_CE_PORT_TRG_T),		0,		0,		0),
#endif
#ifdef NATIP_FORWARDING
MIB_CHAIN_TBL_ENTRY(MIB_IP_FW_TBL,		CURRENT_SETTING,	"IP_FW_TBL",			sizeof(MIB_CE_IP_FW_T),			0,		0,		0),
#endif
#ifdef URL_BLOCKING_SUPPORT
MIB_CHAIN_TBL_ENTRY(MIB_URL_TBL,		CURRENT_SETTING,	"URL_TBL",			sizeof(url_entryx),		0,		0,		0),
#endif
#ifdef _CWMP_MIB_ /*jiunming, mib for cwmp-tr069*/
#ifdef WLAN_SUPPORT
MIB_CHAIN_TBL_ENTRY(CWMP_PSK_TBL,		CURRENT_SETTING,	"CWMP_PSK_TBL",			sizeof(CWMP_PSK_T),			0,mib_cwmp_psk_default_table,sizeof(mib_cwmp_psk_default_table)),
#endif
#ifdef _PRMT_X_CT_COM_PPPOE_
MIB_CHAIN_TBL_ENTRY(CWMP_CT_PPPOE_TBL,		CURRENT_SETTING,	"CWMP_CT_PPPOE_TBL",		sizeof(CWMP_CT_PPPOE_T),		0,		0,		0),
#endif
#endif /*_CWMP_MIB_*/
MIB_CHAIN_TBL_ENTRY(MIB_MAC_BASE_DHCP_TBL,	CURRENT_SETTING,	"MAC_BASE_DHCP_TBL",		sizeof(MIB_CE_MAC_BASE_DHCP_T),		0,		0,		0),
// add for auto-pvc-search
MIB_CHAIN_TBL_ENTRY(MIB_AUTO_PVC_SEARCH_TBL, CURRENT_SETTING,	"AUTO_PVC_SEARCH_TBL",			sizeof(MIB_AUTO_PVC_SEARCH_T),			0,mib_auto_pvc_search_default_table,sizeof(mib_auto_pvc_search_default_table)),
#ifdef CONFIG_USER_DDNS
MIB_CHAIN_TBL_ENTRY(MIB_DDNS_TBL,		CURRENT_SETTING,	"MIB_DDNS_TBL",			sizeof(MIB_CE_DDNS_T),			0,		0,		0),
#endif
// Jenny, add for PPPoE session information
MIB_CHAIN_TBL_ENTRY(MIB_PPPOE_SESSION_TBL,		CURRENT_SETTING,	"PPPOE_SESSION_TBL",			sizeof(MIB_CE_PPPOE_SESSION_T),			0,		0,		0),
#ifdef DOMAIN_BLOCKING_SUPPORT  // Added by Mason Yu
MIB_CHAIN_TBL_ENTRY(MIB_DOMAIN_BLOCKING_TBL,		CURRENT_SETTING,	"DOMAIN_BLOCKING_TBL",			sizeof(MIB_CE_DOMAIN_BLOCKING_T),		0,		0,		0),
#endif
MIB_CHAIN_TBL_ENTRY(MIB_RIP_TBL,		CURRENT_SETTING,	"RIP_TBL",			sizeof(MIB_CE_RIP_T),		0,		0,		0),
#ifdef WLAN_MBSSID
MIB_CHAIN_TBL_ENTRY(MIB_MBSSIB_TBL,		CURRENT_SETTING,	"MBSSIB_TBL",			sizeof(MIB_CE_MBSSIB_T),		0,mib_mbssid_default_table, sizeof(mib_mbssid_default_table)),
MIB_CHAIN_TBL_ENTRY(MIB_MBSSIB_WEP_TBL,		CURRENT_SETTING,	"MBSSIB_WEP_TBL",		sizeof(MIB_CE_MBSSIB_WEP_T),		0,mib_mbssid_wep_default_table, sizeof(mib_mbssid_wep_default_table)),
#endif
#ifdef PORT_TRIGGER_SUPPORT
MIB_CHAIN_TBL_ENTRY(MIB_PORT_TRIGGER_TBL,CURRENT_SETTING,	"MIB_PORT_TRIGGER_TBL",		sizeof(porttrigger_entry),		0,			0,			0),
#endif
#ifdef MAC_FILTER_EBTABLES_SUPPORT
MIB_CHAIN_TBL_ENTRY(MIB_MAC_FILTER_EBTABLES_TBL,CURRENT_SETTING,	"MIB_MAC_FILTER_EBTABLES_TBL",		sizeof(brgmac_entry),		0,			0,			0),
MIB_CHAIN_TBL_ENTRY(MIB_MAC_FILTER_ROUTER_TBL,CURRENT_SETTING,	"MIB_MAC_FILTER_ROUTER_TBL",		sizeof(routemac_entry),		0,			0,			0),
#endif
//penggenyao 
MIB_CHAIN_TBL_ENTRY(MIB_TRAFFICTL_TBL, CURRENT_SETTING, "TRAFFICTL_TBL", sizeof(MIB_CE_IP_TC_T), 0, 0, 0),
MIB_CHAIN_TBL_ENTRY(MIB_IP_QUEUE_CFG_TBL, CURRENT_SETTING, "IP_QUEUE_CFG_TBL", sizeof(MIB_CE_IP_QUEUE_CFG_T), 0, 0,0),
MIB_CHAIN_TBL_ENTRY(MIB_IP_QUEUE_LEN_TBL, CURRENT_SETTING, "IP_QUEUE_LEN_TBL", sizeof(MIB_CE_IP_QUEUE_LEN_T), 0, 0,0),
MIB_CHAIN_TBL_ENTRY(MIB_IP_QUEUE_RULE_TBL, CURRENT_SETTING, "IP_QUEUE_RULE_TBL", sizeof(MIB_CE_IP_QUEUE_RULE_T), 0, 0,0),
{0}

};


