
/*
 *      Web server handler routines for MAC-Base Assignment for DHCP Server stuffs
 *
 */


/*-- System inlcude files --*/
#include <net/if.h>
#include <sys/ioctl.h>
#include <sys/time.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/socket.h>
#include <net/route.h>

/*-- Local inlcude files --*/
#include "../webs.h"
#include "webform.h"
#include "mib.h"
#include "utility.h"
/*ping_zhang:20090312 START:add STB checkbox for designate STB device type*/
#ifdef CONFIG_USER_UDHCP099PRE2
#include "../../../udhcp-0.9.9-pre2/dhcpd.h"
#else
#include "../../../udhcp-0.9.9-pre/dhcpd.h"
#endif
/*ping_zhang:20090312 END*/


#if defined(ZTE_531B_BRIDGE_SC)||defined(ZTE_GENERAL_ROUTER_SC)
#define GOOD_MSG(url) { \
	websHeader(wp); \
	websWrite(wp, T("<body><blockquote><h5>óɹ!<BR>" \
                "<BR><form><input type=button value=\"  ȷ  \" OnClick=window.location.replace(\"%s\")></form></blockquote></body>"), url);\
	websFooter(wp); \
	websDone(wp, 200); \
}
#else
#define GOOD_MSG(url) { \
	websHeader(wp); \
	websWrite(wp, T("<body><blockquote><h5>Change setting successfully!<BR>" \
                "<BR><form><input type=button value=\"  OK  \" OnClick=window.location.replace(\"%s\")></form></blockquote></body>"), url);\
	websFooter(wp); \
	websDone(wp, 200); \
}
#endif


/*ping_zhang:20090319 START:replace ip range with serving pool of tr069*/
#ifdef _PRMT_X_TELEFONICA_ES_DHCPOPTION_
#ifdef IMAGENIO_IPTV_SUPPORT
void formIpRange(webs_t wp, char_t *path, char_t *query)
{
	DHCPS_SERVING_POOL_T dhcpSpEntry;
	MIB_CE_DHCP_OPTION_T optEntry;
	unsigned int i, totalEntry;
	char_t *strVal, *submitUrl;
	int dhcpd_changed_flag = 0;
	char tmpBuf[100];
#ifndef NO_ACTION
	int pid;
#endif	
	struct in_addr ip,opchAddr,stbDnsAdd1,stbDnsAdd2;
	unsigned short opchport, origport;

	totalEntry = mib_chain_total(MIB_DHCPS_SERVING_POOL_TBL); /* get chain record size */

	// Delete
	strVal = websGetVar(wp, T("del"), T(""));
	if (strVal[0]) {
		unsigned int idx;
		
		strVal = websGetVar(wp, T("select"), T(""));		
		if (strVal[0]) {
			for (i=0; i<totalEntry; i++) {
				if( !mib_chain_get( MIB_DHCPS_SERVING_POOL_TBL, i, (void*)&dhcpSpEntry ) )
					continue;
				idx=i;//idx = totalEntry-i-1;			
				snprintf(tmpBuf, 4, "s%d", idx);
				//printf("tmpBuf(select) = %s idx=%d\n", tmpBuf, idx);
				
				if ( !gstrcmp(strVal, T(tmpBuf)) ) {
					dhcpd_changed_flag = 1;					
					// clear dhcp option enty of this pool
					clearOptTbl(dhcpSpEntry.InstanceNum);
				#ifdef SUPPORT_DHCP_RESERVED_IPADDR
					clearDHCPReservedIPAddrByInstNum( dhcpSpEntry.InstanceNum );
				#endif //DHCP_SUPPORT_RESERVED_IPADDR

					// delete from chain record
					if(mib_chain_delete(MIB_DHCPS_SERVING_POOL_TBL, idx) != 1) {
						strcpy(tmpBuf, T(strDelChainerror));
						goto setErr_dhcpd;
					}
					
					break;
				}
			} // end of for
		}
		goto setOk_dhcpd;
	}

	strVal = websGetVar(wp, T("add"), T(""));
	if (strVal[0]) {
		initSPDHCPOptEntry(&dhcpSpEntry);

		// poolname
		strVal = websGetVar(wp, T("name"), T(""));
		if (strVal[0]) {
			DHCPS_SERVING_POOL_T entry;
			for (i=0; i<totalEntry; i++) {
				mib_chain_get(MIB_DHCPS_SERVING_POOL_TBL, i, (void *)&entry);
				if (!gstrcmp(strVal, entry.poolname)) {
					strcpy(tmpBuf, "device is already exist in table!");
					goto setErr_dhcpd;
				}
			}
			strcpy(dhcpSpEntry.poolname, strVal);
			dhcpSpEntry.poolname[MAX_NAME_LEN-1] = 0;
		} else {
			strcpy(tmpBuf, "device name should not be NULL!");
			goto setErr_dhcpd;
		}

		// start IP addr
		strVal = websGetVar(wp, T("sIp"), T(""));
		if (strVal[0]) {
			if ( !inet_aton(strVal, (struct in_addr *)dhcpSpEntry.startaddr) ) {
				strcpy(tmpBuf, "source IP is wrong!");
				goto setErr_dhcpd;
			}
		} else {
			strcpy(tmpBuf, "source IP cannot be empty");
			goto setErr_dhcpd;
		}

		// end IP addr
		strVal = websGetVar(wp, T("dIp"), T(""));
		if (strVal[0]) {
			if ( !inet_aton(strVal, (struct in_addr *)dhcpSpEntry.endaddr) ) {
				strcpy(tmpBuf, "destination IP is wrong!");
				goto setErr_dhcpd;
			}
		} else {
			strcpy(tmpBuf, "destination IP cannot be empty");
			goto setErr_dhcpd;
		}

		if (dhcpSpEntry.endaddr[3] <= dhcpSpEntry.startaddr[3]) {
			strcpy(tmpBuf, "destination IP address should be larger than source IP address!");
			goto setErr_dhcpd;
		}

		// option 60
		strVal = websGetVar(wp, T("Opt60"), T(""));
		if (strVal[0]) {
			strncpy(dhcpSpEntry.vendorclass,strVal,OPTION_60_LEN);
			dhcpSpEntry.vendorclass[OPTION_60_LEN] = 0;
		} else {
			strcpy(tmpBuf, "option60 cannot be NULL!");
			goto setErr_dhcpd;
		}

		// device type
		strVal = websGetVar(wp, T("dhcpDeviceType"), T(""));
		if (strVal[0]) {
			dhcpSpEntry.deviceType = (unsigned char)atoi(strVal);
		}
		else
			dhcpSpEntry.deviceType = CTC_UNKNOWN;

		//reserved option code
		if(dhcpSpEntry.deviceType == CTC_STB)
		{
			dhcpSpEntry.rsvOptCode = DHCP_OPT_240;
			//from fmdhcpd.c
			strVal= websGetVar(wp, T("opchaddr"), T(""));
			if (strVal[0]) {
				if (!inet_aton(strVal, &ip)) {
					strcpy(tmpBuf, T(strInvalidOpchaddr));
					goto setErr_dhcpd;
				}
			} else {
				strcpy(tmpBuf, T(strInvalidOpchaddr));
				goto setErr_dhcpd;
			}
			mib_get(MIB_OPCH_ADDRESS, (void *)&opchAddr);
			if (opchAddr.s_addr != ip.s_addr)
				dhcpd_changed_flag = 1;
			mib_set(MIB_OPCH_ADDRESS, (void *)&ip);

			strVal = websGetVar(wp, T("opchport"), T(""));
			if (strVal[0]) {
				opchport = (unsigned short)atoi(strVal);
			} else {
				strcpy(tmpBuf, T(strInvalidOpchport));
				goto setErr_dhcpd;
			}
			mib_get(MIB_OPCH_PORT, (void *)&origport);
			if (origport != opchport)
				dhcpd_changed_flag = 1;
			mib_set(MIB_OPCH_PORT, (void *)&opchport);
			
			ip.s_addr = 0xffffffff;
			strVal = websGetVar(wp, T("stbdns1"), T(""));
			if (strVal[0]) {
				if (!inet_aton(strVal, &ip)) {
					strcpy(tmpBuf, T(Tinvalid_dns));
					goto setErr_dhcpd;
				}
			}
			mib_get(MIB_IMAGENIO_DNS1, (void *)&stbDnsAdd1);
			if (stbDnsAdd1.s_addr != ip.s_addr)
				dhcpd_changed_flag = 1;
			mib_set(MIB_IMAGENIO_DNS1, (void *)&ip);

			ip.s_addr = 0xffffffff;
			strVal = websGetVar(wp, T("stbdns2"), T(""));
			if (strVal[0]) {
				if (!inet_aton(strVal, &ip)) {
					strcpy(tmpBuf, T(Tinvalid_dns));
					goto setErr_dhcpd;
				}
			}
			mib_get(MIB_IMAGENIO_DNS2, (void *)&stbDnsAdd2);
			if (stbDnsAdd2.s_addr != ip.s_addr)
				dhcpd_changed_flag = 1;
			mib_set(MIB_IMAGENIO_DNS2, (void *)&ip);
		}
		else if(dhcpSpEntry.deviceType == CTC_UNKNOWN)
		{
			dhcpSpEntry.rsvOptCode = DHCP_END;
		}
		else
		{
			memset( &optEntry, 0, sizeof( MIB_CE_DHCP_OPTION_T ) );
			optEntry.enable = 1;
			optEntry.usedFor = eUsedFor_DHCPServer_ServingPool;
			optEntry.dhcpConSPInstNum = dhcpSpEntry.InstanceNum;
			optEntry.dhcpOptInstNum = 1;

			strVal = websGetVar(wp, T("reservedOption"), T(""));
			if (strVal[0]) {
				dhcpSpEntry.rsvOptCode = (unsigned char)atoi(strVal);
				optEntry.tag = (unsigned char)atoi(strVal);
			}
			else{
				strcpy(tmpBuf, "optionCode error!");
				goto setErr_dhcpd;
			}
			//save option str for reserved option
			strVal = websGetVar(wp, T("OptStr"), T(""));
			if (strVal[0]) {
				strncpy(optEntry.value, strVal,OPTION_RSV_LEN);
				optEntry.value[OPTION_RSV_LEN] = 0;
				optEntry.len = strlen(optEntry.value);
			} else {
				strcpy(tmpBuf, "optionStr cannot be NULL!");
				goto setErr_dhcpd;
			}
		}

		dhcpd_changed_flag = 1;
		if (!mib_chain_add(MIB_DHCPS_SERVING_POOL_TBL, (void *)&dhcpSpEntry)) {
			strcpy(tmpBuf, T(strAddChainerror));
			goto setErr_dhcpd;
		} else {
			if( (dhcpSpEntry.deviceType != CTC_STB)&&(dhcpSpEntry.deviceType != CTC_UNKNOWN) )
			{
				if (!mib_chain_add( MIB_DHCP_SERVER_OPTION_TBL, (void*)&optEntry)) {
					strcpy(tmpBuf, T(strAddChainerror));
					goto setErr_dhcpd;
				}
			}
			goto setOk_dhcpd;
		}
	}

	strVal = websGetVar(wp, T("mod"), T(""));
	if (strVal[0]) {
		unsigned int idx;
		unsigned char oldDeviceType;
		
		strVal = websGetVar(wp, T("select"), T(""));		
		if (strVal[0]) {
			for (i=0; i<totalEntry; i++) {
				idx = i; //idx = totalEntry-i-1;			
				snprintf(tmpBuf, 4, "s%d", idx);

				if ( !gstrcmp(strVal, T(tmpBuf)) ) {
					if( !mib_chain_get( MIB_DHCPS_SERVING_POOL_TBL, idx, (void*)&dhcpSpEntry ) ) {
						strcpy(tmpBuf, T("Get chain(MIB_DHCPS_SERVING_POOL_TBL) record error!\n"));
						goto setErr_dhcpd;
					}
					
					// poolname
					strVal = websGetVar(wp, T("name"), T(""));
					if (strVal[0]) {
						DHCPS_SERVING_POOL_T entry;
						for (i=0; i<totalEntry; i++) {
							if (i== idx)
								continue;
							mib_chain_get(MIB_DHCPS_SERVING_POOL_TBL, i, (void *)&entry);
							if (!gstrcmp(strVal, entry.poolname)) {
								strcpy(tmpBuf, "device is already exist in table!");
								goto setErr_dhcpd;
							}
						}
						strcpy(dhcpSpEntry.poolname, strVal);
						dhcpSpEntry.poolname[MAX_NAME_LEN-1] = 0;
					} else {
						strcpy(tmpBuf, "device name should not be NULL!");
						goto setErr_dhcpd;
					}

					// start IP addr
					strVal = websGetVar(wp, T("sIp"), T(""));
					if (strVal[0]) {
						if ( !inet_aton(strVal, (struct in_addr *)dhcpSpEntry.startaddr) ) {
							strcpy(tmpBuf, "source IP is wrong!");
							goto setErr_dhcpd;
						}
					} else {
						strcpy(tmpBuf, "source IP cannot be empty");
						goto setErr_dhcpd;
					}

					// end IP addr
					strVal = websGetVar(wp, T("dIp"), T(""));
					if (strVal[0]) {
						if ( !inet_aton(strVal, (struct in_addr *)dhcpSpEntry.endaddr) ) {
							strcpy(tmpBuf, "destination IP is wrong!");
							goto setErr_dhcpd;
						}
					} else {
						strcpy(tmpBuf, "destination IP cannot be empty");
						goto setErr_dhcpd;
					}

					if (dhcpSpEntry.endaddr[3] <= dhcpSpEntry.startaddr[3]) {
						strcpy(tmpBuf, "destination IP address should be larger than source IP address!");
						goto setErr_dhcpd;
					}

					// option 60
					strVal = websGetVar(wp, T("Opt60"), T(""));
					if (strVal[0]) {
						strncpy(dhcpSpEntry.vendorclass,strVal,OPTION_60_LEN);
						dhcpSpEntry.vendorclass[OPTION_60_LEN] = 0;
					} else {
						strcpy(tmpBuf, "option60 cannot be NULL!");
						goto setErr_dhcpd;
					}

					// device type
					oldDeviceType = dhcpSpEntry.deviceType;
					strVal = websGetVar(wp, T("dhcpDeviceType"), T(""));
					if (strVal[0]) {
						dhcpSpEntry.deviceType = (unsigned char)atoi(strVal);
					}
					else
						dhcpSpEntry.deviceType = CTC_UNKNOWN;

					dhcpd_changed_flag = 1;
					if(mib_chain_update(MIB_DHCPS_SERVING_POOL_TBL, (void *)&dhcpSpEntry, idx) != 1) {
						strcpy(tmpBuf, T(strModChainerror));
						goto setErr_dhcpd;
					}
					
					//clear option table of the server pool
					clearOptTbl(dhcpSpEntry.InstanceNum);
					//reserved option code
					if(dhcpSpEntry.deviceType == CTC_STB)
					{
						dhcpSpEntry.rsvOptCode = DHCP_OPT_240;
						if(mib_chain_update(MIB_DHCPS_SERVING_POOL_TBL, (void *)&dhcpSpEntry, idx) != 1) {
							strcpy(tmpBuf, T(strModChainerror));
							goto setErr_dhcpd;
						}

					
						//from fmdhcpd.c
						strVal= websGetVar(wp, T("opchaddr"), T(""));
						if (strVal[0]) {
							if (!inet_aton(strVal, &ip)) {
								strcpy(tmpBuf, T(strInvalidOpchaddr));
								goto setErr_dhcpd;
							}
						} else {
							strcpy(tmpBuf, T(strInvalidOpchaddr));
							goto setErr_dhcpd;
						}
						mib_get(MIB_OPCH_ADDRESS, (void *)&opchAddr);
						if (opchAddr.s_addr != ip.s_addr)
							dhcpd_changed_flag = 1;
						mib_set(MIB_OPCH_ADDRESS, (void *)&ip);

						strVal = websGetVar(wp, T("opchport"), T(""));
						if (strVal[0]) {
							opchport = (unsigned short)atoi(strVal);
						} else {
							strcpy(tmpBuf, T(strInvalidOpchport));
							goto setErr_dhcpd;
						}
						mib_get(MIB_OPCH_PORT, (void *)&origport);
						if (origport != opchport)
							dhcpd_changed_flag = 1;
						mib_set(MIB_OPCH_PORT, (void *)&opchport);
						
						ip.s_addr = 0xffffffff;
						strVal = websGetVar(wp, T("stbdns1"), T(""));
						if (strVal[0]) {
							if (!inet_aton(strVal, &ip)) {
								strcpy(tmpBuf, T(Tinvalid_dns));
								goto setErr_dhcpd;
							}
						}
						mib_get(MIB_IMAGENIO_DNS1, (void *)&stbDnsAdd1);
						if (stbDnsAdd1.s_addr != ip.s_addr)
							dhcpd_changed_flag = 1;
						mib_set(MIB_IMAGENIO_DNS1, (void *)&ip);

						ip.s_addr = 0xffffffff;
						strVal = websGetVar(wp, T("stbdns2"), T(""));
						if (strVal[0]) {
							if (!inet_aton(strVal, &ip)) {
								strcpy(tmpBuf, T(Tinvalid_dns));
								goto setErr_dhcpd;
							}
						}
						mib_get(MIB_IMAGENIO_DNS2, (void *)&stbDnsAdd2);
						if (stbDnsAdd2.s_addr != ip.s_addr)
							dhcpd_changed_flag = 1;
						mib_set(MIB_IMAGENIO_DNS2, (void *)&ip);
					}
					else if(dhcpSpEntry.deviceType == CTC_UNKNOWN)
					{
						dhcpSpEntry.rsvOptCode = DHCP_END;
						if(mib_chain_update(MIB_DHCPS_SERVING_POOL_TBL, (void *)&dhcpSpEntry, idx) != 1) {
							strcpy(tmpBuf, T(strModChainerror));
							goto setErr_dhcpd;
						}
					}
					else
					{
						memset( &optEntry, 0, sizeof( MIB_CE_DHCP_OPTION_T ) );
						optEntry.enable = 1;
						optEntry.usedFor = eUsedFor_DHCPServer_ServingPool;
						optEntry.dhcpConSPInstNum = dhcpSpEntry.InstanceNum;
						optEntry.dhcpOptInstNum = 1;

						strVal = websGetVar(wp, T("reservedOption"), T(""));
						if (strVal[0]) {
							dhcpSpEntry.rsvOptCode = (unsigned char)atoi(strVal);
							optEntry.tag = (unsigned char)atoi(strVal);
							if(mib_chain_update(MIB_DHCPS_SERVING_POOL_TBL, (void *)&dhcpSpEntry, idx) != 1) {
								strcpy(tmpBuf, T(strModChainerror));
								goto setErr_dhcpd;
							}
						}
						else{
							strcpy(tmpBuf, "optionCode error!");
							goto setErr_dhcpd;
						}
						//save option str for reserved option
						strVal = websGetVar(wp, T("OptStr"), T(""));
						if (strVal[0]) {
							strncpy(optEntry.value, strVal,OPTION_RSV_LEN);
							optEntry.value[OPTION_RSV_LEN] = 0;
							optEntry.len = strlen(optEntry.value);
						} else {
							strcpy(tmpBuf, "optionStr cannot be NULL!");
							goto setErr_dhcpd;
						}

						dhcpd_changed_flag = 1;
						if (!mib_chain_add( MIB_DHCP_SERVER_OPTION_TBL, (unsigned char*)&optEntry)) {
							strcpy(tmpBuf, T(strAddChainerror));
							goto setErr_dhcpd;
						} else
							goto setOk_dhcpd;

					}
					
					break;
				}
			} // end of for
		}
		goto setOk_dhcpd;
	}
	
setOk_dhcpd:
#ifdef COMMIT_IMMEDIATELY
	if( dhcpd_changed_flag == 1 )
	{
		unsigned char vChar;
	#ifdef __CLOSE_INTERFACE_BEFORE_WRITE_
		/*to avoid the dead when wrriting the flash*/
		itfcfg("sar", 0);
		itfcfg("eth0", 0);
	#ifdef WLAN_SUPPORT
		itfcfg("wlan0", 0);
	#endif
	#endif /*__CLOSE_INTERFACE_BEFORE_WRITE_*/
		mib_update(CURRENT_SETTING, CONFIG_MIB_ALL);

	#ifdef __CLOSE_INTERFACE_BEFORE_WRITE_
		itfcfg("sar", 1);
		itfcfg("eth0", 1);
	#ifdef WLAN_SUPPORT
		vChar=0;
		mib_get( MIB_WLAN_DISABLED, (void *)&vChar);
		if( vChar==0 )	itfcfg("wlan0", 1);
	#endif //WLAN_SUPPORT
	#endif /*__CLOSE_INTERFACE_BEFORE_WRITE_*/
	}
#endif
	
#ifndef NO_ACTION
	pid = fork();
	if (pid)
		waitpid(pid, NULL, 0);
	else if (pid == 0) {
		snprintf(tmpBuf, 100, "%s/%s", _CONFIG_SCRIPT_PATH, _CONFIG_SCRIPT_PROG);
#ifdef HOME_GATEWAY
		execl( tmpBuf, _CONFIG_SCRIPT_PROG, "gw", "bridge", NULL);
#else
		execl( tmpBuf, _CONFIG_SCRIPT_PROG, "ap", "bridge", NULL);
#endif
		exit(1);
	}
#endif
	if(dhcpd_changed_flag == 1)
	{
		restart_dhcp();
		submitUrl = websGetVar(wp, T("submit-url"), T(""));
		GOOD_MSG(submitUrl);
		return;
	}

	submitUrl = websGetVar(wp, T("submit-url"), T(""));
	if (submitUrl[0])
		websRedirect(wp, submitUrl);
	else
		websDone(wp, 200);
  	return;

setErr_dhcpd:
	ERR_MSG(tmpBuf);
}

#if defined(ZTE_531B_BRIDGE_SC)||defined(ZTE_GENERAL_ROUTER_SC)
int showDeviceIpTable(int eid, webs_t wp, int argc, char_t **argv)
{
	int nBytesSent=0,id=-1;
	unsigned int entryNum,optEntryNum,i,j,optNum;
	DHCPS_SERVING_POOL_T Entry;
	MIB_CE_DHCP_OPTION_T rsvOptEntry,optEntry;
	char startIp[16], endIp[16];
	char devType[16];
	struct in_addr opchAddr;
	unsigned short opchport;
	char optionStr[DHCP_OPT_VAL_LEN];
	
	entryNum = mib_chain_total(MIB_DHCPS_SERVING_POOL_TBL);	
	
	nBytesSent += websWrite(wp, T("<tr><font size=1>"
	"<td align=center width=\"5%%\" bgcolor=\"#808080\"></td>\n"
	"<td align=center width=\"20%%\" bgcolor=\"#808080\">豸</td>\n"
	"<td align=center width=\"20%%\" bgcolor=\"#808080\">豸</td>"
	"<td align=center width=\"20%%\" bgcolor=\"#808080\">ʼַ</td>\n"
	"<td align=center width=\"20%%\" bgcolor=\"#808080\">ַֹ</td>\n"
	"<td align=center width=\"30%%\" bgcolor=\"#808080\">option60</td>"
	"<td align=center width=\"40%%\" bgcolor=\"#808080\" colspan=\"2\">option</td>"
	"</font></tr>\n"));

	for (i=0; i<entryNum; i++) {

		if (!mib_chain_get(MIB_DHCPS_SERVING_POOL_TBL, i, (void *)&Entry))
		{
  			websError(wp, 400, T("ȡؼ¼ʧ!\n"));
			return;
		}		

		strcpy(startIp, inet_ntoa(*((struct in_addr *)Entry.startaddr)));
		strcpy(endIp, inet_ntoa(*((struct in_addr *)Entry.endaddr)));

		switch(Entry.deviceType)
		{
		case CTC_Computer:
			strcpy(devType,"PC");
			break;
		case CTC_Camera:
			strcpy(devType,"");
			break;
		case CTC_HGW:
			strcpy(devType,"ͥ");
			break;
		case CTC_STB:
			strcpy(devType,"");
			break;
		case CTC_PHONE:
			strcpy(devType,"绰");
			break;
		case CTC_UNKNOWN:
		default:
			strcpy(devType,"δ֪");
			break;
		}

		optNum = getSPDHCPOptEntryNum(eUsedFor_DHCPServer_ServingPool, Entry.InstanceNum);
		getSPDHCPRsvOptEntryByCode(Entry.InstanceNum, Entry.rsvOptCode, &rsvOptEntry, &id);
		if(Entry.deviceType == CTC_STB) {
			optNum += 1;
			mib_get(MIB_OPCH_ADDRESS, (void *)&opchAddr);
			mib_get(MIB_OPCH_PORT, (void *)&opchport);
			sprintf(optionStr, ":::::%s:%d", inet_ntoa(opchAddr), opchport);
		}else if(Entry.deviceType == CTC_UNKNOWN) {
			optNum += 1;
			strcpy(optionStr,"");
		}else {
			if(id!=-1)
				strcpy(optionStr,rsvOptEntry.value);
			else
				strcpy(optionStr,"");
		}
		
		nBytesSent += websWrite(wp, T("<tr>"
			"<td align=center width=\"5%%\" bgcolor=\"#C0C0C0\" rowspan=\"%d\"><input type=\"radio\" name=\"select\" value=\"s%d\" "
			"onClick=\"postsetting(devname[%d],devtype[%d],startip[%d],endip[%d],option[%d],opCode[%d],opStr[%d])\"></td>\n"
			"<td align=center width=\"20%%\" bgcolor=\"#C0C0C0\" rowspan=\"%d\"><font size=\"2\">%s</font></td>\n"
			"<td align=center width=\"20%%\" bgcolor=\"#C0C0C0\" rowspan=\"%d\"><font size=\"2\">%s</font></td>\n"
			"<td align=center width=\"20%%\" bgcolor=\"#C0C0C0\" rowspan=\"%d\"><font size=\"2\">%s</font></td>\n"
			"<td align=center width=\"20%%\" bgcolor=\"#C0C0C0\" rowspan=\"%d\"><font size=\"2\">%s</font></td>\n"
			"<td align=center width=\"30%%\" bgcolor=\"#C0C0C0\" rowspan=\"%d\"><font size=\"2\">%s</font></td>\n"
			"<td align=center width=\"10%%\" bgcolor=\"#C0C0C0\"><font size=\"2\">%d</font></td>\n"
			"<td align=center width=\"30%%\" bgcolor=\"#C0C0C0\"><font size=\"2\">%s</font></td>\n"),
			optNum,i, i, i, i, i, i, i, i,
			optNum,Entry.poolname, optNum,devType, optNum,startIp, optNum,endIp, optNum,Entry.vendorclass,Entry.rsvOptCode, optionStr);

		optEntryNum = mib_chain_total(MIB_DHCP_SERVER_OPTION_TBL);
		for (j=0; j<optEntryNum; j++)
		{
			if(j==id)
				continue;
			if (!mib_chain_get(MIB_DHCP_SERVER_OPTION_TBL, j, (void *)&optEntry) || !optEntry.enable)
				continue;
			if (optEntry.usedFor!=eUsedFor_DHCPServer_ServingPool ||optEntry.dhcpConSPInstNum!=Entry.InstanceNum)
				continue;
			nBytesSent += websWrite(wp, T("<tr>"
				"<td align=center width=\"10%%\" bgcolor=\"#C0C0C0\"><font size=\"2\">%d</font></td>\n"
				"<td align=center width=\"30%%\" bgcolor=\"#C0C0C0\"><font size=\"2\">%s</font></td>\n"
				"</tr>\n"),
				optEntry.tag,optEntry.value);
		}
		nBytesSent += websWrite(wp, T("</tr>\n"));
	}
	
	return 0;
}
#else
int showDeviceIpTable(int eid, webs_t wp, int argc, char_t **argv)
{
	int nBytesSent=0,id=-1;
	unsigned int entryNum,optEntryNum,i,j,optNum;
	DHCPS_SERVING_POOL_T Entry;
	MIB_CE_DHCP_OPTION_T rsvOptEntry,optEntry;
	char startIp[16], endIp[16];
	char devType[16];
	struct in_addr opchAddr;
	unsigned short opchport;
	char optionStr[DHCP_OPT_VAL_LEN];
	
	entryNum = mib_chain_total(MIB_DHCPS_SERVING_POOL_TBL);	
	
	nBytesSent += websWrite(wp, T("<tr><font size=1>"
	"<td align=center width=\"5%%\" bgcolor=\"#808080\">Select</td>\n"
	"<td align=center width=\"20%%\" bgcolor=\"#808080\">device name</td>\n"
	"<td align=center width=\"20%%\" bgcolor=\"#808080\">device type</td>"
	"<td align=center width=\"20%%\" bgcolor=\"#808080\">start address</td>\n"
	"<td align=center width=\"20%%\" bgcolor=\"#808080\">end address</td>\n"
	"<td align=center width=\"30%%\" bgcolor=\"#808080\">option60</td>"
	"<td align=center width=\"40%%\" bgcolor=\"#808080\" colspan=\"2\">reserved option</td>"
	"</font></tr>\n"));

	for (i=0; i<entryNum; i++) {

		if (!mib_chain_get(MIB_DHCPS_SERVING_POOL_TBL, i, (void *)&Entry))
		{
  			websError(wp, 400, T("Get chain(MIB_DHCPS_SERVING_POOL_TBL) record error!\n"));
			return;
		}		

		strcpy(startIp, inet_ntoa(*((struct in_addr *)Entry.startaddr)));
		strcpy(endIp, inet_ntoa(*((struct in_addr *)Entry.endaddr)));

		switch(Entry.deviceType)
		{
		case CTC_Computer:
			strcpy(devType,"PC");
			break;
		case CTC_Camera:
			strcpy(devType,"Camera");
			break;
		case CTC_HGW:
			strcpy(devType,"HGW");
			break;
		case CTC_STB:
			strcpy(devType,"STB");
			break;
		case CTC_PHONE:
			strcpy(devType,"Phone");
			break;
		case CTC_UNKNOWN:
		default:
			strcpy(devType,"Unknown");
			break;
		}

		optNum = getSPDHCPOptEntryNum(eUsedFor_DHCPServer_ServingPool, Entry.InstanceNum);
		id=-1;//re-init
		getSPDHCPRsvOptEntryByCode(Entry.InstanceNum, Entry.rsvOptCode, &rsvOptEntry, &id);
		if(Entry.deviceType == CTC_STB) {
			optNum += 1;
			mib_get(MIB_OPCH_ADDRESS, (void *)&opchAddr);
			mib_get(MIB_OPCH_PORT, (void *)&opchport);
			sprintf(optionStr, ":::::%s:%d", inet_ntoa(opchAddr), opchport);
		}else if(Entry.deviceType == CTC_UNKNOWN) {
			optNum += 1;
			strcpy(optionStr,"");
		}else {
			if(id!=-1)
				strcpy(optionStr,rsvOptEntry.value);
			else
				strcpy(optionStr,"");
		}
		
		nBytesSent += websWrite(wp, T("<tr>"
			"<td align=center width=\"5%%\" bgcolor=\"#C0C0C0\" rowspan=\"%d\"><input type=\"radio\" name=\"select\" value=\"s%d\" "
			"onClick=\"postsetting(devname[%d],devtype[%d],startip[%d],endip[%d],option[%d],opCode[%d],opStr[%d])\"></td>\n"
			"<td align=center width=\"20%%\" bgcolor=\"#C0C0C0\" rowspan=\"%d\"><font size=\"2\">%s</font></td>\n"
			"<td align=center width=\"20%%\" bgcolor=\"#C0C0C0\" rowspan=\"%d\"><font size=\"2\">%s</font></td>\n"
			"<td align=center width=\"20%%\" bgcolor=\"#C0C0C0\" rowspan=\"%d\"><font size=\"2\">%s</font></td>\n"
			"<td align=center width=\"20%%\" bgcolor=\"#C0C0C0\" rowspan=\"%d\"><font size=\"2\">%s</font></td>\n"
			"<td align=center width=\"30%%\" bgcolor=\"#C0C0C0\" rowspan=\"%d\"><font size=\"2\">%s</font></td>\n"
			"<td align=center width=\"10%%\" bgcolor=\"#C0C0C0\"><font size=\"2\">%d</font></td>\n"
			"<td align=center width=\"30%%\" bgcolor=\"#C0C0C0\"><font size=\"2\">%s</font></td>\n"),
			optNum,i, i, i, i, i, i, i, i,
			optNum,Entry.poolname, optNum,devType, optNum,startIp, optNum,endIp, optNum,Entry.vendorclass,Entry.rsvOptCode, optionStr);

		optEntryNum = mib_chain_total(MIB_DHCP_SERVER_OPTION_TBL);
		for (j=0; j<optEntryNum; j++)
		{
			if(j==id)
				continue;
			if (!mib_chain_get(MIB_DHCP_SERVER_OPTION_TBL, j, (void *)&optEntry) || !optEntry.enable)
				continue;
			if (optEntry.usedFor!=eUsedFor_DHCPServer_ServingPool ||optEntry.dhcpConSPInstNum!=Entry.InstanceNum)
				continue;
			nBytesSent += websWrite(wp, T("<tr>"
				"<td align=center width=\"10%%\" bgcolor=\"#C0C0C0\"><font size=\"2\">%d</font></td>\n"
				"<td align=center width=\"30%%\" bgcolor=\"#C0C0C0\"><font size=\"2\">%s</font></td>\n"
				"</tr>\n"),
				optEntry.tag,optEntry.value);
		}
		nBytesSent += websWrite(wp, T("</tr>\n"));
	}
	
	return 0;
}
#endif
#endif
#endif

#if 0
#ifndef _PRMT_X_TELEFONICA_ES_DHCPOPTION_
#ifdef IMAGENIO_IPTV_SUPPORT
void formIpRange(webs_t wp, char_t *path, char_t *query)
{
	MIB_CE_IP_RANGE_DHCP_T Entry;
	unsigned int i, totalEntry;
	char_t *strVal, *submitUrl;
	int dhcpd_changed_flag = 0;
	char tmpBuf[100];
#ifndef NO_ACTION
	int pid;
#endif	
/*ping_zhang:20090313 START:Telefonica DHCP option new request*/
	struct in_addr ip,opchAddr,stbDnsAdd1,stbDnsAdd2;
	unsigned short opchport, origport;
/*ping_zhang:20090313 END*/

	totalEntry = mib_chain_total(MIB_IP_RANGE_DHCP_TBL); /* get chain record size */

	// Delete
	strVal = websGetVar(wp, T("del"), T(""));
	if (strVal[0]) {
		unsigned int idx;
		
		strVal = websGetVar(wp, T("select"), T(""));		
		if (strVal[0]) {
			for (i=0; i<totalEntry; i++) {
				idx = totalEntry-i-1;			
				snprintf(tmpBuf, 4, "s%d", idx);
				//printf("tmpBuf(select) = %s idx=%d\n", tmpBuf, idx);
				
				if ( !gstrcmp(strVal, T(tmpBuf)) ) {
					dhcpd_changed_flag = 1;
					// delete from chain record
					if(mib_chain_delete(MIB_IP_RANGE_DHCP_TBL, idx) != 1) {
						strcpy(tmpBuf, T(strDelChainerror));
						goto setErr_dhcpd;
					}
				}
			} // end of for
		}
		goto setOk_dhcpd;
	}

	strVal = websGetVar(wp, T("add"), T(""));
	if (strVal[0]) {
		strVal = websGetVar(wp, T("name"), T(""));
		if (strVal[0]) {
			MIB_CE_IP_RANGE_DHCP_T entry;
			for (i=0; i<totalEntry; i++) {
				mib_chain_get(MIB_IP_RANGE_DHCP_TBL, i, (void *)&entry);
				if (!gstrcmp(strVal, entry.devname)) {
					strcpy(tmpBuf, "device is already exist in table!");
					goto setErr_dhcpd;
				}
			}
			strcpy(Entry.devname, strVal);
			/*ping_zhang: fix garbage string bugs*/
			Entry.devname[20-1] = 0;
		} else {
			strcpy(tmpBuf, "device name should not be NULL!");
			goto setErr_dhcpd;
		}

		strVal = websGetVar(wp, T("sIp"), T(""));
		if (strVal[0]) {
			if ( !inet_aton(strVal, (struct in_addr *)Entry.startIP) ) {
				strcpy(tmpBuf, "source IP is wrong!");
				goto setErr_dhcpd;
			}
		} else {
			strcpy(tmpBuf, "source IP cannot be empty");
			goto setErr_dhcpd;
		}

		strVal = websGetVar(wp, T("dIp"), T(""));
		if (strVal[0]) {
			if ( !inet_aton(strVal, (struct in_addr *)Entry.endIP) ) {
				strcpy(tmpBuf, "destination IP is wrong!");
				goto setErr_dhcpd;
			}
		} else {
			strcpy(tmpBuf, "destination IP cannot be empty");
			goto setErr_dhcpd;
		}

		if (Entry.endIP[3] <= Entry.startIP[3]) {
			strcpy(tmpBuf, "destination IP address should be larger than source IP address!");
			goto setErr_dhcpd;
		}

		strVal = websGetVar(wp, T("Opt60"), T(""));
		if (strVal[0]) {
/*ping_zhang:20090312 START:add STB checkbox for designate STB device type*/
			MIB_CE_IP_RANGE_DHCP_T entry;
			for (i=0; i<totalEntry; i++) {
				mib_chain_get(MIB_IP_RANGE_DHCP_TBL, i, (void *)&entry);
				if (!gstrcmp(strVal, entry.option60)) {
					sprintf(tmpBuf, "device with option60:%s is already exist in table!", entry.option60);
					goto setErr_dhcpd;
				}
			}
/*ping_zhang:20090312 END*/
			strcpy(Entry.option60, strVal);
			/*ping_zhang: fix garbage string bugs*/
			Entry.option60[MAX_DHCP_OPT_60_LEN] = 0;
		} else {
			strcpy(tmpBuf, "option60 cannot be NULL!");
			goto setErr_dhcpd;
		}

/*ping_zhang:20090312 START:add STB checkbox for designate STB device type*/
#if 0
		strVal = websGetVar(wp, T("isSTB"), T(""));
		if( !gstrcmp(strVal, T("ON")) )
			Entry.deviceType = CTC_STB;
		else
			Entry.deviceType = CTC_UNKNOWN;
#endif
/*ping_zhang:20090312 END*/

/*ping_zhang:20090313 START:Telefonica DHCP option new request*/
		// device type
		strVal = websGetVar(wp, T("dhcpDeviceType"), T(""));
		if (strVal[0]) {
			Entry.deviceType = (unsigned char)atoi(strVal);
		}
		else
			Entry.deviceType = CTC_UNKNOWN;

		//reserved option code
		if(Entry.deviceType == CTC_STB)
		{
			Entry.optionCode = DHCP_OPT_240;
			/*ping_zhang:20090316	 optionStr is NULL for STB*/
			strcpy(Entry.optionStr,"");
			//option str for reserved option
					//from fmdhcpd.c
			strVal= websGetVar(wp, T("opchaddr"), T(""));
			if (strVal[0]) {
				if (!inet_aton(strVal, &ip)) {
					strcpy(tmpBuf, T(strInvalidOpchaddr));
					goto setErr_dhcpd;
				}
			} else {
				strcpy(tmpBuf, T(strInvalidOpchaddr));
				goto setErr_dhcpd;
			}
			mib_get(MIB_OPCH_ADDRESS, (void *)&opchAddr);
			if (opchAddr.s_addr != ip.s_addr)
				dhcpd_changed_flag = 1;
			mib_set(MIB_OPCH_ADDRESS, (void *)&ip);

			strVal = websGetVar(wp, T("opchport"), T(""));
			if (strVal[0]) {
				opchport = (unsigned short)atoi(strVal);
			} else {
				strcpy(tmpBuf, T(strInvalidOpchport));
				goto setErr_dhcpd;
			}
			mib_get(MIB_OPCH_PORT, (void *)&origport);
			if (origport != opchport)
				dhcpd_changed_flag = 1;
			mib_set(MIB_OPCH_PORT, (void *)&opchport);
			
			ip.s_addr = 0xffffffff;
			strVal = websGetVar(wp, T("stbdns1"), T(""));
			if (strVal[0]) {
				if (!inet_aton(strVal, &ip)) {
					strcpy(tmpBuf, T(Tinvalid_dns));
					goto setErr_dhcpd;
				}
			}
			mib_get(MIB_IMAGENIO_DNS1, (void *)&stbDnsAdd1);
			if (stbDnsAdd1.s_addr != ip.s_addr)
				dhcpd_changed_flag = 1;
			mib_set(MIB_IMAGENIO_DNS1, (void *)&ip);

			ip.s_addr = 0xffffffff;
			strVal = websGetVar(wp, T("stbdns2"), T(""));
			if (strVal[0]) {
				if (!inet_aton(strVal, &ip)) {
					strcpy(tmpBuf, T(Tinvalid_dns));
					goto setErr_dhcpd;
				}
			}
			mib_get(MIB_IMAGENIO_DNS2, (void *)&stbDnsAdd2);
			if (stbDnsAdd2.s_addr != ip.s_addr)
				dhcpd_changed_flag = 1;
			mib_set(MIB_IMAGENIO_DNS2, (void *)&ip);
		}
		else if(Entry.deviceType == CTC_UNKNOWN)
		{
			Entry.optionCode = DHCP_END;
			strcpy(Entry.optionStr,"");
		}
		else
		{
			strVal = websGetVar(wp, T("reservedOption"), T(""));
			if (strVal[0]) {
				Entry.optionCode = (unsigned char)atoi(strVal);
			}
			else{
				strcpy(tmpBuf, "optionCode error!");
				goto setErr_dhcpd;
			}
			//option str for reserved option
			strVal = websGetVar(wp, T("OptStr"), T(""));
			if (strVal[0]) {
				strcpy(Entry.optionStr, strVal);
				/*ping_zhang: fix garbage string bugs*/
				Entry.option60[MAX_DHCP_OPT_RSV_LEN] = 0;
			} else {
				strcpy(tmpBuf, "optionStr cannot be NULL!");
				goto setErr_dhcpd;
			}
		}
/*ping_zhang:20090313 START:Telefonica DHCP option new request*/

		dhcpd_changed_flag = 1;
		if (!mib_chain_add(MIB_IP_RANGE_DHCP_TBL, (void *)&Entry)) {
			strcpy(tmpBuf, T(strAddChainerror));
			goto setErr_dhcpd;
		} else
			goto setOk_dhcpd;
	}

	strVal = websGetVar(wp, T("mod"), T(""));
	if (strVal[0]) {
		unsigned int idx;
		
		strVal = websGetVar(wp, T("select"), T(""));		
		if (strVal[0]) {
			for (i=0; i<totalEntry; i++) {
				idx = totalEntry-i-1;			
				snprintf(tmpBuf, 4, "s%d", idx);
				
				if ( !gstrcmp(strVal, T(tmpBuf)) ) {
					strVal = websGetVar(wp, T("name"), T(""));
					if (strVal[0]) {
						MIB_CE_IP_RANGE_DHCP_T entry;
						int j;
						
						for (j=0; j<totalEntry; j++) {
							if (j == idx)
								continue;
							
							mib_chain_get(MIB_IP_RANGE_DHCP_TBL, j, (void *)&entry);
							if (!gstrcmp(strVal, entry.devname)) {
								strcpy(tmpBuf, "device is already exist in table!");
								goto setErr_dhcpd;
							}
						}
						strcpy(Entry.devname, strVal);
						/*ping_zhang: fix garbage string bugs*/
						Entry.devname[20-1] = 0;
					} else {
						strcpy(tmpBuf, "device name should not be NULL!");
						goto setErr_dhcpd;
					}
					
					strVal = websGetVar(wp, T("sIp"), T(""));
					if (strVal[0]) {
						if ( !inet_aton(strVal, (struct in_addr *)Entry.startIP) ) {
							strcpy(tmpBuf, "source IP is wrong!");
							goto setErr_dhcpd;
						}
					} else {
						strcpy(tmpBuf, "source IP cannot be empty");
						goto setErr_dhcpd;
					}

					strVal = websGetVar(wp, T("dIp"), T(""));
					if (strVal[0]) {
						if ( !inet_aton(strVal, (struct in_addr *)Entry.endIP) ) {
							strcpy(tmpBuf, "destination IP is wrong!");
							goto setErr_dhcpd;
						}
					} else {
						strcpy(tmpBuf, "destination IP cannot be empty");
						goto setErr_dhcpd;
					}
					
					if (Entry.endIP[3] <= Entry.startIP[3]) {
						strcpy(tmpBuf, "destination IP address should be larger than source IP address!");
						goto setErr_dhcpd;
					}

					strVal = websGetVar(wp, T("Opt60"), T(""));
					if (strVal[0]) {
/*ping_zhang:20090312 START:add STB checkbox for designate STB device type*/
						MIB_CE_IP_RANGE_DHCP_T entry;
						int k;
						
						for (k=0; k<totalEntry; k++) {
							if (k== idx)
								continue;
							
							mib_chain_get(MIB_IP_RANGE_DHCP_TBL, k, (void *)&entry);
							if (!gstrcmp(strVal, entry.option60)) {
								sprintf(tmpBuf, "device with option60:%s is already exist in table!",entry.option60);
								goto setErr_dhcpd;
							}
						}
/*ping_zhang:20090312 END*/
						strcpy(Entry.option60, strVal);
						/*ping_zhang: fix garbage string bugs*/
						Entry.option60[MAX_DHCP_OPT_60_LEN] = 0;
					} else {
						strcpy(tmpBuf, "option60 cannot be NULL!");
						goto setErr_dhcpd;
					}

/*ping_zhang:20090312 START:add STB checkbox for designate STB device type*/
#if 0
					strVal = websGetVar(wp, T("isSTB"), T(""));
					if( !gstrcmp(strVal, T("ON")) )
						Entry.deviceType = CTC_STB;
					else
						Entry.deviceType = CTC_UNKNOWN;
#endif
/*ping_zhang:20090312 END*/
/*ping_zhang:20090313 START:Telefonica DHCP option new request*/
					// device type
					strVal = websGetVar(wp, T("dhcpDeviceType"), T(""));
					if (strVal[0]) {
						Entry.deviceType = (unsigned char)atoi(strVal);
					}
					else
						Entry.deviceType = CTC_UNKNOWN;

					//reserved option code
					if(Entry.deviceType == CTC_STB)
					{
						Entry.optionCode = DHCP_OPT_240;
						/*ping_zhang:20090316	 optionStr is NULL for STB*/
						strcpy(Entry.optionStr,"");
						//from fmdhcpd.c
						strVal= websGetVar(wp, T("opchaddr"), T(""));
						if (strVal[0]) {
							if (!inet_aton(strVal, &ip)) {
								strcpy(tmpBuf, T(strInvalidOpchaddr));
								goto setErr_dhcpd;
							}
						} else {
							strcpy(tmpBuf, T(strInvalidOpchaddr));
							goto setErr_dhcpd;
						}
						mib_get(MIB_OPCH_ADDRESS, (void *)&opchAddr);
						if (opchAddr.s_addr != ip.s_addr)
							dhcpd_changed_flag = 1;
						mib_set(MIB_OPCH_ADDRESS, (void *)&ip);

						strVal = websGetVar(wp, T("opchport"), T(""));
						if (strVal[0]) {
							opchport = (unsigned short)atoi(strVal);
						} else {
							strcpy(tmpBuf, T(strInvalidOpchport));
							goto setErr_dhcpd;
						}
						mib_get(MIB_OPCH_PORT, (void *)&origport);
						if (origport != opchport)
							dhcpd_changed_flag = 1;
						mib_set(MIB_OPCH_PORT, (void *)&opchport);
						
						ip.s_addr = 0xffffffff;
						strVal = websGetVar(wp, T("stbdns1"), T(""));
						if (strVal[0]) {
							if (!inet_aton(strVal, &ip)) {
								strcpy(tmpBuf, T(Tinvalid_dns));
								goto setErr_dhcpd;
							}
						}
						mib_get(MIB_IMAGENIO_DNS1, (void *)&stbDnsAdd1);
						if (stbDnsAdd1.s_addr != ip.s_addr)
							dhcpd_changed_flag = 1;
						mib_set(MIB_IMAGENIO_DNS1, (void *)&ip);

						ip.s_addr = 0xffffffff;
						strVal = websGetVar(wp, T("stbdns2"), T(""));
						if (strVal[0]) {
							if (!inet_aton(strVal, &ip)) {
								strcpy(tmpBuf, T(Tinvalid_dns));
								goto setErr_dhcpd;
							}
						}
						mib_get(MIB_IMAGENIO_DNS2, (void *)&stbDnsAdd2);
						if (stbDnsAdd2.s_addr != ip.s_addr)
							dhcpd_changed_flag = 1;
						mib_set(MIB_IMAGENIO_DNS2, (void *)&ip);
					}
					else if(Entry.deviceType == CTC_UNKNOWN)
					{
						Entry.optionCode = DHCP_END;
						strcpy(Entry.optionStr,"");
					}
					else
					{
						strVal = websGetVar(wp, T("reservedOption"), T(""));
						if (strVal[0]) {
							Entry.optionCode = (unsigned char)atoi(strVal);
						}
						else{
							strcpy(tmpBuf, "optionCode error!");
							goto setErr_dhcpd;
						}
						//option str for reserved option
						strVal = websGetVar(wp, T("OptStr"), T(""));
						if (strVal[0]) {
							strcpy(Entry.optionStr, strVal);
							/*ping_zhang: fix garbage string bugs*/
							Entry.optionStr[MAX_DHCP_OPT_RSV_LEN] = 0;
						} else {
							strcpy(tmpBuf, "optionStr cannot be NULL!");
							goto setErr_dhcpd;
						}
					}
/*ping_zhang:20090313 START:Telefonica DHCP option new request*/
					dhcpd_changed_flag = 1;

					// modify chain record
					if(mib_chain_update(MIB_IP_RANGE_DHCP_TBL, (void *)&Entry, idx) != 1) {
						strcpy(tmpBuf, T(strDelChainerror));
						goto setErr_dhcpd;
					}
				}
			} // end of for
		}
		goto setOk_dhcpd;
	}
	
setOk_dhcpd:
#ifdef COMMIT_IMMEDIATELY
	if( dhcpd_changed_flag == 1 )
	{
		unsigned char vChar;
	#ifdef __CLOSE_INTERFACE_BEFORE_WRITE_
		/*to avoid the dead when wrriting the flash*/
		itfcfg("sar", 0);
		itfcfg("eth0", 0);
	#ifdef WLAN_SUPPORT
		itfcfg("wlan0", 0);
	#endif
	#endif /*__CLOSE_INTERFACE_BEFORE_WRITE_*/
		mib_update(CURRENT_SETTING, CONFIG_MIB_ALL);

	#ifdef __CLOSE_INTERFACE_BEFORE_WRITE_
		itfcfg("sar", 1);
		itfcfg("eth0", 1);
	#ifdef WLAN_SUPPORT
		vChar=0;
		mib_get( MIB_WLAN_DISABLED, (void *)&vChar);
		if( vChar==0 )	itfcfg("wlan0", 1);
	#endif //WLAN_SUPPORT
	#endif /*__CLOSE_INTERFACE_BEFORE_WRITE_*/
	}
#endif
	
#ifndef NO_ACTION
	pid = fork();
	if (pid)
		waitpid(pid, NULL, 0);
	else if (pid == 0) {
		snprintf(tmpBuf, 100, "%s/%s", _CONFIG_SCRIPT_PATH, _CONFIG_SCRIPT_PROG);
#ifdef HOME_GATEWAY
		execl( tmpBuf, _CONFIG_SCRIPT_PROG, "gw", "bridge", NULL);
#else
		execl( tmpBuf, _CONFIG_SCRIPT_PROG, "ap", "bridge", NULL);
#endif
		exit(1);
	}
#endif
	if(dhcpd_changed_flag == 1)
	{
		restart_dhcp();
		submitUrl = websGetVar(wp, T("submit-url"), T(""));
		GOOD_MSG(submitUrl);
		return;
	}

	submitUrl = websGetVar(wp, T("submit-url"), T(""));
	if (submitUrl[0])
		websRedirect(wp, submitUrl);
	else
		websDone(wp, 200);
  	return;

setErr_dhcpd:
	ERR_MSG(tmpBuf);
}

#if defined(ZTE_531B_BRIDGE_SC)||defined(ZTE_GENERAL_ROUTER_SC)
int showDeviceIpTable(int eid, webs_t wp, int argc, char_t **argv)
{
	int nBytesSent=0;
	unsigned int entryNum, i;
	MIB_CE_IP_RANGE_DHCP_T Entry;
	char startIp[16], endIp[16];
/*ping_zhang:20090313 START:Telefonica DHCP option new request*/
	char devType[16];
/*ping_zhang:20090313 END*/
	struct in_addr opchAddr;
	unsigned short opchport;
	char optionStr[30];
	
	entryNum = mib_chain_total(MIB_IP_RANGE_DHCP_TBL);	
	
	nBytesSent += websWrite(wp, T("<tr><font size=1>"
	"<td align=center width=\"5%%\" bgcolor=\"#808080\"></td>\n"
	"<td align=center width=\"20%%\" bgcolor=\"#808080\">豸</td>\n"
/*ping_zhang:20090313 START:Telefonica DHCP option new request*/
	"<td align=center width=\"20%%\" bgcolor=\"#808080\">豸</td>"
/*ping_zhang:20090313 END*/
	"<td align=center width=\"20%%\" bgcolor=\"#808080\">ʼַ</td>\n"
	"<td align=center width=\"20%%\" bgcolor=\"#808080\">ַֹ</td>\n"
	"<td align=center width=\"30%%\" bgcolor=\"#808080\">option60</td>"
/*ping_zhang:20090313 START:Telefonica DHCP option new request*/
	"<td align=center width=\"40%%\" bgcolor=\"#808080\" colspan=\"2\">option</td>"
/*ping_zhang:20090313 END*/
	"</font></tr>\n"));

/*ping_zhang:20090316 START:set option string for STB*/
	mib_get(MIB_OPCH_ADDRESS, (void *)&opchAddr);
	mib_get(MIB_OPCH_PORT, (void *)&opchport);
	sprintf(optionStr, ":::::%s:%d", inet_ntoa(opchAddr), opchport);
/*ping_zhang:20090316 START:Cli for telefonica DHCP option new request*/

	for (i=0; i<entryNum; i++) {

		if (!mib_chain_get(MIB_IP_RANGE_DHCP_TBL, i, (void *)&Entry))
		{
  			websError(wp, 400, T("ȡؼ¼ʧ!\n"));
			return;
		}		

		strcpy(startIp, inet_ntoa(*((struct in_addr *)Entry.startIP)));
		strcpy(endIp, inet_ntoa(*((struct in_addr *)Entry.endIP)));

/*ping_zhang:20090313 START:Telefonica DHCP option new request*/
		switch(Entry.deviceType)
		{
		case CTC_Computer:
			strcpy(devType,"PC");
			break;
		case CTC_Camera:
			strcpy(devType,"Camera");
			break;
		case CTC_HGW:
			strcpy(devType,"HGW");
			break;
		case CTC_STB:
			strcpy(devType,"STB");
			break;
		case CTC_PHONE:
			strcpy(devType,"Phone");
			break;
		case CTC_UNKNOWN:
		default:
			strcpy(devType,"δ֪");
			break;
		}
/*ping_zhang:20090313 END*/

		nBytesSent += websWrite(wp, T("<tr>"
			"<td align=center width=\"5%%\" bgcolor=\"#C0C0C0\"><input type=\"radio\" name=\"select\" value=\"s%d\" "
			"onClick=postsetting(devname[%d],devtype[%d],startip[%d],endip[%d],option[%d],opCode[%d],opStr[%d])></td>\n"
			"<td align=center width=\"20%%\" bgcolor=\"#C0C0C0\"><font size=\"2\">%s</font></td>\n"
/*ping_zhang:20090313 START:Telefonica DHCP option new request*/
			"<td align=center width=\"20%%\" bgcolor=\"#C0C0C0\"><font size=\"2\">%s</font></td>\n"
/*ping_zhang:20090313 END*/
			"<td align=center width=\"20%%\" bgcolor=\"#C0C0C0\"><font size=\"2\">%s</font></td>\n"
			"<td align=center width=\"20%%\" bgcolor=\"#C0C0C0\"><font size=\"2\">%s</font></td>\n"
			"<td align=center width=\"30%%\" bgcolor=\"#C0C0C0\"><font size=\"2\">%s</font></td>\n"
/*ping_zhang:20090313 START:Telefonica DHCP option new request*/
			"<td align=center width=\"10%%\" bgcolor=\"#C0C0C0\"><font size=\"2\">%d</font></td>\n"
			"<td align=center width=\"30%%\" bgcolor=\"#C0C0C0\"><font size=\"2\">%s</font></td>\n"
/*ping_zhang:20090313 END*/
			"</tr>\n"),
			i, i, i, i, i, i, i, i,
			Entry.devname, devType, startIp, endIp, Entry.option60,Entry.optionCode,Entry.deviceType==CTC_STB?optionStr:Entry.optionStr);
	}
	
	return 0;
}
#else
int showDeviceIpTable(int eid, webs_t wp, int argc, char_t **argv)
{
	int nBytesSent=0;
	unsigned int entryNum, i;
	MIB_CE_IP_RANGE_DHCP_T Entry;
	char startIp[16], endIp[16];
/*ping_zhang:20090313 START:Telefonica DHCP option new request*/
	char devType[16];
/*ping_zhang:20090313 END*/
	struct in_addr opchAddr;
	unsigned short opchport;
	char optionStr[30];
	
	entryNum = mib_chain_total(MIB_IP_RANGE_DHCP_TBL);	
	
	nBytesSent += websWrite(wp, T("<tr><font size=1>"
	"<td align=center width=\"5%%\" bgcolor=\"#808080\">Select</td>\n"
	"<td align=center width=\"20%%\" bgcolor=\"#808080\">device name</td>\n"
/*ping_zhang:20090313 START:Telefonica DHCP option new request*/
	"<td align=center width=\"20%%\" bgcolor=\"#808080\">device type</td>"
/*ping_zhang:20090313 END*/
	"<td align=center width=\"20%%\" bgcolor=\"#808080\">start address</td>\n"
	"<td align=center width=\"20%%\" bgcolor=\"#808080\">end address</td>\n"
	"<td align=center width=\"30%%\" bgcolor=\"#808080\">option60</td>"
/*ping_zhang:20090313 START:Telefonica DHCP option new request*/
	"<td align=center width=\"40%%\" bgcolor=\"#808080\" colspan=\"2\">reserved option</td>"
/*ping_zhang:20090313 END*/
	"</font></tr>\n"));

/*ping_zhang:20090316 START:set option string for STB*/
	mib_get(MIB_OPCH_ADDRESS, (void *)&opchAddr);
	mib_get(MIB_OPCH_PORT, (void *)&opchport);
	sprintf(optionStr, ":::::%s:%d", inet_ntoa(opchAddr), opchport);
/*ping_zhang:20090316 START:Cli for telefonica DHCP option new request*/

	for (i=0; i<entryNum; i++) {

		if (!mib_chain_get(MIB_IP_RANGE_DHCP_TBL, i, (void *)&Entry))
		{
  			websError(wp, 400, T("Get chain(MIB_IP_RANGE_DHCP_TBL) record error!\n"));
			return;
		}		

		strcpy(startIp, inet_ntoa(*((struct in_addr *)Entry.startIP)));
		strcpy(endIp, inet_ntoa(*((struct in_addr *)Entry.endIP)));

/*ping_zhang:20090313 START:Telefonica DHCP option new request*/
		switch(Entry.deviceType)
		{
		case CTC_Computer:
			strcpy(devType,"PC");
			break;
		case CTC_Camera:
			strcpy(devType,"Camera");
			break;
		case CTC_HGW:
			strcpy(devType,"HGW");
			break;
		case CTC_STB:
			strcpy(devType,"STB");
			break;
		case CTC_PHONE:
			strcpy(devType,"Phone");
			break;
		case CTC_UNKNOWN:
		default:
			strcpy(devType,"Unknown");
			break;
		}
/*ping_zhang:20090313 END*/

		nBytesSent += websWrite(wp, T("<tr>"
			"<td align=center width=\"5%%\" bgcolor=\"#C0C0C0\"><input type=\"radio\" name=\"select\" value=\"s%d\" "
			"onClick=postsetting(devname[%d],devtype[%d],startip[%d],endip[%d],option[%d],opCode[%d],opStr[%d])></td>\n"
			"<td align=center width=\"20%%\" bgcolor=\"#C0C0C0\"><font size=\"2\">%s</font></td>\n"
/*ping_zhang:20090313 START:Telefonica DHCP option new request*/
			"<td align=center width=\"20%%\" bgcolor=\"#C0C0C0\"><font size=\"2\">%s</font></td>\n"
/*ping_zhang:20090313 END*/
			"<td align=center width=\"20%%\" bgcolor=\"#C0C0C0\"><font size=\"2\">%s</font></td>\n"
			"<td align=center width=\"20%%\" bgcolor=\"#C0C0C0\"><font size=\"2\">%s</font></td>\n"
			"<td align=center width=\"30%%\" bgcolor=\"#C0C0C0\"><font size=\"2\">%s</font></td>\n"
/*ping_zhang:20090313 START:Telefonica DHCP option new request*/
			"<td align=center width=\"10%%\" bgcolor=\"#C0C0C0\"><font size=\"2\">%d</font></td>\n"
			"<td align=center width=\"30%%\" bgcolor=\"#C0C0C0\"><font size=\"2\">%s</font></td>\n"
/*ping_zhang:20090313 END*/
			"</tr>\n"),
			i, i, i, i, i, i, i, i,
			Entry.devname, devType, startIp, endIp, Entry.option60,Entry.optionCode,Entry.deviceType==CTC_STB?optionStr:Entry.optionStr);
	}
	
	return 0;
}
#endif
#endif
#endif
/*ping_zhang:20090319 END*/
#endif //if 0
