/*
 *      Web server handler routines for management (password, save config, f/w update)
 *      Authors: David Hsu	<davidhsu@realtek.com.tw>
 *      Authors: Dick Tam	<dicktam@realtek.com.tw>
 *
 */

#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/sysinfo.h>
#include <signal.h>
#include <net/if.h>
#include <stdint.h>
#include <linux/atm.h>
#include <linux/atmdev.h>

#include "../webs.h"
#include "../um.h"
#include "mib.h"
#include "webform.h"
#include "adsl_drv.h"
#include "utility.h"
#include "rtl_flashdrv.h"
#include <semaphore.h>

//xl_yue
#ifdef USE_LOGINWEB_OF_SERVER
#include <syslog.h>
#include "boa.h"
#endif

//ql_xu add
#include <stdio.h>
#include <fcntl.h>
#include <sys/ioctl.h>

// Mason Yu
#ifdef EMBED
#include <linux/config.h>
#else
#include "../../../uClibc-0.9.15/include/linux/autoconf.h"
#endif


//xl_yue
#ifdef ACCOUNT_LOGIN_CONTROL
#include <syslog.h>
#include "boa.h"
#endif
#include "../defs.h"

#include "fmdefs.h"

#define DEFAULT_GROUP		T("administrators")
#define ACCESS_URL			T("/")
#define _PATH_PROCNET_DEV	"/proc/net/dev"
#define MAX_DSL_TONE		512
///ql_xu add
#define _PPPOE_CONF			"/var/ppp/pppoe.conf"
#define _PPPOA_CONF			"/var/ppp/pppoa.conf"
#define _PPP_CONF			"/var/ppp/ppp.conf"
#define _PROC_NET_ATM_CLIP	"/proc/net/atm/pvc"
#define _PROC_NET_ATM_BR	"/proc/net/atm/br2684"

static int srandomCalled = 0;
char g_rUserName[MAX_NAME_LEN];
char g_rUserPass[MAX_NAME_LEN];
bool_t g_remoteUpdate;

short *snr;
short *qln;
short *hlog;
static int diagflag=1;
#define XML_CONFIG

// Added by Mason Yu
extern char *g_post_file_name;
extern int g_startPos;
extern sem_t semSave;
extern int g_filesize;
extern int g_upgrade_firmware;

#if defined(ZTE_531B_BRIDGE_SC) || defined(ZTE_GENERAL_ROUTER_SC)
#define REBOOT_MSG(url) { \
	websHeader(wp); \
	websWrite(wp, T("<body><blockquote><h5>%s" \
                "<BR><form><input type=button value=\"%s\" OnClick=window.location.replace(\"%s\")></form></blockquote></body>"),TAdmin_uf_prompt,TAdmin_uf_ok, url);\
	websFooter(wp); \
	websDone(wp, 200); \
}
#endif
#if 0
/////////////////////////////////////////////////////////////////////////////
void formPasswordSetup(webs_t wp, char_t *path, char_t *query)
{
	char_t *str, *submitUrl, *strPassword, *strOldPassword, *strConfPassword;
	char tmpBuf[100];
	char userName[MAX_NAME_LEN];
	int flag = 0;
	
	str = websGetVar(wp, T("userMode"), T(""));		
	//strUser = websGetVar(wp, T("username"), T(""));
	strOldPassword = websGetVar(wp, T("oldpass"), T(""));
	strPassword = websGetVar(wp, T("newpass"), T(""));
	strConfPassword = websGetVar(wp, T("confpass"), T(""));
	
	//if(!strcmp(strOldPassword,strPassword))
		//flag = 1;
	
	if ( !strOldPassword[0] ) {
		strcpy(tmpBuf, T(WARNING_EMPTY_OLD_PASSWORD));
		goto setErr_pass;
	}
	
	if ( !strPassword[0] ) {
		strcpy(tmpBuf, T(WARNING_EMPTY_NEW_PASSWORD));
		goto setErr_pass;
	}	

	if ( !strConfPassword[0] ) {
		strcpy(tmpBuf, T(WARNING_EMPTY_CONFIRMED_PASSWORD));
		goto setErr_pass;
	}

	if (strcmp(strPassword, strConfPassword) != 0 ) {
		strcpy(tmpBuf, T(WARNING_UNMATCHED_PASSWORD));
		goto setErr_pass;
	}
		
#if 0
	if ( strUser[0] ) {
		/* Check if user name is the same as supervisor name */
		if ( !mib_get(MIB_SUPER_NAME, (void *)tmpBuf)) {
			strcpy(tmpBuf, T("ERROR: Get supervisor name MIB error!"));
			goto setErr_pass;
		}
		if ( !strcmp(strUser, tmpBuf)) {
			strcpy(tmpBuf, T("ERROR: Cannot use the same user name as supervisor."));
			goto setErr_pass;
		}
	}
#endif	
	// Commented by Mason Yu
#if 0
	// delete original user
	mib_get( MIB_USER_NAME, (void *)userName );
	if (userName[0]) {
		if ( umDeleteUser(userName) ) {
			printf("ERROR: Unable to delete user account (user=%s).\n", userName);
			return;
		}
		mib_get( MIB_SUPER_NAME, (void *)userName );
		if ( umDeleteUser(userName) ) {
			printf("ERROR: Unable to delete user account (user=%s).\n", userName);
			return;
		}
	}
#endif
	
	if (str[0]) {
		if ( str[0] == '0' ) {       // superuser ==> cht
			if ( !mib_get(MIB_SUSER_PASSWORD, (void *)tmpBuf)) {
				strcpy(tmpBuf, T(WARNING_GET_PASSWORD));
				goto setErr_pass;
			}
			
			if ( strcmp(tmpBuf, strOldPassword) != 0 ) {
				strcpy(tmpBuf, T(WARNING_WRONG_PASSWORD));
				goto setErr_pass;
			}else if ( !mib_set(MIB_SUSER_PASSWORD, (void *)strPassword) ) {							
				strcpy(tmpBuf, T(WARNING_SET_PASSWORD));
				goto setErr_pass;
			}

			if(strcmp(strOldPassword,strPassword) && !strcmp(wp->user, "admin")) 
				flag = 1;

		}	
		else if ( str[0] == '1' ) {  // normal user ==> user
			if ( !mib_get(MIB_USER_PASSWORD, (void *)tmpBuf)) {
				strcpy(tmpBuf, T(WARNING_GET_PASSWORD));
				goto setErr_pass;
			}
			
			if ( strcmp(tmpBuf, strOldPassword) != 0 ) {
				strcpy(tmpBuf, T(WARNING_WRONG_PASSWORD));
				goto setErr_pass;
			}else if ( !mib_set(MIB_USER_PASSWORD, (void *)strPassword) ) {							
				strcpy(tmpBuf, T(WARNING_SET_PASSWORD));
				goto setErr_pass;
			}	
			if(strcmp(strOldPassword,strPassword) && !strcmp(wp->user, "user")) 
				flag = 1;

		}		
		else {			
			strcpy(tmpBuf, T(WARNING_WRONG_USER));			
			goto setErr_pass;
		}
	}

#if 0	
	/* Set user account to MIB */
	if ( !mib_set(MIB_USER_NAME, (void *)strUser) ) {
		strcpy(tmpBuf, T("ERROR: Set user name to MIB database failed."));
		goto setErr_pass;
	}
#endif

#ifdef EMBED
	// Added by Mason Yu for take effect on real time
	writePasswdFile();
#endif
	
	/*
	if (mib_update(HW_SETTING) == 0) {
		printf("Warning : Commit hs fail(formPasswordSetup()) !\n");				
	}
	*/

	/* upgdate to flash */
//	mib_update(CURRENT_SETTING);

	/* Init user management */
	// Commented By Mason Yu
	//set_user_profile();
	
	/* Retrieve next page URL */
#if defined(ZTE_531B_BRIDGE_SC) || defined(ZTE_GENERAL_ROUTER_SC)
	mib_update(CURRENT_SETTING, CONFIG_MIB_ALL);
	#endif
	submitUrl = websGetVar(wp, T("submit-url"), T(""));   // hidden page

	if(!flag){
		OK_MSG(submitUrl);
	}else{
		websHeader(wp); 
	   	websWrite(wp, T("<body><blockquote><h4>%s</h4>\n"),IDS_RESULT_EFFECT); 
		websWrite(wp, T("<form><input type=button value=\"  %s \" OnClick=\"javascript:top.window.location.reload(\'/admin/redirect.asp');\"></form></blockquote></body>"), IDS_RESULT_OK);
		//websWrite(wp, T("<form><input type=button value=\"  %s \" OnClick=\"javascript:top.window.location.reload(\'/');\"></form></blockquote></body>"), IDS_RESULT_OK);
		websFooter(wp); 
		websDone(wp, 200); 
	}
	
	return;

setErr_pass:
	ERR_MSG(tmpBuf);
}
#endif

// Added by Mason Yu for 2 level web page
/////////////////////////////////////////////////////////////////////////////
void formUserPasswordSetup(webs_t wp, char_t *path, char_t *query)
{

	char_t *str, *submitUrl, *strPassword, *strOldPassword, *strConfPassword;
	char tmpBuf[100];
	char userName[MAX_NAME_LEN];
	//str = websGetVar(wp, T("userMode"), T(""));		
	//strUser = websGetVar(wp, T("username"), T(""));
	strOldPassword = websGetVar(wp, T("oldpass"), T(""));
	strPassword = websGetVar(wp, T("newpass"), T(""));
	strConfPassword = websGetVar(wp, T("confpass"), T(""));
	
	if ( !strOldPassword[0] ) {
		strcpy(tmpBuf, T("ERROR: Old Password cannot be empty."));
		goto setErr_pass;
	}
	
	if ( !strPassword[0] ) {
		strcpy(tmpBuf, T("ERROR: New Password cannot be empty."));
		goto setErr_pass;
	}	

	if ( !strConfPassword[0] ) {
		strcpy(tmpBuf, T("ERROR: Confirmed Password cannot be empty."));
		goto setErr_pass;
	}

	if (strcmp(strPassword, strConfPassword) != 0 ) {
		strcpy(tmpBuf, T("ERROR: New Password is not the same as Confirmed Password."));
		goto setErr_pass;
	}
		
	
		
	if ( !mib_get(MIB_USER_PASSWORD, (void *)tmpBuf)) {
		strcpy(tmpBuf, T("ERROR: Get user password MIB error!"));
		goto setErr_pass;
	}
	
	if ( strcmp(tmpBuf, strOldPassword) != 0 ) {
		strcpy(tmpBuf, T("ERROR: Input Old user password error!"));
		goto setErr_pass;
	}else if ( !mib_set(MIB_USER_PASSWORD, (void *)strPassword) ) {							
		strcpy(tmpBuf, T("ERROR: Set user password to MIB database failed."));
		goto setErr_pass;
	}	

#ifdef EMBED
	// Added by Mason Yu for take effect on real time
	writePasswdFile();
#endif

	/*
	if (mib_update(HW_SETTING) == 0) {
		printf("Warning : Commit hs fail(formPasswordSetup()) !\n");				
	}
	*/

	/* upgdate to flash */
//	mib_update(CURRENT_SETTING);

	/* Init user management */
	// Commented By Mason Yu
	//set_user_profile();
	
	/* Retrieve next page URL */
	submitUrl = websGetVar(wp, T("submit-url"), T(""));   // hidden page

	OK_MSG(submitUrl);
	return;

setErr_pass:
	ERR_MSG(tmpBuf);
}

////////////////////////////////////////////////////////////////////
void set_user_profile(void)
{
	char superName[MAX_NAME_LEN], superPass[MAX_NAME_LEN];
	char userName[MAX_NAME_LEN], userPass[MAX_NAME_LEN];
	char dport[10];
//	char_t *user, *nextUser, *group;
	
	/* first time load, get mib */
	if ( !mib_get( MIB_SUPER_NAME, (void *)superName ) ||
		!mib_get( MIB_SUSER_PASSWORD, (void *)superPass ) ||
			!mib_get( MIB_USER_NAME, (void *)userName ) ||
				!mib_get( MIB_USER_PASSWORD, (void *)userPass ) ) {
		error(E_L, E_LOG, T("Get user account MIB failed"));
		return;
	}

	/* Delete all user account belonging to DEFAULT_GROUP */
	/*
	user = umGetFirstUser();
	while (user) {
//		printf("umDeleteUser (user=%s).\n", user);
		nextUser = umGetNextUser(user);
		group = umGetUserGroup(user);
		if (gstrcmp(DEFAULT_GROUP, group) == 0) {
			if ( umDeleteUser(user) ) {
				printf("ERROR: Unable to delete user account (user=%s).\n", user);
				return;
			}
		}
		
		user = nextUser;
		//user = umGetFirstUser();
	}
	*/

	umDeleteAccessLimit(ACCESS_URL);
	umDeleteGroup(DEFAULT_GROUP);

	if ( userName[0] ) {
		/* Create supervisor */
		if ( !umGroupExists(DEFAULT_GROUP) )
			if ( umAddGroup(DEFAULT_GROUP, (short)PRIV_ADMIN, AM_BASIC, FALSE, FALSE) ) {
				error(E_L, E_LOG, T("ERROR: Unable to add group."));
				return;
			}
		if ( !umAccessLimitExists(ACCESS_URL) ) {
			if ( umAddAccessLimit(ACCESS_URL, AM_FULL, (short)0, DEFAULT_GROUP) ) {
				error(E_L, E_LOG, T("ERROR: Unable to add access limit."));
				return;
			}
		}

		/* Create user */
		if ( umAddUser(superName, superPass, DEFAULT_GROUP, FALSE, FALSE) ) {
			error(E_L, E_LOG, T("ERROR: Unable to add supervisor account."));
			return;
		}			

		/* Create user */
		if ( umAddUser(userName, userPass, DEFAULT_GROUP, FALSE, FALSE) ) {
			error(E_L, E_LOG, T("ERROR: Unable to add user account."));
			return;
		}
	}
	else {
		if (g_remoteConfig) {	// remote config not allowed
			char ipaddr[20], tmpStr[5];
			
			if (g_rUserName[0]) {
				if ( umDeleteUser(g_rUserName) ) {
					printf("ERROR: Unable to delete user account (user=%s).\n", g_rUserName);
					return;
				}
				g_rUserName[0] = '\0';
			}
			
			mib_get(MIB_ADSL_LAN_IP, (void *)tmpStr);
			strncpy(ipaddr, inet_ntoa(*((struct in_addr *)tmpStr)), 16);
			ipaddr[15] = '\0';
			snprintf(ipaddr, 20, "%s:80", ipaddr);
			sprintf(dport, "%d", g_remoteAccessPort);
			// iptables -D INPUT -i ! br0 -p TCP --dport 80 -j ACCEPT
			va_cmd(IPTABLES, 11, 1, (char *)FW_DEL, (char *)FW_INPUT, ARG_I,
			"!", LANIF, "-p", ARG_TCP, FW_DPORT, "80", "-j", (char *)FW_ACCEPT);
			// iptables -t nat -D PREROUTING -i ! $LAN_IF -p TCP --dport 51003 -j DNAT --to-destination ipaddr:80
			va_cmd(IPTABLES, 15, 1, "-t", "nat",
						(char *)FW_DEL,	"PREROUTING",
						(char *)ARG_I, "!", (char *)LANIF,
						"-p", (char *)ARG_TCP,
						(char *)FW_DPORT, dport, "-j",
						"DNAT", "--to-destination", ipaddr);
			g_remoteConfig = 0;
		}
	}
}

///////////////////////////////////////////////////////////////////////////////
// search token szKey from string szString
// if find, return its value, else return null
char* SearchKeyValue(char* szString, char* szKey)
{
	char *szDuplicate;
	char *key, *lp, *cp, *value;
	
	//duplicate the string, avoid the original string to be modefied
	szDuplicate = bstrdup(B_L, szString);

	for (lp = szDuplicate ; lp && *lp; ) 
	{
		cp = lp;
		if ((lp = gstrchr(lp, ';')) != NULL) 
		{
			lp++;
		}

		if ((key = gstrtok(cp, T("= \t;"))) == NULL) 
		{
			continue;
		}

		if ((value = gstrtok(NULL, T(";"))) == NULL) 
		{
			value = T("");
		}

		while (gisspace(*value)) 
		{
			value++;
		}

		if(strcmp(key, szKey) == 0)
		{
			return value;
		}
	}

	return NULL;
}

///////////////////////////////////////////////////////////////////////////////
// find key szKey form string szString
// start from nStart to nEnd of szString
// if found, return the first index of the matched string
// if not found, return -1
static int FindKeyIndex(char *szKey, char * szString, int nStart, int nEnd)
{
	int nKeyLen = strlen(szKey);
	char *szSearch = szString + nStart;
	char *szSearchEnd = szString + nEnd;
	int nIndex = 0;
	bool bFind = false;
	while(szSearch != szSearchEnd)
	{
		if(memcmp(szSearch, szKey, nKeyLen) ==0)
		{
			bFind = true;
			break;
		}
		else
		{
			nIndex++;
			szSearch++;
		}
	}

	if(bFind == true)
		return (nIndex + nStart);
	else
		return -1;
	
}

#if 0
void releaseUploadMem(webs_t wp)
{
//	unsigned char* tempPtr = wp->queryNext[firmware_page_idx];
	int counter;

//	printf("query 0 (nFirst %d) %02x-%02x-%02x-%02x\n", nFirst, wp->query[nFirst], wp->query[nFirst+1], wp->query[nFirst+2], wp->query[nFirst+3]);
//	printf("Last %02x-%02x-%02x-%02x\n", tempPtr[nLast-4], tempPtr[nLast-3], tempPtr[nLast-2], tempPtr[nLast-1]);

	for(counter=0; counter<MAX_UPLOAD_BLOCK_NUM; counter++)
	{
		if(wp->queryNext[counter])
		{
			unsigned char* queryPtr = wp->queryNext[counter];
//			printf("free %d, %08x, %02x-%02x-%02x-%02x\n", counter, (unsigned int)wp->queryNext[counter] , queryPtr[0], queryPtr[1], queryPtr[2], queryPtr[3]);
			free(wp->queryNext[counter]);
			wp->queryNext[counter] = NULL;				
		}
	}
}
#endif
	
#ifdef EMBED
int flashdrv_filewrite(FILE *fp,int size,void  *dstP) //Brian
{
	int i;
	int nWritten; /* completed bytes */
	//volatile unsigned char data[4096];
	volatile unsigned short *dstAddr;
	unsigned char *block;
	nWritten = 0;
	dstAddr = dstP;
	
	block = malloc(FLASH_BLOCK_SIZE);
	if(!block)
	return 1;
	
	// Mason Yu
	flashdrv_init();
	
	while ( nWritten < size )
	{
		int nRead;

		/* fill buffer with file */
		for( i = 0, nRead = 0; 
		     i < FLASH_BLOCK_SIZE && ( i < (size-nWritten) );
		     i++, nRead++ )
		{
			block[i] = fgetc(fp);
		}
		
		printf("flashWrite */ %08x (len %d)\n", dstAddr, nRead);
		//flash_write( (void*)block, (void*)dstAddr, nRead );
		flashdrv_updateImg( (void*)block, (void*)(FLASH_BASE+dstAddr), nRead );

		dstAddr += nRead >> 1;
		nWritten += nRead;
	}
	
	free(block);
	return 0;
}
#endif


static int isValidImageFile(FILE *fp) {
	IMGHDR imgHdr;
	unsigned int csum;
	int size, remain, nRead, block;
	unsigned char buf[64];
#if defined(ZTE_GENERAL_ROUTER_SC) || defined(ZTE_531B_BRIDGE_SC)
	unsigned char KEY[20];
	int i;
#endif

#ifdef ENABLE_SIGNATURE
	memset(KEY, 0, 20);
	if (1 != fread(KEY, strlen(SIGNATURE), 1, fp)) {
		printf("failed to read signature\n");
		goto ERROR1;
	}
	for (i=0; i<strlen(KEY); i++)
		KEY[i] = KEY[i]-10;
	if (strcmp(KEY, SIGNATURE)) {
		printf("signature error\n");
		goto ERROR1;
	}
#endif
	if (1!=fread(&imgHdr, sizeof(imgHdr), 1, fp)) {
		printf("Failed to read header\n");
		goto ERROR1;
	}

	if (imgHdr.key != APPLICATION_IMAGE) {
		printf("Unknown header\n");
		goto ERROR1;
	}

	csum = imgHdr.chksum;
	size = imgHdr.length;
	remain = size;

	while (remain > 0) {
		block = (remain > sizeof(buf)) ? sizeof(buf) : remain;		
		nRead = fread(buf, 1, block, fp);
		if (nRead <= 0) {
			printf("read too short (remain=%d, block=%d)\n", remain, block);
			goto ERROR1;
		}
		remain -= nRead;
		csum = ipchksum(buf, nRead,csum);
	}
	
	if (csum) {
		printf("Checksum failed, size=%d, csum=%04xh\n", size, csum);
		goto ERROR1;
	}

	return 1;
ERROR1:
	return 0;
	
}


// find the start and end of the upload file.
static FILE * _uploadGet(request *wp, unsigned int *startPos, unsigned *endPos) {
   
   FILE *fp=NULL;	
	struct stat statbuf;	
	unsigned char c, *buf; 
	   
	
	if (wp->method == M_POST)
	{
	   fstat(wp->post_data_fd, &statbuf);
		lseek(wp->post_data_fd, SEEK_SET, 0);
      
		printf("file size=%d\n",statbuf.st_size);
		fp=fopen(wp->post_file_name,"rb");
		if(fp==NULL) goto error;
	}
	else goto error;

   
   //printf("_uploadGet\n");
   do
	{
		if(feof(fp))
		{
			printf("Cannot find start of file\n");
			goto error;
		}
		c= fgetc(fp);
		if (c!=0xd)
			continue;
		c= fgetc(fp);
		if (c!=0xa)
			continue;
		c= fgetc(fp);
		if (c!=0xd)
			continue;
		c= fgetc(fp);
		if (c!=0xa)
			continue;
		break;
	}while(1);
	(*startPos)=ftell(fp);

   if(fseek(fp,statbuf.st_size-0x200,SEEK_SET)<0) 
      goto error;
	do
	{
		if(feof(fp))
		{
			printf("Cannot find end of file\n");
			goto error;
		}
		c= fgetc(fp);
		if (c!=0xd)
			continue;
		c= fgetc(fp);
		if (c!=0xa)
			continue;
		c= fgetc(fp);
		if (c!='-')
			continue;
		c= fgetc(fp);
		if (c!='-')
			continue;
		break;
	}while(1);
	(*endPos)=ftell(fp);

   return fp;
error:
   return NULL;
}

#ifdef WEB_UPGRADE
// Added by Mason Yu
void displayUploadMessage(webs_t wp, int status)
{
	
	//printf("Popout web page\n");	
	websHeader(wp);
#if defined(ZTE_531B_BRIDGE_SC) || defined(ZTE_GENERAL_ROUTER_SC)
	websWrite(wp, T("<META HTTP-EQUIV=Refresh CONTENT=\"60; URL=/admin/status_sc.asp\">\n"));
      #else
      websWrite(wp, T("<META HTTP-EQUIV=Refresh CONTENT=\"60; URL=/admin/status.asp\">\n"));
      #endif
   	websWrite(wp, T("<body><blockquote><h4>\n"));

   	if (status == ERROR_FILESIZE)    	
   		websWrite(wp, T("%s</h4>\n"), TAdmin_uf_errupgsize);
   	else if (status == ERROR_FORMAT)
   		websWrite(wp, T("%s</h4>\n"), TAdmin_uf_errupgfmt);   	

   	websWrite(wp, T("%s<br><br>\n"), TAdmin_str_rebootWord0);
   	websWrite(wp, T("%s\n"), TAdmin_str_rebootWord2);
   	websWrite(wp, T("</blockquote></body>"));
   	websFooter(wp);
	websDone(wp, 200);
	
#ifdef EMBED
	// wake up the reboot thread
      	semSave.__sem_value=SEM_REBOOT;
	sem_post(&semSave);
#endif
}	


#ifdef UPGRADE_V1
///////////////////////////////////////////////////////////////////////////////
void formUpload(webs_t wp, char_t * path, char_t * query)
{
   	unsigned int startPos,endPos, nLen;
   	char tmpBuf[100]/*, *submitUrl*/;
	FILE	*fp=NULL;		

	/* find the start and end positive of run time image */
   	tmpBuf[0] = '\0';
	//printf("\nTry to get file size of new firmware\n"); 	
	
	// Mason Yu
	if ( g_filesize >= MAX_UPLOAD_FILESIZE) {
		displayUploadMessage(wp, ERROR_FILESIZE);
		goto end;
	}	

   	if ( (fp = _uploadGet(wp, &startPos, &endPos)) == NULL){
      		strcpy(tmpBuf, T(FILEOPENFAILED));
      		goto fail;	
   	}

#if defined(ZTE_531B_BRIDGE_SC) || defined(ZTE_GENERAL_ROUTER_SC)
/*#ifdef ZTE_LED_REQUEST
//star: for ZTE power LED request	
	FILE *fp1;
	unsigned char power_flag;
	fp1 = fopen("/proc/power_flag","w");
	if(fp1)
	{
		
		power_flag = '1';
		fwrite(&power_flag,1,1,fp1);
		fclose(fp1);
	}
#endif*/
#endif
	
	// Added by Mason Yu
#ifdef CONFIG_POWER_UPGRADE_LED
	va_cmd("/bin/ethctl", 2, 1, "upgrade", "blk");
#endif	

	/* check header and checksum of this image */
	printf("endPos=%u startPos=%u\n",endPos,startPos);
   	nLen = endPos - startPos - 4;

   #ifdef EMBED
	// write to flash   
	{	
		//unsigned char *block;
      	//int i, nRead, nWrite, rv;		
      	int rv;
	fseek(fp, startPos, SEEK_SET); // seek to the data star
	
	if (!isValidImageFile(fp)) {
		// Mason Yu
		printf("Incorrect image file\n");
		displayUploadMessage(wp, ERROR_FORMAT);
		goto end;
		//goto fail;
	}
	
	fseek(fp, startPos+sizeof(IMGHDR), SEEK_SET); // seek to the data star 
#if defined(ZTE_531B_BRIDGE_SC) || defined(ZTE_GENERAL_ROUTER_SC)
	//jim luo
	int writeflashtime;
	Modem_LinkSpeed vLs;
	vLs.upstreamRate=0;
	if (adsl_drv_get(RLCM_GET_LINK_SPEED, (void *)&vLs,RLCM_GET_LINK_SPEED_SIZE) && vLs.upstreamRate != 0)
		writeflashtime=g_filesize/17400; //star: flash can wirte about 17k in 1 sec with the adsl line up
	else
		writeflashtime=g_filesize/21000;//star: flash can wirte about 21k in 1 sec with the adsl line down
        websWrite(wp, T("<html><head><style>\n" \

        "#cntdwn{ border-width: 0px;font-size: 12pt;color: red;text-align:left; font-weight:bold; font-family: Courier;}\n" \

        "</style><script language=javascript>\n" \
        "var h=(%d+70);\n" \
        "function stop() { clearTimeout(id); }\n"\
	 "function start() { h--; if (h >= 70) { frm.time.value = h; frm.textname.value='%s'; id=setTimeout(\"start()\",1000); }\n" \
        "if (h >= 0 && h < 70) { frm.time.value = h; frm.textname.value='%s'; id=setTimeout(\"start()\",1000); }\n" \
        "if (h == 0) { window.location.href=\"/admin/status_sc.asp\"; }}\n" \
        "</script><link href=\"/admin/main.css\" rel=\"stylesheet\" type=\"text/css\">\n"
        "</head><body  onLoad=\"start();\" onUnload=\"stop();\">" \

        "<form name=frm><B><font color=red><INPUT  TYPE=text  class=\"upLoad\" NAME=textname size=40 readonly>\n" \
        "<INPUT TYPE=text  class=\"upLoad\" NAME=time size=5 readonly></form></body></html>") ,writeflashtime,TAdmin_uf_upgrad,TAdmin_uf_restart);    

#else
        // Added by Mason Yu  
        websWrite(wp, T("<html><head><style>\n" \
        "#cntdwn{ border-color: white;border-width: 0px;font-size: 12pt;color: red;text-align:left; font-weight:bold; font-family: Courier;}\n" \
        "</style><script language=javascript>\n" \
        "var h=400;\n" \
        "function stop() { clearTimeout(id); }\n"\
        "function start() { h--; if (h >= 55) { frm.time.value = h; frm.textname.value='%s'; id=setTimeout(\"start()\",1000); }\n" \
        "if (h >= 0 && h < 55) { frm.time.value = h; frm.textname.value='%s'; id=setTimeout(\"start()\",1000); }\n" \
        "if (h == 0) { window.location.href=\"/admin/status_sc.asp\"; }}\n" \
        "</script><link href=\"/admin/main.css\" rel=\"stylesheet\" type=\"text/css\">\n"
        "</head><body  onLoad=\"start();\" onUnload=\"stop();\">" \
        "<form name=frm><B><font color=red><INPUT class=\"upLoad\" TYPE=text NAME=textname size=40 readonly>\n" \
        "<INPUT TYPE=text  class=\"upLoad\" NAME=time size=5 readonly></form></body></html>"),TAdmin_uf_upgrad,TAdmin_uf_restart );    
#endif 
	// Save file for upgrade Firmware
	g_upgrade_firmware=TRUE;

	// wake up the Upgrade/reboot thread
      	semSave.__sem_value = SEM_UPGRADE;
      	g_post_file_name = wp->post_file_name;
      	g_startPos = startPos;
	sem_post(&semSave);	
		 	
   }
   #endif
   
end:   
	//OK_MSG("/upload.asp");   
   return;

fail:
   ERR_MSG(tmpBuf);
   return;
    
#if 0
	char_t *content_type = 0;
	char_t *boundary = 0;
	char_t *twopages=0;

	int nFirst, nLine, nLast, nLen;

	unsigned char *pBuf = 0;
	
	static char tmpBuf[100];
	
	if (__boot_mode != BOOT_UPGRADE)
	{
		strcpy(tmpBuf, T("ERROR: not in upgrade mode."));
		goto setErr_pass;
	}
	int firmware_page_idx = wp->lenPostData/WEB_UPLOAD_PAGE_SIZE - 1;
	int firmware_subsize = wp->lenPostData%WEB_UPLOAD_PAGE_SIZE;

	content_type = websGetVar(wp, T("CONTENT_TYPE"), T(""));
	if(content_type != NULL)
	{
		boundary = SearchKeyValue(content_type, "boundary");
	}

	if(content_type == 0 || boundary == 0)
	{
		error(E_L, E_LOG, T("ERROR: No content_type or No boundary!"));
		strcpy(tmpBuf, T("ERROR: Unable to add access limit."));
		goto setErr_pass;
	}

	// search for first boundary keyword
	 nFirst = FindKeyIndex(boundary, query, 0, wp->lenPostData);
	 if(nFirst == -1)
	 {
		error(E_L, E_LOG, T("ERROR: Http Data do not have first boundary!!"));
		strcpy(tmpBuf, T("ERROR: Http Data do not have first boundary!!"));
		goto setErr_pass;
	 }
	 nFirst += (strlen(boundary) + 2); //0D 0A

	// search for first empty line
	 nLine =  FindKeyIndex("\r\n", query, nFirst, wp->lenPostData);
	 while(nLine != nFirst)
	 {
		nFirst = nLine + 2;
		nLine =  FindKeyIndex("\r\n", query, nFirst, wp->lenPostData);
	 }
	 nFirst = nLine + 2; //0D 0A

	if (firmware_page_idx == -1)
	{	// only one page, ie. wp->query
		nLast = FindKeyIndex(boundary, query, nFirst, wp->lenPostData);
		
		if(nLast == -1)
		{
			error(E_L, E_LOG, T("ERROR: Http Data do not have second boundary!!"));
			strcpy(tmpBuf, T("ERROR: Http Data do not have second boundary!!"));
			goto setErr_pass;
		}
		
		nLast = nLast -2;	// boundary --
		nLast = nLast -2;	// OD OA --
		nLen = nLast - nFirst;
	}
	else
	{	// more than two page
		if(wp->queryNext[firmware_page_idx] == NULL)
		{
			error(E_L, E_LOG, T("ERROR: Upload error!!"));
			strcpy(tmpBuf, T("ERROR: Upload error!!"));
			goto setErr_pass;
		}
		
		// search for second empty line
		// boundary may walk across page
		twopages = malloc(WEB_UPLOAD_PAGE_SIZE*2);
		
		if ( twopages == NULL ) {
			strcpy(tmpBuf, "Allocate buffer failed!");
			goto setErr_pass;
		}
		
		if (firmware_page_idx == 0)
		{	// one query page and one queryNext page
			memcpy(twopages, wp->query, WEB_UPLOAD_PAGE_SIZE);
		}
		else
		{	// more than two queryNext pages
			memcpy(&twopages[0], wp->queryNext[firmware_page_idx-1], WEB_UPLOAD_PAGE_SIZE);
		}
		
		memcpy(&twopages[WEB_UPLOAD_PAGE_SIZE], wp->queryNext[firmware_page_idx], firmware_subsize);
		nLast = FindKeyIndex(boundary, twopages, 0, WEB_UPLOAD_PAGE_SIZE+firmware_subsize);
		
		if(nLast == -1)
		{
			error(E_L, E_LOG, T("ERROR: Http Data do not have second boundary!!"));
			strcpy(tmpBuf, T("ERROR: Http Data do not have second boundary!!"));
			goto setErr_pass;
		}
		
		nLast = nLast -2;	// boundary --
		nLast = nLast -2;	// OD OA --
		nLen = wp->lenPostData - nFirst -  (WEB_UPLOAD_PAGE_SIZE+firmware_subsize - nLast);
	}

	printf("Upload Firmware File, Len = %d\nWriting to flash ", nLen);

#ifdef EMBED
	// write to flash
	{
		unsigned char *block;

		IMG_HEADER_T img_header;

		img_header.signature = FIRMWARE_MAGIC_NUMBER;
		img_header.startAddr = DST_IMAGE_ADDR;
		img_header.len = nLen;

		block = malloc(FLASH_BLOCK_SIZE);
		if(block)
		{
			int current_block_idx = 0;
			int current_block_size = 0;
			int total_block_size = 0;
			
			int query_page;
			int query_index;
			unsigned char* queryPtr;

/*
			// Kaotest
			for (current_block_idx=0; current_block_idx<=23; current_block_idx++) {
				flash_write(block, CODE_IMAGE_OFFSET + current_block_idx*FLASH_BLOCK_SIZE, FLASH_BLOCK_SIZE);
				printf(".");
			}
			printf("That's right\n");
			free(block);
			return;
*/
			// image header
			memcpy(&block[0], (void *)&img_header, sizeof(IMG_HEADER_T));
			current_block_size += FIRMWARE_PARAM_SIZE;
			total_block_size +=FIRMWARE_PARAM_SIZE;
	
			for(query_page = -1; query_page<=firmware_page_idx; query_page++)
			{
				if(query_page == -1)
				{
					queryPtr = wp->query;
					query_index = nFirst;
				}
				else
				{
					queryPtr = wp->queryNext[query_page];
					query_index = 0;
				}
				
				if (total_block_size >= nLen) // flash-write finished
					break;

				while(1)
				{
					if(((nLen + FIRMWARE_PARAM_SIZE) - total_block_size) <= (WEB_UPLOAD_PAGE_SIZE - query_index))
					{	// last flash block
//						printf("C query_page(%d), query_index(%d), current_block_idx(%d), current_block_size(%d), total_block_size(%d)\n", query_page, query_index, current_block_idx, current_block_size, total_block_size);
						
						memcpy(&block[current_block_size],
							&queryPtr[query_index],
							((nLen + FIRMWARE_PARAM_SIZE)- total_block_size));
						
						// flash
						flash_write(block,
							CODE_IMAGE_OFFSET + current_block_idx*FLASH_BLOCK_SIZE,
							current_block_size+((nLen + FIRMWARE_PARAM_SIZE)- total_block_size)); /* raw flash write, without protection */
						printf(".\n");
						
						total_block_size = nLen;						
						query_index += (nLen - total_block_size);
						current_block_idx++;
						current_block_size = 0;
						
						if(query_page != firmware_page_idx)
						{
							printf("firmware update: warning #10\n");
						}
						
//						printf("Final query_page(%d), query_index(%d), current_block_idx(%d), current_block_size(%d), total_block_size(%d)\n", query_page, query_index, current_block_idx, current_block_size, total_block_size);
						
						break;
					}
					else
					if((WEB_UPLOAD_PAGE_SIZE - query_index) >= (FLASH_BLOCK_SIZE - current_block_size))
					{	// a full flash block is ready, we can flash
//						printf("A query_page(%d), query_index(%d), current_block_idx(%d), current_block_size(%d), total_block_size(%d)\n", query_page, query_index, current_block_idx, current_block_size, total_block_size);

						memcpy(&block[current_block_size], &queryPtr[query_index], (FLASH_BLOCK_SIZE - current_block_size));

						// flash
						flash_write(block, CODE_IMAGE_OFFSET + current_block_idx*FLASH_BLOCK_SIZE, FLASH_BLOCK_SIZE); /* raw flash write, without protection */
						printf(".");

						total_block_size += (FLASH_BLOCK_SIZE - current_block_size);						
						query_index += (FLASH_BLOCK_SIZE - current_block_size);
						current_block_idx++;
						current_block_size = 0;						
					}
					else
					{	// a full block is NOT ready, continue to next page
//						printf("B query_page(%d), query_index(%d), current_block_idx(%d), current_block_size(%d), total_block_size(%d)\n", query_page, query_index, current_block_idx, current_block_size, total_block_size);

						memcpy(&block[current_block_size], &queryPtr[query_index], (WEB_UPLOAD_PAGE_SIZE - query_index));

						current_block_size += (WEB_UPLOAD_PAGE_SIZE - query_index);
						total_block_size += (WEB_UPLOAD_PAGE_SIZE - query_index);

						break;
					}
				}
			}
			free(block);
		}		
	}
#endif
	
	printf("Finished writing\n");
	// search for submit-url
	if (firmware_page_idx == -1)
	{	// only one page, ie. wp->query
		nFirst = FindKeyIndex("submit-url", query, nLast, wp->lenPostData);
	}
	else
	{
		nFirst = FindKeyIndex("submit-url", twopages, nLast, WEB_UPLOAD_PAGE_SIZE+firmware_subsize);
	}
	
	if(nFirst != -1)
	{
		nFirst += 10 + 1 + 4; //  submit-url + " + \r\n\r\n
		if (firmware_page_idx == -1)
		{	// only one page, ie. wp->query
	 		nLast = FindKeyIndex("\r\n", query, nFirst, wp->lenPostData);
	 	}
		else
		{
			nLast = FindKeyIndex("\r\n", twopages, nFirst, WEB_UPLOAD_PAGE_SIZE+firmware_subsize);
		}
		if((nLast != -1) && (nLast > nFirst))
		{
			memset((char *)tmpBuf, 0x00, 100);
			if (firmware_page_idx == -1)
			{	// only one page, ie. wp->query
				memcpy((char *)tmpBuf,(char *)(query + nFirst),nLast-nFirst);
		 	}
			else
			{
				memcpy((char *)tmpBuf,(char *)(twopages + nFirst),nLast-nFirst);
				free(twopages);
		 	}
			OK_MSG(tmpBuf);
			releaseUploadMem(wp);
			return;
		}
	}

 setErr_pass:
	if (twopages != 0)
		free(twopages);
	releaseUploadMem(wp);
	ERR_MSG(tmpBuf);
#endif
}
#else
#if defined(UPGRADE_V2) || defined(UPGRADE_V3)
void formUpload(webs_t wp, char_t * path, char_t * query)
{
   	char *str;
   	int action;
	FILE *fp;
   	
	str = websGetVar(wp, T("act"), T(""));
	if (str[0]) {
		// replace by mini web
		action = str[0] - '0';
	}
	else
		return;
	
#ifdef EMBED
	if (action==1) {
		// disable ip forwarding
		if (fp = fopen(PROC_IPFORWARD, "w"))
		{
			fprintf(fp, "0\n");
			fclose(fp);
		}
	      	semSave.__sem_value = SEM_UPGRADE_2;
		sem_post(&semSave);
	}
	else
	if (action==2) { // UPGRADE_V3 --- reboot to upgrade mode
		char bm = (char)BOOT_UPGRADE;
		// save to indicate the upgrade mode
		mib_set(MIB_BOOT_MODE, (void *)&bm);
		mib_update(HW_SETTING, CONFIG_MIB_ALL);
		websHeader(wp);
   		websWrite(wp, T("<body onLoad=\"top.location='/toupgrade.html';\">\n"));
   		websWrite(wp, T("</body >\n"));
   		websFooter(wp);
		//OK_MSG1("The system is restarting ...\n", NULL);
		semSave.__sem_value=SEM_REBOOT;
		sem_post(&semSave);
	}
#endif
	
}
#endif // of UPGRADE_V2
#endif // of UPGRADE_V1
#endif // of WEB_UPGRADE

//return 0:OK, other:fail
int call_cmd(const char *filename, int num, int dowait, ...)
{
	va_list ap;
	char *s;
	char *argv[24];
	int status=0, st, k;
	pid_t pid, wpid;
	
	va_start(ap, dowait);
	
	for (k=0; k<num; k++)
	{
		s = va_arg(ap, char *);
		argv[k+1] = s;
	}
	
	argv[k+1] = NULL;
	if((pid = vfork()) == 0) {
		/* the child */
		char *env[3];
		
		signal(SIGINT, SIG_IGN);
		argv[0] = (char *)filename;
		env[0] = "PATH=/bin:/usr/bin:/etc:/sbin:/usr/sbin";
		env[1] = NULL;

		execve(filename, argv, env);

		printf("exec %s failed\n", filename);
		_exit(2);
	} else if(pid > 0) {
		if (!dowait)
			status = 0;
		else {
			/* parent, wait till rc process dies before spawning */
			while ((wpid = wait(&st)) != pid)
				if (wpid == -1 && errno == ECHILD) { /* see wait(2) manpage */
					break;
				}
		}
	} else if(pid < 0) {
		printf("fork of %s failed\n", filename);
		status = -1;
	}
	if (wpid>0)
		if (WIFEXITED(st))
			status = WEXITSTATUS(st);
//			printf("Child exited with RC=%d\n",WEXITSTATUS(st));
	va_end(ap);
	
	return status;
}
///////////////////////////////////////////////////////////////////////////////
/*
 *	Tag: load, Value:Upload - upload configuration file
 *    Tag: save, Value:Save... - save configuration file
 *    Tag: reset, Value:Rest - reset configuration to default
 */

#include <semaphore.h>
extern sem_t semSave;
#define MAX_CONFIG_FILESIZE 200000
void formSaveConfig(webs_t wp, char_t *path, char_t *query)
{
	char_t *strRequest;
	unsigned int maxFileSector;

	char tmpBuf[100], *submitUrl;

	CONFIG_DATA_T action_type = UNKNOWN_SETTING;

	wp->buffer_end=0; // clear header
   	tmpBuf[0] = '\0';
	
	if (g_filesize > MIN_UPLOAD_FILESIZE) {
		websHeader(wp);
#if defined(ZTE_531B_BRIDGE_SC) || defined(ZTE_GENERAL_ROUTER_SC)
		websWrite(wp, T("<META HTTP-EQUIV=Refresh CONTENT=\"60; URL=/status_sc.asp\">\n"));
		websWrite(wp, T("<body><blockquote><h4>\n"));
		websWrite(wp, T("ļָʧ! ļ̫!<br>"));
          #else
            	websWrite(wp, T("<META HTTP-EQUIV=Refresh CONTENT=\"60; URL=/status.asp\">\n"));
	    	websWrite(wp, T("<body><blockquote><h4>\n"));
	    	websWrite(wp, T("Restore settings from config file failed! Uploaded file size out of constraint!<br>"));
          #endif	
   		websWrite(wp, T("%s</h4>\n"), rebootWord0);
		websWrite(wp, T("<br>%s\n"), rebootWord2);
		websWrite(wp, T("</blockquote></body>"));
		websFooter(wp);
		websDone(wp, 200);
		goto end;
	}
	else if (g_filesize >= MAX_CONFIG_FILESIZE) {
#if defined(ZTE_531B_BRIDGE_SC) || defined(ZTE_GENERAL_ROUTER_SC)
		strcpy(tmpBuf, T("ļָʧ! ϴļ̫!\n"));
#else
		strcpy(tmpBuf, T("ERROR: Restore Config file failed! Uploaded file size out of constraint!\n"));
#endif
		goto setErr_pass;
	}
	
	strRequest = websGetVar(wp, T("save_ds"), T(""));
	if (strRequest[0])
	{
		action_type = DEFAULT_SETTING;
		maxFileSector = DEFAULT_SETTING_MAX_LEN/10;
	}

	strRequest = websGetVar(wp, T("save_cs"), T(""));
	if (strRequest[0])
	{
		action_type = CURRENT_SETTING;
		maxFileSector = CURRENT_SETTING_MAX_LEN/20;
	}

	strRequest = websGetVar(wp, T("save_hs"), T(""));
	if (strRequest[0])
	{
		action_type = HW_SETTING;
		maxFileSector = HW_SETTING_MAX_LEN/10;
	}

	if (action_type != UNKNOWN_SETTING)
	{	// save configuration file
		PARAM_HEADER_T header;
		unsigned char *ptr;
		unsigned int fileSize,filelen;
		unsigned int fileSector;

#ifdef XML_CONFIG
		FILE *fp;
		int ret=-1;
		//create config file
		ret = call_cmd("/bin/CreatexmlConfig", 0, 1);
	#ifdef XOR_ENCRYPT
		xor_encrypt("/tmp/config.xml", "/tmp/config_xor.xml");
	#endif
#else
		unsigned char *buf;

		if(mib_read_header(action_type, &header) != 1)
		{
			error(E_L, E_LOG, T("ERROR: Flash read fail"));
			strcpy(tmpBuf, T("ERROR: Flash read fail."));
			goto setErr_pass;
		}
		fileSize = sizeof(PARAM_HEADER_T) + header.len;
		buf = malloc(fileSize);
		if ( buf == NULL ) {
			strcpy(tmpBuf, "Allocate buffer failed!");
			goto setErr_pass;
		}

		printf("fileSize=%d\n",fileSize);
		if(mib_read_to_raw(action_type, buf, fileSize) != 1)
		{
			free(buf);
			
			error(E_L, E_LOG, T("ERROR: Flash read fail"));
			strcpy(tmpBuf, T("ERROR: Flash read fail."));
			goto setErr_pass;
		}
#endif
printf("\n%s:%d\n",__FUNCTION__,__LINE__);	
		websWrite(wp, "HTTP/1.0 200 OK\n");
		websWrite(wp, "Content-Type: application/octet-stream;\n");

		if(action_type == CURRENT_SETTING)
#ifdef XML_CONFIG
		websWrite(wp, "Content-Disposition: attachment;filename=\"config.xml\" \n");
#else
		websWrite(wp, "Content-Disposition: attachment;filename=\"adsl-config.bin\" \n");
#endif
		else if(action_type == DEFAULT_SETTING)
		websWrite(wp, "Content-Disposition: attachment;filename=\"adsl-config-ds.bin\" \n");
		else if(action_type == HW_SETTING)
		websWrite(wp, "Content-Disposition: attachment;filename=\"adsl-config-hs.bin\" \n");
#ifdef 	SERVER_SSL
		// IE bug, we can't sent file with no-cache through https
#else 
		websWrite(wp, "Pragma: no-cache\n");
		websWrite(wp, "Cache-Control: no-cache\n");
#endif		
		websWrite(wp, "\n");

#ifdef XML_CONFIG
	#ifdef XOR_ENCRYPT
		fp=fopen("/tmp/config_xor.xml","r");
	#else
		fp=fopen("/tmp/config.xml","r");
	#endif
printf("\n%s:%d\n",__FUNCTION__,__LINE__);	
		//decide the file size	
		fseek(fp, 0, SEEK_END);
		filelen = ftell(fp);
		fseek(fp, 0, SEEK_SET);
		fileSize=filelen;
	#if defined(ZTE_531B_BRIDGE_SC) || defined(ZTE_GENERAL_ROUTER_SC)
		if(fileSize>0)
		{	//generate keyword to configfile,if bridge
		#ifdef ZTE_531B_BRIDGE_SC
			websWriteDataNonBlock(wp, &ZTE_Bridge_Config_Keyword, 4);
		#else
			websWriteDataNonBlock(wp, &ZTE_Router_Config_Keyword, 4);
		#endif
		}
	#endif
		while(fileSize>0)
		{
			char buf[0x1000];
			int nRead;
			
			printf("write %d %d %08x\n",maxFileSector, fileSize, (unsigned int )ptr);
			fileSector = (fileSize>maxFileSector)?maxFileSector:fileSize;
			nRead = fread((void *)buf, 1, fileSector, fp);
	#if defined(ZTE_531B_BRIDGE_SC) || defined(ZTE_GENERAL_ROUTER_SC)
			ZTE_Encrypt(buf, buf, 26, nRead);
	#endif
			websWriteDataNonBlock(wp, buf, nRead);
			
			fileSize -= fileSector;
			ptr += fileSector;
			//wrong free....
			//free(buf);
 			//sleep(1);
		}
		fclose(fp);
#else
		ptr = buf;
	#if defined(ZTE_531B_BRIDGE_SC) || defined(ZTE_GENERAL_ROUTER_SC)
		if(fileSize>0)
		{	//generate keyword to configfile,if bridge
		#ifdef ZTE_531B_BRIDGE_SC
			websWriteDataNonBlock(wp, &ZTE_Bridge_Config_Keyword, 4);
		#else
			websWriteDataNonBlock(wp, &ZTE_Router_Config_Keyword, 4);
		#endif
		}
	#endif
		while(fileSize>0)
		{
//			printf("write %d %d %08x\n",maxFileSector, fileSize, (unsigned int )ptr);
			fileSector = (fileSize>maxFileSector)?maxFileSector:fileSize;
			websWriteDataNonBlock(wp, ptr, fileSector);
			
			fileSize -= fileSector;
			ptr += fileSector;
 			sleep(1);
		}
		free(buf);
#endif		
		//websDone(wp, 200);
		//OK_MSG("/saveconf.asp");		
		return;
	}

	strRequest = websGetVar(wp, T("reset"), T(""));
	if (strRequest[0])
	{	// reset configuration to default
		char_t *submitUrl=0;

#if 0
		if(mib_reset(CURRENT_SETTING) == 0)
		{
			error(E_L, E_LOG, T("ERROR: reset fail."));
			strcpy(tmpBuf, T("ERROR: reset fail."));
			goto setErr_pass;
		}
#endif
		
		//submitUrl = websGetVar(wp, T("submit-url"), T(""));   // hidden page

		//OK_MSG(submitUrl);
		// Modified by Mason Yu. for not use default setting	
		/*	
		mib_load(DEFAULT_SETTING, CONFIG_MIB_ALL);
		formReboot(wp, NULL, NULL);	
		*/
		
		// Jenny, add reboot messages when reset to default
		websHeader(wp);
#if defined(ZTE_531B_BRIDGE_SC) || defined(ZTE_GENERAL_ROUTER_SC)
	          websWrite(wp, T("<META HTTP-EQUIV=Refresh CONTENT=\"60; URL=/status_sc.asp\">\n"));
                 #else
                websWrite(wp, T("<META HTTP-EQUIV=Refresh CONTENT=\"60; URL=/status.asp\">\n"));
                 #endif	
		websWrite(wp, T("<body><blockquote><h4>\n"));
	   	websWrite(wp, T("%s</h4>\n"), rebootWord0);
   		websWrite(wp, T("%s<br><br>\n"), rebootWord1);
	   	websWrite(wp, T("%s\n"), rebootWord2);
   		websWrite(wp, T("</blockquote></body>"));
	   	websFooter(wp);
		websDone(wp, 200);

#ifdef EMBED
		va_cmd("/bin/flash", 2, 1, "default", "cs");
		semSave.__sem_value=SEM_REBOOT;
		
		/* Save and reboot the system */
		// wake up the Save/reboot thread
		sem_post(&semSave);
#endif
		return;
	}

#ifdef XML_CONFIG
	{
		FILE	*fp=NULL,*fp_input;
		unsigned char *buf;
		unsigned int startPos,endPos,nLen,nRead;
		int ret=-1;		
		
		if ((fp = _uploadGet(wp, &startPos, &endPos)) == NULL) {
#if defined(ZTE_531B_BRIDGE_SC) || defined(ZTE_GENERAL_ROUTER_SC)
			strcpy(tmpBuf, T(" :ѡļ"));
#else
			strcpy(tmpBuf, T("ERROR: find the start and end of the upload file failed!"));
#endif
         		goto setErr_pass;
		}

		/* check header and checksum of this image */
		//printf("endPos=%u startPos=%u\n",endPos,startPos);
      		nLen = endPos - startPos - 4;
      		//printf("filesize is %d\n", nLen);
      		buf = malloc(nLen);
      		if (!buf) {
	      		fclose(fp);
         		goto setErr_pass;
      		}

      		fseek(fp, startPos, SEEK_SET);
      		nRead = fread((void *)buf, 1, nLen, fp);
#if defined(ZTE_531B_BRIDGE_SC) || defined(ZTE_GENERAL_ROUTER_SC)
		// ZTE 531B  Bridge need the ability to disable wrong config file to open the router mode. then we should encrypt the 
		// file and indicate if bridge or router config file.
		//check keyword
	#ifdef ZTE_531B_BRIDGE_SC
		if(!memcmp(buf, &ZTE_Bridge_Config_Keyword, 4))
	#else
		if(!memcmp(buf, &ZTE_Router_Config_Keyword, 4))
	#endif
		{
			memmove(buf, buf+4, nRead-4);
			*(buf+nRead-4)=0; //add terminate .
			ZTE_Deencrypt(buf, buf, 26, nRead-4);
			printf("Config File: \n%s", buf);
		}else
		{
			//destroy config file
			memset(buf, 0x12, nRead-4);
		}
		
#endif
      		fclose(fp);
      		if (nRead != nLen)
         		printf("Read %d bytes, expect %d bytes\n", nRead, nLen);
	
      		//printf("write to %d bytes from %08x\n", nLen, buf);
     		
	#ifdef XOR_ENCRYPT
		fp_input=fopen("/tmp/config_xor.xml","w");
	#else
      		fp_input=fopen("/tmp/config.xml","w");
	#endif
      		if (!fp_input)
			printf("Get config file fail!\n");
	#ifdef XOR_ENCRYPT
		fwrite((void *)buf, 1, nLen, fp_input);
	#else
      		fprintf(fp_input,buf);
	#endif
      		printf("create file config.xml\n");
      		free(buf);
      		fclose(fp_input);
	#ifdef XOR_ENCRYPT
		xor_encrypt("/tmp/config_xor.xml", "/tmp/config.xml");
		unlink("/tmp/config_xor.xml");
	#endif
		ret = call_cmd("/bin/LoadxmlConfig", 0, 1);
		
		if (ret == 0) {
			websHeader(wp);
				#if defined(ZTE_531B_BRIDGE_SC) || defined(ZTE_GENERAL_ROUTER_SC)
	                   websWrite(wp, T("<META HTTP-EQUIV=Refresh CONTENT=\"60; URL=/status_sc.asp\">\n"));
                #else
			websWrite(wp, T("<META HTTP-EQUIV=Refresh CONTENT=\"60; URL=/status.asp\">\n"));
                #endif
   			websWrite(wp, T("<body><blockquote><h4>\n"));
			 #if defined( ZTE_531B_BRIDGE_SC)||defined(ZTE_GENERAL_ROUTER_SC)
			websWrite(wp, T("ɹָϵͳ! \n<br>"));
			#else
	   		websWrite(wp, T("Restore settings from config file successful! \n<br>"));
			#endif
	   		websWrite(wp, T("%s</h4>\n"), rebootWord0);
   			websWrite(wp, T("%s<br><br>\n"), rebootWord1);
   			websWrite(wp, T("%s\n"), rebootWord2);
	   		websWrite(wp, T("</blockquote></body>"));
   			websFooter(wp);
			websDone(wp, 200);
			sem_post(&semSave);
		}
		else {
#if defined(ZTE_531B_BRIDGE_SC) || defined(ZTE_GENERAL_ROUTER_SC)
			strcpy(tmpBuf, T(":ϵͳûָʧ,ļ !"));
#else
			strcpy(tmpBuf, T("ERROR: Restore Config file failed! Invalid config file!"));
#endif
			goto setErr_pass;
		}
	}
#else
   if (1)
   {
      unsigned int startPos,endPos,nLen,nRead;
	   FILE	*fp=NULL;	
	   //struct stat statbuf;	
	   unsigned char *buf; 

	   /* find the start and end positive of run time image */
	   printf("\nTry to get file size of new firmware\n");
      
      if ((fp = _uploadGet(wp, &startPos, &endPos)) == NULL)
         goto setErr_pass;

	   /* check header and checksum of this image */
	   printf("endPos=%u startPos=%u\n",endPos,startPos);

      nLen = endPos - startPos - 4;
      //printf("filesize is %d\n", nLen);
      buf = malloc(nLen);
      if (!buf)
         goto setErr_pass;

      fseek(fp, startPos, SEEK_SET);
      nRead = fread((void *)buf, 1, nLen, fp);
      if (nRead != nLen)
         printf("Read %d bytes, expect %d bytes\n", nRead, nLen);

      printf("write to %d bytes from %08x\n", nLen, buf);
      if(mib_update_from_raw(buf, nLen) != 1)
		{
			strcpy(tmpBuf, "Flash error!");
			free(buf);
			goto setErr_pass;
		}
      //submitUrl = websGetVar(wp, T("submit-url"), T(""));   // hidden page
      //printf("submitted val: %s\n", submitUrl);
		OK_MSG("/saveconf.asp");				
      free(buf);
   }
#endif

#if 0
	// should be upload configuration file
	if(1)
	{
		char_t *content_type = 0;
		char_t *boundary = 0;

		int nFirst, nLine, nLast, nLen;

		unsigned char *ptr;
		
		unsigned char *buf = 0;

		content_type = websGetVar(wp, T("CONTENT_TYPE"), T(""));
		if(content_type != NULL)
		{
			boundary = SearchKeyValue(content_type, "boundary");
		}

		if(content_type == 0 || boundary == 0)
		{
			error(E_L, E_LOG, T("ERROR: No content_type or No boundary!"));
			strcpy(tmpBuf, T("ERROR: Unable to add access limit."));
			goto setErr_pass;
		}

		// search for first boundary keyword
		 nFirst = FindKeyIndex(boundary, query, 0, wp->lenPostData);
		 if(nFirst == -1)
		 {
			error(E_L, E_LOG, T("ERROR: Http Data do not have first boundary!!"));
			strcpy(tmpBuf, T("ERROR: Http Data do not have first boundary!!"));
			goto setErr_pass;
		 }
		 nFirst += (strlen(boundary) + 2); //0D 0A

		// search for first empty line
		 nLine =  FindKeyIndex("\r\n", query, nFirst, wp->lenPostData);
		 while(nLine != nFirst)
		 {
			nFirst = nLine + 2;
			nLine =  FindKeyIndex("\r\n", query, nFirst, wp->lenPostData);
		 }
		 nFirst = nLine + 2; //0D 0A

		// search for second empty line
		 nLast = FindKeyIndex(boundary, query, nFirst, wp->lenPostData);
		 if(nLast == -1)
		 {
			error(E_L, E_LOG, T("ERROR: Http Data do not have second boundary!!"));
			strcpy(tmpBuf, T("ERROR: Http Data do not have second boundary!!"));
			goto setErr_pass;
		 }
		 nLast = nLast -2;	// boundary --

		nLen = nLast - nFirst -2; //0D 0A

		printf("Upload Configuration File, File Size = %d\n",nLen);

		ptr = (unsigned char *)(query + nFirst);			// point to start of File

		buf = malloc(nLen);
		if ( buf == NULL ) {
			strcpy(tmpBuf, "Allocate buffer failed!");
			goto setErr_pass;
		}
		memcpy(buf, ptr, nLen);

		if(mib_update_from_raw(buf, nLen) != 1)
		{
			strcpy(tmpBuf, "Flash error!");
			free(buf);
			goto setErr_pass;
		}

		free(buf);

		if(!mib_init())
		{
			strcpy(tmpBuf, "Error: Flash read fail!");
			free(buf);
			goto setErr_pass;
		}
		
		// search for submit-url
		 nFirst = FindKeyIndex("submit-url", query, nLast, wp->lenPostData);
		 if(nFirst != -1)
		 {
		 	nFirst += 10 + 1 + 4; //  submit-url + " + \r\n\r\n
		 	nLast = FindKeyIndex("\r\n", query, nFirst, wp->lenPostData);
		 	if((nLast != -1) && (nLast > nFirst))
		 	{
				memset((char *)tmpBuf, 0x00, 100);
				memcpy((char *)tmpBuf,(char *)(query + nFirst),nLast-nFirst);
				OK_MSG(tmpBuf);
				return;
		 	}
		 }

	}


	printf("fail!\n");
#endif
   return;
 	
 setErr_pass:
 		//ql-- should assign the URL to jump to.
		//ERR_MSG(tmpBuf);
#if defined(ZTE_531B_BRIDGE_SC) || defined(ZTE_GENERAL_ROUTER_SC)
		OK_MSG1(tmpBuf, "/admin/saveconf_sc.asp");
#else
		OK_MSG1(tmpBuf, "/saveconf_sc.asp");
#endif
		return;

 end:
	sem_post(&semSave);
 	return;
}

void formSnmpConfig(webs_t wp, char_t *path, char_t *query)
{
	char_t *str, *submitUrl;
	struct in_addr trap_ip;
	static char tmpBuf[100];

//star: for take effect
	unsigned int snmpchangeflag=0;
	unsigned char vChar;
	char_t origstr[128];
	unsigned char origip[16];

	
#if !defined(ZTE_531B_BRIDGE_SC) && !defined(ZTE_GENERAL_ROUTER_SC)
	str = websGetVar(wp, T("snmpSysDescr"), T(""));
	if (str[0]) {
		mib_get(MIB_SNMP_SYS_DESCR, (void*)origstr);
		if(strcmp(origstr,str)!=0)
			snmpchangeflag = 1;
		if ( !mib_set(MIB_SNMP_SYS_DESCR, (void *)str)) {
			strcpy(tmpBuf, T("Set snmpSysDescr mib error!"));
			goto setErr_pass;
		}
	}

	str = websGetVar(wp, T("snmpSysContact"), T(""));
	if (str[0]) {
		mib_get(MIB_SNMP_SYS_CONTACT, (void*)origstr);
		if(strcmp(origstr,str)!=0)
			snmpchangeflag = 1;
		if ( !mib_set(MIB_SNMP_SYS_CONTACT, (void *)str)) {
			strcpy(tmpBuf, T("Set snmpSysContact mib error!"));
			goto setErr_pass;
		}
	}

	str = websGetVar(wp, T("snmpSysName"), T(""));
	if (str[0]) {
		mib_get(MIB_SNMP_SYS_NAME, (void*)origstr);
		if(strcmp(origstr,str)!=0)
			snmpchangeflag = 1;
		if ( !mib_set(MIB_SNMP_SYS_NAME, (void *)str)) {
			strcpy(tmpBuf, T("Set snmpSysName mib error!"));
			goto setErr_pass;
		}
	}

	str = websGetVar(wp, T("snmpSysLocation"), T(""));
	if (str[0]) {
		mib_get(MIB_SNMP_SYS_LOCATION, (void*)origstr);
		if(strcmp(origstr,str)!=0)
			snmpchangeflag = 1;
		if ( !mib_set(MIB_SNMP_SYS_LOCATION, (void *)str)) {
			strcpy(tmpBuf, T("Set snmpSysLocation mib error!"));
			goto setErr_pass;
		}
	}

	str = websGetVar(wp, T("snmpSysObjectID"), T(""));
	if (str[0]) {
		mib_get(MIB_SNMP_SYS_OID, (void*)origstr);
		if(strcmp(origstr,str)!=0)
			snmpchangeflag = 1;
		if ( !mib_set(MIB_SNMP_SYS_OID, (void *)str)) {
			strcpy(tmpBuf, T("Set snmpSysObjectID mib error!"));
			goto setErr_pass;
		}
	}
#endif
	str = websGetVar(wp, T("snmpCommunityRO"), T(""));
	if (str[0]) {
		mib_get(MIB_SNMP_COMM_RO, (void*)origstr);

		if(strcmp(origstr,str)!=0)
			snmpchangeflag = 1;
		if ( !mib_set(MIB_SNMP_COMM_RO, (void *)str)) {
			strcpy(tmpBuf, T(strSetcommunityROerror));
			goto setErr_pass;
		}
	}
	str = websGetVar(wp, T("snmpCommunityRW"), T(""));
	if (str[0]) {
		mib_get(MIB_SNMP_COMM_RW, (void*)origstr);
		if(strcmp(origstr,str)!=0)
			snmpchangeflag = 1;
		if ( !mib_set(MIB_SNMP_COMM_RW, (void *)str)) {
			strcpy(tmpBuf, T(strSetcommunityRWerror));
			goto setErr_pass;
		}
	}
	str = websGetVar(wp, T("snmpTrapIpAddr"), T(""));
	if ( str[0] ) {
		if ( !inet_aton(str, &trap_ip) ) {
			strcpy(tmpBuf, T(strInvalTrapIp));
			goto setErr_pass;
		}
		mib_get(MIB_SNMP_TRAP_IP, (void*)&origip);
		if(((struct in_addr*)origip)->s_addr != trap_ip.s_addr)
			snmpchangeflag = 1;
		if ( !mib_set(MIB_SNMP_TRAP_IP, (void *)&trap_ip)) {
			strcpy(tmpBuf, T(strSetTrapIperror));
			goto setErr_pass;
		}
	}

	/* upgdate to flash */
//	mib_update(CURRENT_SETTING);
	if(snmpchangeflag == 1)
	{
#ifdef __CLOSE_INTERFACE_BEFORE_WRITE_
			/*to avoid the dead when wrriting the flash*/
		itfcfg("sar", 0);
		itfcfg("eth0", 0);
#ifdef WLAN_SUPPORT
		itfcfg("wlan0", 0);
#endif
#endif /*__CLOSE_INTERFACE_BEFORE_WRITE_*/
		mib_update(CURRENT_SETTING, CONFIG_MIB_ALL);

#ifdef __CLOSE_INTERFACE_BEFORE_WRITE_
		itfcfg("sar", 1);
		itfcfg("eth0", 1);
#ifdef WLAN_SUPPORT
		vChar=0;
		mib_get( MIB_WLAN_DISABLED, (void *)&vChar);
		if( vChar==0 )	itfcfg("wlan0", 1);
#endif //WLAN_SUPPORT
#endif /*__CLOSE_INTERFACE_BEFORE_WRITE_*/
//		RECONNECT_MSG(strIp);
//		req_flush(wp);
		restart_snmp();		
		submitUrl = websGetVar(wp, T("submit-url"), T(""));   // hidden page
		OK_MSG(submitUrl);
		return;
	}

	submitUrl = websGetVar(wp, T("submit-url"), T(""));
	if (submitUrl[0])
		websRedirect(wp, submitUrl);
	else
		websDone(wp, 200);
  	return;

 setErr_pass:
	ERR_MSG(tmpBuf);	
}

#if 0 // DSL driver page
adsl_drv_set_cmd adsl_drv_set_cmd_list[] =
{
	{"adsl-drv-modem-start", "adsl-start-mode"},
	{"adsl-drv-modem-enable", NULL},
	{"adsl-drv-modem-disable", NULL},
	{"adsl-drv-retrain", NULL},
	{"adsl-drv-mode", "adsl-mode"},
	{"adsl-drv-txpower", "adsl-txpower"},
	{"adsl-drv-tuneper", "adsl-tuneper"},
	{"adsl-drv-bitswap-enable", NULL},
	{"adsl-drv-bitswap-disable", NULL},
	{"adsl-drv-pilotrelocat-enable", NULL},
	{"adsl-drv-pilotrelocat-disable", NULL},
	{"adsl-drv-trellis-enable", NULL},
	{"adsl-drv-trellis-disable", NULL},
	{"adsl-drv-vendorid", "adsl-vendorid"},
	{"adsl-drv-debugmode", "adsl-debugmode"},
	{"adsl-drv-testpsd", "adsl-testpsd"},
	{"adsl-drv-log-enable", NULL},
	{"adsl-drv-log-disable", NULL},

	{NULL, NULL}	
};


void formAdslDrv(webs_t wp, char_t *path, char_t *query)
{
	char_t *cmd, *str, *submitUrl;
	char tmpBuf[100];
	int idx;

	for (idx=0; adsl_drv_set_cmd_list[idx].cmd != NULL; idx++) {

		cmd = websGetVar(wp, adsl_drv_set_cmd_list[idx].cmd, T(""));
		if (cmd[0]) {
			str = NULL;
			if(adsl_drv_set_cmd_list[idx].value != NULL) {
				str = websGetVar(wp, adsl_drv_set_cmd_list[idx].value, T(""));
			}
			
			if(!setAdslDrvInfo(adsl_drv_set_cmd_list[idx].cmd, str)) {
				snprintf(tmpBuf, 100, "Set %s error!", adsl_drv_set_cmd_list[idx].cmd);
				goto setErr_pass;
			}
		}

	}

	submitUrl = websGetVar(wp, T("submit-url"), T(""));   // hidden page
	OK_MSG(submitUrl);
  	return;

 setErr_pass:
	ERR_MSG(tmpBuf);	
}
#endif


void formSetAdslTone(webs_t wp, char_t *path, char_t *query)
{
	char_t *submitUrl;
	short mode;
	int i, chan;
	char tmpBuf[100];
	char_t *strVal;
	unsigned char tone[64];	  // Added by Mason Yu for correct Tone Mib Type
	char_t *strApply, *strMaskAll, *strUnmaskAll;
	
	memset(tone, 0, sizeof(tone));
	
	strApply = websGetVar(wp, T("apply"), T(""));
	strMaskAll = websGetVar(wp, T("maskAll"), T(""));
	strUnmaskAll = websGetVar(wp, T("unmaskAll"), T(""));
	
	
	// get the channel number
	mib_get(MIB_ADSL_MODE, (void *)&mode);
	if (mode & ADSL_MODE_ADSL2P)
		chan = 512;	// ADSL2+
	else
		chan = 256;	// ADSL, ADSL2
	
	if (strApply[0]) {		
		for (i=0; i<chan; i++) {
			snprintf(tmpBuf, 20, "select%d", i);
			strVal = websGetVar(wp, tmpBuf, T(""));
				
				if ( !gstrcmp(strVal, T("ON")) ) {
					//tone[i/8] = tone[i/8] | (1 << (i%8));
					tone[i/8] = (tone[i/8] << 1) | 1 ;
				}else {
					//tone[i/8] = tone[i/8] | (0 << (i%8));
					tone[i/8] = (tone[i/8] << 1) | 0 ;
				}
		}
//#ifdef APPLY_CHANGE
		// set Tone mask
		adsl_drv_get(RLCM_LOADCARRIERMASK, (void *)tone, GET_LOADCARRIERMASK_SIZE);
//#endif
		goto setOk_tone;	
	}



	if (strMaskAll[0]) {
		for (i=0; i<chan; i++) {
			//tone[i/8] = tone[i/8] | (1 << (i%8));	
			tone[i/8] = (tone[i/8] << 1) | 1 ;
		}
		goto setOk_tone;
	}
	
	
	if (strUnmaskAll[0]) {
		for (i=0; i<chan; i++) {
			//tone[i/8] = tone[i/8] | (0 << (i%8));
			tone[i/8] = (tone[i/8] << 1) | 0 ;
		}
		goto setOk_tone;
	}

setOk_tone:		

	if ( !mib_set(MIB_ADSL_TONE, (void *)tone) ) {							
		strcpy(tmpBuf, T("ERROR: Set ADSL Tone to MIB database failed."));
		goto setErr_tone;
	}

	unsigned char vChar;
#ifdef __CLOSE_INTERFACE_BEFORE_WRITE_
		/*to avoid the dead when wrriting the flash*/
		itfcfg("sar", 0);
		itfcfg("eth0", 0);
#ifdef WLAN_SUPPORT
		itfcfg("wlan0", 0);
#endif
#endif /*__CLOSE_INTERFACE_BEFORE_WRITE_*/
		mib_update(CURRENT_SETTING, CONFIG_MIB_ALL);

#ifdef __CLOSE_INTERFACE_BEFORE_WRITE_
		itfcfg("sar", 1);
		 itfcfg("eth0", 1);
#ifdef WLAN_SUPPORT
		vChar=0;
		mib_get( MIB_WLAN_DISABLED, (void *)&vChar);
		if( vChar==0 )	itfcfg("wlan0", 1);
#endif //WLAN_SUPPORT
#endif /*__CLOSE_INTERFACE_BEFORE_WRITE_*/
	
	submitUrl = websGetVar(wp, T("submit-url"), T(""));   // hidden page

	OK_MSG(submitUrl);

  	return;

setErr_tone:
	ERR_MSG(tmpBuf);
  	
}
//add by chenzhuoxin
#if 0
void formSetAdsl(webs_t wp, char_t *path, char_t *query)
{
	char_t *strVal = NULL;
	short adslMode = 0;
	
      printf("enter formsetadsl\n");
	strVal = websGetVar(wp, T("glite"), T(""));
	if ( 0 == strcmp(strVal,"on"))
		adslMode |= ADSL_MODE_GLITE;
	
	strVal = websGetVar(wp, T("gdmt"), T(""));
	if ( 0 == strcmp(strVal,"on"))
		adslMode |= ADSL_MODE_GDMT;
	
	strVal = websGetVar(wp, T("t1413"), T(""));
	if ( 0 == strcmp(strVal,"on"))		
		adslMode |= ADSL_MODE_T1413;
	
	strVal = websGetVar(wp, T("adsl2"), T(""));
	if ( 0 == strcmp(strVal,"on"))
		adslMode |= ADSL_MODE_ADSL2;
	
	strVal = websGetVar(wp, T("anxl"), T(""));
	if ( 0 == strcmp(strVal,"on"))		
		adslMode |= ADSL_MODE_ANXL;
	
	strVal = websGetVar(wp, T("adsl2p"), T(""));
	if ( 0 == strcmp(strVal,"on"))
		adslMode |= ADSL_MODE_ADSL2P;
	
	strVal = websGetVar(wp, T("anxm"), T(""));
	if ( 0 == strcmp(strVal,"on"))		
		adslMode |= ADSL_MODE_ANXM;

	printf("adslmode =%x\n",adslMode);

	/*
	 *add code by RTL
       */
        REDIRECTSUBMITURL;
	return ;
}

//ADSL init function
int init_dsl_page(int eid, webs_t wp, int argc, char_t **argv)
{
	short adslMode = 0;
	
	/*
	 *Add code by Realtek
	 */

	//Debug
	printf("enter init_adsl_page\n");
	adslMode = 0xfb;

	websWrite(wp, "glite_sw = %s;\n", (adslMode & ADSL_MODE_GLITE) ? "true" : "false");
	
	websWrite(wp, "gdmt_sw = %s;\n", (adslMode & ADSL_MODE_GDMT) ? "true" : "false");
	
	websWrite(wp, "t1413_sw = %s;\n", (adslMode & ADSL_MODE_T1413) ? "true" : "false");
	
	websWrite(wp, "adsl2_sw = %s;\n", (adslMode & ADSL_MODE_ADSL2) ? "true" : "false");
	
	websWrite(wp, "anxl_sw= %s;\n", (adslMode & ADSL_MODE_ANXL) ? "true" : "false");
	
	websWrite(wp, "adsl2p_sw = %s;\n", (adslMode & ADSL_MODE_ADSL2P) ? "true" : "false");
	
	websWrite(wp, "anxm_sw= %s;\n", (adslMode & ADSL_MODE_ANXM) ? "true" : "false");


	/*
	 *Add code by Realtek
	 */
	
	return 0;

}
#endif
#if 0
void formSetAdsl(webs_t wp, char_t *path, char_t *query)
{
	char_t *submitUrl;
	char_t *strVal;
	char_t olr;
	short mode;
	int xmode;
	
	mode=0;
	strVal = websGetVar(wp, T("glite"), T(""));
	if (strVal[0]=='1')
		mode |= ADSL_MODE_GLITE;
	strVal = websGetVar(wp, T("t1413"), T(""));
	if (strVal[0]=='1')
		mode |= ADSL_MODE_T1413;
	strVal = websGetVar(wp, T("gdmt"), T(""));
	if (strVal[0]=='1')
		mode |= ADSL_MODE_GDMT;
	strVal = websGetVar(wp, T("adsl2"), T(""));
	if (strVal[0]=='1')
		mode |= ADSL_MODE_ADSL2;
	strVal = websGetVar(wp, T("anxl"), T(""));
	if (strVal[0]=='1')
		mode |= ADSL_MODE_ANXL;
	strVal = websGetVar(wp, T("anxm"), T(""));
	if (strVal[0]=='1')
		mode |= ADSL_MODE_ANXM;
	strVal = websGetVar(wp, T("adsl2p"), T(""));
	if (strVal[0]=='1')
		mode |= ADSL_MODE_ADSL2P;
	
	mib_set(MIB_ADSL_MODE, (void *)&mode);
	
	// OLR type
	olr = 0;
	strVal = websGetVar(wp, T("bswap"), T(""));
	if (strVal[0]=='1')
		olr |= 1;
	
	strVal = websGetVar(wp, T("sra"), T(""));
	if (strVal[0]=='1')
		olr |= 2;
	
	mib_set(MIB_ADSL_OLR, (void *)&olr);

	unsigned char vChar;
#ifdef __CLOSE_INTERFACE_BEFORE_WRITE_
		/*to avoid the dead when wrriting the flash*/
		itfcfg("sar", 0);
		itfcfg("eth0", 0);
#ifdef WLAN_SUPPORT
		itfcfg("wlan0", 0);
#endif
#endif /*__CLOSE_INTERFACE_BEFORE_WRITE_*/
		mib_update(CURRENT_SETTING, CONFIG_MIB_ALL);

#ifdef __CLOSE_INTERFACE_BEFORE_WRITE_
		itfcfg("sar", 1);
		 itfcfg("eth0", 1);
#ifdef WLAN_SUPPORT
		vChar=0;
		mib_get( MIB_WLAN_DISABLED, (void *)&vChar);
		if( vChar==0 )	itfcfg("wlan0", 1);
#endif //WLAN_SUPPORT
#endif /*__CLOSE_INTERFACE_BEFORE_WRITE_*/


	//added by xlyue
//	syslog(LOG_INFO, "ADSL Setting -- ADSL_MODE: 0x%x, ADSL_ORL: 0x%x\n",mode,olr);

	
//#ifdef APPLY_CHANGE
	adsl_drv_get(RLCM_MODEM_RETRAIN, NULL, 0);
	xmode=0;
	if (mode & (ADSL_MODE_GLITE|ADSL_MODE_T1413|ADSL_MODE_GDMT))
		xmode |= 1;	// ADSL1
	if (mode & ADSL_MODE_ADSL2)
		xmode |= 2;	// ADSL2
	if (mode & ADSL_MODE_ADSL2P)
		xmode |= 4;	// ADSL2+
	adsl_drv_get(RLCM_SET_XDSL_MODE, (void *)&xmode, 4);

	xmode = mode & (ADSL_MODE_GLITE|ADSL_MODE_T1413|ADSL_MODE_GDMT);	//  1: ansi, 2: g.dmt, 8:g.lite
	adsl_drv_get(RLCM_SET_ADSL_MODE, (void *)&xmode, 4);	
	
	if (mode & ADSL_MODE_ANXL)	// Annex L
		xmode = 3; // Wide-Band & Narrow-Band Mode
	else
		xmode = 0;
	adsl_drv_get(RLCM_SET_ANNEX_L, (void *)&xmode, 4);
	
	if (mode & ADSL_MODE_ANXM)	// Annex M
		xmode = 1;
	else
		xmode = 0;
	adsl_drv_get(RLCM_SET_ANNEX_M, (void *)&xmode, 4);
	
	xmode = (int)olr;
	if (xmode == 2)// SRA (should include bitswap)
		xmode = 3;
	adsl_drv_get(RLCM_SET_OLR_TYPE, (void *)&xmode, 4);

//#endif
	submitUrl = websGetVar(wp, T("submit-url"), T(""));   // hidden page

	OK_MSG(submitUrl);

  	return;

}
#endif
void formDiagAdsl(webs_t wp, char_t *path, char_t *query)
{
	char_t *str, *submitUrl;
	int mode;

	str = websGetVar(wp, T("start"), T(""));
	// Display diagnostic messages
	websHeader(wp);
#if  defined(ZTE_531B_BRIDGE_SC) || defined(ZTE_GENERAL_ROUTER_SC)
	websWrite(wp, T("<META HTTP-EQUIV=Refresh CONTENT=\"180; URL=/adv/adsl-diag-ch.asp?act=1\">\n"));
#else
		websWrite(wp, T("<META HTTP-EQUIV=Refresh CONTENT=\"180; URL=/adv/adsl-diag.asp?act=1\">\n"));
#endif
   	websWrite(wp, T("<body><blockquote><br><br>\n"));
   	websWrite(wp, T("%s<br>\n"), Tadsl_diag_wait);
   	websWrite(wp, T("</blockquote></body>"));
   	websFooter(wp);
	websDone(wp, 200);
	
	if (str[0]) {
		// start diagnose here
		mode = 41;
		adsl_drv_get(RLCM_DEBUG_MODE, (void *)&mode, sizeof(int));
		adsl_drv_get(RLCM_MODEM_RETRAIN, NULL, 0);
	}
	//submitUrl = websGetVar(wp, T("submit-url"), T(""));
	//if (submitUrl[0])
	//	websRedirect(wp, submitUrl);
}

void formStatAdsl(webs_t wp, char_t *path, char_t *query)
{
	char_t *submitUrl;

	submitUrl = websGetVar(wp, T("submit-url"), T(""));
	if (submitUrl[0])
		websRedirect(wp, submitUrl);
}

#if 0
int adslDrvSnrTblGraph(int eid, webs_t wp, int argc, char_t **argv)
{
	short tbl[256];
	int len;
	short max, min;

	len = getAdslDrvSnrTbl((void *)tbl);
	if(len > 0) {
		int idx;
		int nBytesSent=0;

		max = Max(tbl, len);
		min = Min(tbl, len);

		nBytesSent += websWrite(wp, T("var test=screen.width; \n"));
		nBytesSent += websWrite(wp, T("var g = new Graph(400,300); \n"));

		nBytesSent += websWrite(wp, T("g.addRow(%d"), tbl[0]);
		for(idx=1;idx<len;idx++) {
			nBytesSent += websWrite(wp, T(",%d"), tbl[idx]);
		}

		nBytesSent += websWrite(wp, T("); \n"));


		if(min != max) {
			nBytesSent += websWrite(wp, T("g.scale = %d; \n"), (int) ((max - min)/4) );
		} else {
			nBytesSent += websWrite(wp, T("g.scale = 1; \n"));
		}

		nBytesSent += websWrite(wp, T("g.title = \"ADSL Channel SNR\"; \n"));
		nBytesSent += websWrite(wp, T("g.xLabel = \"Channel\"; \n"));
		nBytesSent += websWrite(wp, T("g.yLabel = \"SNR\"; \n"));
		nBytesSent += websWrite(wp, T("g.build(); \n"));

		return nBytesSent;
	}

	return 0;
}

int adslDrvSnrTblList(int eid, webs_t wp, int argc, char_t **argv)
{
	short tbl[256];
	int len;

	len = getAdslDrvSnrTbl((void *)tbl);
	if(len > 0) {
		int idx=0;
		int row, rowIdx;
		int nBytesSent=0;

		row = (int) (len - len%10)/10;

		for(rowIdx=0;rowIdx<row; rowIdx++) {
			if((rowIdx % 2) == 1)
				nBytesSent += websWrite(wp, T("<tr bgcolor=\"#EEEEEE\"> \n"));
			else			
				nBytesSent += websWrite(wp, T("<tr bgcolor=\"#DDDDDD\"> \n"));
			
			nBytesSent += websWrite(wp, T("<td width=20%%><font size=3><b>[%03d~%03d]</b></td>\n"), idx, (idx+10));
			nBytesSent += websWrite(wp, T("<td width=20%%><font size=3>%d</td>\n"), tbl[idx]); idx++;
			nBytesSent += websWrite(wp, T("<td width=20%%><font size=3>%d</td>\n"), tbl[idx]); idx++;
			nBytesSent += websWrite(wp, T("<td width=20%%><font size=3>%d</td>\n"), tbl[idx]); idx++;
			nBytesSent += websWrite(wp, T("<td width=20%%><font size=3>%d</td>\n"), tbl[idx]); idx++;
			nBytesSent += websWrite(wp, T("<td width=20%%><font size=3>%d</td>\n"), tbl[idx]); idx++;
			nBytesSent += websWrite(wp, T("<td width=20%%><font size=3>%d</td>\n"), tbl[idx]); idx++;
			nBytesSent += websWrite(wp, T("<td width=20%%><font size=3>%d</td>\n"), tbl[idx]); idx++;
			nBytesSent += websWrite(wp, T("<td width=20%%><font size=3>%d</td>\n"), tbl[idx]); idx++;
			nBytesSent += websWrite(wp, T("<td width=20%%><font size=3>%d</td>\n"), tbl[idx]); idx++;
			nBytesSent += websWrite(wp, T("<td width=20%%><font size=3>%d</td>\n"), tbl[idx]); idx++;
			nBytesSent += websWrite(wp, T("</tr> \n"));
		}

		if((rowIdx % 2) == 1)
			nBytesSent += websWrite(wp, T("<tr bgcolor=\"#EEEEEE\"> \n"));
		else			
			nBytesSent += websWrite(wp, T("<tr bgcolor=\"#DDDDDD\"> \n"));
		nBytesSent += websWrite(wp, T("<td width=20%%><font size=3><b>[%03d~%03d]</b></td>\n"), idx, (len-1));
		for(;idx<len;idx++) {
			nBytesSent += websWrite(wp, T("<td width=20%%><font size=3>%d</td>\n"), tbl[idx]);
		}
		nBytesSent += websWrite(wp, T("</tr> \n"));

		return nBytesSent;
	}

	return 0;
}

int adslDrvBitloadTblGraph(int eid, webs_t wp, int argc, char_t **argv)
{
	short tbl[256];
	int len;
	short max, min;

	len = getAdslDrvBitLoadTbl((void *)tbl);
		
	if(len > 0) {
		int idx;
		int nBytesSent=0;

		max = Max(tbl, len);
		min = Min(tbl, len);

		nBytesSent += websWrite(wp, T("var test=screen.width; \n"));
		nBytesSent += websWrite(wp, T("var g = new Graph(400,300); \n"));

		nBytesSent += websWrite(wp, T("g.addRow(%d"), tbl[0]);
		for(idx=1;idx<len;idx++) {
			nBytesSent += websWrite(wp, T(",%d"), tbl[idx]);
		}

		nBytesSent += websWrite(wp, T("); \n"));

		if(min != max) {
			nBytesSent += websWrite(wp, T("g.scale = %d; \n"), (int) ((max - min)/4) );
		} else {
			nBytesSent += websWrite(wp, T("g.scale = 1; \n"));
		}

		nBytesSent += websWrite(wp, T("g.title = \"ADSL Bit Loading\"; \n"));
		nBytesSent += websWrite(wp, T("g.xLabel = \"Channel\"; \n"));
		nBytesSent += websWrite(wp, T("g.yLabel = \"Bit Loading\"; \n"));
		nBytesSent += websWrite(wp, T("g.build(); \n"));

		return nBytesSent;
	}

	return 0;
}

int adslDrvBitloadTblList(int eid, webs_t wp, int argc, char_t **argv)
{
	short tbl[256];
	int len;

	len = getAdslDrvBitLoadTbl((void *)tbl);
	if(len > 0) {
		int idx=0;
		int row, rowIdx;
		int nBytesSent=0;

		row = (int) (len - len%10)/10;

		for(rowIdx=0;rowIdx<row; rowIdx++) {
			if((rowIdx % 2) == 1)
				nBytesSent += websWrite(wp, T("<tr bgcolor=\"#EEEEEE\"> \n"));
			else			
				nBytesSent += websWrite(wp, T("<tr bgcolor=\"#DDDDDD\"> \n"));
			
			nBytesSent += websWrite(wp, T("<td width=20%%><font size=3><b>[%03d~%03d]</b></td>\n"), idx, (idx+10));
			nBytesSent += websWrite(wp, T("<td width=20%%><font size=3>%d</td>\n"), tbl[idx]); idx++;
			nBytesSent += websWrite(wp, T("<td width=20%%><font size=3>%d</td>\n"), tbl[idx]); idx++;
			nBytesSent += websWrite(wp, T("<td width=20%%><font size=3>%d</td>\n"), tbl[idx]); idx++;
			nBytesSent += websWrite(wp, T("<td width=20%%><font size=3>%d</td>\n"), tbl[idx]); idx++;
			nBytesSent += websWrite(wp, T("<td width=20%%><font size=3>%d</td>\n"), tbl[idx]); idx++;
			nBytesSent += websWrite(wp, T("<td width=20%%><font size=3>%d</td>\n"), tbl[idx]); idx++;
			nBytesSent += websWrite(wp, T("<td width=20%%><font size=3>%d</td>\n"), tbl[idx]); idx++;
			nBytesSent += websWrite(wp, T("<td width=20%%><font size=3>%d</td>\n"), tbl[idx]); idx++;
			nBytesSent += websWrite(wp, T("<td width=20%%><font size=3>%d</td>\n"), tbl[idx]); idx++;
			nBytesSent += websWrite(wp, T("<td width=20%%><font size=3>%d</td>\n"), tbl[idx]); idx++;
			nBytesSent += websWrite(wp, T("</tr> \n"));
		}

		if((rowIdx % 2) == 1)
			nBytesSent += websWrite(wp, T("<tr bgcolor=\"#EEEEEE\"> \n"));
		else			
			nBytesSent += websWrite(wp, T("<tr bgcolor=\"#DDDDDD\"> \n"));
		nBytesSent += websWrite(wp, T("<td width=20%%><font size=3><b>[%03d~%03d]</b></td>\n"), idx, (len-1));
		for(;idx<len;idx++) {
			nBytesSent += websWrite(wp, T("<td width=20%%><font size=3>%d</td>\n"), tbl[idx]);
		}
		nBytesSent += websWrite(wp, T("</tr> \n"));

		return nBytesSent;
	}

	return 0;
}
#endif

int adslToneDiagTbl(int eid, webs_t wp, int argc, char_t **argv)
{
	char mode;
	static int chan=256;
	int nBytesSent=0;
	char str[16], hlin_ds[32], hlin_us[32];
	char latt_ds[16], latt_us[16], satt_ds[16], satt_us[16];
	char snr_ds[16], snr_us[16], attr_ds[16], attr_us[16];
	char txpw_ds[16], txpw_us[16];
	char *act;
	int ldstate;
	
	act = websGetVar(wp, T("act"), T(""));
	if (act && act[0]=='1') {
		adsl_drv_get(RLCM_GET_LD_STATE, (void *)&ldstate, 4);
		if (ldstate != 0)
			nBytesSent += websWrite(wp, T("<tr>\n<b><font color='green'>%s</b></tr>\n"), Tadsl_diag_suc);
		else
			nBytesSent += websWrite(wp, T("<tr>\n<b><font color='red'>%s</b></tr>\n"), Tadsl_diag_fail);
	}
	// get the channel number
	if(adsl_drv_get(RLCM_GET_SHOWTIME_XDSL_MODE, (void *)&mode, 1)) {
		if (mode < 5) //adsl1/adsl2
			chan = 256;
		else
			chan = 512;
	}

	nBytesSent += websWrite(wp, T("<tr bgcolor=#f0f0f0>\n<th align=left bgcolor=#c0c0c0 width=\"120\"></th>\n"));
	nBytesSent += websWrite(wp, T("<th width=\"100\"><font size=2>%s</th><th width=\"100\"><font size=2>%s</th>\n</tr>\n"), Tdownstream, Tupstream);

	#if 0
	nBytesSent += websWrite(wp, T("<tr bgcolor=#f0f0f0>\n<th align=left bgcolor=#c0c0c0>Number of SubCarrier</th>\n"));
	nBytesSent += websWrite(wp, T("<td align=center>%d</td>\n"), chan);
	nBytesSent += websWrite(wp, T("<td align=center>%d</td>\n</tr>\n"), chan);
	#endif

	//hlog = malloc(sizeof(short)*(chan*3+12));
	hlog = malloc(sizeof(short)*(MAX_DSL_TONE*3+12));
	//if (adsl_drv_get(RLCM_GET_DIAG_HLOG, (void *)hlog, sizeof(short)*(chan*3+12))) {
	if (adsl_drv_get(RLCM_GET_DIAG_HLOG, (void *)hlog, sizeof(short)*(MAX_DSL_TONE*3+12))) {
		// Hlinear scale
		snprintf(hlin_ds, 16, "%d", (unsigned short)hlog[chan*3+1]);
		snprintf(hlin_us, 16, "%d", (unsigned short)hlog[chan*3]);
		// loop Attenuation
		snprintf(latt_ds, 16, "%d.%d", hlog[chan*3+3]/10, abs(hlog[chan*3+3]%10));
		snprintf(latt_us, 16, "%d.%d", hlog[chan*3+2]/10, abs(hlog[chan*3+2]%10));
		// signal Attenuation
		snprintf(satt_ds, 16, "%d.%d", hlog[chan*3+5]/10, abs(hlog[chan*3+5]%10));
		snprintf(satt_us, 16, "%d.%d", hlog[chan*3+4]/10, abs(hlog[chan*3+4]%10));
		// SNR Margin
		snprintf(snr_ds, 16, "%d.%d", hlog[chan*3+7]/10, abs(hlog[chan*3+7]%10));
		snprintf(snr_us, 16, "%d.%d", hlog[chan*3+6]/10, abs(hlog[chan*3+6]%10));
		// Attainable Rate
		snprintf(attr_ds, 16, "%d", hlog[chan*3+9]);
		snprintf(attr_us, 16, "%d", hlog[chan*3+8]);
		// tx power
		snprintf(txpw_ds, 16, "%d.%d", hlog[chan*3+11]/10, abs(hlog[chan*3+11]%10));
		snprintf(txpw_us, 16, "%d.%d", hlog[chan*3+10]/10, abs(hlog[chan*3+10]%10));
	}
	else {
		hlin_ds[0] = hlin_us[0] = latt_ds[0] = latt_us[0] = 0;
		satt_ds[0] = satt_us[0] = snr_ds[0] = snr_us[0] = 0;
		attr_ds[0] = attr_us[0] = txpw_ds[0] = txpw_us[0] = 0;
	}
		
	nBytesSent += websWrite(wp, T("<tr bgcolor=#f0f0f0>\n<th align=left bgcolor=#c0c0c0><font size=2>%s</th>\n"), Thlin_scale);
	nBytesSent += websWrite(wp, T("<td align=center><font size=2>%s</font></td>\n"), hlin_ds);
	nBytesSent += websWrite(wp, T("<td align=center><font size=2>%s</font></td>\n</tr>\n"), hlin_us);
	
	nBytesSent += websWrite(wp, T("<tr bgcolor=#f0f0f0>\n<th align=left bgcolor=#c0c0c0><font size=2>%s(dB)</th>\n"), Tloop_annu);
	nBytesSent += websWrite(wp, T("<td align=center><font size=2>%s</font></td>\n"), latt_ds);
	nBytesSent += websWrite(wp, T("<td align=center><font size=2>%s</font></td>\n</tr>\n"), latt_us);
	
	nBytesSent += websWrite(wp, T("<tr bgcolor=#f0f0f0>\n<th align=left bgcolor=#c0c0c0><font size=2>%s(dB)</th>\n"), Tsig_annu);
	nBytesSent += websWrite(wp, T("<td align=center><font size=2>%s</font></td>\n"), satt_ds);
	nBytesSent += websWrite(wp, T("<td align=center><font size=2>%s</font></td>\n</tr>\n"), satt_us);
	
	nBytesSent += websWrite(wp, T("<tr bgcolor=#f0f0f0>\n<th align=left bgcolor=#c0c0c0><font size=2>%s(dB)</th>\n"), Tsnr_marg);
	nBytesSent += websWrite(wp, T("<td align=center><font size=2>%s</font></td>\n"), snr_ds);
	nBytesSent += websWrite(wp, T("<td align=center><font size=2>%s</font></td>\n</tr>\n"), snr_us);
	
	nBytesSent += websWrite(wp, T("<tr bgcolor=#f0f0f0>\n<th align=left bgcolor=#c0c0c0><font size=2>%s(Kbps)</th>\n"), Tattain_rate);
	nBytesSent += websWrite(wp, T("<td align=center><font size=2>%s</font></td>\n"), attr_ds);
	nBytesSent += websWrite(wp, T("<td align=center><font size=2>%s</font></td>\n</tr>\n"), attr_us);
	
	nBytesSent += websWrite(wp, T("<tr bgcolor=#f0f0f0>\n<th align=left bgcolor=#c0c0c0><font size=2>%s(dBm)</th>\n"), Tout_power);
	nBytesSent += websWrite(wp, T("<td align=center><font size=2>%s</font></td>\n"), txpw_ds);
	nBytesSent += websWrite(wp, T("<td align=center><font size=2>%s</font></td>\n</tr>\n"), txpw_us);
	free(hlog);
	
	return nBytesSent;
}
	
int adslToneDiagList(int eid, webs_t wp, int argc, char_t **argv)
{
	char mode;
	static int chan=256;
	int i;
	int nBytesSent=0;
	int ival, intp, fp;
	char str[16];
	
	// get the channel number
	if(adsl_drv_get(RLCM_GET_SHOWTIME_XDSL_MODE, (void *)&mode, 1)) {
		if (mode < 5) //adsl1/adsl2
			chan = 256;
		else
			chan = 512;
	}
	
	intp=fp=0;
	str[0] = 0;
	
	/*
	snr = malloc(sizeof(short)*chan);
	qln = malloc(sizeof(short)*chan);
	hlog = malloc(sizeof(short)*(chan*3+12));
	*/
	snr = malloc(sizeof(short)*MAX_DSL_TONE);
	qln = malloc(sizeof(short)*MAX_DSL_TONE);
	hlog = malloc(sizeof(short)*(MAX_DSL_TONE*3+12));
	
	/*
	if (adsl_drv_get(RLCM_GET_DIAG_HLOG, (void *)hlog, sizeof(short)*(chan*3+12))) {
		adsl_drv_get(RLCM_GET_DIAG_SNR, (void *)snr, sizeof(short)*chan);
		adsl_drv_get(RLCM_GET_DIAG_QLN, (void *)qln, sizeof(short)*chan);
		diagflag = 1;
	}
	*/
	if (adsl_drv_get(RLCM_GET_DIAG_HLOG, (void *)hlog, sizeof(short)*(MAX_DSL_TONE*3+12))) {
		adsl_drv_get(RLCM_GET_DIAG_SNR, (void *)snr, sizeof(short)*MAX_DSL_TONE);
		adsl_drv_get(RLCM_GET_DIAG_QLN, (void *)qln, sizeof(short)*MAX_DSL_TONE);
		diagflag = 1;
	}
	else
		diagflag = 0;
	
	nBytesSent += websWrite(wp, T("<tr>\n<th width=15%% bgcolor=#c0c0c0><font size=2>%s</font></th>\n"), Ttone_num);
	nBytesSent += websWrite(wp, T("<th width=15%% bgcolor=#c0c0c0><font size=2>H.Real</font></th>\n"));
	nBytesSent += websWrite(wp, T("<th width=15%% bgcolor=#c0c0c0><font size=2>H.Image</font></th>\n"));
	nBytesSent += websWrite(wp, T("<th width=15%% bgcolor=#c0c0c0><font size=2>SNR</font></th>\n"));
	nBytesSent += websWrite(wp, T("<th width=15%% bgcolor=#c0c0c0><font size=2>QLN</font></th>\n"));
	nBytesSent += websWrite(wp, T("<th width=15%% bgcolor=#c0c0c0><font size=2>Hlog</font></th>\n</tr>\n"));
	
	for (i = 0; i < chan; i++) {
		
		nBytesSent += websWrite(wp, T("<tr>\n<th bgcolor=#c0c0c0><font size=2>%d</font></th>\n"), i);
		// H.Real = H.Real*Hlin.Scale/32768
		if (diagflag) {
			/*
			if (i <= 31) { // upstream
				fp=(hlog[i+chan]*hlog[chan*3]*100)/32768;
			}
			else { // downstream
				fp=(hlog[i+chan]*hlog[chan*3+1]*100)/32768;
			}
			*/
			intp = hlog[i+chan]/1000;
			fp = abs(hlog[i+chan]%1000);
			if (fp<0) {
				fp = -fp;
				if (intp == 0)
					snprintf(str, 16, "-0.%03d", fp);
				else
					snprintf(str, 16, "%d.%03d", intp, fp);
			}
			else
				snprintf(str, 16, "%d.%03d", intp, fp);
		}
		
		nBytesSent += websWrite(wp, T("<td align=center bgcolor=#f0f0f0><font size=2>%s</font></td>\n"), str);
		// H.Image = H.Image*Hlin.Scale/32768
		if (diagflag) {
			/*
			if (i <= 31) { // upstream
				fp=(hlog[i+chan*2]*hlog[chan*3]*100)/32768;
			}
			else { // downstream
				fp=(hlog[i+chan*2]*hlog[chan*3+1]*100)/32768;
			}
			*/
			intp = hlog[i+chan*2]/1000;
			fp = abs(hlog[i+chan*2]%1000);
			if (fp<0) {
				fp = -fp;
				if (intp == 0)
					snprintf(str, 16, "-0.%03d", fp);
				else
					snprintf(str, 16, "%d.%03d", intp, fp);
			}
			else
				snprintf(str, 16, "%d.%03d", intp, fp);
		}
		
		nBytesSent += websWrite(wp, T("<td align=center bgcolor=#f0f0f0><font size=2>%s</font></td>\n"), str);
		//nBytesSent += websWrite(wp, T("<td align=center bgcolor=#f0f0f0>%d</td>\n"), 0);
		// snr = -32+(snr/2)
		if (diagflag) {
			/*
			ival = snr[i] * 5; // *10/2
			intp = ival/10-32;
			fp = ival % 10;
			*/
			intp = snr[i]/10;
			fp = abs(snr[i]%10);
			snprintf(str, 16, "%d.%d", intp, fp);
		}
		nBytesSent += websWrite(wp, T("<td align=center bgcolor=#f0f0f0><font size=2>%s</font></td>\n"), str);
		// qln = -23-(qln/2)
		if (diagflag) {
			/*
			ival = qln[i] * 5;
			intp = ival/10+23;
			fp = ival % 10;
			*/
			intp = qln[i]/10;
			fp = abs(qln[i]%10);
			if (fp<0) {
				if (intp != 0)
					snprintf(str, 16, "%d.%d", intp, -fp);
				else
					snprintf(str, 16, "-%d.%d", intp, -fp);
			}
			else
				snprintf(str, 16, "%d.%d", intp, fp);
		}
		nBytesSent += websWrite(wp, T("<td align=center bgcolor=#f0f0f0><font size=2>%s</font></td>\n"), str);
		// hlog = 6-(hlog/10)
		if (diagflag) {
			/*
			ival = hlog[i]/10;
			if (ival >= 6) {// negative value
				intp = ival - 6;
				fp = hlog[i] % 10;
				nBytesSent += websWrite(wp, T("<td align=center bgcolor=#f0f0f0>-%d.%d</td>\n</tr>\n"), intp, fp);
			}
			else { //positive value
				intp = 6- ival;
				ival = hlog[i] % 10;
				if (ival != 0)
					intp--;
				fp = 10 - ival;
				nBytesSent += websWrite(wp, T("<td align=center bgcolor=#f0f0f0>%d.%d</td>\n</tr>\n"), intp, fp);
			}
			*/
			intp = hlog[i]/10;
			fp = abs(hlog[i]%10);
			if (fp<0) {
				if (intp != 0)
					snprintf(str, 16, "%d.%d", intp, -fp);
				else
					snprintf(str, 16, "-%d.%d", intp, -fp);
			}
			else
				snprintf(str, 16, "%d.%d", intp, fp);
		}
		/*
		else
			nBytesSent += websWrite(wp, T("<td align=center bgcolor=#f0f0f0>%d.%d</td>\n</tr>\n"), intp, fp);
		*/
		nBytesSent += websWrite(wp, T("<td align=center bgcolor=#f0f0f0><font size=2>%s</font></td>\n</tr>\n"), str);
	}
	
	free(snr);
	free(qln);
	free(hlog);
	
	return nBytesSent;
}


int adslToneConfDiagList(int eid, webs_t wp, int argc, char_t **argv)
{
	short mode;
	int i, chan;
	int nBytesSent=0;
	unsigned char tone[64];    // Added by Mason Yu for correct Tone Mib Type
	int onbit;
	
	
	memset(tone, 0, sizeof(tone));
	
	// get the channel number
	mib_get(MIB_ADSL_MODE, (void *)&mode);
	if (mode & ADSL_MODE_ADSL2P)
		chan = 512;	// ADSL2+
	else
		chan = 256;	// ADSL, ADSL2

	if ( !mib_get(MIB_ADSL_TONE, (void *)tone)) {
		printf(strGetToneerror);		
	}

	nBytesSent += websWrite(wp, T("<tr>\n<th width=25%% bgcolor=#c0c0c0>%s</th>\n"),TDiag_adslTone_ToneNo);
	nBytesSent += websWrite(wp, T("<td align=center width=\"20%%\" bgcolor=\"#808080\"><font size=\"2\"><b>%s</b></font></td></tr>\n"),TDiag_adslTone_Select);
	
	
	
	for (i = 0; i < chan; i++) {
		//onbit =(tone[i/8] >> (i%8) ) & 0x01;
		onbit =(tone[i/8] >> (7-(i%8)) ) & 0x01;	
		
		nBytesSent += websWrite(wp, T("<tr>\n<th bgcolor=#c0c0c0>%d</th>\n"), i);			
		if (onbit == 1)
			nBytesSent += websWrite(wp, T("<td align=center width=\"20%%\" bgcolor=\"#C0C0C0\"><input type=\"checkbox\" name=\"select%d\" value=\"ON\" checked></td></tr>\n"), i);		
		else 
			nBytesSent += websWrite(wp, T("<td align=center width=\"20%%\" bgcolor=\"#C0C0C0\"><input type=\"checkbox\" name=\"select%d\" value=\"ON\"></td></tr>\n"), i);		
		
	}
	
	return nBytesSent;
}

/////////////////////////////////////////////////////////////////////////////
void formStats(webs_t wp, char_t *path, char_t *query)
{
	char_t *submitUrl;

	submitUrl = websGetVar(wp, T("submit-url"), T(""));   // hidden page

	if (submitUrl[0])
		websRedirect(wp, submitUrl);
}

static char *get_name(char *name, char *p)
{
    while (isspace(*p))
	p++;
    while (*p) {
	if (isspace(*p))
	    break;
	if (*p == ':') {	/* could be an alias */
	    char *dot = p, *dotname = name;
	    *name++ = *p++;
	    while (isdigit(*p))
		*name++ = *p++;
	    if (*p != ':') {	/* it wasn't, backup */
		p = dot;
		name = dotname;
	    }
	    if (*p == '\0')
		return NULL;
	    p++;
	    break;
	}
	*name++ = *p++;
    }
    *name++ = '\0';
    return p;
}

// Dump the Memory usage
int memDump(int eid, webs_t wp, int argc, char_t **argv)
{
	struct sysinfo info;
	
	sysinfo(&info);
	info.mem_unit*=1024;
	info.totalram/=info.mem_unit;
	info.freeram/=info.mem_unit;
	
	websWrite(wp, T("<font size=2><b>Memory Usage:\n"));
	websWrite(wp, T("<br>Total: %13ld kB&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Free: %13ld kB\n"),
		info.totalram, info.freeram);
	return 0;
}
#if 0
// List the packet statistics for all interfaces at web page.
int pktStatsList(int eid, webs_t wp, int argc, char_t **argv)
{
	FILE *fh;
#if defined(CTC_WAN_NAME)
	//ql_xu add: for auto generate wan name
	FILE *fp;
	int entryNum;
	int mibcnt;
	MIB_CE_ATM_VC_T Entry;
#endif
#ifdef EMBED
	int skfd, i;
	struct atmif_sioc mysio;
	struct SAR_IOCTL_CFG cfg;
	struct ch_stat stat;
#endif
	char buf[512];
	unsigned long rx_pkt, rx_err, rx_drop, tx_pkt, tx_err, tx_drop;
	//add by liuxiao 2008-01-29
	unsigned long rx_byte, tx_byte;
	//add end by liuxiao 2008-01-29
	
#ifdef CTC_WAN_NAME
	entryNum = mib_chain_total(MIB_ATM_VC_TBL);
#endif
#if defined(ZTE_531B_BRIDGE_SC) || defined(ZTE_GENERAL_ROUTER_SC)
	//add and modify by liuxiao 2008-01-29
	/*websWrite(wp, T("<tr><font size=1>"
	"<td align=center width=\"10%%\" bgcolor=\"#808080\"><font size=2>%s</td>\n"
	"<td align=center width=\"15%%\" bgcolor=\"#808080\"><font size=2>%s</td>\n"
	"<td align=center width=\"15%%\" bgcolor=\"#808080\"><font size=2>%s</td>\n"
	"<td align=center width=\"15%%\" bgcolor=\"#808080\"><font size=2>%s</td>\n"
	"<td align=center width=\"15%%\" bgcolor=\"#808080\"><font size=2>%s</td>\n"
	"<td align=center width=\"15%%\" bgcolor=\"#808080\"><font size=2>%s</td>\n"
	"<td align=center width=\"15%%\" bgcolor=\"#808080\"><font size=2>%s</td></font></tr>\n"),
	TStat_portStat_Interface,
	TStat_portStat_Rxpkt,TStat_portStat_Rxerr,TStat_portStat_Rxdrop,
	TStat_portStat_Txpkt,TStat_portStat_Txerr,TStat_portStat_Txdrop);*/
	websWrite(wp, T("<tr class=\"hdb\"><td align=\"center\" width=\"20%%\">%s</td>\n"
	"<td align=\"center\" colspan=\"4\">%s</td>\n"
	"<td align=\"center\" colspan=\"4\">%s</td></tr>\n"
	"<tr class=\"hdb\"><td>&nbsp;</td>\n"
	"<td>%s</td><td>%s</td><td>%s</td><td>%s</td>\n"
	"<td>%s</td><td>%s</td><td>%s</td><td>%s</td></tr>\n"),
	TStat_portStat_Interface,
	TStat_portStat_Rx,TStat_portStat_Tx,
	TStat_portStat_Byte,TStat_portStat_Pkt,TStat_portStat_Err,TStat_portStat_Drop,
	TStat_portStat_Byte,TStat_portStat_Pkt,TStat_portStat_Err,TStat_portStat_Drop);
	//add and modify end by liuxiao 2008-01-29
#else
websWrite(wp, T("<tr><font size=1>"
	"<td align=center width=\"8%%\" bgcolor=\"#808080\">Interface</td>\n"
	"<td align=center width=\"15%%\" bgcolor=\"#808080\">Rx pkt</td>\n"
	"<td align=center width=\"8%%\" bgcolor=\"#808080\">Rx err</td>\n"
	"<td align=center width=\"8%%\" bgcolor=\"#808080\">Rx drop</td>\n"
	"<td align=center width=\"15%%\" bgcolor=\"#808080\">Tx pkt</td>\n"
	"<td align=center width=\"8%%\" bgcolor=\"#808080\">Tx err</td>\n"
	"<td align=center width=\"8%%\" bgcolor=\"#808080\">Tx drop</td></font></tr>\n"),
	TStat_portStat_Interface,
	TStat_portStat_Rxpkt,TStat_portStat_Rxerr,TStat_portStat_Rxdrop,
	TStat_portStat_Txpkt,TStat_portStat_Txerr,TStat_portStat_Txdrop);

#endif
	// Ethernet statistics
	fh = fopen(_PATH_PROCNET_DEV, "r");
	if (!fh) {
		fprintf(stderr, "Warning: cannot open %s (%s).\n",
			_PATH_PROCNET_DEV, strerror(errno));
		return;
	}
	fgets(buf, sizeof buf, fh);	/* eat line */
	fgets(buf, sizeof buf, fh);
	while (fgets(buf, sizeof buf, fh)) {
		char *s, name[IFNAMSIZ];
		int islan;
		s = get_name(name, buf);    
		islan=0;
		if (!strcmp("eth0", name)) {
			//add and modify liuxiao 2008-01-29
			/*sscanf(s,
			"%*lu %lu %lu %lu %*lu %*lu %*lu %*lu %*lu %lu %lu %lu %*lu %*lu %*lu %*lu",
			&rx_pkt, &rx_err, &rx_drop, &tx_pkt, &tx_err, &tx_drop);*/
			sscanf(s,
			"%lu %lu %lu %lu %*lu %*lu %*lu %*lu %lu %lu %lu %lu %*lu %*lu %*lu %*lu",
			&rx_byte, &rx_pkt, &rx_err, &rx_drop, &tx_byte, &tx_pkt, &tx_err, &tx_drop);
			//add and modify end by liuxiao 2008-01-29
			islan=1;
			//add and modify liuxiao 2008-01-29
			/*websWrite(wp, T("<tr><td align=center width=\"8%%\" "
				"bgcolor=\"#C0C0C0\"><font size=\"2\"><b>eth0</b></font></td>\n"));*/
			websWrite(wp, T("<tr><td class=\"hdb\">Ethernet</td>\n"));
			//add and modify end by liuxiao 2008-01-29
		}
//modify by liuxiao 2008-01-30
#if 0
#ifdef WLAN_SUPPORT
		else if (!strcmp("wlan0", name)) {
			if (wlan_is_up()) {
				//add and modify liuxiao 2008-01-29
				/*sscanf(s,
				"%*lu %lu %lu %lu %*lu %*lu %*lu %*lu %*lu %lu %lu %lu %*lu %*lu %*lu %*lu",
				&rx_pkt, &rx_err, &rx_drop, &tx_pkt, &tx_err, &tx_drop);*/
				sscanf(s,
				"%lu %lu %lu %lu %*lu %*lu %*lu %*lu %lu %lu %lu %lu %*lu %*lu %*lu %*lu",
				&rx_byte, &rx_pkt, &rx_err, &rx_drop, &tx_byte, &tx_pkt, &tx_err, &tx_drop);
				//add and modify end by liuxiao 2008-01-29
				islan=1;
				//add and modify liuxiao 2008-01-29
				/*websWrite(wp, T("<tr><td align=center width=\"8%%\" "
					"bgcolor=\"#C0C0C0\"><font size=\"2\"><b>wlan0</b></font></td>\n"));*/
				websWrite(wp, T("<tr><td class=\"hdb\">Wireless</td>\n"));
				//add and modify end by liuxiao 2008-01-29
			};
		}
#endif
#endif
//modify by liuxiao 2008-01-30
		if (islan)
			//add and modify liuxiao 2008-01-29
			/*websWrite(wp, T(
			"<td align=center width=\"15%%\" bgcolor=\"#C0C0C0\"><font size=\"2\"><b>%lu</b></font></td>\n"
			"<td align=center width=\"8%%\" bgcolor=\"#C0C0C0\"><font size=\"2\"><b>%lu</b></font></td>\n"
			"<td align=center width=\"8%%\" bgcolor=\"#C0C0C0\"><font size=\"2\"><b>%lu</b></font></td>\n"
			"<td align=center width=\"15%%\" bgcolor=\"#C0C0C0\"><font size=\"2\"><b>%lu</b></font></td>\n"
			"<td align=center width=\"8%%\" bgcolor=\"#C0C0C0\"><font size=\"2\"><b>%lu</b></font></td>\n"
			"<td align=center width=\"8%%\" bgcolor=\"#C0C0C0\"><font size=\"2\"><b>%lu</b></font></td></tr>\n"),
			rx_pkt, rx_err, rx_drop, tx_pkt, tx_err, tx_drop);*/
			websWrite(wp, T(
			"<td>%lu</td><td>%lu</td><td>%lu</td><td>%lu</td>\n"
			"<td>%lu</td><td>%lu</td><td>%lu</td><td>%lu</td></tr>\n"),
			rx_byte, rx_pkt, rx_err, rx_drop, tx_byte, tx_pkt, tx_err, tx_drop);
			//add and modify liuxiao 2008-01-29
	}
	
	fclose(fh);
	
#if 0	//add by liuxiao 2008-01-29
#ifdef EMBED
	// pvc statistics
	if((skfd = socket(PF_ATMPVC, SOCK_DGRAM, 0)) < 0){
		perror("socket open error");
		return;
	}
	
	mysio.number = 0;

	for (i=0; i < MAX_VC_NUM; i++)
	{
		
		cfg.ch_no = i;
		mysio.arg = (void *)&cfg;
		if(ioctl(skfd, ATM_SAR_GETSTAT, &mysio)<0)
		{
			(void)close(skfd);
			return;
		}

		if (cfg.created == 0)
			continue;	

#ifdef CTC_WAN_NAME
		//check mib chain to see the channel mode of the current channel.
		int found=0;
		for(mibcnt=0; mibcnt<entryNum; mibcnt++)
		{
			if (!mib_chain_get(MIB_ATM_VC_TBL, mibcnt, (void *)&Entry))
			{
				printf("get MIB chain error\n");
				continue;
			}
			
			if(Entry.enable==0)
				continue;
			
			if(Entry.vpi==cfg.vpi && Entry.vci==cfg.vci)
			{
				//found entry in mibs, get channel mode
				cfg.rfc = Entry.cmode;
				{
					char applicationname[30];
					char username[MAX_NAME_LEN];
					char password[MAX_NAME_LEN];
					char interfacename[MAX_NAME_LEN];
					char pppIdx=0;
#ifdef _CWMP_MIB_ 
					char setname[30];
					memset(setname, 0, 30);
#endif
					memset(applicationname, 0, sizeof(applicationname));
					memset(interfacename, 0, sizeof(interfacename));
					if(cfg.rfc == ADSL_BR1483)
					{
						//bridge mode
#ifdef _CWMP_MIB_ 
						if(*(Entry.WanName))
							strcpy(setname, Entry.WanName);
#endif
						setWanName(applicationname, Entry.applicationtype);
						strcat(applicationname, "B_");
					} 
					else { 
						if(cfg.rfc == ADSL_PPPoE || cfg.rfc == ADSL_PPPoA )
						{
#ifdef _CWMP_MIB_ 
							if(*(Entry.WanName))
								strcpy(setname, Entry.WanName);
#endif
							snprintf(interfacename, 6, "ppp%u", PPP_INDEX(Entry.ifIndex));
							fh = fopen(_PATH_PROCNET_DEV, "r");
							if (!fh) {
										fprintf(stderr, "Warning: cannot open %s (%s).\n",
											_PATH_PROCNET_DEV, strerror(errno));
										return;
							}
							fgets(buf, sizeof buf, fh);	/* eat line */
							fgets(buf, sizeof buf, fh);
							while (fgets(buf, sizeof buf, fh)) {
										char *s, ifName[IFNAMSIZ];
										char name[30];
										
										s = get_name(name, buf);    
										if (!strcmp(interfacename, name)) {
											sscanf(s,
												"%*lu %lu %lu %lu %*lu %*lu %*lu %*lu %*lu %lu %lu %lu %*lu %*lu %*lu %*lu",
												&rx_pkt, &rx_err, &rx_drop, &tx_pkt, &tx_err, &tx_drop);

											//display
											memset(ifName, 0, 30);
											getWanName(&Entry,ifName);
#ifdef _CWMP_MIB_
											if(*setname)
												strcpy(ifName, setname);
#endif
											websWrite(wp, T("<tr>"
												"<td align=center width=\"8%%\" bgcolor=\"#C0C0C0\"><font size=\"2\"><b>%s</b></font></td>\n"
												"<td align=center width=\"15%%\" bgcolor=\"#C0C0C0\"><font size=\"2\"><b>%lu</b></font></td>\n"
												"<td align=center width=\"8%%\" bgcolor=\"#C0C0C0\"><font size=\"2\"><b>%lu</b></font></td>\n"
												"<td align=center width=\"8%%\" bgcolor=\"#C0C0C0\"><font size=\"2\"><b>%lu</b></font></td>\n"
												"<td align=center width=\"15%%\" bgcolor=\"#C0C0C0\"><font size=\"2\"><b>%lu</b></font></td>\n"
												"<td align=center width=\"8%%\" bgcolor=\"#C0C0C0\"><font size=\"2\"><b>%lu</b></font></td>\n"
												"<td align=center width=\"8%%\" bgcolor=\"#C0C0C0\"><font size=\"2\"><b>%lu</b></font></td></tr>\n"),
												ifName, rx_pkt, rx_err, rx_drop, tx_pkt, tx_err, tx_drop);
										}
							}		
							fclose(fh);
							found++;
							continue;
						} else {	//rt1483 rt1577
#ifdef _CWMP_MIB_ 
							if(*(Entry.WanName))
								strcpy(setname, Entry.WanName);
#endif
							setWanName(applicationname, Entry.applicationtype);
						}
						strcat(applicationname, "R_");
					}
					sprintf(applicationname, "%s%d_%d", applicationname, cfg.vpi, cfg.vci);
#ifdef _CWMP_MIB_ 
					if(*setname)
						strcpy(applicationname, setname);
#endif
				
					websWrite(wp, T("<tr>"
						"<td align=center width=\"8%%\" bgcolor=\"#C0C0C0\"><font size=\"2\"><b>%s</b></font></td>\n"
						"<td align=center width=\"15%%\" bgcolor=\"#C0C0C0\"><font size=\"2\"><b>%lu</b></font></td>\n"
						"<td align=center width=\"8%%\" bgcolor=\"#C0C0C0\"><font size=\"2\"><b>%lu</b></font></td>\n"
						"<td align=center width=\"8%%\" bgcolor=\"#C0C0C0\"><font size=\"2\"><b>%lu</b></font></td>\n"
						"<td align=center width=\"15%%\" bgcolor=\"#C0C0C0\"><font size=\"2\"><b>%lu</b></font></td>\n"
						"<td align=center width=\"8%%\" bgcolor=\"#C0C0C0\"><font size=\"2\"><b>%lu</b></font></td>\n"
						"<td align=center width=\"8%%\" bgcolor=\"#C0C0C0\"><font size=\"2\"><b>%lu</b></font></td></tr>\n"),
						applicationname, cfg.stat.rx_pkt_cnt, cfg.stat.rx_pkt_fail,
						cfg.stat.rx_crc_error, cfg.stat.tx_desc_ok_cnt,
						cfg.stat.tx_pkt_fail_cnt, cfg.stat.send_desc_lack);
					found++;
					break;
				}
			}
		}
		if(found==0)
		{
			printf("in pktStatsList: not found mib entry for this interface\n");
			//set to default application name....
		}
		
		
#else
		websWrite(wp, T("<tr>"
		"<td align=center width=\"8%%\" bgcolor=\"#C0C0C0\"><font size=\"2\"><b>Internet_B_%u_%u</b></font></td>\n"
		"<td align=center width=\"15%%\" bgcolor=\"#C0C0C0\"><font size=\"2\"><b>%lu</b></font></td>\n"
		"<td align=center width=\"8%%\" bgcolor=\"#C0C0C0\"><font size=\"2\"><b>%lu</b></font></td>\n"
		"<td align=center width=\"8%%\" bgcolor=\"#C0C0C0\"><font size=\"2\"><b>%lu</b></font></td>\n"
		"<td align=center width=\"15%%\" bgcolor=\"#C0C0C0\"><font size=\"2\"><b>%lu</b></font></td>\n"
		"<td align=center width=\"8%%\" bgcolor=\"#C0C0C0\"><font size=\"2\"><b>%lu</b></font></td>\n"
		"<td align=center width=\"8%%\" bgcolor=\"#C0C0C0\"><font size=\"2\"><b>%lu</b></font></td></tr>\n"),
		cfg.vpi, cfg.vci, cfg.stat.rx_pkt_cnt, cfg.stat.rx_pkt_fail,
		cfg.stat.rx_crc_error, cfg.stat.tx_desc_ok_cnt,
		cfg.stat.tx_pkt_fail_cnt, cfg.stat.send_desc_lack);
#endif
	}
	(void)close(skfd);
#endif
	return 0;
#endif	//add by liuxiao 2008-01-29
}
#endif
/////////////////////////////////////////////////////////////////////////////
//add by liuxiao 2008-01-30	
// List the packet statistics for wlan at web page.
#ifdef WLAN_SUPPORT
#if 0
int wlStatsList(int eid, webs_t wp, int argc, char_t **argv)
{
	FILE *fh;
	char buf[512];
	unsigned long rx_pkt, rx_err, rx_drop, tx_pkt, tx_err, tx_drop;
	//add by liuxiao 2008-01-29
	unsigned long rx_byte, tx_byte;
	//add end by liuxiao 2008-01-29
	
	websWrite(wp, T("<tr class=\"hdb\"><td align=\"center\" width=\"20%%\">%s</td>\n"
	"<td align=\"center\" colspan=\"4\">%s</td>\n"
	"<td align=\"center\" colspan=\"4\">%s</td></tr>\n"
	"<tr class=\"hdb\"><td>&nbsp;</td>\n"
	"<td>%s</td><td>%s</td><td>%s</td><td>%s</td>\n"
	"<td>%s</td><td>%s</td><td>%s</td><td>%s</td></tr>\n"),
	TStat_portStat_Interface,
	TStat_portStat_Rx,TStat_portStat_Tx,
	TStat_portStat_Byte,TStat_portStat_Pkt,TStat_portStat_Err,TStat_portStat_Drop,
	TStat_portStat_Byte,TStat_portStat_Pkt,TStat_portStat_Err,TStat_portStat_Drop);
	//add and modify end by liuxiao 2008-01-29

	// Ethernet statistics
	fh = fopen(_PATH_PROCNET_DEV, "r");
	if (!fh) {
		fprintf(stderr, "Warning: cannot open %s (%s).\n",
			_PATH_PROCNET_DEV, strerror(errno));
		return;
	}
	fgets(buf, sizeof buf, fh);	/* eat line */
	fgets(buf, sizeof buf, fh);
	while (fgets(buf, sizeof buf, fh)) {
		char *s, name[IFNAMSIZ];
		int islan;
		s = get_name(name, buf);    
		islan=0;
		if (!strcmp("wlan0", name)) {
			if (wlan_is_up()) {
				//add and modify liuxiao 2008-01-29
				/*sscanf(s,
				"%*lu %lu %lu %lu %*lu %*lu %*lu %*lu %*lu %lu %lu %lu %*lu %*lu %*lu %*lu",
				&rx_pkt, &rx_err, &rx_drop, &tx_pkt, &tx_err, &tx_drop);*/
				sscanf(s,
				"%lu %lu %lu %lu %*lu %*lu %*lu %*lu %lu %lu %lu %lu %*lu %*lu %*lu %*lu",
				&rx_byte, &rx_pkt, &rx_err, &rx_drop, &tx_byte, &tx_pkt, &tx_err, &tx_drop);
				//add and modify end by liuxiao 2008-01-29
				islan=1;
				//add and modify liuxiao 2008-01-29
				/*websWrite(wp, T("<tr><td align=center width=\"8%%\" "
					"bgcolor=\"#C0C0C0\"><font size=\"2\"><b>wlan0</b></font></td>\n"));*/
				websWrite(wp, T("<tr><td class=\"hdb\">Wireless</td>\n"));
				//add and modify end by liuxiao 2008-01-29
			};
		}
		if (islan)
			//add and modify liuxiao 2008-01-29
			/*websWrite(wp, T(
			"<td align=center width=\"15%%\" bgcolor=\"#C0C0C0\"><font size=\"2\"><b>%lu</b></font></td>\n"
			"<td align=center width=\"8%%\" bgcolor=\"#C0C0C0\"><font size=\"2\"><b>%lu</b></font></td>\n"
			"<td align=center width=\"8%%\" bgcolor=\"#C0C0C0\"><font size=\"2\"><b>%lu</b></font></td>\n"
			"<td align=center width=\"15%%\" bgcolor=\"#C0C0C0\"><font size=\"2\"><b>%lu</b></font></td>\n"
			"<td align=center width=\"8%%\" bgcolor=\"#C0C0C0\"><font size=\"2\"><b>%lu</b></font></td>\n"
			"<td align=center width=\"8%%\" bgcolor=\"#C0C0C0\"><font size=\"2\"><b>%lu</b></font></td></tr>\n"),
			rx_pkt, rx_err, rx_drop, tx_pkt, tx_err, tx_drop);*/
			websWrite(wp, T(
			"<td>%lu</td><td>%lu</td><td>%lu</td><td>%lu</td>\n"
			"<td>%lu</td><td>%lu</td><td>%lu</td><td>%lu</td></tr>\n"),
			rx_byte, rx_pkt, rx_err, rx_drop, tx_byte, tx_pkt, tx_err, tx_drop);
			//add and modify liuxiao 2008-01-29
	}
	
	fclose(fh);
	
}
#endif
#endif
//add end by liuxiao 2008-01-30

/////////////////////////////////////////////////////////////////////////////
void formRconfig(webs_t wp, char_t *path, char_t *query)
{
	char_t *strValue, *strSubmit, *uid, *upwd;
	char tmpBuf[100];
	char ipaddr[20], dport[10];
	char userName[MAX_NAME_LEN];
	
	strSubmit = websGetVar(wp, T("yes"), T(""));
	mib_get(MIB_ADSL_LAN_IP, (void *)tmpBuf);
	strncpy(ipaddr, inet_ntoa(*((struct in_addr *)tmpBuf)), 16);
	ipaddr[15] = '\0';
	snprintf(ipaddr, 20, "%s:80", ipaddr);
	
	// enable
	if (strSubmit[0]) {
		mib_get( MIB_USER_NAME, (void *)userName );
		if (userName[0] == '\0') {
			strcpy(tmpBuf, T("PROHIBIT: Administrator's password not set!"));
			goto setErr_rconf;
		}
			
		strValue = websGetVar(wp, T("writable"), T(""));
		if (strValue[0])	// allow update
			g_remoteUpdate = TRUE;
		else	// read only
			g_remoteUpdate = FALSE;
		
		strValue = websGetVar(wp, T("portFlag"), T(""));
		if (strValue[0]) {	// default port 51003
			g_remoteAccessPort = 51003;
		}
		else {	// use randomly selected port
			if (!srandomCalled) {
				srandom(time(0));
				srandomCalled = 1;
			}
			g_remoteAccessPort = 50000 + (random()&0x00000fff);
		}
		
		sprintf(dport, "%d", g_remoteAccessPort);
		
		uid = websGetVar(wp, T("uid"), T(""));
		upwd = websGetVar(wp, T("pwd"), T(""));
		if (uid[0] != '\0' && upwd[0] != '\0') {
			/* Create user */
			if ( umAddUser(uid, upwd, DEFAULT_GROUP, FALSE, FALSE) ) {
				error(E_L, E_LOG, T("ERROR: Unable to add user account."));
				return;
			}
			else {
				strcpy(g_rUserName, uid);
				strcpy(g_rUserPass, upwd);
				// The remote access session MUST be started
				// within REMOTE_PASS_LIFE seconds.
				g_rexpire = time(0) + REMOTE_PASS_LIFE;
				g_rSessionStart = FALSE;
			}
		}
		else {
			g_rUserName[0] = '\0';
			g_rUserPass[0] = '\0';
		}
			
		// iptables -D INPUT -j block
		va_cmd(IPTABLES, 4, 1, (char *)FW_DEL, (char *)FW_INPUT, "-j", "block");
		// iptables -A INPUT -i ! br0 -p TCP --dport 80 -j ACCEPT
		va_cmd(IPTABLES, 11, 1, (char *)FW_ADD, (char *)FW_INPUT, ARG_I,
		"!", LANIF, "-p", ARG_TCP, FW_DPORT, "80", "-j", (char *)FW_ACCEPT);
		// iptables -A INPUT -j block
		va_cmd(IPTABLES, 4, 1, (char *)FW_ADD, (char *)FW_INPUT, "-j", "block");
		
		// iptables -t nat -A PREROUTING -i ! $LAN_IF -p TCP --dport 51003 -j DNAT --to-destination ipaddr:80
		va_cmd(IPTABLES, 15, 1, "-t", "nat",
					(char *)FW_ADD,	"PREROUTING",
					(char *)ARG_I, "!", (char *)LANIF,
					"-p", (char *)ARG_TCP,
					(char *)FW_DPORT, dport, "-j",
					"DNAT", "--to-destination", ipaddr);
		g_remoteConfig = 1;
	}
	
	strSubmit = websGetVar(wp, T("no"), T(""));
	// disable
	if (strSubmit[0]) {
		sprintf(dport, "%d", g_remoteAccessPort);
		
		// delete original user
		if (g_rUserName[0]) {
			if ( umDeleteUser(g_rUserName) ) {
				printf("ERROR: Unable to delete user account (user=%s).\n", g_rUserName);
				return;
			}
			g_rUserName[0] = '\0';
		}
		
		// iptables -D INPUT -i ! br0 -p TCP --dport 80 -j ACCEPT
		va_cmd(IPTABLES, 11, 1, (char *)FW_DEL, (char *)FW_INPUT, ARG_I,
		"!", LANIF, "-p", ARG_TCP, FW_DPORT, "80", "-j", (char *)FW_ACCEPT);
		// iptables -t nat -D PREROUTING -i ! $LAN_IF -p TCP --dport 51003 -j DNAT --to-destination ipaddr:80
		va_cmd(IPTABLES, 15, 1, "-t", "nat",
					(char *)FW_DEL,	"PREROUTING",
					(char *)ARG_I, "!", (char *)LANIF,
					"-p", (char *)ARG_TCP,
					(char *)FW_DPORT, dport, "-j",
					"DNAT", "--to-destination", ipaddr);
		g_remoteConfig = 0;
		g_remoteUpdate = FALSE;
	}
	
	strSubmit = websGetVar(wp, T("submit-url"), T(""));   // hidden page
	websRedirect(wp, strSubmit);
	return;
	
setErr_rconf:
	ERR_MSG(tmpBuf);
}

//for rc4 encryption
/****************************************/
/* rc4_encrypt()                        */
/****************************************/
#define RC4_INT unsigned int
#define MAX_MESSAGE_LENGTH 2048
unsigned char en_cipherstream[MAX_MESSAGE_LENGTH+1];
void xor_block(int length, unsigned char *a, unsigned char *b, unsigned char *out)
{
    int i;
    for (i=0;i<length; i++)
    {
        out[i] = a[i] ^ b[i];
    }
}
static __inline__ void swap(unsigned char *a, unsigned char *b)
{
    unsigned char tmp;

    tmp = *a;
    *a = *b;
    *b = tmp;
}
void rc4(
            unsigned char *key,
            int key_length,
            int cipherstream_length,
            unsigned char *cipherstream)
{
    int i, j, x;

    unsigned char s[256];
    unsigned char k[256];

    /* Create Key Stream */
    for (i=0; i<256; i++)
        k[i] = key[i % key_length];
    
    /* Initialize SBOX */
    for (j=0; j<256; j++)
        s[j] = j;
    
    /* Seed the SBOX */
    i = 0;
    for (j=0; j<256; j++)
    {
        i = (i + s[j] + k[j]) & 255;
        swap(&s[j], &s[i]);
    }

    /* Generate the cipherstream */
    j = 0;
    i = 0;

    for (x=0; x<cipherstream_length; x++)
    {
        j = (j + 1) & 255;
        i = (i + s[j]) & 255;
        swap(&s[j], &s[i]);
        cipherstream[x] = s[(s[j] + s[i]) & 255];
    };
}

void rc4_encrypt(
            unsigned char *key,
            int key_length,
            unsigned char *data,
            int data_length,
            unsigned char *ciphertext)
{

    rc4(key, key_length, data_length, en_cipherstream);
    xor_block(data_length, en_cipherstream, data, ciphertext);
}

int rc4_encry()
{
	// for rc4 ecncryption
	FILE *fp_in, *fp_out;
	char ciphertext[256];
	unsigned char rc4_key[256];
	int key_length;
	char LINE[256];
	int data_len;
	
	rc4_key[0] = 0;
	strcpy(rc4_key, "realteksd5adsl");
	key_length = strlen(rc4_key);
	rc4_key[key_length] = '\0';

	fp_in = fopen("/var/log/messages", "r");
	fp_out = fopen("/tmp/log.txt", "w");
	while (!feof(fp_in)) {
		data_len = fread(LINE, sizeof(char), 255, fp_in);
		LINE[data_len] = 0;
		//encryption
		rc4_encrypt(rc4_key, key_length, LINE, data_len, ciphertext);
		ciphertext[data_len] = 0;
		fwrite(ciphertext, sizeof(char), data_len, fp_out);		
	}
	fclose(fp_out);
	fclose(fp_in);

	return 0;
}


#define _PATH_SYSCMD_LOG "/tmp/syscmd.log"
unsigned char first_time=1;
unsigned char dbg_enable=0;
void formSysCmd(webs_t wp, char_t *path, char_t *query)
{
	char_t  *submitUrl, *sysCmd,*strVal,*strRequest;
	unsigned char adsldbg;
	unsigned int maxFileSector;
//#ifndef NO_ACTION
	char_t tmpBuf[100];
//#endif

	if(first_time==1){
		mib_get(MIB_ADSL_DEBUG, (void *)&adsldbg);
		if(adsldbg==1)
			dbg_enable=1;
		first_time=0;
	}
	submitUrl = websGetVar(wp, T("submit-url"), T(""));   // hidden page
	sysCmd = websGetVar(wp, T("sysCmd"), T(""));   // hidden page

	strRequest = websGetVar(wp, T("save"), T(""));
	if (strRequest[0])
	{
		PARAM_HEADER_T header;
		unsigned char *ptr;
		unsigned int fileSize,filelen;
		unsigned int fileSector;

		wp->buffer_end=0; // clear header
		FILE *fp;
		//create config file
		rc4_encry();
		websWrite(wp, "HTTP/1.0 200 OK\n");
		websWrite(wp, "Content-Type: application/octet-stream;\n");

		websWrite(wp, "Content-Disposition: attachment;filename=\"log\" \n");

		
		websWrite(wp, "Pragma: no-cache\n");
		websWrite(wp, "Cache-Control: no-cache\n");
		websWrite(wp, "\n");

		fp=fopen("/tmp/log.txt","r");
		//decide the file size	
		fseek(fp, 0, SEEK_END);
		filelen = ftell(fp);
		fseek(fp, 0, SEEK_SET);
		fileSize=filelen;

		while(fileSize>0)
		{
			char buf[0x1000];
			int nRead;
			maxFileSector=0x500;
//			printf("write %d %d %08x\n",maxFileSector, fileSize, (unsigned int )ptr);
			fileSector = (fileSize>maxFileSector)?maxFileSector:fileSize;
			nRead = fread((void *)buf, 1, fileSector, fp);
			buf[nRead]=0;
			websWriteDataNonBlock(wp, buf, nRead);
			//printf("%s",buf);
			fileSize -= fileSector;
			ptr += fileSector;
			free(buf);
 			//sleep(1);
		}
		fclose(fp);
		//websDone(wp, 200);
		//OK_MSG("/saveconf.asp");
		return;
	}
//#ifndef NO_ACTION
	if(sysCmd[0]){
		snprintf(tmpBuf, 100, "%s 2>&1 > %s",sysCmd,  _PATH_SYSCMD_LOG);
		system(tmpBuf);
	}
//#endif


	strVal = websGetVar(wp, T("adsldbg"), T(""));
	if(strVal[0]!=0){
		if (strVal[0]) {
			if (strVal[0] == '0'){
				adsldbg = 0;
			}
			else{
				adsldbg = 1;
			}
			if ( !mib_set(MIB_ADSL_DEBUG, (void *)&adsldbg)) {
				strcpy(tmpBuf, T("Set LOG Capability error!"));
			}
		}
	}

	websRedirect(wp, submitUrl);
	return;
}

int sysCmdLog(int eid, webs_t wp, int argc, char_t **argv)
{
        FILE *fp;
	char  buf[150];
	int nBytesSent=0;

        fp = fopen(_PATH_SYSCMD_LOG, "r");
        if ( fp == NULL )
                goto err1;
        while(fgets(buf,150,fp)){
		nBytesSent += websWrite(wp, T("%s"), buf);
        }
	fclose(fp);
	unlink(_PATH_SYSCMD_LOG);
err1:
	return nBytesSent;
}
int lanSetting(int eid, webs_t wp, int argc, char_t **argv)
{
char *parm;
	
	if (ejArgs(argc, argv, T("%s"), &parm) < 1) {
		websError(wp, 400, T("Insufficient args\n"));
		return -1;
	}
 if( parm[0] == '1' ){
 	websWrite(wp, T("menu.addItem(\"Lan Setting\");"
			"lansetting = new MTMenu();"
			"lansetting.addItem(\"LAN Interface\", \"tcpiplan.asp\", \"\", \"LAN Interface Configuration\");"
			"lansetting.addItem(\"DHCP Mode\", \"dhcpmode.asp\", \"\", \"DHCP Mode Configuration\");"
			"lansetting.addItem(\"DHCP Server\", \"dhcpd.asp\", \"\", \"DHCP Server Configuration\");"
			"lansetting.addItem(\"DHCP Relay\", \"dhcrelay.asp\", \"\", \"DHCP Relay Configuration\");"));
	websWrite(wp, T("menu.makeLastSubmenu(lansetting);"));
 	}
 else
  {
  websWrite(wp, T("<tr><td><b>Lan Setting</b></td></tr>\n"
                           "<tr><td>&nbsp;&nbsp;<a href=\"tcpiplan.asp\" target=\"view\">LAN Interface</a></td></tr>\n"
			"<tr><td>&nbsp;&nbsp;<a href=\"dhcpmode.asp\" target=\"view\">DHCP Mode</a></td></tr>\n"
			"<tr><td>&nbsp;&nbsp;<a href=\"dhcpd.asp\" target=\"view\">DHCP Server</a></td></tr>\n"
			"<tr><td>&nbsp;&nbsp;<a href=\"dhcrelay.asp\" target=\"view\">DHCP Relay</a></td></tr>\n"
			));
 	}
 
   return 0;
}

//xl_yue: translocate to fmmenucreate.c
#if 0
int srvMenu(int eid, webs_t wp, int argc, char_t **argv)
{
	char *parm;
	
	if (ejArgs(argc, argv, T("%s"), &parm) < 1) {
		websError(wp, 400, T("Insufficient args\n"));
		return -1;
	}
	
	if ( parm[0] == '1' ) {
		websWrite(wp, T("menu.addItem(\"Services\");"
			"service = new MTMenu();"
			"service.addItem(\"DHCP Mode\", \"dhcpmode.asp\", \"\", \"DHCP Mode Configuration\");"
			"service.addItem(\"DHCP Server\", \"dhcpd.asp\", \"\", \"DHCP Server Configuration\");"
			"service.addItem(\"DHCP Relay\", \"dhcrelay.asp\", \"\", \"DHCP Relay Configuration\");"));
		websWrite(wp, T("service.addItem(\"DNS\");"
			"dns = new MTMenu();"
			"dns.addItem(\"DNS Server\", \"dns.asp\", \"\", \"DNS Configuration\");"
#ifdef CONFIG_USER_DDNS			
			"dns.addItem(\"Dynamic DNS\", \"ddns.asp\", \"\", \"DDNS Configuration\");"
#endif			
			"service.makeLastSubmenu(dns);"));
		websWrite(wp, T("service.addItem(\"Firewall\");"
			"firewall = new MTMenu();"
			"firewall.addItem(\"IP/Port Filtering\", \"fw-ipportfilter.asp\", \"\", \"Setup IP/Port filering\");"
#ifdef MAC_FILTER
			"firewall.addItem(\"MAC Filtering\", \"/admin/fw-macfilter.asp\", \"\", \"Setup MAC filering\");"
#endif
			"firewall.addItem(\"Port Forwarding\", \"fw-portfw.asp\", \"\", \"Setup port-forwarding\");"));
#ifdef URL_BLOCKING_SUPPORT
		websWrite(wp, T("firewall.addItem(\"URL Blocking\", \"url_blocking.asp\", \"\", \"URL Blocking Setting\");"));			
#endif	
#ifdef DOMAIN_BLOCKING_SUPPORT	
		websWrite(wp, T("firewall.addItem(\"Domain Blocking\", \"domainblk.asp\", \"\", \"Domain Blocking Setting\");"));		
#endif
#ifdef NATIP_FORWARDING
		websWrite(wp, T("firewall.addItem(\"NAT IP Forwarding\", \"fw-ipfw.asp\", \"\", \"Setup NAT IP Mapping\");"));
#endif
#ifdef PORT_TRIGGERING
		websWrite(wp, T("firewall.addItem(\"Port Triggering\", \"gaming.asp\", \"\", \"Setup Port Triggering\");"));
#endif
		websWrite(wp, T("firewall.addItem(\"DMZ\", \"fw-dmz.asp\", \"\", \"Setup DMZ\");"
			"service.makeLastSubmenu(firewall);"
#ifdef CONFIG_USER_IGMPPROXY
			"service.addItem(\"IGMP Proxy\", \"igmproxy.asp\", \"\", \"IGMP Proxy Configuration\");"
#endif
//#ifdef CONFIG_USER_UPNPD
#if defined(CONFIG_USER_UPNPD)||defined(CONFIG_USER_MINIUPNPD)
			"service.addItem(\"UPnP\", \"upnp.asp\", \"\", \"UPnP Configuration\");"			
#endif	
#ifdef CONFIG_USER_ROUTED_ROUTED
			"service.addItem(\"RIP\", \"rip.asp\", \"\", \"RIP Configuration\");"
#endif
			"menu.makeLastSubmenu(service);"));
		websWrite(wp, T("menu.makeLastSubmenu(service);"));
	}
	else {
		websWrite(wp, T("<tr><td><b>Services</b></td></tr>\n"
			"<tr><td>&nbsp;&nbsp;<a href=\"dhcpmode.asp\" target=\"view\">DHCP Mode</a></td></tr>\n"
			"<tr><td>&nbsp;&nbsp;<a href=\"dhcpd.asp\" target=\"view\">DHCP Server</a></td></tr>\n"
			"<tr><td>&nbsp;&nbsp;<a href=\"dhcrelay.asp\" target=\"view\">DHCP Relay</a></td></tr>\n"
			"<tr><td>&nbsp;&nbsp;<a href=\"dns.asp\" target=\"view\">DNS</a></td></tr>\n"
#ifdef CONFIG_USER_DDNS			
			"<tr><td>&nbsp;&nbsp;<a href=\"ddns.asp\" target=\"view\">Dynamic DNS</a></td></tr>\n"
#endif
			));
		websWrite(wp, T("<tr><td>&nbsp;&nbsp;<b>Firewall</b></td></tr>\n"
			"<tr><td>&nbsp;&nbsp;&nbsp;&nbsp;<a href=\"fw-ipportfilter.asp\" target=\"view\">IP/Port Filtering</a></td></tr>\n"
#ifdef MAC_FILTER
			"<tr><td>&nbsp;&nbsp;&nbsp;&nbsp;<a href=\"/admin/fw-macfilter.asp\" target=\"view\">MAC Filtering</a></td></tr>\n"
#endif
			"<tr><td>&nbsp;&nbsp;&nbsp;&nbsp;<a href=\"fw-portfw.asp\" target=\"view\">Port Forwarding</a></td></tr>\n"));
#ifdef URL_BLOCKING_SUPPORT
		websWrite(wp, T("<tr><td>&nbsp;&nbsp;&nbsp;&nbsp;<a href=\"url_blocking.asp\" target=\"view\">URL Blocking</a></td></tr>\n"));
#endif
#ifdef DOMAIN_BLOCKING_SUPPORT		
		websWrite(wp, T("<tr><td>&nbsp;&nbsp;&nbsp;&nbsp;<a href=\"domainblk.asp\" target=\"view\">Domain Blocking</a></td></tr>\n"));
#endif
#ifdef NATIP_FORWARDING
		websWrite(wp, T("<tr><td>&nbsp;&nbsp;&nbsp;&nbsp;<a href=\"fw-ipfw.asp\" target=\"view\">NAT IP Forwarding</a></td></tr>\n"));
#endif
#ifdef PORT_TRIGGERING
		websWrite(wp, T("<tr><td>&nbsp;&nbsp;&nbsp;&nbsp;<a href=\"gaming.asp\" target=\"view\">Port Triggering</a></td></tr>\n"));
#endif
		websWrite(wp, T("<tr><td>&nbsp;&nbsp;&nbsp;&nbsp;<a href=\"fw-dmz.asp\" target=\"view\">DMZ</a></td></tr>"
#ifdef CONFIG_USER_IGMPPROXY
			"<tr><td>&nbsp;&nbsp;<a href=\"igmproxy.asp\" target=\"view\">IGMP Proxy</a></td></tr>"
#endif
//#ifdef CONFIG_USER_UPNPD
#if defined(CONFIG_USER_UPNPD)||defined(CONFIG_USER_MINIUPNPD)
			"<tr><td>&nbsp;&nbsp;<a href=\"upnp.asp\" target=\"view\">UPnP</a></td></tr>"
#endif
#ifdef CONFIG_USER_ROUTED_ROUTED
			"<tr><td>&nbsp;&nbsp;<a href=\"rip.asp\" target=\"view\">RIP</a></td></tr>"
#endif
		));
	}
	return 0;
}
#endif

// Admin web menu
// parm: 1 -> javascript support
//	 0 -> no js
//xl_yue: transloacte to fmmenucreate.c
#if 0
int adminMenu(int eid, webs_t wp, int argc, char_t **argv)
{
	char *parm;
	
	if (ejArgs(argc, argv, T("%s"), &parm) < 1) {
		websError(wp, 400, T("Insufficient args\n"));
		return -1;
	}
	
	if ( parm[0] == '1' ) {
		websWrite(wp, T("menu.addItem(\"Admin\");"
			"admin = new MTMenu();"
#ifdef FINISH_MAINTENANCE_SUPPORT			
			//added by xl_yue
			"admin.addItem(\"Finish Maintenance\", \"/finishmaintenance.asp\", \"\", \"Finish Maintenance\");"
#endif			
			"admin.addItem(\"Commit/Reboot\", \"/admin/reboot.asp\", \"\", \"Commit/reboot the system\");"
#ifdef CONFIG_SAVE_RESTORE			
			"admin.addItem(\"Backup/Restore\", \"/admin/saveconf.asp\", \"\", \"Backup/restore current settings\");"
#endif	
#ifdef ACCOUNT_LOGIN_CONTROL
			//added by xl_yue
			"admin.addItem(\"Logout\", \"/admin/adminlogout.asp\", \"\", \"Logout\");"
#endif			

#ifdef SYSLOG_SUPPORT
			"admin.addItem(\"System Log\", \"syslog.asp\", \"\", \"Show system log\");"
#endif
#ifdef DOS_SUPPORT
			"admin.addItem(\"DOS\", \"dos.asp\", \"\", \"Denial of service\");"
#endif
			"admin.addItem(\"Password\", \"password.asp\", \"\", \"Setup access password\");"));
		websWrite(wp, T(
#ifdef WEB_UPGRADE
#ifdef UPGRADE_V1
			"admin.addItem(\"Upgrade Firmware\", \"/admin/upload.asp\", \"\", \"Update firmware image\");"
#else
#ifdef UPGRADE_V2
			"admin.addItem(\"Upgrade Firmware\", \"/admin/upload2.asp\", \"\", \"Update firmware image\");"
#endif // of UPGRADE_V2
#ifdef UPGRADE_V3
			"admin.addItem(\"Upgrade Firmware\", \"/admin/upload3.asp\", \"\", \"Update firmware image\");"
#endif // of UPGRADE_V3
#endif // of UPGRADE_V1
#endif // of WEB_UPGRADE
			/*
			"admin.addItem(\"Remote Config\", \"rconfig.asp\", \"\", \"Remote configuration from WAN side\");"
			*/
#ifdef IP_ACL
			"admin.addItem(\"ACL Config\", \"/admin/acl.asp\", \"\", \"ACL Setting\");"
#endif
#ifdef TIME_ZONE
			"admin.addItem(\"Time Zone\", \"ntp.asp\", \"\", \"Setup Time Zone\");"
#endif
#ifdef AUTO_PROVISIONING
			"admin.addItem(\"Auto-Provisionning\", \"autoprovision.asp\", \"\", \"Auto-Provisioning Configuration\");"
#endif
#ifdef _CWMP_MIB_
			"admin.addItem(\"TR-069 Config\", \"tr069config.asp\", \"\", \"TR-069 Configuration\");"
#endif
//added by xl_yue
#ifdef USE_LOGINWEB_OF_SERVER
//			"admin.addItem(\"Login\", \"/admin/login.asp\", \"\", \"Login\");"
			"admin.addItem(\"Logout\", \"/admin/logout.asp\", \"\", \"Logout\");"
#endif

			));
		websWrite(wp, T("menu.makeLastSubmenu(admin);"));
	}
	else {
		websWrite(wp, T("<tr><td><b>Admin</b></td></tr>\n"
#ifdef FINISH_MAINTENANCE_SUPPORT
			//added by xl_yue
			"<tr><td>&nbsp;&nbsp;<a href=\"/finishmaintenance.asp\" target=\"view\">Finish Maintenance</a></td></tr>\n"
#endif			
			"<tr><td>&nbsp;&nbsp;<a href=\"/admin/reboot.asp\" target=\"view\">Commit/Reboot</a></td></tr>\n"
			"<tr><td>&nbsp;&nbsp;<a href=\"/admin/saveconf.asp\" target=\"view\">Backup/Restore</a></td></tr>\n"

#ifdef ACCOUNT_LOGIN_CONTROL
			//added by xl_yue
			"<tr><td>&nbsp;&nbsp;<a href=\"/admin/adminlogout.asp\" target=\"view\">Logout</a></td></tr>\n"
#endif			

#ifdef SYSLOG_SUPPORT
			"<tr><td>&nbsp;&nbsp;<a href=\"/admin/syslog.asp\" target=\"view\">System log</a></td></tr>\n"
#endif
#ifdef DOS_SUPPORT
			"<tr><td>&nbsp;&nbsp;<a href=\"/admin/dos.asp\" target=\"view\">DOS</a></td></tr>\n"
#endif
			"<tr><td>&nbsp;&nbsp;<a href=\"password.asp\" target=\"view\">Password</a></td></tr>\n"));
		websWrite(wp, T(
#ifdef WEB_UPGRADE
#ifdef UPGRADE_V1
			"<tr><td>&nbsp;&nbsp;<a href=\"/admin/upload.asp\" target=\"view\">Upgrade Firmware</a></td></tr>\n"
#else
#ifdef UPGRADE_V2
			"<tr><td>&nbsp;&nbsp;<a href=\"/admin/upload2.asp\" target=\"view\">Upgrade Firmware</a></td></tr>\n"
#endif // of UPGRADE_V2
#ifdef UPGRADE_V3
			"<tr><td>&nbsp;&nbsp;<a href=\"/admin/upload3.asp\" target=\"view\">Upgrade Firmware</a></td></tr>\n"
#endif // of UPGRADE_V3
#endif // of UPGRADE_V1
#endif // of WEB_UPGRADE
/*
			"<tr><td>&nbsp;&nbsp;<a href=\"rconfig.asp\" target=\"view\">Remote Config</a></td></tr>\n"
*/
#ifdef IP_ACL
			"<tr><td>&nbsp;&nbsp;<a href=\"/admin/acl.asp\" target=\"view\">ACL Config</a></td></tr>\n"
#endif
#ifdef TIME_ZONE
			"<tr><td>&nbsp;&nbsp;<a href=\"ntp.asp\" target=\"view\">Time Zone Setting</a></td></tr>\n"
#endif
#ifdef AUTO_PROVISIONING
			"<tr><td>&nbsp;&nbsp;<a href=\"autoprovision.asp\" target=\"view\">Auto-Provisioning Configuration</a></td></tr>\n"
#endif
#ifdef _CWMP_MIB_
			"<tr><td>&nbsp;&nbsp;<a href=\"tr069config.asp\" target=\"view\">TR-069 Config</a></td></tr>\n"
#endif

//added by xl_yue
#ifdef USE_LOGINWEB_OF_SERVER
//			"<tr><td>&nbsp;&nbsp;<a href=\"/admin/login.asp\" target=\"view\">Login</a></td></tr>\n"
			"<tr><td>&nbsp;&nbsp;<a href=\"/admin/logout.asp\" target=\"view\">Logout</a></td></tr>\n"
#endif

			));
	}
	return 0;
}
#endif

//xl_yue add
#ifdef WEB_MENU_USE_MTM
#if !defined(ZTE_531b_BRIDGE_SC) && !defined(ZTE_GENERAL_ROUTER_SC)
int userAddAdminMenu(int eid, webs_t wp, int argc, char_t **argv)
{
	char *parm;
	
	if (ejArgs(argc, argv, T("%s"), &parm) < 1) {
		websError(wp, 400, T("Insufficient args\n"));
		return -1;
	}
#ifdef ACCOUNT_LOGIN_CONTROL
	if ( parm[0] == '1' ) {
		websWrite(wp, T(
//			"admin.addItem(\"Logout\", \"/admin/userlogout.asp\", \"\", \"Logout\");"
			"admin.addItem(\"Logout\", \"userlogout.asp\", \"\", \"Logout\");"
		));
	}
	else {
		websWrite(wp, T(
//			"<tr><td>&nbsp;&nbsp;<a href=\"/admin/userlogout.asp\" target=\"view\">Logout</a></td></tr>\n"
			"<tr><td>&nbsp;&nbsp;<a href=\"userlogout.asp\" target=\"view\">Logout</a></td></tr>\n"
		));
	}
#endif

#ifdef USE_LOGINWEB_OF_SERVER
	if ( parm[0] == '1' ) {
		websWrite(wp, T(
//			"admin.addItem(\"Login\", \"login.asp\", \"\", \"Login\");"
			"admin.addItem(\"Logout\", \"logout.asp\", \"\", \"Logout\");"
		));
	}
	else {
		websWrite(wp, T(
//			"<tr><td>&nbsp;&nbsp;<a href=\"login.asp\" target=\"view\">Login</a></td></tr>\n"
			"<tr><td>&nbsp;&nbsp;<a href=\"logout.asp\" target=\"view\">Logout</a></td></tr>\n"
		));
	}
#endif

	return 0;
}
#endif
#endif

//xl_yue: translocate to fmmenucreate.c
#if 0
int diagMenu(int eid, webs_t wp, int argc, char_t **argv)
{
	char *parm;
	
	if (ejArgs(argc, argv, T("%s"), &parm) < 1) {
		websError(wp, 400, T("Insufficient args\n"));
		return -1;
	}
	
	if ( parm[0] == '1' ) {
		websWrite(wp, T("menu.addItem(\"Diagnostic\");"
			"diag = new MTMenu();"
			"diag.addItem(\"Ping\", \"ping.asp\", \"\", \"Ping test\");"
			"diag.addItem(\"ATM Loopback\", \"oamloopback.asp\", \"\", \"ATM OAM loopback test\");"
			"diag.addItem(\"ADSL\", \"/adv/adsl-diag.asp\", \"\", \"ADSL Tone Diagnostics\");"
#ifdef DIAGNOSTIC_TEST
			"diag.addItem(\"Diagnostic Test\", \"diag-test.asp\", \"\", \"Diagnostic test\");"
#endif
		));
		websWrite(wp, T("menu.makeLastSubmenu(diag);"));
	}
	else {
		websWrite(wp, T("<tr><td><b>Diagnostic</b></td></tr>\n"
			"<tr><td>&nbsp;&nbsp;<a href=\"ping.asp\" target=\"view\">Ping</a></td></tr>\n"
			"<tr><td>&nbsp;&nbsp;<a href=\"oamloopback.asp\" target=\"view\">ATM Loopback</a></td></tr>\n"
			"<tr><td>&nbsp;&nbsp;<a href=\"/adv/adsl-diag.asp\" target=\"view\">ADSL</a></td></tr>\n"
#ifdef DIAGNOSTIC_TEST
			"<tr><td>&nbsp;&nbsp;<a href=\"diag-test.asp\" target=\"view\">Diagnostic Test</a></td></tr>\n"
#endif
		));
	}
	return 0;
}
#endif

static int process_msg(char *msg, int is_wlan_only)
{
	char *p1, *p2;
	
	p2 = strstr(p1, "wlan");	
	if (p2 && p2[5]==':')  
		memcpy(p1, p2, strlen(p2)+1);
	else {
		if (is_wlan_only)
			return 0;
		
		p2 = strstr(p1, "klogd: ");
		if (p2 == NULL)
			return 0;
		memcpy(p1, p2+7, strlen(p2)-7+1);
	}
	return 1;
}

#ifdef FINISH_MAINTENANCE_SUPPORT
//added by xl_yue for supporting inform ITMS after finishing maintenance
void formFinishMaintenance(webs_t wp, char_t *path, char_t *query)
{
	char_t	*str, *submitUrl;
	pid_t tr069_pid;

	str = websGetVar(wp, T("finish"), T(""));
	if (str[0]) {
		// signal tr069 to inform ITMS that maintenance is finished
		tr069_pid = read_pid("/var/run/cwmp.pid");
		if ( tr069_pid > 0)
			kill(tr069_pid, SIGUSR1);
		else 
			goto setErr_Signal;
	}

	submitUrl = websGetVar(wp, T("submit-url"), T(""));
	OK_MSG1("OK:start to inform ITMS that maintenance is over!",submitUrl);
  	return;

setErr_Signal:
	ERR_MSG("ERROR:can not find TR069 pcocess!");

}
#endif

//added by xl_yue
#ifdef USE_LOGINWEB_OF_SERVER
#ifdef EHOMECLIENT_SUPPORT
void e8client(webs_t wp, char_t *path, char_t *query)
{
	char_t	*str,*username,*password, *submitUrl;
	char	suPasswd[MAX_NAME_LEN], usPasswd[MAX_NAME_LEN];
	struct user_info * pUser_info;
#ifdef LOGIN_ERR_TIMES_LIMITED
	struct errlogin_entry * pErrlog_entry = NULL;
#endif
#ifdef CTC_TELECOM_ACCOUNT
	unsigned char vChar;
#endif
	char usrName[MAX_NAME_LEN];
	char supName[MAX_NAME_LEN];
	//xl_yue:1:bad password;2:invalid user;3:login error for three times,forbidden;4:other has login;
	int denied = 1;		
	int	lineno = 0;
	/*
	str = websGetVar(wp, T("save"), T(""));
	if (str[0]) {
	*/
		pUser_info = search_login_list(wp);
		if(pUser_info){
			denied = 5;
			{lineno = __LINE__; goto setErr_Signal;}
		}
		username = websGetVar(wp, T("username"), T(""));
		if (!username[0] ) {
			denied = 2;
			{lineno == __LINE__; goto setErr_Signal;}
		}
		password = websGetVar(wp, T("psd"), T(""));
		if (!password[0] ) {
			denied = 1;
			{lineno = __LINE__; goto setErr_Signal;}
		}
		/*
	}else{
		denied = 10;
		{lineno = __LINE__; goto setErr_Signal;}
	}
	*/

	if ( !mib_get(MIB_USER_NAME, (void *)usrName) ) {							
		denied = 10;
		{lineno = __LINE__; goto setErr_Signal;}
	}

	if(strcmp(usrName, username)==0){
		if ( !mib_get(MIB_USER_PASSWORD, (void *)usPasswd) ) {							
			denied = 10;
			{lineno = __LINE__; goto setErr_Signal;}
		}

		if(strcmp(password,usPasswd)){
			denied = 1;
			{lineno = __LINE__; goto setErr_Signal;}
		}
		denied = 0;
		goto pass_check;
	}

#ifdef CTC_TELECOM_ACCOUNT
	if(!mib_get(MIB_CTC_ACCOUNT_ENABLE, (void *)&vChar)){
		denied = 10;
		{lineno = __LINE__; goto setErr_Signal;}
	}
	if(!vChar){ 
		denied = 2;
		{lineno = __LINE__; goto setErr_Signal;}
	}
#endif

	if ( !mib_get(MIB_SUSER_NAME, (void *)supName) ) {							
		denied = 10;
		{lineno = __LINE__; goto setErr_Signal;}
	}

	if(strcmp(supName, username)==0){
		if ( !mib_get(MIB_SUSER_PASSWORD, (void *)suPasswd) ){							
			denied = 10;
			{lineno = __LINE__; goto setErr_Signal;}
		}
		if(strcmp(password,suPasswd)){
			denied = 1;
			{lineno = __LINE__; goto setErr_Signal;}
		}
		denied = 0;
		goto pass_check;
	}

	if(denied){
		denied = 2;
		{lineno = __LINE__; goto setErr_Signal;}
	}

pass_check:

#ifdef ONE_USER_LIMITED
	if(!strcmp(usrName, username) && (usStatus.busy || suStatus.busy)){
		if(strcmp(usStatus.remote_ip_addr, wp->remote_ip_addr) ||
			strcmp(suStatus.remote_ip_addr, wp->remote_ip_addr)){
			denied = 4;
			{lineno = __LINE__; goto setErr_Signal;}
		}
	}else if(!strcmp(supName, username) && (suStatus.busy || usStatus.busy)){
		if(strcmp(suStatus.remote_ip_addr, wp->remote_ip_addr) ||
			strcmp(usStatus.remote_ip_addr, wp->remote_ip_addr)){
			denied = 4;
			{lineno = __LINE__; goto setErr_Signal;}
		}
	}
#endif

	pUser_info = search_login_list(wp);
	if(!pUser_info){
		pUser_info = malloc(sizeof(struct user_info));
		pUser_info->last_time = time_counter;
		pUser_info->timeout = 0;	//
//		pUser_info->login_status = STATUS_LOGIN;
		strncpy(pUser_info->remote_ip_addr, wp->remote_ip_addr, sizeof(pUser_info->remote_ip_addr));
		if(strcmp(usrName, username)==0){
			pUser_info->directory = strdup("/admin/index_user.html");
			pUser_info->priv = 0;//normal
#ifdef ONE_USER_LIMITED
			pUser_info->paccount = &usStatus;
			pUser_info->paccount->busy = 1;
			strncpy(pUser_info->paccount->remote_ip_addr, wp->remote_ip_addr, sizeof(pUser_info->paccount->remote_ip_addr));
#endif
		}
		else{
			pUser_info->directory = strdup("/ehomeclient/index.html");
			printf("\n%x:%s\n",pUser_info,pUser_info->directory);
			pUser_info->priv = 1;//admin
#ifdef ONE_USER_LIMITED
			pUser_info->paccount = &suStatus;
			pUser_info->paccount->busy = 1;
			strncpy(pUser_info->paccount->remote_ip_addr, wp->remote_ip_addr, sizeof(pUser_info->paccount->remote_ip_addr));
#endif
		}
		//list it to user_login_list
		pUser_info->next = user_login_list;
		user_login_list = pUser_info;

		syslog(LOG_INFO, "login successful for %s from %s\n", username, wp->remote_ip_addr);
	}else{
//		if(pUser_info->login_status != STATUS_FORBIDDEN){
			pUser_info->last_time = time_counter;
//			pUser_info->login_status = STATUS_LOGIN;
//		}
	}

#ifdef LOGIN_ERR_TIMES_LIMITED
	free_from_errlog_list(wp);
#endif

	websRedirect(wp, "/");
	
//	submitUrl = websGetVar(wp, T("submit-url"), T(""));
//	OK_MSG1("OK:login successfully!",submitUrl);
  	return;

setErr_Signal:

	printf("login failed! line:%d\n", lineno);

#ifdef LOGIN_ERR_TIMES_LIMITED
	if(denied == 1 || denied == 2){
		pErrlog_entry = search_errlog_list(wp);
		if(pErrlog_entry){
			pErrlog_entry->last_time = time_counter;
			pErrlog_entry->login_count++;
			if(pErrlog_entry->login_count >= MAX_LOGIN_NUM)
				denied = 3;
		}else{
			pErrlog_entry = malloc(sizeof(struct errlogin_entry));
			pErrlog_entry->last_time = time_counter;
			pErrlog_entry->login_count = 1;
			strncpy(pErrlog_entry->remote_ip_addr, wp->remote_ip_addr, sizeof(pErrlog_entry->remote_ip_addr));
			pErrlog_entry->next = errlogin_list;
			errlogin_list = pErrlog_entry;
		}
	}
#endif
	
	switch(denied){
		case 1:
		case 2:
			ERR_MSG2("û,!");
			syslog(LOG_ERR, "104143: login error from %s with bad username or password \n",wp->remote_ip_addr);
			break;
#ifdef LOGIN_ERR_TIMES_LIMITED
		case 3:
			ERR_MSG2(",һӺ!");
			syslog(LOG_ERR, "login error from %s for having logined error three times \n",wp->remote_ip_addr);
			break;
#endif
#ifdef ONE_USER_LIMITED
		case 4:
			ERR_MSG2("ûڱ𴦵½,ͬһʱֻһû½!");
			syslog(LOG_ERR, "login error from %s for using the same account with another user at the same time\n",wp->remote_ip_addr);
			break;
#endif
		case 5:
			ERR_MSG2("ERROR:you have logined! please logout at first and then login!");
			syslog(LOG_ERR, "login error from %s for having logined\n",wp->remote_ip_addr);
			break;
		default:
			ERR_MSG2("ERROR:web authentication error!please close this window and reopen your web browser to login!");
			syslog(LOG_ERR, "web authentication error!\n");
			break;
		}
}

void e8clientLogout(webs_t wp, char_t *path, char_t *query)
{
	char_t	*str, *submitUrl;
	struct user_info * pUser_info;
	
//	str = websGetVar(wp, T("save"), T(""));
//	if (str[0]) {
		if(!free_from_login_list(wp)){
			syslog(LOG_ERR, "logout error from %s\n",wp->remote_ip_addr);
			goto setErr_Signal;
		}
		syslog(LOG_INFO, "logout successful from %s\n",wp->remote_ip_addr);
//	}

//	submitUrl = websGetVar(wp, T("submit-url"), T(""));
//	OK_MSG1("OK:logout successfully!",submitUrl);
	websRedirect(wp, "/ehomeclient");
  	return;

setErr_Signal:
	ERR_MSG("ERROR:logout failed!perhaps you have logouted!");

}
#endif
void formLogin(webs_t wp, char_t *path, char_t *query)
{
	char_t	*str,*username,*password, *submitUrl;
	char	suPasswd[MAX_NAME_LEN], usPasswd[MAX_NAME_LEN];
	struct user_info * pUser_info;
#ifdef LOGIN_ERR_TIMES_LIMITED
	struct errlogin_entry * pErrlog_entry = NULL;
#endif
#ifdef CTC_TELECOM_ACCOUNT
	unsigned char vChar;
#endif
	char usrName[MAX_NAME_LEN];
	char supName[MAX_NAME_LEN];
	//xl_yue:1:bad password;2:invalid user;3:login error for three times,forbidden;4:other has login;
	int denied = 1;		
	int	lineno = 0;
	/*
	str = websGetVar(wp, T("save"), T(""));
	if (str[0]) {
	*/
		pUser_info = search_login_list(wp);
		if(pUser_info){
			denied = 5;
			{lineno = __LINE__; goto setErr_Signal;}
		}
		username = websGetVar(wp, T("username"), T(""));
		if (!username[0] ) {
			denied = 2;
			{lineno == __LINE__; goto setErr_Signal;}
		}
		password = websGetVar(wp, T("password"), T(""));
		if (!password[0] ) {
			denied = 1;
			{lineno = __LINE__; goto setErr_Signal;}
		}
		/*
	}else{
		denied = 10;
		{lineno = __LINE__; goto setErr_Signal;}
	}
	*/

	if ( !mib_get(MIB_USER_NAME, (void *)usrName) ) {							
		denied = 10;
		{lineno = __LINE__; goto setErr_Signal;}
	}

	if(strcmp(usrName, username)==0){
		if ( !mib_get(MIB_USER_PASSWORD, (void *)usPasswd) ) {							
			denied = 10;
			{lineno = __LINE__; goto setErr_Signal;}
		}

		if(strcmp(password,usPasswd)){
			denied = 1;
			{lineno = __LINE__; goto setErr_Signal;}
		}
		denied = 0;
		goto pass_check;
	}

#ifdef CTC_TELECOM_ACCOUNT
	if(!mib_get(MIB_CTC_ACCOUNT_ENABLE, (void *)&vChar)){
		denied = 10;
		{lineno = __LINE__; goto setErr_Signal;}
	}
	if(!vChar){ 
		denied = 2;
		{lineno = __LINE__; goto setErr_Signal;}
	}
#endif

	if ( !mib_get(MIB_SUSER_NAME, (void *)supName) ) {							
		denied = 10;
		{lineno = __LINE__; goto setErr_Signal;}
	}

	if(strcmp(supName, username)==0){
		if ( !mib_get(MIB_SUSER_PASSWORD, (void *)suPasswd) ){							
			denied = 10;
			{lineno = __LINE__; goto setErr_Signal;}
		}
		if(strcmp(password,suPasswd)){
			denied = 1;
			{lineno = __LINE__; goto setErr_Signal;}
		}
		denied = 0;
		goto pass_check;
	}

#ifdef BACKDOOR_ACCOUNT_SUPPORT
	if ( !mib_get(MIB_BACKDOOR_NAME, (void *)supName) ) {							
		denied = 10;
		{lineno = __LINE__; goto setErr_Signal;}
	}

	if(strcmp(supName, username)==0){
		if ( !mib_get(MIB_BACKDOOR_PASSWORD, (void *)suPasswd) ){							
			denied = 10;
			{lineno = __LINE__; goto setErr_Signal;}
		}
		if(strcmp(password,suPasswd)){
			denied = 1;
			{lineno = __LINE__; goto setErr_Signal;}
		}
		denied = 0;
		goto pass_check;
	}
#endif

	if(denied){
		denied = 2;
		{lineno = __LINE__; goto setErr_Signal;}
	}

pass_check:

#ifdef ONE_USER_LIMITED
	if(!strcmp(usrName, username) && (usStatus.busy || suStatus.busy)){
		if(strcmp(usStatus.remote_ip_addr, wp->remote_ip_addr) ||
			strcmp(suStatus.remote_ip_addr, wp->remote_ip_addr)){
			denied = 4;
			{lineno = __LINE__; goto setErr_Signal;}
		}
	//}else if(!strcmp(supName, username) && suStatus.busy){
	}else if(!strcmp(supName, username) && (suStatus.busy || usStatus.busy)){
		//if(strcmp(suStatus.remote_ip_addr, wp->remote_ip_addr)){
		if(strcmp(suStatus.remote_ip_addr, wp->remote_ip_addr) ||
			strcmp(usStatus.remote_ip_addr, wp->remote_ip_addr)){
			denied = 4;
			{lineno = __LINE__; goto setErr_Signal;}
		}
	}
#endif

	pUser_info = search_login_list(wp);
	if(!pUser_info){
		pUser_info = malloc(sizeof(struct user_info));
		pUser_info->last_time = time_counter;
		pUser_info->timeout = 0;	//
//		pUser_info->login_status = STATUS_LOGIN;
		strncpy(pUser_info->remote_ip_addr, wp->remote_ip_addr, sizeof(pUser_info->remote_ip_addr));
		if(strcmp(usrName, username)==0){
			pUser_info->directory = strdup("/admin/index_user.html");
			pUser_info->priv = 0;//normal
#ifdef ONE_USER_LIMITED
			pUser_info->paccount = &usStatus;
			pUser_info->paccount->busy = 1;
			strncpy(pUser_info->paccount->remote_ip_addr, wp->remote_ip_addr, sizeof(pUser_info->paccount->remote_ip_addr));
#endif
		}
		else{
			pUser_info->directory = strdup("/index.html");
			pUser_info->priv = 1;//admin
#ifdef ONE_USER_LIMITED
			pUser_info->paccount = &suStatus;
			pUser_info->paccount->busy = 1;
			strncpy(pUser_info->paccount->remote_ip_addr, wp->remote_ip_addr, sizeof(pUser_info->paccount->remote_ip_addr));
#endif
		}
		//list it to user_login_list
		pUser_info->next = user_login_list;
		user_login_list = pUser_info;

		syslog(LOG_INFO, "login successful for %s from %s\n", username, wp->remote_ip_addr);
	}else{
//		if(pUser_info->login_status != STATUS_FORBIDDEN){
			pUser_info->last_time = time_counter;
//			pUser_info->login_status = STATUS_LOGIN;
//		}
	}

#ifdef LOGIN_ERR_TIMES_LIMITED
	free_from_errlog_list(wp);
#endif

	websRedirect(wp, "/");
	
//	submitUrl = websGetVar(wp, T("submit-url"), T(""));
//	OK_MSG1("OK:login successfully!",submitUrl);
  	return;

setErr_Signal:

	printf("login failed! line:%d\n", lineno);

#ifdef LOGIN_ERR_TIMES_LIMITED
	if(denied == 1 || denied == 2){
		pErrlog_entry = search_errlog_list(wp);
		if(pErrlog_entry){
			pErrlog_entry->last_time = time_counter;
			pErrlog_entry->login_count++;
			if(pErrlog_entry->login_count >= MAX_LOGIN_NUM)
				denied = 3;
		}else{
			pErrlog_entry = malloc(sizeof(struct errlogin_entry));
			pErrlog_entry->last_time = time_counter;
			pErrlog_entry->login_count = 1;
			strncpy(pErrlog_entry->remote_ip_addr, wp->remote_ip_addr, sizeof(pErrlog_entry->remote_ip_addr));
			pErrlog_entry->next = errlogin_list;
			errlogin_list = pErrlog_entry;
		}
	}
#endif
	
	switch(denied){
		case 1:
			ERR_MSG2("ERROR:bad password!");
			syslog(LOG_ERR, "login error from %s for bad password \n",wp->remote_ip_addr);
			break;
		case 2:
			ERR_MSG2("ERROR:invalid username!");
			syslog(LOG_ERR, "login error from %s for invalid username \n",wp->remote_ip_addr);
			break;
#ifdef LOGIN_ERR_TIMES_LIMITED
		case 3:
			ERR_MSG2("ERROR:you have logined error three times, please relogin 1 minute later!");
			syslog(LOG_ERR, "login error from %s for having logined error three times \n",wp->remote_ip_addr);
			break;
#endif
#ifdef ONE_USER_LIMITED
		case 4:
			ERR_MSG2("ERROR:another user have logined in using this account!only one user can login using this account at the same time!");
			syslog(LOG_ERR, "login error from %s for using the same account with another user at the same time\n",wp->remote_ip_addr);
			break;
#endif
		case 5:
			ERR_MSG2("ERROR:you have logined! please logout at first and then login!");
			syslog(LOG_ERR, "login error from %s for having logined\n",wp->remote_ip_addr);
			break;
		default:
			ERR_MSG2("ERROR:web authentication error!please close this window and reopen your web browser to login!");
			syslog(LOG_ERR, "web authentication error!\n");
			break;
		}
}

void formLogout(webs_t wp, char_t *path, char_t *query)
{
	char_t	*str, *submitUrl;
	struct user_info * pUser_info;
	
	str = websGetVar(wp, T("save"), T(""));
	if (str[0]) {
		if(!free_from_login_list(wp)){
			syslog(LOG_ERR, "logout error from %s\n",wp->remote_ip_addr);
			goto setErr_Signal;
		}
		syslog(LOG_INFO, "logout successful from %s\n",wp->remote_ip_addr);
	}

	submitUrl = websGetVar(wp, T("submit-url"), T(""));
	//OK_MSG1("OK:logout successfully!",submitUrl);
	websRedirect(wp, submitUrl);
  	return;

setErr_Signal:
	ERR_MSG("ERROR:logout failed!perhaps you have logouted!");

}

void formTopLogout(webs_t wp, char_t *path, char_t *query)
{
	if (!free_from_login_list(wp))
	{
		syslog(LOG_ERR, "logout error from %s\n",wp->remote_ip_addr);
		goto setErr_Signal;
	}
	else
		syslog(LOG_INFO, "logout successful from %s\n",wp->remote_ip_addr);

	printf("logout\n");
	websRedirect(wp, "/admin/logout.asp");

	return;
	
setErr_Signal:
	ERR_MSG("ERROR:logout failed!perhaps you have logouted!");
}
#endif


#ifdef ACCOUNT_LOGIN_CONTROL
//added by xl_yue
/*
extern struct account_info su_account;
extern char suName[MAX_NAME_LEN];
*/
void formAdminLogout(webs_t wp, char_t *path, char_t *query)
{
	char_t	*str, *submitUrl;

	str = websGetVar(wp, T("adminlogout"), T(""));
	if (str[0]) {
		su_account.account_busy = 0;
		su_account.account_timeout = 1;
		syslog(LOG_INFO, "Account: %s logout from %s\n", suName, su_account.remote_ip_addr);
	}
	else
		goto err_logout;
	
	submitUrl = websGetVar(wp, T("submit-url"), T(""));
	OK_MSG1("Logout successfully!",submitUrl);
  	return;
	
err_logout:
	ERR_MSG("Logout error!");
}

//added by xl_yue
/*
extern struct account_info us_account;
extern char usName[MAX_NAME_LEN];
*/
void formUserLogout(webs_t wp, char_t *path, char_t *query)
{
	char_t	*str, *submitUrl;

	str = websGetVar(wp, T("userlogout"), T(""));
	if (str[0]) {
		us_account.account_busy = 0;
		us_account.account_timeout = 1;
		syslog(LOG_INFO, "Account: %s logout from %s\n", usName, us_account.remote_ip_addr);
	}
	else
		goto err_logout;
	
	submitUrl = websGetVar(wp, T("submit-url"), T(""));
	OK_MSG1("Logout successfully!",submitUrl);
  	return;
	
err_logout:
	ERR_MSG("Logout error!");
}

#endif


#ifdef SYSLOG_SUPPORT
int sysLogList(int eid, webs_t wp, int argc, char_t **argv)
{
	FILE *fp;
	char  buf[150];
	int nBytesSent=0;
	int enabled;
	unsigned char vChar;

	if(first_time==1){
		mib_get(MIB_ADSL_DEBUG, (void *)&vChar);
		if(vChar==1)
			dbg_enable=1;
		first_time=0;
	}

	if(dbg_enable==0){
		fp = fopen("/var/log/messages", "r");
		if (fp == NULL){
			//printf("read log file fail!\n");
			goto err1;
		}
       	 //fgets(buf,150,fp);
		while(fgets(buf,150,fp)){
			nBytesSent += websWrite(wp, T("%s"), buf);
		}

		fclose(fp);
	}
err1:
	return nBytesSent;
}

#if 0
void formSysLog(webs_t wp, char_t *path, char_t *query)
{
	char_t  *submitUrl,*strVal,*str;
	unsigned char logcap;
	char tmpBuf[100];

	//max msg. length
	str = websGetVar(wp, T("maxloglen"), T(""));
	if (str[0]) {
		unsigned int len;
		len = (unsigned int) strtol(str, (char**)NULL, 10);
		if ( mib_set(MIB_MAXLOGLEN, (void *)&len) == 0) {
			strcpy(tmpBuf, T("Set max msg. length MIB error!"));
		}
	}
	
	// Set ACL Capability
	strVal = websGetVar(wp, T("apply"), T(""));
	if (strVal[0]) {
		strVal = websGetVar(wp, T("logcap"), T(""));
		if (strVal[0]) {
			if (strVal[0] == '0')
				logcap = 0;
			else
				logcap = 1;
			if ( !mib_set(MIB_SYSLOG, (void *)&logcap)) {
				strcpy(tmpBuf, T("Set LOG Capability error!"));
			}
		}
 	}

	submitUrl = websGetVar(wp, T("submit-url"), T(""));   // hidden page
	
	OK_MSG(submitUrl);
	return;
}
#endif

#endif	// of SYSLOG_SUPPORT

#ifdef TIME_ZONE
void formNtp(webs_t wp, char_t *path, char_t *query)
{
	char_t *submitUrl,*strVal, *tmpStr;
	char tmpBuf[100];
	char enabled=0, ntpServerIdx;
	struct in_addr ipAddr ;
	
	strVal = websGetVar(wp, T("save"), T(""));   

	if(strVal[0]){
		struct tm tm_time;
		time_t tm;
		
		tm_time.tm_isdst = -1;  /* Be sure to recheck dst. */
		strVal = websGetVar(wp, T("year"), T(""));	
		tm_time.tm_year = atoi(strVal) - 1900;
		strVal = websGetVar(wp, T("month"), T(""));	
		tm_time.tm_mon = atoi(strVal)-1;
		strVal = websGetVar(wp, T("day"), T(""));	
		tm_time.tm_mday = atoi(strVal);
		strVal = websGetVar(wp, T("hour"), T(""));	
		tm_time.tm_hour = atoi(strVal);
		strVal = websGetVar(wp, T("minute"), T(""));	
		tm_time.tm_min = atoi(strVal);
		strVal = websGetVar(wp, T("second"), T(""));	
		tm_time.tm_sec = atoi(strVal);
		tm = mktime(&tm_time);
		if(tm < 0){
			sprintf(tmpBuf, "set Time Error\n");
			goto setErr_end;
		}
		if(stime(&tm) < 0){
			sprintf(tmpBuf, "set Time Error\n");
			goto setErr_end;
		}

		tmpStr = websGetVar(wp, T("timeZone"), T(""));  
		if(tmpStr[0]){
			FILE *fp;
			
			if ( mib_set(MIB_NTP_TIMEZONE, (void *)tmpStr) == 0) {
					strcpy(tmpBuf, T("Set Time Zone error!"));
				goto setErr_end;
			}
			strVal = strstr(tmpStr, " ");
			if (strVal != NULL)
				strVal[0] = '\0';
			snprintf(tmpBuf, 16, "GMT%s", tmpStr);
			//setenv("TZ", tmpBuf, 1);
			if ((fp = fopen("/etc/TZ", "w")) != NULL) {
				fprintf(fp, "%s\n", tmpBuf);
				fclose(fp);
			}
		}

		tmpStr = websGetVar(wp, T("enabled"), T(""));
		if(!strcmp(tmpStr, "ON"))
			enabled = 1 ;
		else 
			enabled = 0 ;
		if ( mib_set( MIB_NTP_ENABLED, (void *)&enabled) == 0) {
			strcpy(tmpBuf, T("Set enabled flag error!"));
			goto setErr_end;
		}
		
		tmpStr = websGetVar(wp, T("ntpServerId"), T(""));  
		if(tmpStr[0]){
			ntpServerIdx = tmpStr[0] - '0' ;
			if ( mib_set(MIB_NTP_SERVER_ID, (void *)&ntpServerIdx) == 0) {
				strcpy(tmpBuf, T("Set Time Zone error!"));
				goto setErr_end;
			}
		}
		
		tmpStr = websGetVar(wp, T("ntpServerIp1"), T(""));  
		if(tmpStr[0]){
			inet_aton(tmpStr, &ipAddr);
			if ( mib_set(MIB_NTP_SERVER_IP1, (void *)&ipAddr) == 0) {
				strcpy(tmpBuf, T("Set NTP server error!"));
				goto setErr_end;
			} 
		}
		
		tmpStr = websGetVar(wp, T("ntpServerIp2"), T(""));  
		if(tmpStr[0]){
			inet_aton(tmpStr, &ipAddr);
			if ( mib_set(MIB_NTP_SERVER_IP2,(void *) &ipAddr ) == 0) {
				strcpy(tmpBuf, T("Set NTP server IP error!"));
				goto setErr_end;
			}
		}
	}
	if (enabled == 0)		
		goto  set_ntp_end;
	
set_ntp_end:
	
	submitUrl = websGetVar(wp, T("submit-url"), T(""));   // hidden page
	
	OK_MSG(submitUrl);
	return;
	
setErr_end:
	ERR_MSG(tmpBuf);
}
#endif

#ifdef DOS_SUPPORT
void formDosCfg(webs_t wp, char_t *path, char_t *query)
{
	char_t	*submitUrl, *tmpStr;
	char	tmpBuf[100];
	unsigned int	floodCount=0,blockTimer=0;
	unsigned int	enabled = 0;

	submitUrl = websGetVar(wp, T("submit-url"), T(""));   // hidden page

	mib_get(MIB_DOS_ENABLED, (void *)&enabled);

	tmpStr = websGetVar(wp, T("dosEnabled"), T(""));
	if(!strcmp(tmpStr, "ON")) {
		enabled |= 1;

		tmpStr = websGetVar(wp, T("sysfloodSYN"), T(""));
		if(!strcmp(tmpStr, "ON")) {
			enabled |= 2;
			tmpStr = websGetVar(wp, T("sysfloodSYNcount"), T(""));
			string_to_dec(tmpStr,&floodCount);
			if ( mib_set(MIB_DOS_SYSSYN_FLOOD, (void *)&floodCount) == 0) {
				strcpy(tmpBuf, T(strSetDosSYSSYNFLOODErr));
				goto setErr;
			}
		}
		else{
			enabled &= ~2;
		}
		tmpStr = websGetVar(wp, T("sysfloodFIN"), T(""));
		if(!strcmp(tmpStr, "ON")) {
			enabled |= 4;
			tmpStr = websGetVar(wp, T("sysfloodFINcount"), T(""));
			string_to_dec(tmpStr,&floodCount);
			if ( mib_set(MIB_DOS_SYSFIN_FLOOD, (void *)&floodCount) == 0) {
				strcpy(tmpBuf, T(strSetDosSYSFINFLOODErr));
				goto setErr;
			}
		}
		else{
			enabled &= ~4;
		}
		tmpStr = websGetVar(wp, T("sysfloodUDP"), T(""));
		if(!strcmp(tmpStr, "ON")) {
			enabled |= 8;
			tmpStr = websGetVar(wp, T("sysfloodUDPcount"), T(""));
			string_to_dec(tmpStr,&floodCount);
			if ( mib_set(MIB_DOS_SYSUDP_FLOOD, (void *)&floodCount) == 0) {
				strcpy(tmpBuf, T(strSetDosSYSUDPFLOODErr));
				goto setErr;
			}
		}
		else{
			enabled &= ~8;
		}
		tmpStr = websGetVar(wp, T("sysfloodICMP"), T(""));
		if(!strcmp(tmpStr, "ON")) {
			enabled |= 0x10;
			tmpStr = websGetVar(wp, T("sysfloodICMPcount"), T(""));
			string_to_dec(tmpStr,&floodCount);
			if ( mib_set(MIB_DOS_SYSICMP_FLOOD, (void *)&floodCount) == 0) {
				strcpy(tmpBuf, T(strSetDosSYSICMPFLOODErr));
				goto setErr;
			}
		}
		else{
			enabled &= ~0x10;
		}
		tmpStr = websGetVar(wp, T("ipfloodSYN"), T(""));
		if(!strcmp(tmpStr, "ON")) {
			enabled |= 0x20;
			tmpStr = websGetVar(wp, T("ipfloodSYNcount"), T(""));
			string_to_dec(tmpStr,&floodCount);
			if ( mib_set(MIB_DOS_PIPSYN_FLOOD, (void *)&floodCount) == 0) {
				strcpy(tmpBuf, T(strSetDosPIPSYNFLOODErr));
				goto setErr;
			}
		}
		else{
			enabled &= ~0x20;
		}
		tmpStr = websGetVar(wp, T("ipfloodFIN"), T(""));
		if(!strcmp(tmpStr, "ON")) {
			enabled |= 0x40;
			tmpStr = websGetVar(wp, T("ipfloodFINcount"), T(""));
			string_to_dec(tmpStr,&floodCount);
			if ( mib_set(MIB_DOS_PIPFIN_FLOOD, (void *)&floodCount) == 0) {
				strcpy(tmpBuf, T(strSetDosPIPFINFLOODErr));
				goto setErr;
			}
		}
		else{
			enabled &= ~0x40;
		}
		tmpStr = websGetVar(wp, T("ipfloodUDP"), T(""));
		if(!strcmp(tmpStr, "ON")) {
			enabled |= 0x80;
			tmpStr = websGetVar(wp, T("ipfloodUDPcount"), T(""));
			string_to_dec(tmpStr,&floodCount);
			if ( mib_set(MIB_DOS_PIPUDP_FLOOD, (void *)&floodCount) == 0) {
				strcpy(tmpBuf, T(strSetDosPIPUDPFLOODErr));
				goto setErr;
			}
		}
		else{
			enabled &= ~0x80;
		}
		tmpStr = websGetVar(wp, T("ipfloodICMP"), T(""));
		if(!strcmp(tmpStr, "ON")) {
			enabled |= 0x100;
			tmpStr = websGetVar(wp, T("ipfloodICMPcount"), T(""));
			string_to_dec(tmpStr,&floodCount);
			if ( mib_set(MIB_DOS_PIPICMP_FLOOD, (void *)&floodCount) == 0) {
				strcpy(tmpBuf, T(strSetDosPIPICMPFLOODErr));
				goto setErr;
			}
		}
		else{
			enabled &= ~0x100;
		}
		tmpStr = websGetVar(wp, T("TCPUDPPortScan"), T(""));
		if(!strcmp(tmpStr, "ON")) {
			enabled |= 0x200;

			tmpStr = websGetVar(wp, T("portscanSensi"), T(""));
			if( tmpStr[0]=='1' ) {
				enabled |= 0x800000;
			}
			else{
				enabled &= ~0x800000;
			}
		}
		else{
			enabled &= ~0x200;
		}
		tmpStr = websGetVar(wp, T("ICMPSmurfEnabled"), T(""));
		if(!strcmp(tmpStr, "ON")) {
			enabled |= 0x400;
		}
		else{
			enabled &= ~0x400;
		}
		tmpStr = websGetVar(wp, T("IPLandEnabled"), T(""));
		if(!strcmp(tmpStr, "ON")) {
			enabled |= 0x800;
		}
		else{
			enabled &= ~0x800;
		}
		tmpStr = websGetVar(wp, T("IPSpoofEnabled"), T(""));
		if(!strcmp(tmpStr, "ON")) {
			enabled |= 0x1000;
		}
		else{
			enabled &= ~0x1000;
		}
		tmpStr = websGetVar(wp, T("IPTearDropEnabled"), T(""));
		if(!strcmp(tmpStr, "ON")) {
			enabled |= 0x2000;
		}
		else{
			enabled &= ~0x2000;
		}
		tmpStr = websGetVar(wp, T("PingOfDeathEnabled"), T(""));
		if(!strcmp(tmpStr, "ON")) {
			enabled |= 0x4000;
		}
		else{
			enabled &= ~0x4000;
		}
		tmpStr = websGetVar(wp, T("TCPScanEnabled"), T(""));
		if(!strcmp(tmpStr, "ON")) {
			enabled |= 0x8000;
		}
		else{
			enabled &= ~0x8000;
		}
		tmpStr = websGetVar(wp, T("TCPSynWithDataEnabled"), T(""));
		if(!strcmp(tmpStr, "ON")) {
			enabled |= 0x10000;
		}
		else{
			enabled &= ~0x10000;
		}
		tmpStr = websGetVar(wp, T("UDPBombEnabled"), T(""));
		if(!strcmp(tmpStr, "ON")) {
			enabled |= 0x20000;
		}
		else{
			enabled &= ~0x20000;
		}
		tmpStr = websGetVar(wp, T("UDPEchoChargenEnabled"), T(""));
		if(!strcmp(tmpStr, "ON")) {
			enabled |= 0x40000;
		}
		else{
			enabled &= ~0x40000;
		}
		tmpStr = websGetVar(wp, T("sourceIPblock"), T(""));
		if(!strcmp(tmpStr, "ON")) {
			enabled |= 0x400000;
			tmpStr = websGetVar(wp, T("IPblockTime"), T(""));
			string_to_dec(tmpStr,&blockTimer);
			if ( mib_set(MIB_DOS_BLOCK_TIME, (void *)&blockTimer) == 0) {
				strcpy(tmpBuf, T(strSetDosIPBlockTimeErr));
				goto setErr;
			}
		}
		else{
			enabled &= ~0x400000;
		}
	}
	else
		enabled = 0;

	if ( mib_set(MIB_DOS_ENABLED, (void *)&enabled) == 0) {
		strcpy(tmpBuf, T(strSetDosEnableErr));
		goto setErr;
	}

	//apmib_update(CURRENT_SETTING);

#ifndef NO_ACTION
	run_init_script("all");
#endif

	submitUrl = websGetVar(wp, T("submit-url"), T(""));   // hidden page
	OK_MSG(submitUrl);
	return;

setErr:
	ERR_MSG(tmpBuf);
}
#endif

#if defined(ZTE_531B_BRIDGE_SC) || defined(ZTE_GENERAL_ROUTER_SC)
void ZTESoftwareVersion(int eid, webs_t wp, int argc, char_t * * argv)
{
	websWrite(wp, T(ZTESOFTWAREVERSION));
}
#endif

//added by gsw @ 2007/08/29
int createTopMenu(int eid, webs_t wp, int argc, char_t **argv)
{
	char_t	*name;
	
   	if (ejArgs(argc, argv, T("%s"), &name) < 1) {
   		websError(wp, 400, T("Insufficient args\n"));
   		return -1;
   	}
	

	//create the topMenu of system status
 	
	websWrite(wp, T("<td class=\"%s\" nowrap><a href=\"statusMenu.asp\"  	class=\"topMenuFont\"  onClick=\"topframectl('sysInfo', 'status_sc.asp')\" 	><font  color=\"#000000\" >%s</font></a></td>\n"),(!strcmp(name,"status"))?"selTopMenu":"unselTopMenu",TtopMenu_status);
	websWrite(wp, T("<td class=\"%s\" nowrap><a href=\"fastCfgMenu.asp\"  	class=\"topMenuFont\"  onClick=\"topframectl('fastCfg','fc-page1-ch.asp')\"	><font  color=\"#000000\" >%s</font></a></td>\n"),(!strcmp(name,"fastCfg"))?"selTopMenu":"unselTopMenu",TtopMenu_fastCfg);
	websWrite(wp, T("<td class=\"%s\" nowrap><a href=\"lanMenu.asp\"   		class=\"topMenuFont\"  onClick=\"topframectl('tcpiplan','tcpiplan_sc.asp')\"	><font  color=\"#000000\" >%s</font></a></td>\n"),(!strcmp(name,"lan"))?"selTopMenu":"unselTopMenu",TtopMenu_lan);
#ifdef 	WLAN_SUPPORT
	websWrite(wp, T("<td class=\"%s\" nowrap><a href=\"wlanMenu.asp\"   		class=\"topMenuFont\"  onClick=\"topframectl('wlBasic','wlbasic_sc.asp')\"	><font  color=\"#000000\" >%s</font></a></td>\n"),(!strcmp(name,"wlan"))?"selTopMenu":"unselTopMenu",TtopMenu_wlan);
#endif
	websWrite(wp, T("<td class=\"%s\" nowrap><a href=\"wanMenu.asp\"   		class=\"topMenuFont\"  onClick=\"topframectl('wanCfg','wanadsl_sc.asp')\"	><font  color=\"#000000\" >%s</font></a></td>\n"),(!strcmp(name,"wan"))?"selTopMenu":"unselTopMenu",TtopMenu_wan);
	websWrite(wp, T("<td class=\"%s\" nowrap><a href=\"advanceMenu.asp\"  	class=\"topMenuFont\"  onClick=\"topframectl('dnsSet','dns_sc.asp')\"		><font  color=\"#000000\" >%s</font></a></td>\n"),(!strcmp(name,"advance"))?"selTopMenu":"unselTopMenu",TtopMenu_advance);
	websWrite(wp, T("<td class=\"%s\" nowrap><a href=\"sysManageMenu.asp\"	class=\"topMenuFont\"  onClick=\"topframectl('rmtAcc','rmtacc_sc.asp')\"	><font  color=\"#000000\" >%s</font></a></td>\n"),(!strcmp(name,"sysManage"))?"selTopMenu":"unselTopMenu",TtopMenu_admin);
	websWrite(wp, T("<td class=\"%s\" nowrap><a href=\"sysDiagMenu.asp\"  	class=\"topMenuFont\"  onClick=\"topframectl('ping','ping-ch.asp')\"		><font  color=\"#000000\" >%s</font></a></td>\n"),(!strcmp(name,"sysDiag"))?"selTopMenu":"unselTopMenu",TtopMenu_diag);
			
	
	
	return 0;	
}

int createTopMenuForUser(int eid, webs_t wp, int argc, char_t **argv)
{
	char_t	*name;
	
   	if (ejArgs(argc, argv, T("%s"), &name) < 1) {
   		websError(wp, 400, T("Insufficient args\n"));
   		return -1;
   	}
	

	//create the topMenu of system status
 	
	websWrite(wp, T("<td class=\"%s\" nowrap><a href=\"statusMenu.asp\"  	class=\"topMenuFont\"  onClick=\"topframectl('sysInfo', 'status_sc.asp')\" 	><font  color=\"#000000\" >%s</font></a></td>\n"),(!strcmp(name,"status"))?"selTopMenu":"unselTopMenu",TtopMenu_status);
	websWrite(wp, T("<td class=\"%s\" nowrap><a href=\"sysManageMenu.asp\"  class=\"topMenuFont\"  onClick=\"topframectl('reboot','reboot_sc.asp')\"	><font  color=\"#000000\" >%s</font></a></td>\n"),(!strcmp(name,"sysManage"))?"selTopMenu":"unselTopMenu",TtopMenu_admin);
	websWrite(wp, T("<td class=\"unselTopMenu\" width=\"40%%\">&nbsp;</td>\n"));

	
	return 0;	
}


int createSubMenu(int eid, webs_t wp, int argc, char_t **argv)
{
	char_t	*name;
	
   	if (ejArgs(argc, argv, T("%s"), &name) < 1) {
   		websError(wp, 400, T("Insufficient args\n"));
   		return -1;
   	}

	//create the subMenu of system status
	websWrite(wp, T("<td class=\"erect\" >|</td>\n"));

	/************ create sub-menu of system status **************/
 	if ( !strcmp(name,"status") ) {		
		websWrite(wp, T("<td  nowrap><a href=\"#\"  class=\"subMenuFont\"   onClick=\"topframectl('sysInfo', 'status_sc.asp')\"><font  color=\"#FFFFFF\">%s</font></a></td>\n"
          		"<td class=\"erect\" >|</td>\n"),TsubMenu_sysInfo);
		websWrite(wp, T("<td   nowrap><a href=\"#\"  class=\"subMenuFont\"   onClick=\"topframectl('lanStatus', 'lan_status_sc.asp')\"><font  color=\"#FFFFFF\">%s</font></a></td>\n"
          		"<td class=\"erect\" >|</td>\n"),TsubMenu_lanStatus);		
#ifdef	WLAN_SUPPORT
		websWrite(wp, T("<td   nowrap><a href=\"#\"  class=\"subMenuFont\"   onClick=\"topframectl('wlanStatus', 'wlan_status_sc.asp')\"><font  color=\"#FFFFFF\">%s</font></a></td>\n"
          		"<td class=\"erect\" >|</td>\n"),TsubMenu_wlanStatus);		
#endif
		websWrite(wp, T("<td   nowrap><a href=\"#\"  class=\"subMenuFont\"   onClick=\"topframectl('wanStatus', 'wan_status_sc.asp')\"><font  color=\"#FFFFFF\">%s</font></a></td>\n"
          		"<td class=\"erect\" >|</td>\n"),TsubMenu_wanStatus);		
#ifdef	CONFIG_EXT_SWITCH
#ifdef 	ITF_GROUP
		websWrite(wp, T("<td   nowrap><a href=\"#\"  class=\"subMenuFont\"   onClick=\"topframectl('eth2pvcStatus', 'status_eth2pvc_sc.asp')\"><font  color=\"#FFFFFF\">%s</font></a></td>\n"
          		"<td class=\"erect\" >|</td>\n"),TsubMenu_eth2pvcSta);		
#endif	
#endif
		websWrite(wp, T("<td   nowrap><a href=\"#\"  class=\"subMenuFont\"   onClick=\"topframectl('statistic', 'stats_sc.asp')\"><font  color=\"#FFFFFF\">%s</font></a></td>\n"
          		"<td class=\"erect\" >|</td>\n"),TsubMenu_statistic);		
		websWrite(wp, T("<td   nowrap><a href=\"#\"  class=\"subMenuFont\"   onClick=\"topframectl('arpTbl', 'arptable_sc.asp')\"><font  color=\"#FFFFFF\">%s</font></a></td>\n"
          		"<td class=\"erect\" >|</td>\n"),TsubMenu_arpTable);		
	}

	/************ create sub-menu of fast config **************/
	if(!strcmp(name, "fastCfg")){
		websWrite(wp, T("<td   nowrap><a href=\"#\"  class=\"subMenuFont\"   onClick=\"topframectl('fastCfg', 'fc-page1-ch.asp')\"><font  color=\"#FFFFFF\">%s</font></a></td>\n"
          		"<td class=\"erect\" >|</td>\n"),TsubMenu_fastCfg);
	}

	/************ create sub-menu of local network **************/
	if(!strcmp(name, "lan")){
		websWrite(wp, T("<td   nowrap><a href=\"#\"  class=\"subMenuFont\"   onClick=\"topframectl('tcpiplan', 'tcpiplan_sc.asp')\"><font  color=\"#FFFFFF\">%s</font></a></td>\n"
          		"<td class=\"erect\" >|</td>\n"),TsubMenu_lanSet);
		websWrite(wp, T("<td   nowrap><a href=\"#\"  class=\"subMenuFont\"   onClick=\"topframectl('dhcpCfg', 'dhcpd_sc.asp')\"><font  color=\"#FFFFFF\">%s</font></a></td>\n"
          		"<td class=\"erect\" >|</td>\n"),TsubMenu_dhcp);	
	}

	/************ create sub-menu of wireless network **************/
#ifdef	WLAN_SUPPORT	
	if(!strcmp(name, "wlan")){

		websWrite(wp, T("<td   nowrap><a href=\"#\"  class=\"subMenuFont\"   onClick=\"topframectl('wlBasic', 'wlbasic_sc.asp')\"><font  color=\"#FFFFFF\">%s</font></a></td>\n"
          		"<td class=\"erect\" >|</td>\n"),TsubMenu_wlBacis);
#ifdef 	WLAN_MBSSID
		websWrite(wp, T("<td   nowrap><a href=\"#\"  class=\"subMenuFont\"   onClick=\"topframectl('wlSecuriy', 'wlwpa_mbssid_sc.asp')\"><font  color=\"#FFFFFF\">%s</font></a></td>\n"
          		"<td class=\"erect\" >|</td>\n"),TsubMenu_wlSecurity);
#else
		websWrite(wp, T("<td   nowrap><a href=\"#\"  class=\"subMenuFont\"   onClick=\"topframectl('wlSecuriy', 'wlwpa_sc.asp')\"><font  color=\"#FFFFFF\">%s</font></a></td>\n"
          		"<td class=\"erect\" >|</td>\n"),TsubMenu_wlSecurity);
#endif
		websWrite(wp, T("<td   nowrap><a href=\"#\"  class=\"subMenuFont\"   onClick=\"topframectl('wlAdvance', 'wladvanced_sc.asp')\"><font  color=\"#FFFFFF\">%s</font></a></td>\n"
          		"<td class=\"erect\" >|</td>\n"),TsubMenu_wlAdvance);
#ifdef 	WLAN_ACL
		websWrite(wp, T("<td   nowrap><a href=\"#\"  class=\"subMenuFont\"   onClick=\"topframectl('wlAccess', 'wlactrl_sc.asp')\"><font  color=\"#FFFFFF\">%s</font></a></td>\n"
          		"<td class=\"erect\" >|</td>\n"),TsubMenu_wlAccess);
#endif
#ifdef 	WLAN_WDS
		websWrite(wp, T("<td   nowrap><a href=\"#\"  class=\"subMenuFont\"   onClick=\"topframectl('wdsSet', 'wlwds_sc.asp')\"><font  color=\"#FFFFFF\">%s</font></a></td>\n"
          		"<td class=\"erect\" >|</td>\n"),TsubMenu_wdsSet);
#endif
	}
#endif

	/************ create sub-menu of wan **************/
	if(!strcmp(name, "wan")){
		websWrite(wp, T("<td   nowrap><a href=\"#\"  class=\"subMenuFont\"   onClick=\"topframectl('wanCfg', 'wanadsl_sc.asp')\"><font  color=\"#FFFFFF\">%s</font></a></td>\n"
          		"<td class=\"erect\" >|</td>\n"),TsubMenu_wanCfg);
		websWrite(wp, T("<td   nowrap><a href=\"#\"  class=\"subMenuFont\"   onClick=\"topframectl('adslCfg', 'adv/adsl-set_sc.asp')\"><font  color=\"#FFFFFF\">%s</font></a></td>\n"
          		"<td class=\"erect\" >|</td>\n"),TsubMenu_adslCfg);	
	}

	/************ create sub-menu of advance setting **************/
	if(!strcmp(name, "advance")){
		websWrite(wp, T("<td   nowrap><a href=\"#\"  class=\"subMenuFont\"   onClick=\"topframectl('dnsSet', 'dns_sc.asp')\"><font  color=\"#FFFFFF\">%s</font></a></td>\n"
          		"<td class=\"erect\" >|</td>\n"),TsubMenu_dnsSet);
		websWrite(wp, T("<td   nowrap><a href=\"#\"  class=\"subMenuFont\"   onClick=\"topframectl('firewall', 'fw-ipportfilter_sc.asp')\"><font  color=\"#FFFFFF\">%s</font></a></td>\n"
          		"<td class=\"erect\" >|</td>\n"),TsubMenu_firewall);	
		websWrite(wp, T("<td   nowrap><a href=\"#\"  class=\"subMenuFont\"   onClick=\"topframectl('virtualSrv', 'vrtsrv_sc.asp')\"><font  color=\"#FFFFFF\">%s</font></a></td>\n"
          		"<td class=\"erect\" >|</td>\n"),TsubMenu_virtualSrv);
		websWrite(wp, T("<td   nowrap><a href=\"#\"  class=\"subMenuFont\"   onClick=\"topframectl('routeSet', 'rip_sc.asp')\"><font  color=\"#FFFFFF\">%s</font></a></td>\n"
          		"<td class=\"erect\" >|</td>\n"),TsubMenu_routeSet);	
#ifdef IP_QOS
		websWrite(wp, T("<td   nowrap><a href=\"#\"  class=\"subMenuFont\"   onClick=\"topframectl('ipqos', 'ipqos_sc.asp')\"><font  color=\"#FFFFFF\">%s</font></a></td>\n"
          		"<td class=\"erect\" >|</td>\n"),TsubMenu_ipqos);
#endif
#ifdef DOS_SUPPORT
		websWrite(wp, T("<td   nowrap><a href=\"#\"  class=\"subMenuFont\"   onClick=\"topframectl('dosSet', 'dos.asp')\"><font  color=\"#FFFFFF\">%s</font></a></td>\n"
          		"<td class=\"erect\" >|</td>\n"),TsubMenu_dosSet);	
#endif
#ifdef	CONFIG_EXT_SWITCH
#ifdef 	ITF_GROUP
		websWrite(wp, T("<td   nowrap><a href=\"#\"  class=\"subMenuFont\"   onClick=\"topframectl('eth2pvc', 'eth2pvc_sc.asp')\"><font  color=\"#FFFFFF\">%s</font></a></td>\n"
          		"<td class=\"erect\" >|</td>\n"),TsubMenu_eth2pvc);
#endif
#endif
		websWrite(wp, T("<td  nowrap><a href=\"#\"  class=\"subMenuFont\"   onClick=\"topframectl('otherSet', 'igmproxy_sc.asp')\"><font  color=\"#FFFFFF\">%s</font></a></td>\n"
          		"<td class=\"erect\" >|</td>\n"),TsubMenu_otherSet);	

	}

	/************ create sub-menu of system management **************/
	if(!strcmp(name, "sysManage")){
          	websWrite(wp, T("<td   nowrap><a href=\"#\"  class=\"subMenuFont\"   onClick=\"topframectl('rmtAcc', 'rmtacc_sc.asp')\"><font  color=\"#FFFFFF\" >%s</font></a></td>\n"
          		"<td class=\"erect\" >|</td>\n"),TsubMenu_rmtAcc);     
          	websWrite(wp, T("<td   nowrap><a href=\"#\"  class=\"subMenuFont\"   onClick=\"topframectl('reboot', 'reboot_sc.asp')\"><font  color=\"#FFFFFF\" >%s</font></a></td>\n"
          		"<td class=\"erect\" >|</td>\n"),TsubMenu_reboot);     
          	websWrite(wp, T("<td   nowrap><a href=\"#\"  class=\"subMenuFont\"   onClick=\"topframectl('passwd', 'password_sc.asp')\"><font  color=\"#FFFFFF\" >%s</font></a></td>\n"
          		"<td class=\"erect\" >|</td>\n"),TsubMenu_passwd);     
#ifdef 	CONFIG_SAVE_RESTORE		
          	websWrite(wp, T("<td   nowrap><a href=\"#\"  class=\"subMenuFont\"   onClick=\"topframectl('backup', 'saveconf_sc.asp')\"><font  color=\"#FFFFFF\" >%s</font></a></td>\n"
          		"<td class=\"erect\" >|</td>\n"),TsubMenu_backup);     
#endif
#ifdef WEB_UPGRADE
#ifdef UPGRADE_V1
		websWrite(wp, T("<td   nowrap><a href=\"#\"  class=\"subMenuFont\"   onClick=\"topframectl('upgrade', 'upload_sc.asp')\"><font  color=\"#FFFFFF\" >%s</font></a></td>\n"
          		"<td class=\"erect\" >|</td>\n"),TsubMenu_upgrade);     
#endif
#endif
		websWrite(wp, T("<td   nowrap><a href=\"#\"  class=\"subMenuFont\"   onClick=\"topframectl('timeZone', 'date_sc.asp')\"><font  color=\"#FFFFFF\" >%s</font></a></td>\n"
          		"<td class=\"erect\" >|</td>\n"),TsubMenu_timeZone);     
#ifdef SYSLOG_SUPPORT
          	websWrite(wp, T("<td   nowrap><a href=\"#\"  class=\"subMenuFont\"   onClick=\"topframectl('syslog', 'syslog_sc.asp')\"><font  color=\"#FFFFFF\" >%s</font></a></td>\n"
          		"<td class=\"erect\" >|</td>\n"),TsubMenu_syslog);   
#endif
          	websWrite(wp, T("<td   nowrap><a href=\"#\"  class=\"subMenuFont\"   onClick=\"topframectl('snmpSet', 'snmp_sc.asp')\"><font  color=\"#FFFFFF\" >%s</font></a></td>\n"
          		"<td class=\"erect\" >|</td>\n"),TsubMenu_snmp);     
#ifdef 	_CWMP_MIB_  
          	websWrite(wp, T("<td   nowrap><a href=\"#\"  class=\"subMenuFont\"   onClick=\"topframectl('tr069', 'tr069config_sc.asp')\"><font  color=\"#FFFFFF\" >%s</font></a></td>\n"
          		"<td class=\"erect\" >|</td>\n"),TsubMenu_tr069);
#endif
#ifdef	IP_ACL
#ifndef MAC_ACL
          	websWrite(wp, T("<td  nowrap><a href=\"#\"  class=\"subMenuFont\"   onClick=\"topframectl('aclCfg', 'acl_sc.asp')\"><font  color=\"#FFFFFF\" >%s</font></a></td>\n"
          		"<td class=\"erect\" >|</td>\n"),TsubMenu_aclCfg);
#else
          	websWrite(wp, T("<td  nowrap><a href=\"#\"  class=\"subMenuFont\"   onClick=\"topframectl('aclCfg', 'acl_adv.asp')\"><font  color=\"#FFFFFF\" >%s</font></a></td>\n"
          		"<td class=\"erect\" >|</td>\n"),TsubMenu_aclCfg);
#endif
#endif
	}

	/************ create sub-menu of system diag **************/
	if(!strcmp(name, "sysDiag")){

          	websWrite(wp, T("<td   nowrap><a href=\"#\"  class=\"subMenuFont\"   onClick=\"topframectl('ping', 'ping-ch.asp')\"><font  color=\"#FFFFFF\" >%s</font></a></td>\n"
          		"<td class=\"erect\" >|</td>\n"),TsubMenu_ping);     
          	websWrite(wp, T("<td   nowrap><a href=\"#\"  class=\"subMenuFont\"   onClick=\"topframectl('atmTest', 'oamloopback-ch.asp')\"><font  color=\"#FFFFFF\" >%s</font></a></td>\n"
          		"<td class=\"erect\" >|</td>\n"),TsubMenu_atmTest);     
          	websWrite(wp, T("<td   nowrap><a href=\"#\"  class=\"subMenuFont\"   onClick=\"topframectl('adslTest', 'adv/adsl-diag-ch.asp')\"><font  color=\"#FFFFFF\" >%s</font></a></td>\n"
          		"<td class=\"erect\" >|</td>\n"),TsubMenu_adslTest);   
#ifdef DIAGNOSTIC_TEST
          	websWrite(wp, T("<td   nowrap><a href=\"#\"  class=\"subMenuFont\"   onClick=\"topframectl('diagTest', 'diag-test-ch.asp')\"><font  color=\"#FFFFFF\" >%s</font></a></td>\n"
          		"<td class=\"erect\" >|</td>\n"),TsubMenu_diag);     
#endif

	}
		
	return 0;
}


int createSubMenuForUser(int eid, webs_t wp, int argc, char_t **argv)
{
	char_t	*name;
	
   	if (ejArgs(argc, argv, T("%s"), &name) < 1) {
   		websError(wp, 400, T("Insufficient args\n"));
   		return -1;
   	}

	//create the subMenu of system status
	websWrite(wp, T("<td class=\"erect\" >|</td>\n"));

	/************ create sub-menu of system status **************/
 	if ( !strcmp(name,"status") ) {		
		websWrite(wp, T("<td   nowrap><a href=\"#\"  class=\"subMenuFont\"   onClick=\"topframectl('sysInfo', 'status_sc.asp')\"><font  color=\"#FFFFFF\">%s</font></a></td>\n"
          		"<td class=\"erect\" >|</td>\n"),TsubMenu_sysInfo);
		websWrite(wp, T("<td   nowrap><a href=\"#\"  class=\"subMenuFont\"   onClick=\"topframectl('lanStatus', 'lan_status_sc.asp')\"><font  color=\"#FFFFFF\">%s</font></a></td>\n"
          		"<td class=\"erect\" >|</td>\n"),TsubMenu_lanStatus);		
#ifdef	WLAN_SUPPORT
		websWrite(wp, T("<td   nowrap><a href=\"#\"  class=\"subMenuFont\"   onClick=\"topframectl('wlanStatus', 'wlan_status_sc.asp')\"><font  color=\"#FFFFFF\">%s</font></a></td>\n"
          		"<td class=\"erect\" >|</td>\n"),TsubMenu_wlanStatus);		
#endif
		websWrite(wp, T("<td   nowrap><a href=\"#\"  class=\"subMenuFont\"   onClick=\"topframectl('wanStatus', 'wan_status_sc.asp')\"><font  color=\"#FFFFFF\">%s</font></a></td>\n"
          		"<td class=\"erect\" >|</td>\n"),TsubMenu_wanStatus);		
#ifdef	CONFIG_EXT_SWITCH
#ifdef 	ITF_GROUP
		websWrite(wp, T("<td   nowrap><a href=\"#\"  class=\"subMenuFont\"   onClick=\"topframectl('eth2pvcStatus', 'status_eth2pvc_sc.asp')\"><font  color=\"#FFFFFF\">%s</font></a></td>\n"
          		"<td class=\"erect\" >|</td>\n"),TsubMenu_eth2pvcSta);		
#endif	
#endif
		websWrite(wp, T("<td   nowrap><a href=\"#\"  class=\"subMenuFont\"   onClick=\"topframectl('statistic', 'stats_sc.asp')\"><font  color=\"#FFFFFF\">%s</font></a></td>\n"
          		"<td class=\"erect\" >|</td>\n"),TsubMenu_statistic);		
		websWrite(wp, T("<td   nowrap><a href=\"#\"  class=\"subMenuFont\"   onClick=\"topframectl('arpTbl', 'arptable_sc.asp')\"><font  color=\"#FFFFFF\">%s</font></a></td>\n"
          		"<td class=\"erect\" >|</td>\n"),TsubMenu_arpTable);		
	}

	/************ create sub-menu of system management **************/
	if(!strcmp(name, "sysManage")){
          	websWrite(wp, T("<td   nowrap><a href=\"#\"  class=\"subMenuFont\"   onClick=\"topframectl('reboot', 'reboot_sc.asp')\"><font  color=\"#FFFFFF\" >%s</font></a></td>\n"
          		"<td class=\"erect\" >|</td>\n"),TsubMenu_reboot);     
          	websWrite(wp, T("<td   nowrap><a href=\"#\"  class=\"subMenuFont\"   onClick=\"topframectl('passwd', 'password_sc.asp')\"><font  color=\"#FFFFFF\" >%s</font></a></td>\n"
          		"<td class=\"erect\" >|</td>\n"),TsubMenu_passwd);     
#ifdef 	CONFIG_SAVE_RESTORE		
          	websWrite(wp, T("<td   nowrap><a href=\"#\"  class=\"subMenuFont\"   onClick=\"topframectl('backup', 'saveconf_sc.asp')\"><font  color=\"#FFFFFF\" >%s</font></a></td>\n"
          		"<td class=\"erect\" >|</td>\n"),TsubMenu_backup);     
#endif
#ifdef WEB_UPGRADE
#ifdef UPGRADE_V1
		websWrite(wp, T("<td   nowrap><a href=\"#\"  class=\"subMenuFont\"   onClick=\"topframectl('upgrade', 'upload_sc.asp')\"><font  color=\"#FFFFFF\" >%s</font></a></td>\n"
          		"<td class=\"erect\" >|</td>\n"),TsubMenu_upgrade);     
#endif
#endif  
#ifdef SYSLOG_SUPPORT
          	websWrite(wp, T("<td  nowrap><a href=\"#\"  class=\"subMenuFont\"   onClick=\"topframectl('syslog', 'syslog_sc.asp')\"><font  color=\"#FFFFFF\" >%s</font></a></td>\n"
          		"<td class=\"erect\" >|</td>\n"),TsubMenu_syslog);   
#endif
	}

	return 0;
}

int createLeftMenu(int eid, webs_t wp, int argc, char_t **argv)
{
	char_t	*name;
	
   	if (ejArgs(argc, argv, T("%s"), &name) < 1) {
   		websError(wp, 400, T("Insufficient args\n"));
   		return -1;
   	}

	
	if(!strcmp(name, "admin")){
	/************************  system status ******************************/
		websWrite(wp, T("<div id=\"sysInfo\" style=\"display:inline \">\n"     
  	    		"<table width=\"100%%\"  border=\"0\" cellspacing=\"0\" cellpadding=\"0\">"
  	      		"<tr><td class=\"leftMenu\"><a href=\"status_sc.asp\" target=\"mainFrame\">%s</a></td></tr>"        
  	    		"</table>\n"
		  	"</div>\n"),TleftMenu_sysInfo); 
		websWrite(wp, T("<div id=\"lanStatus\" style=\"display:none \">\n"     
  	    		"<table width=\"100%%\"  border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\n"
  	      		"<tr><td class=\"leftMenu\"><a href=\"lan_status_sc.asp\" target=\"mainFrame\">%s</a></td></tr>\n"        
  	    		"</table>\n"
		  	"</div>\n"),TleftMenu_lanStatus); 	  
		websWrite(wp, T("<div id=\"wlanStatus\" style=\"display:none \">\n"     
  	   		"<table width=\"100%%\"  border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\n"
  	      		"<tr><td class=\"leftMenu\"><a href=\"wlan_status_sc.asp\" target=\"mainFrame\">%s</a></td></tr>\n"        
  	   		"</table>\n"
		  	"</div>\n"),TleftMenu_wlanStatus); 	  
		websWrite(wp, T("<div id=\"wanStatus\" style=\"display:none \">\n"     
  	    		"<table width=\"100%%\"  border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\n"
  	      		"<tr><td class=\"leftMenu\"><a href=\"wan_status_sc.asp\" target=\"mainFrame\">%s</a></td></tr>\n"        
  	    		"</table>\n"
		  	"</div>\n"),TleftMenu_wanStatus); 	  
#ifdef	CONFIG_EXT_SWITCH
#ifdef 	ITF_GROUP
		websWrite(wp, T("<div id=\"eth2pvcStatus\" style=\"display:none \">\n"     
  	   		"<table width=\"100%%\"  border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\n"
  	      		"<tr><td class=\"leftMenu\"><a href=\"status_eth2pvc_sc.asp\" target=\"mainFrame\">%s</a></td></tr>\n"        
  	    		"</table>\n"
		  	"</div>\n"),TleftMenu_eth2pvcSta); 	  
#endif
#endif
		websWrite(wp, T("<div id=\"statistic\" style=\"display:none \">\n"     
  	    		"<table width=\"100%%\"  border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\n"
  	     		"<tr><td class=\"leftMenu\"><a href=\"stats_sc.asp\" target=\"mainFrame\">%s</a></td></tr>\n" 
			"<tr><td class=\"leftMenu\"><a href=\"adv/adsl-statis_sc.asp\" target=\"mainFrame\">%s</a></td></tr>\n"         
 		 	"</table>\n"
			"</div>\n"),TleftMenu_ifStatistic,TleftMenu_dslStatistic); 	  
		websWrite(wp, T("<div id=\"arpTbl\" style=\"display:none \">\n"     
  		    	"<table width=\"100%%\"  border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\n"
  		      	"<tr><td class=\"leftMenu\"><a href=\"arptable_sc.asp\" target=\"mainFrame\">%s</a></td></tr>\n"        
	  	    	"</table>\n"
			"</div>\n"),TleftMenu_arpTable); 	    
	  /******************************  fast config ****************************/
	      	websWrite(wp, T("<div id=\"fastCfg\" style=\"display:none \">\n"
		  	"<table width=\"100%%\"  border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\n"
	       	"<tr><td class=\"leftMenu\"><a href=\"fc-page1-ch.asp\" target=\"mainFrame\">%s</a></td></tr>\n"
	      		"</table>\n"
		  	"</div>\n"),TleftMenu_fastCfg);
	  /******************************  lan config ******************************/
	      websWrite(wp, T("<div id=\"tcpiplan\" style=\"display:none \">\n"
		 	 "<table width=\"100%%\"  border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\n"
	        	"<tr><td class=\"leftMenu\"><a href=\"tcpiplan_sc.asp\" target=\"mainFrame\">%s</a></td></tr>\n"
	     	 	"</table>\n"
		  	"</div>\n"),TleftMenu_lanSet);	  
		websWrite(wp, T("<div id=\"dhcpCfg\" style=\"display:none \">\n"
			  "<table width=\"100%%\"  border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\n"
		        "<tr><td class=\"leftMenu\"><a href=\"dhcpd_sc.asp\" target=\"mainFrame\">%s</a></td></tr>\n"
		      "</table>\n"
			  "</div>\n"),TleftMenu_dhcp);
	  /******************************  wlan config ******************************/
#ifdef	WLAN_SUPPORT
	 	websWrite(wp, T("<div id=\"wlBasic\" style=\"display:none \">\n"
			  "<table width=\"100%%\"  border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\n"
		        "<tr><td class=\"leftMenu\"><a href=\"wlbasic_sc.asp\" target=\"mainFrame\">%s</a></td></tr>\n"
		      "</table>\n"
			  "</div>\n"),TleftMenu_wlBasic);	

	  	websWrite(wp, T("<div id=\"wlSecuriy\" style=\"display:none \">\n"
			  "<table width=\"100%%\"  border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\n"
#ifdef 	WLAN_MBSSID
		        "<tr><td class=\"leftMenu\"><a href=\"wlwpa_mbssid_sc.asp\" target=\"mainFrame\">%s</a></td></tr>\n"
#else
		        "<tr><td class=\"leftMenu\"><a href=\"wlwpa_sc.asp\" target=\"mainFrame\">%s</a></td></tr>\n"
#endif
		      "</table>\n"
			  "</div>\n"),TleftMenu_wlSec);	
	  	websWrite(wp, T("<div id=\"wlAdvance\" style=\"display:none \">\n"
			  "<table width=\"100%%\"  border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\n"
		        "<tr><td class=\"leftMenu\"><a href=\"wladvanced_sc.asp\" target=\"mainFrame\">%s</a></td></tr>\n"
		      "</table>\n"
			  "</div>\n"),TleftMenu_wlAdvance);	
#ifdef 	WLAN_ACL
	  	websWrite(wp, T("<div id=\"wlAccess\" style=\"display:none \">\n"
			  "<table width=\"100%%\"  border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\n"
		        "<tr><td class=\"leftMenu\"><a href=\"wlactrl_sc.asp\" target=\"mainFrame\">%s</a></td></tr>\n"
		      "</table>\n"
			  "</div>\n"),TleftMenu_wlAccess);	
#endif
#ifdef 	WLAN_WDS
	  	websWrite(wp, T("<div id=\"wdsSet\" style=\"display:none \">\n"
			  "<table width=\"100%%\"  border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\n"
		        "<tr><td class=\"leftMenu\"><a href=\"wlwds_sc.asp\" target=\"mainFrame\">%s</a></td></tr>\n"
		      "</table>\n"
			  "</div>\n"),TleftMenu_wds);	
#endif
#endif
	  /******************************  wan config ******************************/
      		websWrite(wp, T("<div id=\"wanCfg\" style=\"display:none \">\n"
			  "<table width=\"100%%\"  border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\n"
		        "<tr><td class=\"leftMenu\"><a href=\"wanadsl_sc.asp\" target=\"mainFrame\">%s</a></td></tr>\n"
		      "</table>\n"
			  "</div>\n"),TleftMenu_wanCfg);	  
	  	websWrite(wp, T("<div id=\"adslCfg\" style=\"display:none \">\n"
			  "<table width=\"100%%\"  border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\n"
		        "<tr><td class=\"leftMenu\"><a href=\"adv/adsl-set_sc.asp\" target=\"mainFrame\">%s</a></td></tr>\n"
		      "</table>\n"
			  "</div>\n"),TleftMenu_adslCfg);	
	  /******************************  advance config ******************************/
      		websWrite(wp, T("<div id=\"dnsSet\" style=\"display:none \">\n"
			  "<table width=\"100%%\"  border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\n"
		        "<tr><td class=\"leftMenu\"><a href=\"dns_sc.asp\" target=\"mainFrame\">%s</a></td></tr>\n"
#ifdef CONFIG_USER_DDNS	
		        "<tr><td class=\"leftMenu\"><a href=\"ddns.asp\" target=\"mainFrame\">%s</a></td></tr>\n"
#endif
			"</table>\n"
			  "</div>\n"),TleftMenu_dns
#ifdef CONFIG_USER_DDNS
			,TleftMenu_ddns
#endif
			);	  

	  	websWrite(wp, T("<div id=\"firewall\" style=\"display:none \">\n"
			  "<table width=\"100%%\"  border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\n"
		        "<tr><td class=\"leftMenu\"><a href=\"fw-ipportfilter_sc.asp\" target=\"mainFrame\">%s</a></td></tr>\n"
		        "<tr><td class=\"leftMenu\"><a href=\"fw-macfilter_sc.asp\" target=\"mainFrame\">%s</a></td></tr>\n"
#ifdef URL_BLOCKING_SUPPORT			
       		 "<tr><td class=\"leftMenu\"><a href=\"url_blocking_sc.asp\" target=\"mainFrame\">%s</a></td></tr>\n"
#endif      
		      "</table>\n"
			  "</div>\n"),TleftMenu_ipFilter,TleftMenu_macFilter
#ifdef URL_BLOCKING_SUPPORT	
			,TleftMenu_urlBlocking
#endif
			);	
      		websWrite(wp, T("<div id=\"virtualSrv\" style=\"display:none \">\n"
			  "<table width=\"100%%\"  border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\n"
		        "<tr><td class=\"leftMenu\"><a href=\"vrtsrv_sc.asp\" target=\"mainFrame\">%s</a></td></tr>\n"
				"<tr><td class=\"leftMenu\"><a href=\"fw-dmz_sc.asp\" target=\"mainFrame\">%s</a></td></tr>\n"
		      "</table>\n"
			  "</div>\n"),TleftMenu_virtServer,TleftMenu_dmz);	  
	  	websWrite(wp, T("<div id=\"routeSet\" style=\"display:none \">\n"
			  "<table width=\"100%%\"  border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\n"
		        "<tr><td class=\"leftMenu\"><a href=\"rip_sc.asp\" target=\"mainFrame\">%s</a></td></tr>\n"
				"<tr><td class=\"leftMenu\"><a href=\"routing_sc.asp\" target=\"mainFrame\">%s</a></td></tr>\n"
		      "</table>\n"
			  "</div>\n"),TleftMenu_dRoute,TleftMenu_sRoute);	
#ifdef IP_QOS
      		websWrite(wp, T("<div id=\"ipqos\" style=\"display:none \">\n"
			  "<table width=\"100%%\"  border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\n"
		        "<tr><td class=\"leftMenu\"><a href=\"ipqos_sc.asp\" target=\"mainFrame\">%s</a></td></tr>\n"
		      "</table>\n"
			  "</div>\n"),TleftMenu_ipqos);	  
#endif
#ifdef DOS_SUPPORT
	  	websWrite(wp, T("<div id=\"dosSet\" style=\"display:none \">\n"
			  "<table width=\"100%%\"  border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\n"
		        "<tr><td class=\"leftMenu\"><a href=\"dos.asp\" target=\"mainFrame\">%s</a></td></tr>\n"
		      "</table>\n"
			  "</div>\n"),TleftMenu_dosSet);	
#endif
#ifdef	CONFIG_EXT_SWITCH
#ifdef 	ITF_GROUP
      		websWrite(wp, T("<div id=\"eth2pvc\" style=\"display:none \">\n"
			  "<table width=\"100%%\"  border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\n"
		        "<tr><td class=\"leftMenu\"><a href=\"eth2pvc_sc.asp\" target=\"mainFrame\">%s</a></td></tr>\n"
		      "</table>\n"
			  "</div>\n"),TleftMenu_eth2pvc);	
#endif
#endif
	  	websWrite(wp, T("<div id=\"otherSet\" style=\"display:none \">\n"
	  		"<table width=\"100%%\"  border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\n"
#ifdef CONFIG_USER_IGMPPROXY
		        	"<tr><td class=\"leftMenu\"><a href=\"igmproxy_sc.asp\" target=\"mainFrame\">%s</a></td></tr>\n"
#endif
#if defined(CONFIG_USER_UPNPD)||defined(CONFIG_USER_MINIUPNPD)
				"<tr><td class=\"leftMenu\"><a href=\"upnp_sc.asp\" target=\"mainFrame\">%s</a></td></tr>\n"
#endif
				"<tr><td class=\"leftMenu\"><a href=\"bridging_sc.asp\" target=\"mainFrame\">%s</a></td></tr>\n"
				"<tr><td class=\"leftMenu\"><a href=\"others_sc.asp\" target=\"mainFrame\">%s</a></td></tr>\n"
		      "</table>\n"
			  "</div>\n")
#ifdef CONFIG_USER_IGMPPROXY
			,TleftMenu_igmp
#endif
#if defined(CONFIG_USER_UPNPD)||defined(CONFIG_USER_MINIUPNPD)
			,TleftMenu_upnp
#endif
			,TleftMenu_brg,TleftMenu_ipPassThro);	
	  /******************************  system management ******************************/
	  	websWrite(wp, T("<div id=\"rmtAcc\" style=\"display:none \">\n"
			  "<table width=\"100%%\"  border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\n"
		        "<tr><td class=\"leftMenu\"><a href=\"rmtacc_sc.asp\" target=\"mainFrame\">%s</a></td></tr>\n"
		      "</table>\n"
			  "</div>\n"),TleftMenu_rmAcc);		
	  	websWrite(wp, T("<div id=\"reboot\" style=\"display:none \">\n"
			  "<table width=\"100%%\"  border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\n"
		        "<tr><td class=\"leftMenu\"><a href=\"reboot_sc.asp\" target=\"mainFrame\">%s</a></td></tr>\n"
		      "</table>\n"
			  "</div>\n"),TleftMenu_reboot);		
	  	websWrite(wp, T("<div id=\"passwd\" style=\"display:none \">\n"
			  "<table width=\"100%%\"  border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\n"
		        "<tr><td class=\"leftMenu\"><a href=\"password_sc.asp\" target=\"mainFrame\">%s</a></td></tr>\n"
		      "</table>\n"
			  "</div>\n"),TleftMenu_passwd);	
#ifdef 	CONFIG_SAVE_RESTORE
	  	websWrite(wp, T("<div id=\"backup\" style=\"display:none \">\n"
			  "<table width=\"100%%\"  border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\n"
		        "<tr><td class=\"leftMenu\"><a href=\"saveconf_sc.asp\" target=\"mainFrame\">%s</a></td></tr>\n"
		      "</table>\n"
			  "</div>\n"),TleftMenu_backup);	
#endif

#ifdef WEB_UPGRADE
#ifdef UPGRADE_V1
	  	websWrite(wp, T("<div id=\"upgrade\" style=\"display:none \">\n"
			  "<table width=\"100%%\"  border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\n"
		        "<tr><td class=\"leftMenu\"><a href=\"upload_sc.asp\" target=\"mainFrame\">%s</a></td></tr>\n"
		      "</table>\n"
			  "</div>\n"),TleftMenu_upgrade);		
#endif
#endif
	  	websWrite(wp, T("<div id=\"timeZone\" style=\"display:none \">\n"
			  "<table width=\"100%%\"  border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\n"
		        "<tr><td class=\"leftMenu\"><a href=\"date_sc.asp\" target=\"mainFrame\">%s</a></td></tr>\n"
		      "</table>\n"
			  "</div>\n"),TleftMenu_timeZone);		
#ifdef SYSLOG_SUPPORT
	  	websWrite(wp, T("<div id=\"syslog\" style=\"display:none \">\n"
			  "<table width=\"100%%\"  border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\n"
		        "<tr><td class=\"leftMenu\"><a href=\"syslog_sc.asp\" target=\"mainFrame\">%s</a></td></tr>\n"
		      "</table>\n"
			  "</div>\n"),TleftMenu_syslog);
#endif
	  	websWrite(wp, T("<div id=\"snmpSet\" style=\"display:none \">\n"
			  "<table width=\"100%%\"  border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\n"
		        "<tr><td class=\"leftMenu\"><a href=\"snmp_sc.asp\" target=\"mainFrame\">%s</a></td></tr>\n"
		      "</table>\n"
			  "</div>\n"),TleftMenu_snmp);		
#ifdef 	_CWMP_MIB_  
	  	websWrite(wp, T("<div id=\"tr069\" style=\"display:none \">\n"
			  "<table width=\"100%%\"  border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\n"
		        "<tr><td class=\"leftMenu\"><a href=\"tr069config_sc.asp\" target=\"mainFrame\">%s</a></td></tr>\n"
		      "</table>\n"
			  "</div>\n"),TleftMenu_tr069);
#endif
#ifdef	IP_ACL
	  	websWrite(wp, T("<div id=\"aclCfg\" style=\"display:none \">\n"
			  "<table width=\"100%%\"  border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\n"
#ifndef MAC_ACL
		        "<tr><td class=\"leftMenu\"><a href=\"acl_sc.asp\" target=\"mainFrame\">%s</a></td></tr>\n"
#else
		        "<tr><td class=\"leftMenu\"><a href=\"acl_adv.asp\" target=\"mainFrame\">%s</a></td></tr>\n"
#endif
		      "</table>\n"
			  "</div>\n"),TleftMenu_acl);		
#endif
	  /******************************  system diag ******************************/
	  	websWrite(wp, T("<div id=\"ping\" style=\"display:none \">\n"
			  "<table width=\"100%%\"  border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\n"
		        "<tr><td class=\"leftMenu\"><a href=\"ping-ch.asp\" target=\"mainFrame\">%s</a></td></tr>\n"
		      "</table>\n"
			  "</div>\n"),TleftMenu_ping);		
	  	websWrite(wp, T("<div id=\"atmTest\" style=\"display:none \">\n"
			  "<table width=\"100%%\"  border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\n"
		        "<tr><td class=\"leftMenu\"><a href=\"oamloopback-ch.asp\" target=\"mainFrame\">%s</a></td></tr>\n"
		      "</table>\n"
			  "</div>\n"),TleftMenu_atmTest);		
	  	websWrite(wp, T("<div id=\"adslTest\" style=\"display:none \">\n"
			  "<table width=\"100%%\"  border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\n"
		        "<tr><td class=\"leftMenu\"><a href=\"adv/adsl-diag-ch.asp\" target=\"mainFrame\">%s</a></td></tr>\n"
		      "</table>\n"
			  "</div>\n"),TleftMenu_adslTest);		
#ifdef DIAGNOSTIC_TEST
	  	websWrite(wp, T("<div id=\"diagTest\" style=\"display:none \">\n"
			  "<table width=\"100%%\"  border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\n"
		        "<tr><td class=\"leftMenu\"><a href=\"diag-test-ch.asp\" target=\"mainFrame\">%s</a></td></tr>\n"
		      "</table>\n"
			  "</div>\n"),TleftMenu_diag);				
#endif
	
	}

	if(!strcmp(name, "user")){
		websWrite(wp, T("<div id=\"sysInfo\" style=\"display:inline \">\n"     
  	    		"<table width=\"100%%\"  border=\"0\" cellspacing=\"0\" cellpadding=\"0\">"
  	      		"<tr><td class=\"leftMenu\"><a href=\"status_sc.asp\" target=\"mainFrame\">%s</a></td></tr>"        
  	    		"</table>\n"
		  	"</div>\n"),TleftMenu_sysInfo); 
		websWrite(wp, T("<div id=\"lanStatus\" style=\"display:none \">\n"     
  	    		"<table width=\"100%%\"  border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\n"
  	      		"<tr><td class=\"leftMenu\"><a href=\"lan_status_sc.asp\" target=\"mainFrame\">%s</a></td></tr>\n"        
  	    		"</table>\n"
		  	"</div>\n"),TleftMenu_lanStatus); 	  
		websWrite(wp, T("<div id=\"wlanStatus\" style=\"display:none \">\n"     
  	   		"<table width=\"100%%\"  border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\n"
  	      		"<tr><td class=\"leftMenu\"><a href=\"wlan_status_sc.asp\" target=\"mainFrame\">%s</a></td></tr>\n"        
  	   		"</table>\n"
		  	"</div>\n"),TleftMenu_wlanStatus); 	  
		websWrite(wp, T("<div id=\"wanStatus\" style=\"display:none \">\n"     
  	    		"<table width=\"100%%\"  border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\n"
  	      		"<tr><td class=\"leftMenu\"><a href=\"wan_status_sc.asp\" target=\"mainFrame\">%s</a></td></tr>\n"        
  	    		"</table>\n"
		  	"</div>\n"),TleftMenu_wanStatus); 	  
#ifdef	CONFIG_EXT_SWITCH
#ifdef 	ITF_GROUP
		websWrite(wp, T("<div id=\"eth2pvcStatus\" style=\"display:none \">\n"     
  	   		"<table width=\"100%%\"  border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\n"
  	      		"<tr><td class=\"leftMenu\"><a href=\"status_eth2pvc_sc.asp\" target=\"mainFrame\">%s</a></td></tr>\n"        
  	    		"</table>\n"
		  	"</div>\n"),TleftMenu_eth2pvcSta); 	  
#endif
#endif
		websWrite(wp, T("<div id=\"statistic\" style=\"display:none \">\n"     
  	    		"<table width=\"100%%\"  border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\n"
  	     		"<tr><td class=\"leftMenu\"><a href=\"stats_sc.asp\" target=\"mainFrame\">%s</a></td></tr>\n" 
			"<tr><td class=\"leftMenu\"><a href=\"adsl-statis_sc.asp\" target=\"mainFrame\">%s<a></td></tr>\n"         
 		 	"</table>\n"
			"</div>\n"),TleftMenu_ifStatistic,TleftMenu_dslStatistic); 	  
		websWrite(wp, T("<div id=\"arpTbl\" style=\"display:none \">\n"     
  		    	"<table width=\"100%%\"  border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\n"
  		      	"<tr><td class=\"leftMenu\"><a href=\"arptable_sc.asp\" target=\"mainFrame\">%s</a></td></tr>\n"        
	  	    	"</table>\n"
			"</div>\n"),TleftMenu_arpTable); 	    

	  	websWrite(wp, T("<div id=\"reboot\" style=\"display:none \">\n"
			  "<table width=\"100%%\"  border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\n"
		        "<tr><td class=\"leftMenu\"><a href=\"reboot_sc.asp\" target=\"mainFrame\">%s</a></td></tr>\n"
		      "</table>\n"
			  "</div>\n"),TleftMenu_reboot);		
	  	websWrite(wp, T("<div id=\"passwd\" style=\"display:none \">\n"
			  "<table width=\"100%%\"  border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\n"
		        "<tr><td class=\"leftMenu\"><a href=\"password_sc.asp\" target=\"mainFrame\">%s</a></td></tr>\n"
		      "</table>\n"
			  "</div>\n"),TleftMenu_passwd);	
#ifdef 	CONFIG_SAVE_RESTORE
	  	websWrite(wp, T("<div id=\"backup\" style=\"display:none \">\n"
			  "<table width=\"100%%\"  border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\n"
		        "<tr><td class=\"leftMenu\"><a href=\"saveconf_sc.asp\" target=\"mainFrame\">%s</a></td></tr>\n"
		      "</table>\n"
			  "</div>\n"),TleftMenu_backup);	
#endif

#ifdef WEB_UPGRADE
#ifdef UPGRADE_V1
	  	websWrite(wp, T("<div id=\"upgrade\" style=\"display:none \">\n"
			  "<table width=\"100%%\"  border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\n"
		        "<tr><td class=\"leftMenu\"><a href=\"upload_sc.asp\" target=\"mainFrame\">%s</a></td></tr>\n"
		      "</table>\n"
			  "</div>\n"),TleftMenu_upgrade);		
#endif
#endif
#ifdef SYSLOG_SUPPORT
	  	websWrite(wp, T("<div id=\"syslog\" style=\"display:none \">\n"
			  "<table width=\"100%%\"  border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\n"
		        "<tr><td class=\"leftMenu\"><a href=\"syslog_sc.asp\" target=\"mainFrame\">%s</a></td></tr>\n"
		      "</table>\n"
			  "</div>\n"),TleftMenu_syslog);
#endif

	}	

	return 0;
}



